<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="java.util.Date" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="getfile" class="extensions.generic.GetFileBean" scope="session"/>
<jsp:setProperty name="getfile" property="rootDir" 
	value='<%= application.getRealPath("/WEB-INF/") %>' /> 
<jsp:useBean id="setprops" class="extensions.generic.setPropBean" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<%
	String userName=storeInfo.getTableVal("userName");
	ContextManager cm=modserver.getContextManager();
	String probName=storeInfo.getTableVal("problemName");
	String codeType = request.getParameter("codeType");
	System.out.println("codeType: "+codeType);
	String sessionName = null;
	String propspath = application.getRealPath("/WEB-INF/");
	propspath += "../Properties/Collab.properties";

	/*
   	String NumOfInParam = null;
   	String NumOfOutFiles = null;
	String NumOfInFiles=null;
	String NumOfOutParams=null;
	*/	

	if(codeType.equals("CodeSelection")) {
	   sessionName=storeInfo.getTableVal("sessionName");
 	   setprops.setCM(cm);
	   setprops.setRequests(request);

	} else {
   	   Date currentDate = new Date();
   	   long time = currentDate.getTime(); 
   	   String timestring = (new Long(time).toString());	
   	   sessionName = "session"+timestring;
           storeInfo.setTablePair("sessionName",sessionName);

   	   cm.addSession(sessionName); 

	   setprops.setXML(parseXML);
 	   setprops.setCM(cm);
	   setprops.setRequests(request);

	}

	System.out.println("problemName: "+cm.getCurrentProblemProperty("Name"));
	setprops.setIOArrayRequests(request,true);

	//Setup the createScript bean and create the script.
	//Use a factory pattern here so that the queuing system
	//is determined by the user's selection.
	extensions.generic.createScript cjs=
		extensions.generic.scriptFactory.makeChild(cm.getCurrentSessionProperty("QueueType"),cm,userName);

	cjs.setScriptProperties(propspath);
	cjs.createFlagTable();
	cjs.createHeader();
	cjs.createCommands();
	cjs.writeScript();

	//Now grab the script and give the user a chance to edit it.
	String scriptString="";
	String probDir="Descriptors/users/JSPClient/"+userName+"/"+probName+"/"+sessionName;
	scriptString=getfile.fileToString(probDir+"/job.script");
%>
<html>
<head><title>Edit Script</title></head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">
<center>
<h2>Submit Job</h2>
</center>
The following queue script has been created for you.  You can modify 
it if you wish.  When you are finished, click the "Update Script" button.  You
will then be able to run your job on the selected host 
using the "Submit Job" button on the tool bar.
<center>
<form name=scriptString method=POST action="/GOW/Generic/ReturnPage.jsp">
<textarea name=scriptString cols=40 rows=20>
<%= scriptString %>
</textarea>
</center>
<center>
<input type=submit name="submit" value="Update Script" >
<input type = "button" name="cancel" value="Cancel" onClick="self.location='/GOW/Generic/Main.jsp';">
</center>
</form>
</body>
</html>





