import java.io.*;
import java.net.*;

public class Server {
    public Server() {
    }

    public static void main(String[] args) {
	try {
	    //Open a socket
	    ServerSocket server1=new ServerSocket(8585);
	    String callBack1="localhost"; //pet03.asc.hpc.mil";
	    int callBackPort1=9595;
	    String callBack2="localhost"; //"pet03.asc.hpc.mil";
	    int callBackPort2=9898;
	    int timeout=100000;
		
	    System.out.println("Server can now accept connections.");
	    Socket acceptor1=new Socket(callBack1,callBackPort1);
	    Socket acceptor2=new Socket(callBack2,callBackPort2);


	    if(acceptor1==null) {
		System.out.println("Socket is null");
		System.exit(1);
	    }
	    else {
		System.out.println("Connection accepted");
	    }

	    BufferedReader in1=
		new BufferedReader(new 		
		    InputStreamReader(acceptor1.getInputStream()));
	    PrintWriter out1=
		new PrintWriter(acceptor1.getOutputStream(),true);
  	    BufferedReader in2=
  		new BufferedReader(new 		
  		    InputStreamReader(acceptor2.getInputStream()));
  	    PrintWriter out2=
  		new PrintWriter(acceptor2.getOutputStream(),true);

	    boolean done=false;

	    out1.println("Server contacted");
  	    while(!done) {
  		String line=in1.readLine();
		if(line!=null) {
		    System.out.println(line);
		    //Redirect everything back to the client.
		    out1.println(line);
		    out2.println(line);
		    System.out.println("Output sent");
		    //    done=true;
		}
  	    }
	}
	catch(Exception ex) {
	    ex.printStackTrace();
	}

    }
}
