//package extensions.generic;

import extensions.generic.*;
import org.escience.XSIL.*;
import java.awt.*;
import java.util.Vector;
import java.util.Enumeration;
import java.util.HashMap;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.lang.Object;
import java.io.*;

import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.applet.MainFrame;
//import com.sun.j3d.utils.behaviors.picking.*;


public class Java3DViewer extends Frame
    implements ActionListener {  //, ItemListener {

  static extensions.generic.parseXMLList parsexmllist;
  static XSIL root;
  static extensions.generic.Plot3D plot3d;
  String xmlpath = "c:\\GOW\\WEB-INF\\src\\generic\\molecules.xml";
  //HashMap[] molecules;
  HashMap molecules;
  HashMap axisData;
  HashMap NormalMode;
  HashMap Normalindex;
  HashMap Loadfilelist;
  HashMap Menutable;

  private extensions.generic.CapturingCanvas3D canvasXYZ;
  private VirtualUniverse universe;
  private Locale locale;
  private extensions.generic.renderingObject3D renderobject3d;

  private TextField transX;
  private TextField transY;
  private TextField transZ;
  private TextField rotangle;
  private Checkbox rotxy;
  private Checkbox rotyz;
  private Checkbox rotxz;
  private TextField scaleX;

  private List list;
  private Button translate;
  private Button rotate;
  private Button scale;

  private Label label;

  //Planes of transformations
  private static final int XY = 1,
                           XZ = 2,
                           YZ = 3;
  //The transform types
  private static final int TRANSLATE = 1,
                           ROTATE = 2,
                           SCALE = 3;

  private int MODE; //the current transform mode
  private int lastX = 0, lastY = 0;
  private int plane;
  private int Numberofappl;
  private int moleculecount;
  private boolean Normal_mode; 
  private boolean ss = true;

  //MenuBar Control Variable
  extensions.generic.CmdMenuItem Exitmi, SJPGmi, SCoordmi, RMmi,
	              Loadmi, AxisOnmi, AxisOffmi, Appmi, Helpmi, NormOnmi,
	              NormOffmi, Normtypemi; 
  private extensions.generic.CmdMenuItem[] Normindexmi;
  private Menu Filem, Editm, Viewm, Normm, Helpm; 
	              
  //doTransform variable
  private static final int TotalTG = 50;
  private TransformGroup doTranstg;
  private HashMap doTranstmp;
  private TransformGroup[] doTranstgarray;
  private Transform3D doTranst3d;
  private Transform3D[] doTranst3darray;
  private Vector3d doTransv;
  private Vector3d[] doTransvarray;
  private Vector3d doTransvv;
  private Vector3d[] doTransvvarray;
  private Matrix3d doTransm;
  private Matrix3d doTransm1;
  private double accAngle;

  public Java3DViewer() {
	  
	  molecules = new HashMap();
	  Normalindex = new HashMap();
	  NormalMode = new HashMap();
	  Loadfilelist = new HashMap();
	  Menutable = new HashMap();

	  MenuBar menubar = new MenuBar();
	  Font f = new Font("Dialog", Font.PLAIN, 12);
	  	  
	  Filem = new Menu("File");
	  
	  Filem.setFont(f);
	  Loadmi = new extensions.generic.CmdMenuItem("Load");
	  Loadmi.setFont(f);
	  Loadmi.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent evt) {
			LoadmiEvent();     	            		
    	}	   	
      });
	  	
	  Filem.add(Loadmi);
	  Filem.addSeparator();
	  
	  SJPGmi = new extensions.generic.CmdMenuItem("Save/JPG");
	  SJPGmi.addActionListener(this);
	  //mi.setCommand(new extensions.generic.SaveJPGCmd(canvasXYZ));
	  Filem.add(SJPGmi);
	  
	  SCoordmi = new extensions.generic.CmdMenuItem("Save/Coord");
	  SCoordmi.addActionListener(this);
	  Filem.add(SCoordmi);
	  Filem.addSeparator();
	  
	  Exitmi = new extensions.generic.CmdMenuItem("Exit");
	  Exitmi.addActionListener(this);
	  Exitmi.setCommand(new extensions.generic.ExitCmd());
	  Filem.add(Exitmi);
	  menubar.add(Filem);
	  
	  Editm = new Menu("Edit");	  
	  RMmi = new extensions.generic.CmdMenuItem("Remove");
	  RMmi.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent evt) {
			RemovemiEvent();     	            		
    	}	   	
      });
      
	  Editm.add(RMmi);
	  menubar.add(Editm);
	  
	  Viewm = new Menu("View");
	  AxisOnmi = new extensions.generic.CmdMenuItem("Axis On");
	  AxisOnmi.addActionListener(this);
	  Viewm.add(AxisOnmi);
	  
	  AxisOffmi = new extensions.generic.CmdMenuItem("Axis Off");
	  AxisOffmi.addActionListener(this);
	  Viewm.add(AxisOffmi);
	  
	  Appmi = new extensions.generic.CmdMenuItem("Application");
	  Viewm.add(Appmi);
	  menubar.add(Viewm);

	  Normm = new Menu("Normal Mode");
	  NormOnmi = new extensions.generic.CmdMenuItem("Turn On");
	  NormOnmi.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			NormalOnmiEvent();	
		}
	  });
	
	  Normm.add(NormOnmi);
	  
	  NormOffmi = new extensions.generic.CmdMenuItem("Turn Off");
	  NormOffmi.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			NormalOffmiEvent();

		}
	  });	  		  	
	  		  		  	
	  Normm.add(NormOffmi);
	  Normm.addSeparator();
	  	  
	  Normtypemi = new extensions.generic.CmdMenuItem("Normal Type:");
	  Normtypemi.setFont(new Font("Dialog", Font.BOLD, 11));
	  Normm.add(Normtypemi);
	  Normm.addSeparator();	  	  
	  menubar.add(Normm);
	 	  	  	  
	  Helpm = new Menu("Help");
	  Helpmi = new extensions.generic.CmdMenuItem("Molecule Viewer Help");
	  Helpm.add(Helpmi);	  
	  menubar.add(Helpm);
	  
	  setMenuBar(menubar);

	  /*
      ss = true;
      root = new XSIL(xmlpath,ss);
      XSIL child;
      
      for(int ichild=0;ichild<root.getChildCount();ichild++) {
	  child = root.getChild(ichild);
	  parsexmllist = (extensions.generic.parseXMLList)child;
      }

      Vector geometryName = parsexmllist.getParseXMLgeometriesName();
      Numberofappl = geometryName.size();
      
      String chooseMolecule = "3DGeometry2";
      */
      
      plane = XY;
      moleculecount = 0;
      accAngle = 0.0;
      Normal_mode = false;	  
   
      //doTransform Method ==> Variable initialize
      doTranstg = new TransformGroup();
      setCapabilities(doTranstg);
      doTranstmp = new HashMap();
      doTranstgarray = new TransformGroup[TotalTG];
      doTranst3d = new Transform3D();
      doTranst3darray = new Transform3D[TotalTG];
      doTransv = new Vector3d();
      doTransvv = new Vector3d();
      doTransvarray = new Vector3d[TotalTG];
      doTransvvarray = new Vector3d[TotalTG];
      doTransm = new Matrix3d();
	  doTransm1 = new Matrix3d();

      for(int i=0; i<TotalTG; i++) {
        doTranstgarray[i] = new TransformGroup();
        setCapabilities(doTranstgarray[i]);
        doTranst3darray[i] = new Transform3D();
        doTransvarray[i] = new Vector3d();
        doTransvvarray[i] = new Vector3d();
      }

       //rendering Objects are invoked
       renderobject3d = new extensions.generic.renderingObject3D();

       setLayout(new BorderLayout());

       ControlPanelBox();
	  	  	  
      universe = new VirtualUniverse();
      locale = new Locale( universe );

      label.setText("Mode: Translate");
      MODE = TRANSLATE;//SCALE; ROTATE; TRANSLATE;

      locale.addBranchGraph(createViewplatformGraph(canvasXYZ));

//      BranchGroup scene = createSceneGraph(chooseMolecule);

	  axisData = createAxis();
	  AxisOnmi.setEnabled(false);
	  
	  /*
	  for(int i=0; i<Numberofappl; i++)
	  	if(((String)molecules[i].get("MOLECULE_ID")).equals(chooseMolecule)) {
           molecules[i] = createSceneGraph(chooseMolecule);
           molecules[i].put("MOLECULE_ID", chooseMolecule);
           System.out.println("HashMap: "+molecules[i].toString());
           break;
        }
      */       

      //create some ambience
      BranchGroup bg = new BranchGroup();
      bg.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      bg.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      Color3f lColor1 = new Color3f(1.0f, 1.0f, 1.0f);
      Vector3f lDir1  = new Vector3f(-1.0f, -1.0f, -1.0f);
      Color3f alColor = new Color3f(0.2f, 0.2f, 0.2f);
      
      AmbientLight al = new AmbientLight( alColor );
      BoundingSphere bounds =
         new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000.0);
      al.setInfluencingBounds( bounds );
      DirectionalLight lgt1 = new DirectionalLight(lColor1, lDir1);
      lgt1.setInfluencingBounds(bounds);

      bg.addChild( al );
      bg.addChild( lgt1 );
      locale.addBranchGraph( bg );

//      scene.compile();
//      locale.addBranchGraph( scene );
	  transX.setEnabled(false);
	  Menutable.put("transX",transX);
	  transY.setEnabled(false);
	  Menutable.put("transY",transY);	  
	  transZ.setEnabled(false);
	  Menutable.put("transZ",transZ);	  
	  rotangle.setEnabled(false);
	  Menutable.put("rotangle",rotangle);	  
	  rotxy.setEnabled(false);
	  Menutable.put("rotxy",rotxy);	  
	  rotyz.setEnabled(false);
	  Menutable.put("rotyz",rotyz);	  
	  rotxz.setEnabled(false);
	  Menutable.put("rotxz",rotxz);	  
	  scaleX.setEnabled(false);
	  Menutable.put("scaleX",scaleX);	  
	  translate.setEnabled(false);
	  Menutable.put("translate",translate);	  
	  scale.setEnabled(false);
	  Menutable.put("scale",scale);	  
	  rotate.setEnabled(false);
	  Menutable.put("rotate",rotate);	  
	  list.setEnabled(false);
	  Menutable.put("list",list);	  
	  //Filem.setEnabled(false);
	  SJPGmi.setEnabled(false);
	  Menutable.put("SJPGmi",SJPGmi);	  
	  SCoordmi.setEnabled(false);
	  Menutable.put("SCoordmi",SCoordmi);	  
		  
	  Editm.setEnabled(false);
	  Menutable.put("Editm",Editm);	  
	  Normm.setEnabled(false);   
	  Menutable.put("Normm",Normm);	     

	  SJPGmi.setCommand(new extensions.generic.SaveJPGCmd(canvasXYZ, Java3DViewer.this));
	  SCoordmi.setCommand(new extensions.generic.SaveCoordCmd(list, molecules, Java3DViewer.this));
	  //RMmi.setCommand(new extensions.generic.RemoveCmd(molecules,Menutable,Loadfilelist,locale));
	  AxisOnmi.setCommand(new extensions.generic.AxisOnCmd(axisData, AxisOffmi, AxisOnmi));
	  AxisOffmi.setCommand(new extensions.generic.AxisOffCmd(axisData, AxisOffmi, AxisOnmi));
	  //Loadmi.setCommand(new extensions.generic.LoadCmd(Java3DViewer.this));

      //initTRS(chooseMolecule);

  }

  private void ControlPanelBox() {

	Panel Java3DViewerPanel = new Panel();

    GraphicsConfiguration config =
	          SimpleUniverse.getPreferredConfiguration();
	canvasXYZ = new extensions.generic.CapturingCanvas3D(config);

    Panel ControlPanel = new Panel ();

    Panel transpanel = new Panel ();
    translate = new Button ("Translate");
            
 	transX = new TextField("",5);
	transY = new TextField("",5);
    transZ = new TextField("",5);
	Label ltransX = new Label("     X:");
  	Label ltransY = new Label("     Y:");
  	Label ltransZ = new Label("     Z:");
	Label transTitle = new Label("== Translate Control ==");
	transTitle.setFont(new Font("Dialog", Font.BOLD, 14));

	Panel rotpanel = new Panel();
    rotate = new Button ("Rotate");
	rotangle = new TextField("",5);
	CheckboxGroup rotg = new CheckboxGroup();
	rotxy = new Checkbox("XY", rotg, true);
	rotyz = new Checkbox("YZ", rotg, false);
	rotxz = new Checkbox("XZ", rotg, false);	
	Label lrotangle = new Label("  Angle:");
	Label rotTitle = new Label("== Rotate Control ==");
	rotTitle.setFont(new Font("Dialog", Font.BOLD, 14));

	Panel scalepanel = new Panel();
    scale = new Button ("Scale");
	scaleX = new TextField("",5);
	Label lscaleX = new Label("Scale Level:");
	Label scaleTitle = new Label("== Scale Control ==");
	scaleTitle.setFont(new Font("Dialog", Font.BOLD, 14));

    Panel menulist = new Panel ();
    list = new List ();
    label = new Label ();

    Java3DViewerPanel.setLayout (new GridLayout ());
    //Java3DViewerPanel.setBackground (new java.awt.Color (204, 204, 204));
    //Java3DViewerPanel.setForeground (java.awt.Color.black);
    Java3DViewerPanel.setName ("Java3DViewer");
    Java3DViewerPanel.setFont (new Font ("Dialog", 0, 11));
	//Java3DViewerPanel.setSize(400,400);

    canvasXYZ.setBackground (Color.white);
    canvasXYZ.setName ("canvasXYZ");

    canvasXYZ.addMouseListener (new MouseAdapter () {
        public void mousePressed (MouseEvent evt) {
                canvasXYMousePressed (evt);
        }
       });
        
    canvasXYZ.addMouseMotionListener (new MouseMotionAdapter () {
        public void mouseDragged (MouseEvent evt) {
            if(!Normal_mode) canvasXYMouseDragged (evt);
            else {
                	System.out.println("It has the Normal Mode!!!");
                	return;
           }	            
                  //canvasXZMouseDragged (evt);
                  //canvasYZMouseDragged (evt);
        }
       });
  
    Java3DViewerPanel.add (canvasXYZ);
    add(Java3DViewerPanel, BorderLayout.CENTER);

    ControlPanel.setLayout (new GridLayout (6, 1));
    //ControlPanel1.setBackground (new java.awt.Color (204, 204, 204));
    //ControlPanel1.setForeground (java.awt.Color.black);
    ControlPanel.setName ("ControlPanel");
    ControlPanel.setFont (new Font ("Dialog", 0, 11));

	GridBagConstraints gbc = new GridBagConstraints();

	gbc.fill = GridBagConstraints.NONE;
	gbc.anchor = GridBagConstraints.CENTER;
	gbc.weightx = 100;
	gbc.weighty = 100;

    transpanel.setLayout (new GridBagLayout());
    transpanel.setBackground (new Color (204, 204, 204));
    transpanel.setForeground (Color.black);
    transpanel.setName ("Translate");
    //transpanel.setFont (new Font ("Dialog", 0, 11));
  	
    translate.setFont (new Font ("Dialog", 0, 11));
    translate.addActionListener( new ActionListener() {
    	public void actionPerformed(ActionEvent evt) {

		   String items[] = list.getSelectedItems();
	       if(!Normal_mode) {
               label.setText("Mode: Translate");
               MODE = TRANSLATE; 

               for( int i = 0; i < items.length; i++ ){
                  System.out.println("Translate item: " + items[i]);
                  doTransformText(items[i]);
               }
           } else {
     	        System.out.println("It has the Normal Mode!!!");
     	        return;  }	 
     	            		
    	}	   	
    });

	//transX.setFont (new Font ("Dialog", 0, 11));
	//transX.addActionListener(this);
	add(transpanel, transTitle, gbc, 0,0,4,1);
	add(transpanel, ltransX, gbc, 0,1,1,1);
	add(transpanel, transX, gbc, 1,1,1,1);
	add(transpanel, ltransY, gbc, 2,1,1,1);
	add(transpanel, transY, gbc, 3,1,1,1);
	add(transpanel, ltransZ, gbc, 0,2,1,1);
	add(transpanel, transZ, gbc, 1,2,1,1);
	add(transpanel, translate, gbc, 2,2,1,1);
	
	/*
	transpanel.add(ltransX);
	transpanel.add(transX);
	transpanel.add(ltransY);
	transpanel.add(transY);
	transpanel.add(translate);
	*/
	ControlPanel.add(transpanel);

    rotpanel.setLayout (new GridBagLayout());
    rotpanel.setBackground (new Color (204, 204, 204));
    rotpanel.setForeground (Color.black);
    rotpanel.setName ("Rotate");

	gbc.fill = GridBagConstraints.NONE;
	gbc.anchor = GridBagConstraints.CENTER;
	gbc.weightx = 100;
	gbc.weighty = 100;

    rotate.setFont (new Font ("Dialog", 0, 11));
    rotate.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent evt) {
    		
		   String items[] = list.getSelectedItems();    		
	       if(!Normal_mode) {
              label.setText("Mode: Rotate");
              MODE = ROTATE; 
              for( int i = 0; i < items.length; i++ ){
                  System.out.println("Rotate item: " + items[i]);
                  doTransformText(items[i]);
              }
           } else {
     	        System.out.println("It has the Normal Mode!!!");
     	        return;  }	 	
    		
    	}	   	
    });

	//rotangle.setFont (new Font ("Dialog", 0, 11));
	//rotangle.addActionListener(this);
	add(rotpanel, rotTitle, gbc, 0,0,3,1);
	add(rotpanel, rotxy, gbc, 0,1,1,1);
	add(rotpanel, rotyz, gbc, 1,1,1,1);
	add(rotpanel, rotxz, gbc, 2,1,1,1);
	rotxy.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
			plane = XY;
		}
	});
	rotyz.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
			plane = YZ;
		}
	});
	rotxz.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
			plane = XZ;
		}
	});

	//gbc.anchor = GridBagConstraints.EAST;
	add(rotpanel, lrotangle, gbc, 0,2,1,1);
	//gbc.anchor = GridBagConstraints.WEST;
 	add(rotpanel, rotangle, gbc, 1,2,1,1);
	add(rotpanel, rotate, gbc, 2,2,1,1);	  
	ControlPanel.add(rotpanel);

	gbc.fill = GridBagConstraints.NONE;
	gbc.anchor = GridBagConstraints.CENTER;
	gbc.weightx = 100;
	gbc.weighty = 100;

    scalepanel.setLayout (new GridBagLayout());
    scalepanel.setBackground (new Color (204, 204, 204));
    scalepanel.setForeground (Color.black);
    scalepanel.setName ("Scale");

    scale.setFont (new Font ("Dialog", 0, 11));
    scale.addActionListener(new ActionListener() {
    	public void actionPerformed(ActionEvent evt) {

		   String items[] = list.getSelectedItems();
    	   if(!Normal_mode) {
              label.setText("Mode: Scale");
              MODE = SCALE;
              for( int i = 0; i < items.length; i++ ){
                 System.out.println("Scale item: " + items[i]);
                 doTransformText(items[i]);
              }
           } else {
     	         System.out.println("It has the Normal Mode!!!");
     	         return; }	    		
    		
    	}	   	
    });

	//scalefactor.setFont (new Font ("Dialog", 0, 11));
	//scalefactor.addActionListener(this);
	add(scalepanel, scaleTitle, gbc, 0,0,3,1);
	add(scalepanel, lscaleX, gbc, 0,1,1,1);
	add(scalepanel, scaleX, gbc, 1,1,1,1);
	add(scalepanel, scale, gbc, 2,1,1,1);
	/*
	scalepanel.add(lscaleX);
	scalepanel.add(scaleX);
	scalepanel.add(scale);
    */

    ControlPanel.add (scalepanel);
  
    menulist.setLayout (new FlowLayout (FlowLayout.LEFT));
    menulist.setBackground (new Color (204, 204, 204));
    menulist.setForeground (Color.black);
    menulist.setName ("Menu List");
    menulist.setFont (new Font ("Dialog", 0, 11));
  
    list.setBackground (Color.white);
    list.setForeground (Color.black);
    list.setName ("list1");
    list.setFont (new Font ("Dialog", 0, 11));
    //allow multiple selections:
    list.setMultipleMode( true );
	//list.add("Gamess");
    list.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent evt) {
			listItemEvent(evt);			 				 				 				 				 						 	
		}
	});    
    
    menulist.add (list);    
    ControlPanel.add (menulist);

    add (ControlPanel, BorderLayout.EAST);

    label.setBackground (new Color (204, 204, 204));
    label.setText ("Mode:");
    label.setForeground (Color.black);
    label.setName ("mode");
    label.setFont (new Font ("Dialog", 0, 11));

    add (label, BorderLayout.SOUTH);

  }

/*
  public void itemStateChanged(ItemEvent evt) {
  	
   if(!Normal_mode) {	
    if(evt.getStateChange() == ItemEvent.SELECTED) {
*/  
            
/*
	Enumeration bg = locale.getAllBranchGraphs();
    BranchGroup a = (BranchGroup)bg.nextElement();
    System.out.println( a );
    BranchGroup aa = (BranchGroup)bg.nextElement();
    System.out.println( aa );
*/
  
  /*  
    String allItems[] = list.getItems();
    for(int j=0; j<allItems.length; j++)
      if(allItems[j].equals((String)evt.getItem())) {
      	System.out.println("You have already got it!!!!!");
      	return;
      }	
        
 	for(int i=0; i<Numberofappl; i++)
	  if(((String)molecules[i].get("MOLECULE_ID")).equals((String)evt.getItem())) {
           molecules[i] = createSceneGraph((String)evt.getItem());
           molecules[i].put("MOLECULE_ID", (String)evt.getItem());
		   list.add((String)evt.getItem());
           initTRS((String)evt.getItem());
           //System.out.println("HashMap: "+molecules[i].toString());
           break;
      }       
    }
   } else {
   	  System.out.println("It has the Normal Mode!!!!");
   	  return;
   }	   
  }
*/


  public void add(Panel p, Component c, GridBagConstraints gbc,
                int x, int y, int w, int h) {
	gbc.gridx = x;
	gbc.gridy = y;
	gbc.gridwidth = w;
	gbc.gridheight = h;
	p.add(c, gbc);
  }


/*
  public static Menu makingMenu(Object parent, Object[] items, Object target) {
  	Menu m = null;
  	if(parent instanceof Menu) m = (Menu)parent;
  	else if (parent instanceof String) m = new Menu((String)parent);
  	else return null;
  	
  	for(int i=0; i < items.length; i++)
  	{  if(items[i] instanceof String) {
  		MenuItem mi = new MenuItem((String)items[i]);
  		if(target instanceof ActionListener)
  		   mi.addActionListener((ActionListener)target);
  		m.add(mi);
  	   } else if (items[i] instanceof CheckboxMenuItem &&
  	                 target instanceof ItemListener) {
  		   CheckboxMenuItem cmi = (CheckboxMenuItem)items[i];
  		   cmi.addItemListener((ItemListener)target);
  		   m.add(cmi);
  	   } else if (items[i] instanceof MenuItem) {
  		   MenuItem mi = (MenuItem)items[i];
  		   if(target instanceof ActionListener)
  		     mi.addActionListener((ActionListener)target);
  		   m.add(mi);
  	   } else if (items[i] == null) m.addSeparator();
  	}   	      	   
    return m;
  }  
*/

  public void actionPerformed(ActionEvent evt) {

	extensions.generic.CommandHolder ch = (extensions.generic.CommandHolder)evt.getSource();
	ch.getCommand().Execute();
 
  }

  private void LoadmiEvent() {

	  JFileChooser fc = new JFileChooser(".");
	  extensions.generic.FileXmlFilter filter = 
	              	new extensions.generic.FileXmlFilter();
      fc.setFileFilter(filter);
      int returnVal = fc.showOpenDialog(Java3DViewer.this);

      if (returnVal == JFileChooser.APPROVE_OPTION) {     
            System.out.println("You chose to open this file: " +
            fc.getSelectedFile().getName());    	
      } else {
            System.out.println("Cancelled by user.");
            return;
      }        		    
			
	  MODE = TRANSLATE;
	  label.setText("Mode: Translate");
			
	  transX.setEnabled(true);
	  transY.setEnabled(true);
	  transZ.setEnabled(true);
	  rotangle.setEnabled(true);
	  rotxy.setEnabled(true);
	  rotyz.setEnabled(true);
	  rotxz.setEnabled(true);
	  scaleX.setEnabled(true);
	  translate.setEnabled(true);
	  scale.setEnabled(true);
	  rotate.setEnabled(true);
	  list.setEnabled(true);
	  //Filem.setEnabled(false);
	  SJPGmi.setEnabled(true);
	  SCoordmi.setEnabled(true);
		  
	  Editm.setEnabled(true);
			
	  String filename = fc.getSelectedFile().getName();

      root = new XSIL(filename,ss);
      XSIL child;
      
      for(int ichild=0;ichild<root.getChildCount();ichild++) {
	  	child = root.getChild(ichild);
	  	parsexmllist = (extensions.generic.parseXMLList)child;
      }
      		
      Vector geometries = parsexmllist.getParseXMLgeometries();
      Vector geometryName = parsexmllist.getParseXMLgeometriesName();
      //int vectorsize = geometryName.size();
	  //System.out.println("Vector size: "+vectorsize);
      plot3d = (extensions.generic.Plot3D)geometries.elementAt(0);
      String numofmode = plot3d.getNumofNormalmode();
	  int numofmodei = Integer.parseInt(numofmode);
      String moleculename = (String)geometryName.elementAt(0);
	  Loadfilelist.put(moleculename, parsexmllist);

      String allItems[] = list.getItems();
	  Normalindex.put(moleculename, new Integer(numofmodei));

      for(int j=0; j<allItems.length; j++)
      	if(allItems[j].equals(moleculename)) {
      		 System.out.println("You have already got it!!!!!");
      		 return;
      	}	
        
	  if(numofmodei > 0) {
		  Normm.setEnabled(true); 
		  NormOffmi.setEnabled(false);
		  int numNorm = Normm.getItemCount();
		  System.out.println("Normal Menu: "+numNorm);
			    
		  if(numNorm>5) {
			   for(int i=0; i<(numNorm-5); i++) {
			    	//String itmp = "Mode"+(i+1);
			    	Normm.remove(Normindexmi[i]);
			   }    
		  }	    
			    
		  Normindexmi = new extensions.generic.CmdMenuItem[numofmodei];
		  for(int i=0; i<numofmodei; i++) {

			Normindexmi[i] = new extensions.generic.CmdMenuItem("Mode"+(i+1));
			Normindexmi[i].setEnabled(false);
			Normindexmi[i].addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
			
				String sitem = list.getSelectedItem();
				HashMap tmp = (HashMap)NormalMode.get(sitem);
				String arg = evt.getActionCommand();
			    BranchGroup bg = (BranchGroup)tmp.get(sitem+"BG");
				locale.removeBranchGraph(bg);			            
			            
		 	 	tmp = createSceneGraphAnimation(sitem, arg);
		  		NormalMode.put(sitem, tmp);
		 	}
	  		});						
			Normm.add(Normindexmi[i]);
		  }
		}    
		else Normm.setEnabled(false);				   

        HashMap molecule = createSceneGraph(moleculename);
        molecules.put(moleculename, (HashMap)molecule);
		list.add(moleculename, 0);
        initTRS(moleculename);
           
        int[] selectIndexes = list.getSelectedIndexes();
        if(selectIndexes.length == 0) {
           	 list.select(0);
           	 return;
        }	 	
        for(int i=0; i < selectIndexes.length; i++)
           list.deselect(selectIndexes[i]);
        list.select(0);         
           //System.out.println("HashMap: "+molecules[i].toString());
  }

  private void NormalOnmiEvent() {
 			
		  Normal_mode = true;

		  HashMap tmp = new HashMap();	
		  transX.setEnabled(false);
		  transY.setEnabled(false);
		  transZ.setEnabled(false);
		  rotangle.setEnabled(false);
		  rotxy.setEnabled(false);
		  rotyz.setEnabled(false);
		  rotxz.setEnabled(false);
		  scaleX.setEnabled(false);
		  translate.setEnabled(false);
		  scale.setEnabled(false);
		  rotate.setEnabled(false);
		  list.setEnabled(false);
		  //Filem.setEnabled(false);
		  SJPGmi.setEnabled(false);
		  SCoordmi.setEnabled(false);		  
		  Loadmi.setEnabled(false);
		  
		  Editm.setEnabled(false);
		  NormOffmi.setEnabled(true);
          NormOnmi.setEnabled(false);

		  String allitems[] = list.getItems();
		  String sitem = list.getSelectedItem();
		  System.out.println("Normal On: "+sitem);

			
		  label.setText("Normal Mode");
		 
		  int nindex = ((Integer)Normalindex.get(sitem)).intValue();
		  for(int i=0; i<nindex; i++) Normindexmi[i].setEnabled(true);
		  
		  /*
			if(allitems.length == 0) {
				System.out.println("You don't have the items!!!");
				//NormalMode = createSceneGraphAnimation(Mode1);
				return;
			}
		 */	
				
		  for(int i=0; i<allitems.length; i++) {
			  tmp = (HashMap)molecules.get(allitems[i]);
			  BranchGroup bg = (BranchGroup)tmp.get(allitems[i]+"BG");
			  locale.removeBranchGraph(bg);
			  list.remove(allitems[i]);
		  }

		  /*
		  String filename = (String)Loadfilelist.get(sitem);
      	  root = new XSIL(filename,ss);
      	  XSIL child;
      
      	  for(int ichild=0;ichild<root.getChildCount();ichild++) {
	  			child = root.getChild(ichild);
	  			parsexmllist = (extensions.generic.parseXMLList)child;
      	  }
		  */
          parsexmllist = (extensions.generic.parseXMLList)Loadfilelist.get(sitem);

		  tmp = createSceneGraphAnimation(sitem, "Mode1");
		  NormalMode.put(sitem, tmp);	
						      
		  list.add(sitem,0);           
          list.select(0);
    	
  }

  private void NormalOffmiEvent() {
 			
		  Normal_mode = false;

		  HashMap tmp = new HashMap();	
		  transX.setEnabled(true);
		  transY.setEnabled(true);
		  transZ.setEnabled(true);
		  rotangle.setEnabled(true);
		  rotxy.setEnabled(true);
		  rotyz.setEnabled(true);
		  rotxz.setEnabled(true);
		  scaleX.setEnabled(true);
		  translate.setEnabled(true);
		  scale.setEnabled(true);
		  rotate.setEnabled(true);
		  //Filem.setEnabled(true);
		  SJPGmi.setEnabled(true);
		  SCoordmi.setEnabled(true);		  
		  Loadmi.setEnabled(true);
		  		  
		  Editm.setEnabled(true);
		  list.setEnabled(true);
		  NormOffmi.setEnabled(false);
          NormOnmi.setEnabled(true);		  
          	  		  	
	  	  label.setText("Mode: Translate");
          MODE = TRANSLATE;//SCALE; ROTATE; TRANSLATE;
	  	  
	  	  String sitem = list.getSelectedItem();
	  	  
	  	  int nindex = ((Integer)Normalindex.get(sitem)).intValue();
		  for(int i=0; i<nindex; i++) Normindexmi[i].setEnabled(false);	  	
	  	  tmp = (HashMap)NormalMode.get(sitem);
	  	  
	  	  //String mid = (String)NormalMode.get("MOLECULE_ID");
	  	  
		  BranchGroup bg = (BranchGroup)tmp.get(sitem+"BG");
		  locale.removeBranchGraph(bg);
		  			    			    			    	
		  tmp = createSceneGraph(sitem);
		  molecules.put(sitem, (HashMap)tmp);
		  //list.add(mid, 0);
          //list.select(0);
          initTRS(sitem);   		  	
	  	
	  	 /*
	  	  String[] atom = (String[])NormalMode.get("atom");		  		  
		  int ncount = ((Integer)NormalMode.get("nvertex")).intValue();		  
	      int mcylindercount = ((Integer)NormalMode.get("cylindercount")).intValue();		  
		  
		  for(int i=0; i<atom.length; i++) {
		  	System.out.println("atom: "+atom[i]);
		  	SwitchValueInterpolator svi = 
		  	    (SwitchValueInterpolator)NormalMode.get("Ani"+atom[i]);
		  	svi.setEnabled(true);    
		  }	
		  */
		  		
		  //SwitchValueInterpolator svi = (SwitchValueInterpolator)NormalMode.get   
  }

  private void listItemEvent(ItemEvent evt) {
							 	
          if(evt.getStateChange() == ItemEvent.SELECTED ||
             evt.getStateChange() == ItemEvent.DESELECTED) {
               	
			 //System.out.println(evt.getStateChange()+"Selected: "
			               // + (String)evt.getItem());
			 int[] sitemindexes = list.getSelectedIndexes();
			 if(sitemindexes.length == 0 || sitemindexes.length > 1) {
			 	   Normm.setEnabled(false);
			 	   return;
			 }	
			 else {
			 	
			 	String sitem = list.getSelectedItem();
			 	int sitemindex = ((Integer)Normalindex.get(sitem)).intValue();			 				    			    
				if(sitemindex == 0) { Normm.setEnabled(false);
				                      return;
				                     } 			 	
			 	
			 	Normm.setEnabled(true);
			 	NormOnmi.setEnabled(true);
			 	NormOffmi.setEnabled(false);			 	
			 				 				 	
			    int numNorm = Normm.getItemCount();
			    System.out.println("Normal Menu(list): "+numNorm);
			    
			    if(numNorm>5) {
			    	for(int i=0; i<(numNorm-5); i++) {
			    		//String itmp = "Mode"+(i+1);
			    	    Normm.remove(Normindexmi[i]);
			    	}    
			    }	    
			    
				Normindexmi = new extensions.generic.CmdMenuItem[sitemindex];
				for(int i=0; i<sitemindex; i++) {

					Normindexmi[i] = new extensions.generic.CmdMenuItem("Mode"+(i+1));
					Normindexmi[i].setEnabled(false);
					Normindexmi[i].addActionListener(new ActionListener() {
					  public void actionPerformed(ActionEvent evt) {
			
						String sitem = list.getSelectedItem();
						HashMap tmp = (HashMap)NormalMode.get(sitem);
						String arg = evt.getActionCommand();
			            BranchGroup bg = (BranchGroup)tmp.get(sitem+"BG");
						locale.removeBranchGraph(bg);			            
								
		 	 			tmp = createSceneGraphAnimation(sitem, arg);
		  				NormalMode.put(sitem, tmp);
		 			  }
	  				});						
					Normm.add(Normindexmi[i]);
			    }
			 }    
			    
		  }  
    
  }	

  private void RemovemiEvent() {
  
    	String sallitems[] = list.getSelectedItems();
		HashMap tmp = new HashMap();
				
		for(int i=0; i<sallitems.length; i++) {
		  //for(int j=0; j<molecules.length; j++)
		     tmp = (HashMap)molecules.get(sallitems[i]);
			 //if(((String)molecules[j].get("MOLECULE_ID")).equals(sallitems[i])) {
			 BranchGroup bg = (BranchGroup)tmp.get(sallitems[i]+"BG");
			 locale.removeBranchGraph(bg);
			 list.remove(sallitems[i]);
			 //}
		}
		
		int numItem = list.getItemCount();
		if(numItem == 0) {
			
			list.setEnabled(false);
			Editm.setEnabled(false);
			transX.setEnabled(false);
	  		transY.setEnabled(false);
	  		transZ.setEnabled(false); 
	  		rotangle.setEnabled(false);	  		
	  		rotxy.setEnabled(false);
	  		rotyz.setEnabled(false);  
	  		rotxz.setEnabled(false);
	  		scaleX.setEnabled(false);
	  		translate.setEnabled(false);
	  		scale.setEnabled(false); 
	  		rotate.setEnabled(false);
	  		SJPGmi.setEnabled(false);	  
	  		SCoordmi.setEnabled(false);	  			  		
	  		Normm.setEnabled(false);   
		}
		else {
		  list.select(0);
	      MODE = TRANSLATE;
	      label.setText("Mode: Translate");

		  /*
		  String sitem = list.getSelectedItem();
		  
		  parsexmllist = 
		     (extensions.generic.parseXMLList)Loadfilelist.get(sitem);
		     
      	  Vector geometries = parsexmllist.getParseXMLgeometries();
          //Vector geometryName = parsexmllist.getParseXMLgeometriesName();
          //int vectorsize = geometryName.size();
	      //System.out.println("Vector size: "+vectorsize);
          plot3d = (extensions.generic.Plot3D)geometries.elementAt(0);
          String numofmode = plot3d.getNumofNormalmode();
	      int numofmodei = Integer.parseInt(numofmode);		  
		   */ 
			 
		  String sitem = list.getSelectedItem();
		  int sitemindex = ((Integer)Normalindex.get(sitem)).intValue();			 				    			    
		  if(sitemindex == 0) {
		  		Normm.setEnabled(false);
				return;
		  } 			 	
			 	
		  Normm.setEnabled(true);
		  NormOnmi.setEnabled(true);
		  NormOffmi.setEnabled(false);			 	
			 				 				 	
		  int numNorm = Normm.getItemCount();
		  System.out.println("Normal Menu(list): "+numNorm);
			    
		  if(numNorm>5) {
			    for(int i=0; i<(numNorm-5); i++) {
			    	//String itmp = "Mode"+(i+1);
			    	Normm.remove(Normindexmi[i]);
			    }    
		  }	    
			    
		  Normindexmi = new extensions.generic.CmdMenuItem[sitemindex];
		  for(int i=0; i<sitemindex; i++) {

			 Normindexmi[i] = new extensions.generic.CmdMenuItem("Mode"+(i+1));
			 Normindexmi[i].setEnabled(false);
			 Normindexmi[i].addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
			
					String sitem = list.getSelectedItem();
					HashMap tmp = (HashMap)NormalMode.get(sitem);
					String arg = evt.getActionCommand();
			        BranchGroup bg = (BranchGroup)tmp.get(sitem+"BG");
					locale.removeBranchGraph(bg);			            
								
		 	 		tmp = createSceneGraphAnimation(sitem, arg);
		  			NormalMode.put(sitem, tmp);
		 		}
	  		 });						
			 Normm.add(Normindexmi[i]);
		  }    
		     
		}//else			 	
  
  }	

  private void canvasXYMousePressed (MouseEvent evt) {
    System.out.println( "pressed X: " + evt.getX() + " Y: " + evt.getY() );
    lastX = evt.getX();
    lastY = evt.getY();
  }

  private void canvasXYMouseDragged (MouseEvent evt) {
    System.out.print( "dX: ");
    System.out.print( evt.getX() - lastX );
    System.out.print( " dY: ");
    System.out.print( evt.getY() - lastY );
    System.out.println();
    String items[] = list.getSelectedItems();
    for( int i = 0; i < items.length; i++ ){
      System.out.println("item: " + items[i]);
      doTransform(evt.getX() - lastX, evt.getY() - lastY, items[i]);
    }

    lastX = evt.getX();
    lastY = evt.getY();
  }

  /** This method creates and returns a BranchGroup with a view platform.
   * canvas is the Canvas3D object
   */
  public BranchGroup createViewplatformGraph(Canvas3D canvas){
    TransformGroup vpTrans;
    View view;
    BranchGroup vpRoot;
    ViewPlatform vp;
    PhysicalBody body = new PhysicalBody();
    PhysicalEnvironment environment = new PhysicalEnvironment();

    view = new View();
    view.addCanvas3D( canvas );
    view.setPhysicalBody( body );
    view.setPhysicalEnvironment( environment );

    vpRoot = new BranchGroup();
    vpRoot.setCapability( BranchGroup.ALLOW_CHILDREN_READ );

    Vector3d up = null;
    Point3d center, v;
    Transform3D t = new Transform3D();
    t.set( new Vector3f( 0.0f, 0.0f, 4.0f ) ); //set the vp location to the viewLocation

    vp = new ViewPlatform();
    vpTrans = new TransformGroup(t);

    vpTrans.addChild( vp );
    vpRoot.addChild( vpTrans );

    view.attachViewPlatform( vp );
    return vpRoot;
  }
   
  public void initTRS(String name) {

     TransformGroup trs = new TransformGroup();
  	 //HashMap tmp = new HashMap();
  	 //for(int i=0; i<Numberofappl; i++) {
  	   //System.out.println("initTRS: "+(String)molecules[i].get("MOLECULE_ID"));
	   //if(((String)molecules[i].get("MOLECULE_ID")).equals(name)) {
	   	  HashMap tmp = (HashMap)molecules.get(name);
		  trs = (TransformGroup)tmp.get(name);
		  //break;
       //}
     //}

      Transform3D t3d = new Transform3D();
      trs.getTransform( t3d );

      Vector3d v = new Vector3d();
      t3d.get( v );
      transX.setText(String.valueOf(v.x));
      transY.setText(String.valueOf(v.y));      
	  transZ.setText(String.valueOf(v.z));

      Matrix4d m = new Matrix4d();
      Vector3d axis = new Vector3d();
      AxisAngle4d aa = new AxisAngle4d();
      double newangle;
      axis.set( 0.0d, 0.0d, 1.0d );            
      t3d.get( m );
      aa.set( m );
      newangle =  (double) aa.angle;
      rotangle.setText(String.valueOf(newangle));
      plane = XY;
      rotxy.setState(true);

      double scalenum = t3d.getScale();
      scaleX.setText(String.valueOf(scalenum));
  }


  public void setCapabilities(TransformGroup tg) 
  {
     tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
     tg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
     tg.setCapability(Group.ALLOW_CHILDREN_WRITE);
     tg.setCapability(Group.ALLOW_CHILDREN_READ);
     tg.setCapability(Group.ALLOW_CHILDREN_EXTEND);
     tg.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
  } 


  public void doTransform(int dx, int dy, String name){

     //TransformGroup tg = new TransformGroup();
     //setCapabilities(tg);
     //HashMap molecule_tmp = new HashMap();
     
     if( name == null )
       return;

  	  //for(int i=0; i<Numberofappl; i++)
	    //if(((String)molecules[i].get("MOLECULE_ID")).equals(name)) {
           doTranstmp = (HashMap)molecules.get(name);	    	
           doTranstg = (TransformGroup)doTranstmp.get(name);
           //doTranstmp = molecules[i];
           //System.out.println("doTransform: "+(String)molecules[i].toString());
           //break;
        //}     
	 
	 int totaltg = 0;
     doTranstg.getTransform( doTranst3d );
     
     if(MODE == TRANSLATE) {
       
	   int mnvertex = ((Integer)doTranstmp.get("nvertex")).intValue();
	   int mcylindercount = ((Integer)doTranstmp.get("cylindercount")).intValue();
       totaltg = mnvertex + mcylindercount; //+4;

       //System.out.println("TotalTG: "+totaltg);
       //TransformGroup tgarray[] = new TransformGroup[totaltg];

       //Transform3D t3d = new Transform3D();
       //Transform3D t3darray[] = new Transform3D[totaltg];

       /*
       for(int i = 0; i<totaltg; i++) {
          tgarray[i] = new TransformGroup();
          setCapabilities(tgarray[i]);
       } 
       */  

	   Vector atomsofmolecule = new Vector();
	   atomsofmolecule = (Vector)doTranstmp.get("atom");
	   int numofatom = atomsofmolecule.size();
	   for(int i=0; i<numofatom; i++) {
	      doTranstgarray[i] = (TransformGroup)doTranstmp.get((String)atomsofmolecule.elementAt(i));
          //System.out.println("doTransform1: "+(String)atomsofmolecule.elementAt(i));
       }
     
       for(int i = 1; i<=mcylindercount; i++) {
           String tmp = "Cylindername"+i;
	       doTranstgarray[i+numofatom-1] = (TransformGroup)doTranstmp.get(tmp);
       }

/*
	   int arrayindex = numofatom+mcylindercount;
       tgarray[arrayindex] = (TransformGroup)molecule_tmp.get("axisTG");
       tgarray[arrayindex+1] = (TransformGroup)molecule_tmp.get("XTG");
       tgarray[arrayindex+2] = (TransformGroup)molecule_tmp.get("YTG");
       tgarray[arrayindex+3] = (TransformGroup)molecule_tmp.get("ZTG");
*/

       for(int j=0; j<totaltg; j++) {
            //t3darray[j] = new Transform3D();
            doTranstgarray[j].getTransform( doTranst3darray[j] );
		    //System.out.println("t3dARRAY[M"+j+"] = "+t3darray[j]);
       }
     }
       //System.out.println( "transforming shape: " + name );

     //double TRANSLATE_SCALE = 100.0d;
     switch(MODE){
      case TRANSLATE:
           	//Vector3d v = new Vector3d();
            //Vector3d varray[] = new Vector3d[totaltg];

//        switch(plane){
//          case XY:

            doTranst3d.get( doTransv );
	        for(int k=0; k<totaltg; k++) {
                 //varray[k] = new Vector3d();
	             doTranst3darray[k].get( doTransvarray[k] );
		         //System.out.println("t3dARRAY["+k+"] = "+t3darray[k]);
            }

	        transX.setText(String.valueOf(doTransv.x));
	        transY.setText(String.valueOf(doTransv.y));
            transZ.setText(String.valueOf(doTransv.z));
            
            doTransvv.set( doTransv.x + (double)dx / 100.0d, doTransv.y - (double)dy / 100.0d, doTransv.z );
            doTranst3d.setTranslation( doTransvv );

	        for(int l=0; l<totaltg; l++) {
	           doTransvvarray[l].set( doTransvarray[l].x + (double)dx / 100.0d,
	                 doTransvarray[l].y - (double)dy / 100.0d, doTransvarray[l].z );
	           	
               doTranst3darray[l].setTranslation( doTransvvarray[l] );
            }

/*
          break;
          case XZ:
            t3d.get( v );
            t3d.setTranslation( 
              new Vector3f( v.x + (float)dx / TRANSLATE_SCALE, v.y, v.z - (float)dy / TRANSLATE_SCALE ) );
          break;
          case YZ:
            t3d.get( v );
            t3d.setTranslation( 
              new Vector3f( v.x, v.y + (float)dx / TRANSLATE_SCALE, v.z - (float)dy / TRANSLATE_SCALE) );
          break;
        }
*/

      break;
      case ROTATE:

        switch(plane){
          case XY:
            
            //doTranst3d.get( doTransm );

            accAngle = accAngle + (double)Math.toRadians((double)dy/10.0d);           
			
            if( (accAngle >= 2*Math.PI) || (accAngle <= -2*Math.PI) ){
              accAngle = 0.0d;
            }

                                    
            System.out.println("angle: " + accAngle );
	        rotangle.setText(String.valueOf(accAngle));

            doTransm.rotZ(accAngle);
            //doTransm.mul(doTransm1);
            doTranst3d.setRotation(doTransm);

          break;
          case XZ:

            //doTranst3d.get( doTransm );

            accAngle =  accAngle + (double)Math.toRadians((double)dy/10.0d);

            if( (accAngle >= 2*Math.PI) || (accAngle <= -2*Math.PI) ){
              accAngle = 0.0d;
            }

            System.out.println("angle: " + accAngle );
	        rotangle.setText(String.valueOf(accAngle));

            doTransm.rotY(accAngle);
            //doTransm.mul(doTransm1);
            doTranst3d.setRotation( doTransm );
            
            break;
            
          case YZ:

            //doTranst3d.get( doTransm );

            accAngle = accAngle + (double)Math.toRadians((double)dy/10.0d);

            if( (accAngle >= 2*Math.PI) || (accAngle <= -2*Math.PI) ){
              accAngle = 0.0d;
            }

            System.out.println("angle: " + accAngle );
	        rotangle.setText(String.valueOf(accAngle));

			doTransm.rotX(accAngle);
			//doTransm.mul(doTransm1);
            doTranst3d.setRotation( doTransm );
            
            break;
        }
      break;
      
      case SCALE:
	    	    
	    double scalelevel = doTranst3d.getScale();	
	    
	    doTranst3d.setScale(scalelevel + ((double)dy)/100.0d);	    	        
	    scaleX.setText(String.valueOf(scalelevel + ((double)dy)/100.0d));
	    	    	    	    
      break;
    }

    //System.out.println("doTranst3d: " + doTranst3d); 
    doTranstg.setTransform( doTranst3d );

    if(MODE == TRANSLATE)
      for(int m=0; m<totaltg; m++)
          doTranstgarray[m].setTransform( doTranst3darray[m] );
  }

  public void doTransformText(String name){

     TransformGroup tg = new TransformGroup();
     setCapabilities(tg);
     HashMap molecule_tmp = new HashMap();

     if( name == null )
       return;

  	  //for(int i=0; i<Numberofappl; i++)
	    //if(((String)molecules[i].get("MOLECULE_ID")).equals(name)) {
	       molecule_tmp = (HashMap)molecules.get(name);
           tg = (TransformGroup)molecule_tmp.get(name);
           //molecule_tmp = molecules[i];
           //break;
        //}     
 
	  Transform3D t3d = new Transform3D();    
      Transform3D[] t3darray = null;
      TransformGroup[] tgarray = null; 
	  int totaltg = 0;

      tg.getTransform( t3d );
        
	  if(MODE == TRANSLATE) {

	   int mnvertex = ((Integer)molecule_tmp.get("nvertex")).intValue();
	   int mcylindercount = ((Integer)molecule_tmp.get("cylindercount")).intValue();
	 
       totaltg = mnvertex + mcylindercount; //+4;
       tgarray = new TransformGroup[totaltg];

       t3darray = new Transform3D[totaltg];

       for(int i = 0; i<totaltg; i++) {
          tgarray[i] = new TransformGroup();
          setCapabilities(tgarray[i]);
       }   

	   Vector atomsofmolecule = new Vector();
	   atomsofmolecule = (Vector)molecule_tmp.get("atom");
	   int numofatom = atomsofmolecule.size();
	   for(int i=0; i<numofatom; i++)
	      tgarray[i] = (TransformGroup)molecule_tmp.get((String)atomsofmolecule.elementAt(i));

       for(int i = 1; i<=mcylindercount; i++) {
           String tmp = "Cylindername"+i;
	       tgarray[i+numofatom-1] = (TransformGroup)molecule_tmp.get(tmp);
       }

/*
	   int arrayindex = numofatom+mcylindercount;
       tgarray[arrayindex] = (TransformGroup)molecule_tmp.get("axisTG");
       tgarray[arrayindex+1] = (TransformGroup)molecule_tmp.get("XTG");
       tgarray[arrayindex+2] = (TransformGroup)molecule_tmp.get("YTG");
       tgarray[arrayindex+3] = (TransformGroup)molecule_tmp.get("ZTG");
*/

       for(int j=0; j<totaltg; j++) {
            t3darray[j] = new Transform3D();
            tgarray[j].getTransform( t3darray[j] );
       }
     }
     //System.out.println( "transforming shape: " + name );

     switch(MODE){
      case TRANSLATE:

           	Vector3d v = new Vector3d();           	
            Vector3d varray[] = new Vector3d[totaltg];
	    
//        switch(plane){
//          case XY:

            t3d.get( v );

	        for(int k=0; k<totaltg; k++) {
                 varray[k] = new Vector3d();
	             t3darray[k].get( varray[k] );
            }
            
            t3d.setTranslation( 
              new Vector3d(v.x + Double.parseDouble(transX.getText().trim()),
                           v.y + Double.parseDouble(transY.getText().trim()),
              	           v.z + Double.parseDouble(transZ.getText().trim())));


	    for(int l=0; l<totaltg; l++)
          t3darray[l].setTranslation( 
             new Vector3d( varray[l].x + Double.parseDouble(transX.getText().trim()),
                           varray[l].y + Double.parseDouble(transY.getText().trim()),
                 	       varray[l].z + Double.parseDouble(transZ.getText().trim())));
        break;
      case ROTATE:
        Matrix3d m = new Matrix3d();
        Matrix3d m1 = new Matrix3d();
        double newangle;

        switch(plane){
          case XY:
          
            //t3d.get( m );
 			//System.out.println("Matrix: "+m);           

            accAngle = Double.parseDouble(rotangle.getText().trim());

/*
            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle < 0.0d ){
              newangle = (double)Math.PI;
            }
*/
            m.rotZ(accAngle);
            //System.out.println("Matrix1: "+m);
            //m.mul(m1);  
            t3d.setRotation( m );

          break;
          case XZ:

            //t3d.get( m );

            accAngle = Double.parseDouble(rotangle.getText().trim());

/*
            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle < 0.0d ){
              newangle = (double)Math.PI;
            }
*/
            m.rotY(accAngle);
            //m.mul(m1);
            t3d.setRotation( m );
            
            break;
            
          case YZ:

            //t3d.get( m );

            accAngle = Double.parseDouble(rotangle.getText().trim());

/*
            if( newangle > Math.PI ){
              newangle = 0.0d;
            } else if ( newangle < 0.0d ){
              newangle = (double)Math.PI;
            }
*/
            m.rotX(accAngle);
            //m.mul(m1);
            t3d.setRotation( m );
            
            break;
        }
      break;
      case SCALE:	
	    t3d.setScale(Double.parseDouble(scaleX.getText().trim()));
        break;
    }

    //System.out.println("t3d: " + t3d);
    tg.setTransform( t3d );
    
    if(MODE == TRANSLATE)
      for(int m=0; m<totaltg; m++)
          tgarray[m].setTransform( t3darray[m] );

  }
  
  
  public HashMap createSceneGraph(String targetgeomName) {

      HashMap moleculedata = new HashMap();
      BranchGroup rootBG = new BranchGroup();

//      Transform3D t3D = new Transform3D();
//      t3D.setScale(0.5f);

      Transform3D t3D1 = new Transform3D();
      t3D1.rotX(0.1f);

      Transform3D t3D2 = new Transform3D();	
      t3D2.rotY(-0.25f);

      t3D1.mul(t3D2);
//      t3D.mul(t3D1);

      TransformGroup sceneTG = new TransformGroup(t3D1);
      setCapabilities(sceneTG);

	  moleculedata.put("MOLECULE_ID", targetgeomName);
      moleculedata.put(targetgeomName,sceneTG);

      BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
      //BoundingSphere bounds1 = new BoundingSphere();

    
/*
      // Add mouse behaviors
      // Create the rotate behavior node
      MouseRotate rotBehavior = new MouseRotate();
      rotBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(rotBehavior);
      rotBehavior.setSchedulingBounds(bounds);
      
      // Create the zoom behavior node
      MouseZoom zoomBehavior = new MouseZoom();
      zoomBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(zoomBehavior);
      zoomBehavior.setSchedulingBounds(bounds);
      
      // Create the translate behavior node
      MouseTranslate transBehavior = new MouseTranslate();
      transBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(transBehavior);
      transBehavior.setSchedulingBounds(bounds);
*/
     
      //getting data from XML file to render some objects
      Vector geometries = parsexmllist.getParseXMLgeometries();

	  /*
      Vector geometryName = parsexmllist.getParseXMLgeometriesName();

      int targetIndex = 0;

      for (int i = 0; i < geometryName.size(); i++) {
	  String tmp = (String)geometryName.elementAt(i);
	  if(tmp.equals(targetgeomName)) {
			targetIndex = i;
			break;
	  }
      }
	  */

      plot3d = (extensions.generic.Plot3D)geometries.elementAt(0);

      int nvertex = plot3d.getNvertex();
      moleculedata.put("nvertex", new Integer(nvertex));
	  //System.out.println("Processing geometry " + (targetIndex+1) + ": vertices = " + nvertex);

	  if(nvertex == 0 || plot3d.getCoordXList() == null){
	      System.out.println("Bad Java3DGeometry");
	      //continue;
	  }

	  double[][] coorddata = new double[nvertex][3];
	  double[][] orgcoorddata = new double[nvertex][3];

	  String geomtype = plot3d.getJava3DGeometryType();
	  String coordunit = plot3d.getCoordUnit();
	  
	  String[] atom = plot3d.getAtomList();
	  Vector atomvector = new Vector();
	  for(int i=0; i<atom.length; i++)
	  	   atomvector.addElement(atom[i]);
	  moleculedata.put("atom", atomvector);

	  Vector atomchargevector = new Vector();
	  float[] atomcharge = plot3d.getAtomicChargeList();
	  for(int i=0; i<atomcharge.length; i++)
	       atomchargevector.addElement(new Float(atomcharge[i]));

	  moleculedata.put("atomcharge", atomchargevector);

	  double[] coordx = plot3d.getCoordXList();
	  double[] coordy = plot3d.getCoordYList();
	  double[] coordz = plot3d.getCoordZList();
	  float[] colors = plot3d.getColors();

	  for(int l=0; l<nvertex; l++) {
	     orgcoorddata[l][0] = coordx[l];	
	     orgcoorddata[l][1] = coordy[l];	    
	     orgcoorddata[l][2] = coordz[l];
	  }

	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)	
	    System.out.println(orgcoorddata[l][m]);
	  
	  double maxs = coorddata[0][0];
	  double mins = coorddata[0][0];
	  double absmaxs;
	  double absmins;
	  double normalizedValue;
	  double normalizedAxis = 0.0;

	  for(int l=1; l<nvertex; l++) {
	   for(int m=0; m<3; m++) {
	      if(orgcoorddata[l][m] > maxs) maxs = orgcoorddata[l][m];
	      if(orgcoorddata[l][m] < mins) mins = orgcoorddata[l][m];
	   }
	  }
	  System.out.println("Maxs = "+maxs);
	  System.out.println("Mins = "+mins);	

	  System.out.println("Geometry Type: "+geomtype);

	  if( maxs < -1.0 || maxs > 1.0 || mins < -1.0 || mins > 1.0) {
	    if(maxs < -1.0 || maxs > 1.0) {
		 absmaxs = Math.abs(maxs);
		 if(mins < -1.0 || mins > 1.0) {
			absmins = Math.abs(mins);
			normalizedValue = Math.max(absmaxs, absmins);
			normalizedAxis = Math.ceil(normalizedValue);
		 }
		 else normalizedAxis = Math.ceil(absmaxs);
	    }
	    else {
		absmins = Math.abs(mins);
		normalizedAxis = Math.ceil(absmins);
	    }
	    for(int l=0; l<nvertex; l++)
	     for(int m=0; m<3; m++) {
	    	double tmp = orgcoorddata[l][m] / normalizedAxis;
		coorddata[l][m] = tmp;
	     }
	  }
	  else {
	     for(int l=0; l<nvertex; l++)
	      for(int m=0; m<3; m++)
		coorddata[l][m] = orgcoorddata[l][m];
	  }		


	  moleculedata.put("normaxis", new Double(normalizedAxis));

	  int k=0;
	  
	  for (int l=0; l<nvertex; l++) {	
	  double[] atomaxis = {coorddata[l][0], coorddata[l][1], coorddata[l][2]};      
	  Color3f atomAppearcolor = new Color3f(colors[k+l], colors[k+1+l], colors[k+2+l]);

	  //each Object is rendering. carbon, hydrogens.
	  if(geomtype.equals("Sphere")) {

		double satomchargef = Math.sqrt((double)atomcharge[l]);
        float atomradius = ((float)satomchargef)/15.0f;
      		
        Vector3d atomposition = new Vector3d(atomaxis[0], atomaxis[1], atomaxis[2]);
        renderobject3d.setSphereRender(atomradius,atomAppearcolor,atomposition,sceneTG);
		moleculedata.put(atom[l], (TransformGroup)renderobject3d.hashShape3d.get("Sphere"));
       	               		
	  }
	  k = k+2;
	  }

	  //rendering bars for the bonds between the carbon and hydrogen atoms

	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)
	     System.out.println(coorddata[l][m]); 
	
	  int n=0;
	  int cylindercount = 0;
	  for(int l=0; l<nvertex - 1; l++) {  //nvertex - 1;
	   for(int m=n+1; m<nvertex; m++) {
	     System.out.println("m = "+m);
	     double bondCheck = renderobject3d.getLength(orgcoorddata[l], orgcoorddata[m]);
	     System.out.println("BondCheck = "+bondCheck);
	     //1.5 Angstroms = 2.834Bohr 
	     if(((bondCheck < 2.834467) && (coordunit.equals("BOHR")))
	         || ((bondCheck < 1.50000) && (coordunit.equals("Angstroms"))) ) {

	       float cylinderradius = 0.025f;
               Color3f cylinderAppearcolor = new Color3f(0.9f, 0.1f, 0.0f);

	       renderobject3d.renderingBar(cylinderradius,cylinderAppearcolor,coorddata[l],coorddata[m],sceneTG);
	       cylindercount++;
	       System.out.println("Cylindercount: "+cylindercount);
	       String cylindername = "Cylindername"+cylindercount;
	       moleculedata.put(cylindername, (TransformGroup)renderobject3d.hashShape3d.get("Cylinder"));
	     }	
	   }
	   ++n;
	 }

     moleculedata.put("cylindercount", new Integer(cylindercount));
     
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      rootBG.setCapability( BranchGroup.ALLOW_DETACH );

      rootBG.addChild(sceneTG);

/*
      PickRotateBehavior pickRotate = new PickRotateBehavior(rootBG, canvasXYZ, bounds);
	  rootBG.addChild(pickRotate); 
      PickingCallback identityCallback = new IdentityCallback();
      // Register the class callback to be called 
      pickRotate.setupCallback(identityCallback);
*/
      //rootBG.compile();
      locale.addBranchGraph( rootBG );

      moleculedata.put(targetgeomName+"BG",rootBG);
      return moleculedata;
  }


  public HashMap createSceneGraphAnimation (String targetgeomName, String mode) {

      HashMap moleculedata = new HashMap();
      BranchGroup rootBG = new BranchGroup();

      Transform3D t3D1 = new Transform3D();
      t3D1.rotX(0.1f);

      Transform3D t3D2 = new Transform3D();	
      t3D2.rotY(-0.25f);

      t3D1.mul(t3D2);
      
      TransformGroup sceneTG = new TransformGroup(t3D1);
      setCapabilities(sceneTG);

	  moleculedata.put("MOLECULE_ID", targetgeomName);
      moleculedata.put(targetgeomName,sceneTG);

      BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
      //BoundingSphere bounds1 = new BoundingSphere();

      // Add mouse behaviors
      // Create the rotate behavior node
      MouseRotate rotBehavior = new MouseRotate();
      rotBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(rotBehavior);
      rotBehavior.setSchedulingBounds(bounds);
         
      // Create the zoom behavior node
      MouseZoom zoomBehavior = new MouseZoom();
      zoomBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(zoomBehavior);
      zoomBehavior.setSchedulingBounds(bounds);
      
      // Create the translate behavior node
      MouseTranslate transBehavior = new MouseTranslate();
      transBehavior.setTransformGroup(sceneTG);
      sceneTG.addChild(transBehavior);
      transBehavior.setSchedulingBounds(bounds);

      //getting data from XML file to render some objects
      Vector geometries = parsexmllist.getParseXMLgeometries();
      //Vector geometryName = parsexmllist.getParseXMLgeometriesName();

	  /*
      int targetIndex = 0;

      for (int i = 0; i < geometryName.size(); i++) {
	  String tmp = (String)geometryName.elementAt(i);
	  if(tmp.equals("3DGeometry4")) {
			targetIndex = i;
			break;
	  }
      }
	  */ 
	   
      plot3d = (extensions.generic.Plot3D)geometries.elementAt(0);

      int nvertex = plot3d.getNvertex();
      moleculedata.put("nvertex", new Integer(nvertex));
	  //System.out.println("Processing geometry " + (targetIndex+1) + ": vertices = " + nvertex);

	  if(nvertex == 0 || plot3d.getCoordXList() == null){
	      System.out.println("Bad Java3DGeometry");
	      //continue;
	  }

	  double[][] coorddata = new double[nvertex][3];
	  double[][] orgcoorddata = new double[nvertex][3];

	  String geomtype = plot3d.getJava3DGeometryType();
	  String coordunit = plot3d.getCoordUnit();

	  String[] atom = plot3d.getAtomList();

	  moleculedata.put("atom", atom);

	  float[] atomcharge = plot3d.getAtomicChargeList();
	  
	  System.out.println(mode+":");
	  float[] normalmode = plot3d.getNormalmode(mode);
	  
	  for(int i=0; i< 3*nvertex; i++) {
	    System.out.print(normalmode[i]);
	  }  

	  float[][] modes = new float[nvertex][3];
	  int count = 0;
	  
	  System.out.println("");
	  System.out.println(mode+":");	  
	  for(int i=0; i< nvertex; i++) {
	    for(int j=0; j<3; j++) {
	       modes[i][j] = normalmode[j+count];
	       System.out.print(modes[i][j]);
	    }
	    System.out.println("");   
	    count = count + 3;
	  }  

	  moleculedata.put("atomcharge", atomcharge);

	  double[] coordx = plot3d.getCoordXList();
	  double[] coordy = plot3d.getCoordYList();
	  double[] coordz = plot3d.getCoordZList();
	  float[] colors = plot3d.getColors();

	  for(int l=0; l<nvertex; l++) {
	     orgcoorddata[l][0] = coordx[l];
	     orgcoorddata[l][1] = coordy[l];
	     orgcoorddata[l][2] = coordz[l];
	  }

	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)	
	    System.out.println(orgcoorddata[l][m]);
	  
	  double maxs = coorddata[0][0];
	  double mins = coorddata[0][0];
	  double absmaxs;
	  double absmins;
	  double normalizedValue;
	  double normalizedAxis = 0.0;
	  
	  float[][] normMode = new float[7][3];
	  double tmp;
	  float tmp1;

	  for(int l=1; l<nvertex; l++) {
	   for(int m=0; m<3; m++) {
	      if(orgcoorddata[l][m] > maxs) maxs = orgcoorddata[l][m];
	      if(orgcoorddata[l][m] < mins) mins = orgcoorddata[l][m];
	   }
	  }
	  System.out.println("Maxs = "+maxs);
	  System.out.println("Mins = "+mins);	

	  System.out.println("Geometry Type: "+geomtype);

	  if( maxs < -1.0 || maxs > 1.0 || mins < -1.0 || mins > 1.0) {
	    if(maxs < -1.0 || maxs > 1.0) {
		 absmaxs = Math.abs(maxs);
		 if(mins < -1.0 || mins > 1.0) {
			absmins = Math.abs(mins);
			normalizedValue = Math.max(absmaxs, absmins);
			normalizedAxis = Math.ceil(normalizedValue);
		 }
		 else normalizedAxis = Math.ceil(absmaxs);
	    }
	    else {
		absmins = Math.abs(mins);
		normalizedAxis = Math.ceil(absmins);
	    }
	    for(int l=0; l<nvertex; l++)
	     for(int m=0; m<3; m++) {
	    	tmp = orgcoorddata[l][m] / normalizedAxis;
		    coorddata[l][m] = tmp;
		    //Mode Value is normalized
		    tmp1 = modes[l][m] / (float)normalizedAxis;
		    //normMode[l][m] = tmp1;
		    //Normal mode Position Figuring out
		    normMode[l][m] = (float)tmp + tmp1;
	     }
	  }
	  else {
	     for(int l=0; l<nvertex; l++)
	      for(int m=0; m<3; m++) {
		       coorddata[l][m] = orgcoorddata[l][m];
		       normMode[l][m] = (float)orgcoorddata[l][m] + modes[l][m];
		  }     
	  }		
	  	  
	  moleculedata.put("normaxis", new Double(normalizedAxis));

	  double[][] normModed = new double[nvertex][3];
	  
	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)
	   	 normModed[l][m] = (double)normMode[l][m];  

	  int k=0;

	  for (int l=0; l<nvertex; l++) {
	
	  double[] atomaxis = {coorddata[l][0], coorddata[l][1], coorddata[l][2]};      
	  double[] normalPos = {normModed[l][0], normModed[l][1], normModed[l][2]};
	  //double[] atomaxis = {normModed[l][0], normModed[l][1], normModed[l][2]};
	  Color3f atomAppearcolor = new Color3f(colors[k+l], colors[k+1+l], colors[k+2+l]);

	  //each Object is rendering. carbon, hydrogens.
	  if(geomtype.equals("Sphere")) {

		double satomchargef = Math.sqrt((double)atomcharge[l]);
        float atomradius = ((float)satomchargef)/15.0f;

        Vector3d atomposition = new Vector3d(atomaxis[0], atomaxis[1], atomaxis[2]);
        renderobject3d.setSphereRenderAnimation(atomradius,atomAppearcolor,atomaxis,
                          normalPos,sceneTG, rootBG);
        //renderobject3d.setSphereRender(atomradius,atomAppearcolor,atomposition,sceneTG);
		String anitmp = "Ani"+atom[l];
		moleculedata.put(atom[l], (TransformGroup)renderobject3d.hashShape3d.get("Sphere"));
		moleculedata.put(anitmp, (SwitchValueInterpolator)renderobject3d.hashShape3d.get("SAnimation"));		
       	               		
	  }
	  k = k+2;
	  }

	  //rendering bars for the bonds between the carbon and hydrogen atoms
	  
	  for(int l=0; l<nvertex; l++)
	   for(int m=0; m<3; m++)
	     System.out.println(coorddata[l][m]); 
	
	  int n=0;
	  int cylindercount = 0;
	  for(int l=0; l<nvertex - 1; l++) {  //nvertex - 1;
	   for(int m=n+1; m<nvertex; m++) {
	     System.out.println("m = "+m);
	     double bondCheck = renderobject3d.getLength(orgcoorddata[l], orgcoorddata[m]);
	     System.out.println("BondCheck = "+bondCheck);
	     //1.5 Angstroms = 2.834Bohr 
	     if(((bondCheck < 2.834467) && (coordunit.equals("BOHR")))
	         || ((bondCheck < 1.50000) && (coordunit.equals("Angstroms"))) ) {

	       float cylinderradius = 0.025f;
               Color3f cylinderAppearcolor = new Color3f(0.9f, 0.1f, 0.0f);

	       //renderobject3d.renderingBar(cylinderradius,cylinderAppearcolor,coorddata[l],coorddata[m],sceneTG);
	       renderobject3d.renderingBarAnimation(cylinderradius,cylinderAppearcolor,
	              coorddata[l],coorddata[m], normModed[l],normModed[m],sceneTG, rootBG);

	       cylindercount++;
	       System.out.println("Cylindercount: "+cylindercount);
	       String cylindername = "Cylindername"+cylindercount;
	       String anicylinname = "AniCylinname"+cylindercount;
	       moleculedata.put(cylindername, (TransformGroup)renderobject3d.hashShape3d.get("Cylinder"));
		   moleculedata.put(anicylinname, (SwitchValueInterpolator)renderobject3d.hashShape3d.get("CAnimation"));
	     }	
	   }
	   ++n;
	 }

     moleculedata.put("cylindercount", new Integer(cylindercount));
     
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      rootBG.setCapability( BranchGroup.ALLOW_DETACH );

      rootBG.addChild(sceneTG);

/*
      PickRotateBehavior pickRotate = new PickRotateBehavior(rootBG, canvasXYZ, bounds);
	  rootBG.addChild(pickRotate); 
      PickingCallback identityCallback = new IdentityCallback();
      // Register the class callback to be called 
      pickRotate.setupCallback(identityCallback);
*/
      //rootBG.compile();
      locale.addBranchGraph( rootBG );

      moleculedata.put(targetgeomName+"BG",rootBG);
      return moleculedata;
  }

  public HashMap createAxis() {

      HashMap moleculedata = new HashMap();

      Transform3D t3D1 = new Transform3D();
      t3D1.rotX(0.1f);

      Transform3D t3D2 = new Transform3D();	
      t3D2.rotY(-0.25f);

      t3D1.mul(t3D2);

      TransformGroup axisallTG = new TransformGroup(t3D1);
      setCapabilities(axisallTG);

      moleculedata.put("axisallTG",axisallTG);

      //BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0f);
      
      //add Axis
      TransformGroup axisTG = new TransformGroup();
	  setCapabilities(axisTG);

      extensions.generic.AxisObject axis = new extensions.generic.AxisObject();

      axisTG.addChild(axis);
      axisallTG.addChild(axisTG);
      moleculedata.put("axis", axis);
      moleculedata.put("axisTG", axisTG);

      //hashTransformgroup.put("axis", axis);

      //add the coordinate axis
      // Create a simple Text2D leaf node, add it to the scene graph.
      //X-axis
      Vector3f xposition = new Vector3f(1.4f,0.0f,0.0f);
      renderobject3d.setText2DRender("X", xposition, axisallTG);

      //Y-axis
      Vector3f yposition = new Vector3f(0.0f,1.4f,0.0f);
      renderobject3d.setText2DRender("Y", yposition, axisallTG);

      //Z-axis
      Vector3f zposition = new Vector3f(0.0f,0.0f,1.4f);
      renderobject3d.setText2DRender("Z", zposition, axisallTG);

      moleculedata.put("X", renderobject3d.hashShape3d.get("X"));
      moleculedata.put("Y", renderobject3d.hashShape3d.get("Y"));
      moleculedata.put("Z", renderobject3d.hashShape3d.get("Z"));
      moleculedata.put("XTG", renderobject3d.hashShape3d.get("XTG"));
      moleculedata.put("YTG", renderobject3d.hashShape3d.get("YTG"));
      moleculedata.put("ZTG", renderobject3d.hashShape3d.get("ZTG"));

      BranchGroup rootBG = new BranchGroup();
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_READ );
      rootBG.setCapability( BranchGroup.ALLOW_CHILDREN_WRITE );
      rootBG.setCapability( BranchGroup.ALLOW_DETACH );

      rootBG.addChild(axisallTG);
      locale.addBranchGraph( rootBG );

      return moleculedata;
  }

/*
  public class IdentityCallback extends Object implements PickingCallback{
	  private Transform3D t3d = new Transform3D();
      private Vector3f v = new Vector3f();

      public void transformChanged(int type, TransformGroup tg) {

		tg.getTransform( t3d );
		t3d.get ( v );
        System.out.println("picking"+ v);
      }
  }
*/

	/*
    private void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }
   */

    public static void main(String[] args) {
	      //Frame frame = new MainFrame(new Java3DViewer(), 600, 400);

        Java3DViewer window = new Java3DViewer();
        //window.inAnApplet = false;
        
        window.addWindowListener(new WindowAdapter() {
           public void windowClosing(WindowEvent e) {System.exit(0);}
        });

	    window.setResizable(true);
	    window.setSize(719,550);
        window.setTitle("Java3DViewer");
        //window.pack();
        window.setVisible(true);
        //window.show();
    }
}





