/**
 * Define the exit command.
 */

package extensions.generic;

import extensions.generic.*;
import java.awt.*;
import java.util.HashMap;
import javax.media.j3d.*;
import javax.vecmath.*;


public class RemoveCmd implements Command {
	private HashMap Menutable;
	private HashMap molecules;
	private HashMap Loadfilelist;
	private Locale locale;	
	
	public RemoveCmd(HashMap molecules, HashMap Menutable, 
	           HashMap Loadfilelist, Locale locale) {
		this.Menutable = Menutable;
		this.molecules = molecules;
		this.Loadfilelist = Loadfilelist;
		this.locale = locale;
	}
		
    public void Execute(){
    	
    	List list = (List)Menutable.get("list");    	
    	String sallitems[] = list.getSelectedItems();
    	HashMap tmp = new HashMap();

    	/*
		if(sallitems.length == 0) {
			System.out.println("You don't have the selected item!!!");
			return;
		}
		*/
				
		for(int i=0; i<sallitems.length; i++) {
		  //for(int j=0; j<molecules.length; j++)
		     tmp = (HashMap)molecules.get(sallitems[i]);
			 //if(((String)molecules[j].get("MOLECULE_ID")).equals(sallitems[i])) {
			 BranchGroup bg = (BranchGroup)tmp.get(sallitems[i]+"BG");
			 locale.removeBranchGraph(bg);
			 list.remove(sallitems[i]);
			 //}
		}
		int numItem = list.getItemCount();
		if(numItem == 0) {
			
			list.setEnabled(false);
			MenuItem Editm = (MenuItem)Menutable.get("Editm");
			Editm.setEnabled(false);
			TextField transX = (TextField)Menutable.get("transX");
			transX.setEnabled(false);
	        TextField transY = (TextField)Menutable.get("transY");
	  		transY.setEnabled(false);
	  		TextField transZ = (TextField)Menutable.get("transZ");	  
	  		transZ.setEnabled(false);
	  		TextField rotangle = (TextField)Menutable.get("rotangle");	  
	  		rotangle.setEnabled(false);	  		
	  		Checkbox rotxy = (Checkbox)Menutable.get("rotxy");	  
	  		rotxy.setEnabled(false);
	  		Checkbox rotyz = (Checkbox)Menutable.get("rotyz");	  
	  		rotyz.setEnabled(false);
	  		Checkbox rotxz = (Checkbox)Menutable.get("rotxz");	  
	  		rotxz.setEnabled(false);
	  		TextField scaleX = (TextField)Menutable.get("scaleX");	  
	  		scaleX.setEnabled(false);
	  		Button translate = (Button)Menutable.get("translate");	  
	  		translate.setEnabled(false);
	  		Button scale = (Button)Menutable.get("scale");	  
	  		scale.setEnabled(false);
	  		Button rotate = (Button)Menutable.get("rotate");	  
	  		rotate.setEnabled(false);
	  		MenuItem SJPGmi = (MenuItem)Menutable.get("SJPGmi");	  
	  		SJPGmi.setEnabled(false);
	  		MenuItem SCoordmi = (MenuItem)Menutable.get("SCoordmi");	  
	  		SCoordmi.setEnabled(false);
	  			  		
	  		Menu Normm = (Menu)Menutable.get("Normm");	  
	  		Normm.setEnabled(false);   
		}
		else {
		  list.select(0);
		  String sitem = list.getSelectedItem();
		  
		  extensions.generic.parseXMLList parsexmllist = 
		     (extensions.generic.parseXMLList)Loadfilelist.get(sitem);			
		}			 		
    }
}

