<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.submitJob.*" %>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.StringTokenizer" %>

<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="xmlGOW" class="extensions.generic.parseGOW" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<%!
    boolean validateInput(String logit){
	//int logitindex = 0;
	//String logitsubstring = null;
	StringTokenizer st = null;
	boolean result = false;

	//logitindex = logit.indexOf("STDERR:");
	//logitsubstring = logit.substring(logitindex);
	st = new StringTokenizer(logit);
	//st.nextToken();
	if(st.hasMoreTokens()) result = true;
	else result = false;
	return result;
    }

%>

<html>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">

<%
	String[] codenames = request.getParameterValues("codenames");
	String codeName=request.getParameter("codeName");
	boolean checkflag = true;

	for (int l = 0; l < codenames.length; l++) {
	     if(codeName.equals(codenames[l])) {
		     checkflag = false;
		     break;
	     }
	}

	if(checkflag) {

	String userName=storeInfo.getTableVal("userName");
	submitJob sj=modserver.getSubmitJob();

	String machinenames = request.getParameter("machineName");
	String execpaths = request.getParameter("execpath");
	String workspaces = request.getParameter("workspace");
	String qsubpaths = request.getParameter("qsubpath");
	String classpaths = request.getParameter("classpath");

	String execpathcheck = request.getParameter("execpathverify");
	String workdircheck = request.getParameter("workdirverify");
	String qsubcheck= request.getParameter("qsubverify");
	String classpathcheck= request.getParameter("classpathverify");

	String logit = null;
	String command = "ls -l ";
	String errorcode = null;

	if(execpathcheck.equals("Yes") && checkflag) {
	   command += execpaths;
	   logit=sj.execRemoteCommand(machinenames,userName,command,"rsh");
	   if(!validateInput(logit)) {
		errorcode = "Execution Path: "+execpaths;	
		checkflag = false;
	    }
	    else command = "ls -l ";
	}

	if(workdircheck.equals("Yes") && checkflag) {
	   command += workspaces;
	   logit=sj.execRemoteCommand(machinenames,userName,command,"rsh");
	   if(!validateInput(logit)) {
		errorcode = "Work Directory: "+workspaces;	
		checkflag = false;
	    }
	    else command = "ls -l ";
	}

	if(qsubcheck.equals("Yes") && checkflag) {
	   command += qsubpaths;
	   logit=sj.execRemoteCommand(machinenames,userName,command,"rsh");
	   if(!validateInput(logit)) {
		errorcode = "Qsub Path: "+qsubpaths;	
		checkflag = false;
	    }
	    else command = "ls -l ";
	}

	if(classpathcheck.equals("Yes") && checkflag) {
	   command += classpaths;
	   logit=sj.execRemoteCommand(machinenames,userName,command,"rsh");
	   if(!validateInput(logit)) {
		errorcode = "Class Path: "+classpaths;	
		checkflag = false;
	    }
	    else command = "ls -l ";
	}

	if(checkflag) {

	Hashtable applData = new Hashtable();
	String webpath = application.getRealPath("/WEB-INF/");
	String xmlpath = webpath+"src/generic/ApplDesc.xml";

   	String NumOfInParam = request.getParameter("numofinparam");
        String NumOfInFiles = request.getParameter("numofinfiles");
        String NumOfOutParam = request.getParameter("numofoutparam");
   	String NumOfOutFiles = request.getParameter("numofoutfiles");
	String Iostyle = request.getParameter("iostyle");

	String queuetypes = request.getParameter("queuetype");

	applData.put("applName",codeName);
        applData.put("paramInNum",NumOfInParam);
        applData.put("infileNum", NumOfInFiles);
        applData.put("paramOutNum", NumOfOutParam);
        applData.put("outfileNum",NumOfOutFiles);
	applData.put("iostyle",Iostyle);
	applData.put("hostName",machinenames);
	applData.put("oldhostName",machinenames);
	applData.put("queueType",queuetypes);
	applData.put("execPath",execpaths);
	applData.put("workDir",workspaces);
	applData.put("qsubPath",qsubpaths);
	applData.put("classPath",classpaths);

	xmlGOW.setXML(parseXML);
	xmlGOW.addApplication(xmlpath,applData,true);
	int nappl = xmlGOW.doParse(xmlpath);

%>

<center>
<h2>The new Application Data</h2>
</center>
<br> <b>code: </b><%= codeName %>
<br> <b>input param: </b><%= NumOfInParam %>
<br> <b>input files: </b> <%= NumOfInFiles %>
<br> <b>output param: </b> <%= NumOfOutParam %>
<br> <b>outfiles: </b><%= NumOfOutFiles %>
<br> <b>iostyle: </b><%= Iostyle %>
<br> <b>machine: </b><%= machinenames %>
<br> <b>queue: </b><%= queuetypes %>
<br> <b>exec: </b><%= execpaths %>
<br> <b>work: </b><%= workspaces %>
<br> <b>qsub: </b><%= qsubpaths %>
<br> <b>the content of the hahtable: </b><%= applData.toString() %>
<br> <b>The Number of the existing Applications: </b><%= nappl %>
<hr> 
<h3> Your application was added. if you want to do more things,
Please choose buttons as below. </h3>

<jsp:include page="AdminTrack.jsp" flush="true"/>

<%
	}
	else {
%>

<center>
<h2>Error Report for adding the Application Data</h2>
</center>
<br> <b> <%= machinenames %> </b> has <b>NOT</b> the correct path for
 <b> <%= errorcode %> </b><br>
<b> Please try it again. </b>

<jsp:include page="AdminAdd.jsp" flush="true"/>
<%
	}
%>

<%	}
	else {
%>

<center>
<h2>Error Report for adding the Application Data</h2>
</center>
<br> You used the <b>SAME</b> application name, <b> <%= codeName %>.</b>
<br> In order to add this application, You must use the <b>UNIQUE</b> application name. <br>
<b> Please try it again. </b>

<jsp:include page="AdminAdd.jsp" flush="true"/>
<%
	}
%>

</body>
</html>





