import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class CrpcConfig extends JInternalFrame {

String selectedServer;
desktop d;

  public CrpcConfig(desktop d) {
  super("CRPC Configuration", true, true, true, true);
  this.d = d;
  
  this.selectedServer = d.selectedServer;


  JPanel bck = new JPanel();
  getContentPane().add(bck);

  bck.setLayout(new BorderLayout());
  JPanel titlePanel = new JPanel();
  titlePanel.setLayout(new GridLayout(3,1));
  titlePanel.add(new JLabel(" "));
  titlePanel.add(new JLabel("Configure CRPC for this Server: "+d.selectedServer, JLabel.CENTER));
  titlePanel.add(new JLabel(" "));
  bck.add(titlePanel,BorderLayout.NORTH);

  JTabbedPane tp = new JTabbedPane();

  ParssimPanel jp = new ParssimPanel(d, selectedServer);
  ExpressPanel ep = new ExpressPanel(d, selectedServer);
  CopyPanel cp = new CopyPanel(d, selectedServer);
  RemovePanel rp = new RemovePanel(d, selectedServer); 

  tp.addTab("Parssim",jp);
  tp.addTab("AVS/Express",ep);
  tp.addTab("Copying",cp);
  tp.addTab("Removing",rp);

  bck.add(tp, BorderLayout.CENTER);  

  }

} 




