import java.awt.*;
import javax.swing.*;
import java.util.*;

public class RMRCrpc implements Runnable{

    private JTextField status;
    private JTextArea resultText;
    private JScrollPane sp;
    private String RParssimHost, RParssimUser, RParssimSrc, RWebserverDest;
    private String selectedServer;
    private boolean debug;

  public RMRCrpc(JTextField status, JTextArea resultText, JScrollPane sp, String RParssimHost, String RParssimUser, String RParssimSrc, String RWebserverDest, String selectedServer, boolean debug) {

    this.status = status;
    this.resultText = resultText;
    this.sp = sp;
    this.RParssimHost = RParssimHost;
    this.RParssimUser = RParssimUser;
    this.RParssimSrc = RParssimSrc;
    this.RWebserverDest = RWebserverDest;
    this.selectedServer = selectedServer;
    this.debug = debug;
    if(debug) System.out.println("RMRCrpc constructor completed");
  }

    public void run(){

      /* then run the job */
      status.setText("running...remote delete");
      RemoteDeleteFiles(RParssimHost, RParssimUser, RParssimSrc, RWebserverDest, selectedServer);
      status.setText("completed... remote delete");

    }


    public void RemoteDeleteFiles(String host, String user, String src, String WebserverDest, String selectedServer) {

	String cmdLine = "rm "+src;
	int the_num_of_file = 0;

	/*
	Connection.submit.submitRshwait(host, user, cmdLine+"infile_Movie");
	if(debug) System.out.println("infile_Movie is deleted...");
	resultText.append("rsh -l \n");
	*/

	resultText.append("rcp -p "+user+"@"+host+":"+src+"velTime "+WebserverDest+"\n");
	//resultText.append("waiting... velTime\n");
	//if (debug) System.out.println("waiting... velTime");
	if (debug) System.out.println("rcp -p "+user+"@"+host+":"+src+"velTime "+WebserverDest);

	//do {
	Connection.submit.importFile(src+"velTime", WebserverDest, host, user);
	//}while (!Connection.remote.exists(WebserverDest+"velTime"));
	
	the_num_of_file = getReadBlockandFileCount("velTime");
	resultText.append("Total number of the vel* files: "+the_num_of_file+"\n");
	if(debug) System.out.println("velTime is deleted...");
	resultText.append("velTime is deleted\n");

	Connection.remote.delete(WebserverDest+"velTime");


	if(selectedServer.equals("birch.csit.fsu.edu")) {

	    if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+"velTime");
	    resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+"velTime\n");
	
	    Connection.submit.submitAIXRshwait(host, user, cmdLine+"velTime");

	    String rm_vel;
	    status.setText("vel file Deleting ...");
	    
	    for (int i = 0; i < the_num_of_file; i++) {
		
		if ( i >= 0 && i < 10 ) rm_vel = "vel.00" + i + ".plt" ;
		else if ( i >= 10 && i < 100) rm_vel = "vel.0" + i + ".plt";
		else rm_vel = "vel."+ i + ".plt";
		
		if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_vel);
		resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_vel+"\n");
		
		Connection.submit.submitAIXRshwait(host, user, cmdLine+rm_vel);
		
	    }  //for i=0
	}
	else {
	    if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+"velTime");
	    resultText.append("rsh -l "+user+" "+host+" "+cmdLine+"velTime\n");
	
	    Connection.submit.submitRshwait(host, user, cmdLine+"velTime");

	    String rm_vel;
	    status.setText("vel file Deleting ...");
	    
	    for (int i = 0; i < the_num_of_file; i++) {
		
		if ( i >= 0 && i < 10 ) rm_vel = "vel.00" + i + ".plt" ;
		else if ( i >= 10 && i < 100) rm_vel = "vel.0" + i + ".plt";
		else rm_vel = "vel."+ i + ".plt";
		
		if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+rm_vel);
		resultText.append("rsh -l "+user+" "+host+" "+cmdLine+rm_vel+"\n");
		
		Connection.submit.submitRshwait(host, user, cmdLine+rm_vel);
		
	    }  //for i=0
	} //else

	resultText.append("rcp -p "+user+"@"+host+":"+src+"presTime "+WebserverDest+"\n");
	//resultText.append("waiting... presTime\n");
	//if (debug) System.out.println("waiting... presTime");
	if (debug) System.out.println("rcp -p "+user+"@"+host+":"+src+"presTime "+WebserverDest);
	
	//do {
	Connection.submit.importFile(src+"presTime", WebserverDest, host, user);
	//}while (!Connection.remote.exists(WebserverDest+"presTime"));
	
	the_num_of_file = getReadBlockandFileCount("presTime");
	resultText.append("Total number of the pres* files: "+the_num_of_file+"\n");

	if(debug) System.out.println("presTime is deleted...");
	resultText.append("presTime is deleted\n");

	Connection.remote.delete(WebserverDest+"presTime");	

	if(selectedServer.equals("birch.csit.fsu.edu")) {

	    if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+"presTime");
	    resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+"presTime\n");
	    
	    Connection.submit.submitAIXRshwait(host, user, cmdLine+"presTime");
	    
	    String rm_pres;
	    
	    status.setText("pres file Deleting...");
	    
	    for (int i = 0; i < the_num_of_file; i++) {
		
		if ( i >= 0 && i < 10 ) rm_pres = "pres.00" + i + ".plt" ;
		else if ( i >= 10 && i < 100) rm_pres = "pres.0" + i + ".plt";
		else rm_pres = "pres."+ i + ".plt";
		
		if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_pres);
		resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_pres+"\n");

		Connection.submit.submitAIXRshwait(host, user, cmdLine+rm_pres);
	    }  //for i=0
	}
	else {
	    if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+"presTime");
	    resultText.append("rsh -l "+user+" "+host+" "+cmdLine+"presTime\n");
	    
	    Connection.submit.submitRshwait(host, user, cmdLine+"presTime");
	    
	    String rm_pres;
	    
	    status.setText("pres file Deleting...");
	    
	    for (int i = 0; i < the_num_of_file; i++) {
		
		if ( i >= 0 && i < 10 ) rm_pres = "pres.00" + i + ".plt" ;
		else if ( i >= 10 && i < 100) rm_pres = "pres.0" + i + ".plt";
		else rm_pres = "pres."+ i + ".plt";
		
		if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+rm_pres);
		resultText.append("rsh -l "+user+" "+host+" "+cmdLine+rm_pres+"\n");
		Connection.submit.submitRshwait(host, user, cmdLine+rm_pres);
		
	    }  //for i=0	    
	} //else


	//resultText.append("waiting... concTime\n");
	//if (debug) System.out.println("waiting... concTime");
	resultText.append("rcp -p "+user+"@"+host+":"+src+"concTime "+WebserverDest+"\n");
	if (debug) System.out.println("rcp -p "+user+"@"+host+":"+src+"concTime "+WebserverDest);

	//do {
	Connection.submit.importFile(src+"concTime", WebserverDest, host, user);
	//}while (!Connection.remote.exists(WebserverDest+"concTime"));
	
	the_num_of_file = getReadBlockandFileCount("concTime");
	resultText.append("Total number of the conc* files: "+the_num_of_file+"\n");

	if(debug) System.out.println("concTime is deleted...");
	resultText.append("concTime is deleted\n");
	Connection.remote.delete(WebserverDest+"concTime");	

	if(selectedServer.equals("birch.csit.fsu.edu")) {

	    if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+"concTime");
	    resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+"concTime\n");

	    Connection.submit.submitAIXRshwait(host, user, cmdLine+"concTime");
	    
	    String rm_conc1, rm_conc11, rm_conc21;
	    
	    status.setText("conc file Deleting...");
	    
	    for (int i = 0; i < the_num_of_file; i++) {
		
		if ( i >= 0 && i < 10 ) {
		    rm_conc1 = "conc1-10.00" + i + ".plt" ;
		    rm_conc11 = "conc11-20.00" + i + ".plt";
		    rm_conc21 = "conc21-27.00" + i + ".plt"; }
		
		else if ( i >= 10 && i < 100) { 
		    rm_conc1 = "conc1-10.0" + i + ".plt";
		    rm_conc11 = "conc11-20.0" + i + ".plt";
		    rm_conc21 = "conc21-27.0" + i + ".plt"; }
		
		else {  
		    rm_conc1 = "conc1-10."+ i + ".plt";
		    rm_conc11 = "conc11-20." + i + ".plt";
		    rm_conc21 = "conc21-27." + i + ".plt";  }
		
		if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_conc1);
		resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_conc1+"\n");

		Connection.submit.submitAIXRshwait(host, user, cmdLine+rm_conc1);
		if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_conc11);
		resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_conc11+"\n");
		
		Connection.submit.submitAIXRshwait(host, user, cmdLine+rm_conc11);
		if(debug) System.out.println("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_conc21);
		resultText.append("rsh dirac.csit.fsu.edu -l cyoun rsh "+host+" -l "+user+" "+cmdLine+rm_conc21+"\n");

		Connection.submit.submitAIXRshwait(host, user, cmdLine+rm_conc21);
		
	    }  //for i=0
	}
	else {
	    if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+"concTime");
	    resultText.append("rsh -l "+user+" "+host+" "+cmdLine+"concTime\n");
	    
	    Connection.submit.submitRshwait(host, user, cmdLine+"concTime");
	    
	    String rm_conc1, rm_conc11, rm_conc21;
	    
	    status.setText("conc file Deleting...");
	    
	    for (int i = 0; i < the_num_of_file; i++) {
		
		if ( i >= 0 && i < 10 ) {
		    rm_conc1 = "conc1-10.00" + i + ".plt" ;
		    rm_conc11 = "conc11-20.00" + i + ".plt";
		    rm_conc21 = "conc21-27.00" + i + ".plt"; }
		
		else if ( i >= 10 && i < 100) { 
		    rm_conc1 = "conc1-10.0" + i + ".plt";
		    rm_conc11 = "conc11-20.0" + i + ".plt";
		    rm_conc21 = "conc21-27.0" + i + ".plt"; }
		
		else {  
		    rm_conc1 = "conc1-10."+ i + ".plt";
		    rm_conc11 = "conc11-20." + i + ".plt";
		    rm_conc21 = "conc21-27." + i + ".plt";  }
		
		if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+rm_conc1);
		resultText.append("rsh -l "+user+" "+host+" "+cmdLine+rm_conc1+"\n");
		Connection.submit.submitRshwait(host, user, cmdLine+rm_conc1);
		
		if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+rm_conc11);
		resultText.append("rsh -l "+user+" "+host+" "+cmdLine+rm_conc11+"\n");
		Connection.submit.submitRshwait(host, user, cmdLine+rm_conc11);
		
		if(debug) System.out.println("rsh -l "+user+" "+host+" "+cmdLine+rm_conc21);
		resultText.append("rsh -l "+user+" "+host+" "+cmdLine+rm_conc21+"\n");
		Connection.submit.submitRshwait(host, user, cmdLine+rm_conc21);
		
	    }  //for i=0
	} //else
    }


    public int getReadBlockandFileCount(String filename) {
  
	String file_context = null;
	String file_context1 = null;
	byte[] file_read = null;
	int    read_block_num = 0;
	int    blocksize = 1024;
	int    filesize = 0;
	int    file_count = 0;

	try {

	    Connection.remote.open(RWebserverDest+filename, "r");
	    filesize = Connection.remote.getFileSize();
	    
	    if ( filesize <= blocksize ) {
		file_read = Connection.remote.getBlock();
		file_context = new String(file_read);   }
	    else {
		read_block_num = filesize / blocksize;
		if ( (filesize % blocksize) > 0 ) read_block_num = read_block_num + 1;
		file_read = Connection.remote.getBlock();
		file_context = new String(file_read);
		
		for ( int i=1; i < read_block_num; i++) {		
		    file_read = Connection.remote.getBlock();
		    file_context1 = new String(file_read);
		    file_context = file_context.concat(file_context1); } 
	    }
	    Connection.remote.close();

	    StringTokenizer st = new StringTokenizer(file_context);
	    while (st.hasMoreTokens()) {
		st.nextToken();
		st.nextToken();
		file_count = file_count + 1; 
	    }

	    if(debug) System.out.println("FILE size: "+filesize);
	    if (debug) System.out.println("Reading veltime: "+file_context);
	    
	} catch(WebFlow.RemoteFile2.RemoteFile2Package.FileException ex)
	    {
		if (debug) { System.out.println("Can't read from `" +
						ex.getMessage() + "'");
		System.exit(1); }
	    } catch (WebFlow.RemoteFile2.RemoteFile2Package.EOFFileException ex1) {
		if (debug) { System.out.println("Can't read from `" +
						ex1.getMessage() + "'");
		System.exit(1); }
	    }
	
	return file_count;
    }


    public synchronized void waitFor(long howLong){
	try {
	    wait(howLong);
	} catch (Exception e) { System.out.println(e);}
    }
}




