<%@ page info="Display and modify the application data" %>
<%@ page import="java.util.*" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>

<%
   String codeName=request.getParameter("codeName");
   Vector machineNames=parseXML.getHostListNames(codeName);   
%>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.75 [en] (X11; U; IRIX 6.5 IP32) [Netscape]">
<SCRIPT LANGUAGE="JavaScript">
function checkForm(form) {
	for(var i = 0; i < form.elements.length; i++) {
	  if(form.elements[i].value == "") {
		alert("Fill out ALL fields.")
		return false
	  }
	}
	return true
}
</SCRIPT>
</head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">

<center>
<h2>
The Update form for an application </h2></center>
<form name="updateform" Method="POST" action="/GOW/servlet/WebFlow.Servlets.GOWAdminServlet" onSubmit="return checkForm(this)">
<input type="hidden" name="cmd" value="AdminChange">

Please provide the following information needed to update an application.
<p><b><i>Code: </i></b>
<b><%= codeName %> </b>
<input type="hidden" name=codeName value="<%= codeName %>">

<p><b><i>Number of Input Parameter: </i></b>
<input type=text name=numofinparam size=3 maxlength=3 value="<%= parseXML.getNumberOfInParams(codeName) %>">

<p><b><i>Number of Input Files: </i></b>
<input type=text name=numofinfiles size=3 maxlength=3 value="<%= parseXML.getNumberOfInFiles(codeName) %>">

<p><b><i>Number of Output Parameter: </i></b>
<input type=text name=numofoutparam size=3 maxlength=3 value="<%= parseXML.getNumberOfOutParams(codeName) %>">

<p><b><i>Number of Output Files: </i></b>
<input type=text name=numofoutfiles size=3 maxlength=3 value="<%= parseXML.getNumberOfOutFiles(codeName) %>">

<p><b><i>IO Style: </i></b>
<input type=text name=iostyle size=25 maxlength=80 value="<%= parseXML.getIOStyle(codeName) %>">

<%
	String tmp1;
	String tmp2;
	String tmp3;
	String tmp4;
	String tmp5;

        for(int j=0;j<machineNames.size();j++){ 
           tmp1 = (String)machineNames.elementAt(j);
	   tmp2 = "execpathverify"+ j;
	   tmp3 = "workdirverify"+ j;
	   tmp4 = "qsubverify"+ j;
	   tmp5 = "classpathverify"+j;
	
%>      
	        <p><b><i> <%= j+1 %>. Machine Name: </i></b>
                <input type=text name=machineName size=20 maxlength=80
                        value=<%= tmp1 %>><br>
                <input type=hidden name=oldmachineName size=20 maxlength=80
                        value=<%= tmp1 %>>
<%
	   String queueType =
	      parseXML.getMatchTag(codeName, tmp1,"QueueType");
	   String execPath =
              parseXML.getMatchTag(codeName, tmp1,"ExecPath");
	   String workSpace =
              parseXML.getMatchTag(codeName, tmp1,"WorkDir");
	   String qsubPath =
	      parseXML.getMatchTag(codeName, tmp1,"QsubPath");
	   String classPath =
	      parseXML.getMatchTag(codeName, tmp1,"CLASSPATH");

%>
	  	<table border = 0>
		<td width = 30>
		&nbsp;
		</td> <td>	
	        <b><li>Queue Type: </b>
                <input type=text name=queuetype size=10 maxlength=50
                        value=<%= queueType %>>
	        <b><li>Exec Path: </b>
                <input type=text name=execpath size=25 maxlength=80
                        value=<%= execPath %>> <b> Verify: </b>
		<input type=radio name=<%= tmp2 %> value="Yes" > Yes
		<input type=radio name=<%= tmp2 %> value="No" CHECKED > No
	        <b><li>Work Space: </b>
                <input type=text name=workspace size=25 maxlength=80
                        value=<%= workSpace %>> <b> Verify: </b>
		<input type=radio name=<%= tmp3 %> value="Yes" > Yes
		<input type=radio name=<%= tmp3 %> value="No" CHECKED > No
	        <b><li>Qsub Path: </b>
                <input type=text name=qsubpath size=25 maxlength=80
                        value=<%= qsubPath %>> <b> Verify: </b>
		<input type=radio name=<%= tmp4 %> value="Yes" > Yes
		<input type=radio name=<%= tmp4 %> value="No" CHECKED > No
	        <b><li>CLASSPATH: </b>
                <input type=text name=classpath size=25 maxlength=80
                        value=<%= classPath %>> <b> Verify: </b>
		<input type=radio name=<%= tmp5 %> value="Yes" > Yes
		<input type=radio name=<%= tmp5 %> value="No" CHECKED > No
<%
	Hashtable hash=parseXML.getEnvironHash(codeName,tmp1);	
	Enumeration en=hash.keys();
	while(en.hasMoreElements()) {
	   String key=(String)en.nextElement();
	   String tablename = tmp1+"+"+key;
%>
	        <b><li><%= key %>: </b>
                <input type=text name=<%= tablename %> size=25 maxlength=80
                        value=<%= (String)hash.get(key) %>> <br>
<%
	}
%>
		</td>
		</table>
<%
        }

	Vector vtklist = parseXML.getVtkList(codeName);

        for(int j=0;j<vtklist.size();j++){ 
           tmp1 = (String)vtklist.elementAt(j);
	
%>      
	        <p><b><i> <%= j+1 %>. Vtk Name: </i></b>
                <input type=hidden name=vtkName size=20 maxlength=80
                        value=<%= tmp1 %>> <b><%= tmp1 %></b><br>
<%
	String vizhost = parseXML.getVtkHost(codeName, tmp1);
	String vizpath = parseXML.getVtkPath(codeName, tmp1);
%>
	  	<table border = 0>
		<td width = 30>
		&nbsp;
		</td> <td>	
	        <b><li>Vtk Host: </b>
                <input type=text name=vtkhost size=20 maxlength=80
                        value=<%= vizhost %>>
	        <b><li>Vtk Path: </b>
                <input type=text name=vtkpath size=25 maxlength=80
                        value=<%= vizpath %>>
		</td>
		</table>
<%
	}
%>
<p>
<input type=submit name="submit" value="Update">&nbsp;&nbsp;
<input type = "button" name="cancel" value="Cancel" onClick="self.location='/GOW/Generic/AdminXMLcancel.jsp';">
</form>
</body>
</html>