<%@ page info="Update the script, move it to the backend, and return." %>
<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="WebFlow.RemoteFile.*" %>
<%@ page import="WebFlow.RemoteFile.RemoteFilePackage.*" %>
<%@ page import="WebFlow.SerialHash.*" %>
<%@ page import="java.net.*" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="getfile" class="extensions.generic.GetFileBean" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<%
	String userName=storeInfo.getTableVal("userName");
	String codeType = storeInfo.getTableVal("codeType");

	ContextManager cm = null;
	String descRoot = null;
	RemoteFile rf = null;
	SerialHash sh = null;
	boolean flag = false;

	if(codeType.equals("CodeSelection")) {
	   String slaveHostName = storeInfo.getTableVal("hostName");
	   String slaveMachinename =  storeInfo.getTableVal("slaveMachinename");
   	   if(!slaveHostName.equals(slaveMachinename)) flag = true;
	} else {
	   String archiveType = storeInfo.getTableVal("archiveType");
	   if(archiveType.equals("masterProblemname")) flag = true;
	}

   	if(flag) { 	
       	   cm=modserver.getContextManager();
	   sh=modserver.getSerialHash();
	   descRoot=application.getRealPath("/WEB-INF/Descriptors/users/");
   	} else {
      	   cm=modserver.getContextManagerForSlave();
	   rf=modserver.getRemoteFileForSlave();
	   sh=modserver.getSerialHashForSlave();
	   descRoot=storeInfo.getTableVal("slavedescDir");
   	}

	String probName=storeInfo.getTableVal("problemName");
	String sessionName=storeInfo.getTableVal("sessionName");

	String scriptString=request.getParameter("scriptString");
	//String probDir="Descriptors/users/JSPClient/"+userName+"/"+probName+"/"+sessionName;
	String probDir = cm.getCurrentSessionProperty("Directory");
	scriptString=getfile.removeCharacters(scriptString,"\015");

   	if(flag) {

	getfile.stringToFile(scriptString,probDir+"/job.script");

	} else {

        byte buffer[] = scriptString.getBytes();
        try {
	    rf.open(probDir+"/job.script","rw");
            rf.putBlock(buffer);
            rf.close();
        }catch (FileException ex) { 
            rf.close(); 
        }

	}

	//SerialHash sh=modserver.getSerialHash();
	sh.test();

	String machine=cm.getCurrentSessionProperty("machineName");
	String command=cm.getCurrentSessionProperty("QsubPath");
	command+=" "+cm.getCurrentSessionProperty("Directory")+"/job.script";
	String shValue=machine+"+"+userName+"+"+command;
	sh.openHash(descRoot+"JSPClient/"+userName+"/probHash");
	sh.appendHash(probName,shValue);
	sh.closeHash();
%>
<html>
<head><title>Track Navigator</title></head>
<h2>
<center>
Job Submitted
</center>
</h2>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">
You can submit your queue script
 by selecting it from the list of pending jobs under
the "Submit Job" menu button on the ToolBar.  You can also check the status 
with the job monitoring tool, or you can 
choose from the options below.

<jsp:include page="TrackNavigator.jsp" flush="true"/>

</body>
</html>
