<%@ page info="Visualize data and generate JPEG image." %>
<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="WebFlow.submitJob.*" %>
<%@ page import="WebFlow.RemoteFile.*" %>
<%@ page import="WebFlow.Collaborator.*" %>
<%@ page import="java.net.*" %>
<%@ page import="java.util.*" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="getfile" class="extensions.generic.GetFileBean" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<%
   //String webpath = application.getRealPath("/");
   String webpath = storeInfo.getTableVal("webDir");;
   String url = "/GOW/VizData/";
   String webaccessDir = webpath+"/VizData/";
   String collflag = request.getParameter("collflag");
   String imgflag = request.getParameter("imgflag");
   System.out.println("imgflag: "+imgflag);
   System.out.println("collflag: "+collflag);
   String userName=storeInfo.getTableVal("userName");
   String filename = null;
   String windowname = null;
   String disp = null;
   int index = -1;
   int index1 = -1;
   String rcommand = null;
   String archiveType = storeInfo.getTableVal("archiveType");

   //hard-path removing
   String openHostname = storeInfo.getTableVal("openHostname");
   String masterServerOwner = storeInfo.getTableVal("masterServerOwner");
   String masterServergspath = storeInfo.getTableVal("masterServergspath");
   String slaveServergspath = storeInfo.getTableVal("slaveServergspath");

   ContextManager cm=null;
   submitJob sj = null;
   RemoteFile rf = null;
   boolean flag = false;

   rf = modserver.getRemoteFile();
   if(rf.mkdir(webaccessDir)) System.out.println("Web Directory is created!!!!!");
   else System.out.println("Web Directory is existed!!!!!");

   if(imgflag != null) { 
      String imgdata = request.getParameter("imgdata");

      sj=modserver.getSubmitJob();
      if(archiveType.equals("masterProblemname")) {
	 flag = true;
      } else {      	 
	cm=modserver.getContextManagerForSlave();
      }

      index = imgdata.lastIndexOf("/");
      filename = imgdata.substring(index+1);
      disp = url+filename;

      if(flag) {
         rcommand = "cp"+" "+imgdata+" "+webaccessDir+filename;
         sj.execLocalCommand(rcommand);
      } else {

         String  probDir1 = cm.getCurrentSessionProperty("Directory");
         String machine1 = cm.getCurrentSessionProperty("machineName");
         String rcommand2 = "scp"+" "+userName+"@"+machine1+":"+probDir1+"/"+filename+" "+"/tmp/"+filename;
         String rcommand3 = "cp"+" "+"/tmp/"+filename+" "+webaccessDir+filename;
         String sjout = sj.execRemoteCommand(openHostname,userName,rcommand2,"rsh");
	 System.out.println("Image Data: "+ sjout);

	 /*
         try {
	      Thread.sleep(1000);
         } catch(InterruptedException e) {}
	 */      	

         sj.execRemoteCommand(openHostname,masterServerOwner,rcommand3,"rsh");
      }

   } else {	
      String problemName=storeInfo.getTableVal("problemName");
      String sessionName=storeInfo.getTableVal("sessionName");

      if(archiveType.equals("masterProblemname")) {
         cm=modserver.getContextManager();
         sj=modserver.getSubmitJob();
	 flag = true;
      } else {
      	 cm=modserver.getContextManagerForSlave();
         sj=modserver.getSubmitJobForSlave();
	 rf=modserver.getRemoteFileForSlave();
      }

      String scriptString=request.getParameter("scriptString");
      //String descRoot=application.getRealPath("/WEB-INF/Descriptors/users/")+"JSPClient/"+userName+"/"+problemName+"/"+sessionName+"/";
      //String probDir="Descriptors/users/JSPClient/"+userName+"/"+problemName+"/"+sessionName;
      String probDir = cm.getCurrentSessionProperty("Directory");
      String scriptname = cm.getCurrentSessionProperty("VtkCode");
      if(scriptname.equalsIgnoreCase("gnuplot")) scriptname = "/script.gnu";
      else scriptname = "/scriptmatlab.m";
      scriptString=getfile.removeCharacters(scriptString,"\015");

      if(flag) {

      //cm.selectSession(problemName,sessionName);
      getfile.stringToFile(scriptString,probDir+scriptname);

      } else {

        byte buffer[] = scriptString.getBytes();
        try {
	    rf.open(probDir+scriptname,"rw");
            rf.putBlock(buffer);
            rf.close();
        }catch (Exception ex) { 
            rf.close(); 
        }
      }

      filename = cm.getCurrentSessionProperty("VizOutFile");
      System.out.println("VizeReturnPage: outfile: "+filename);
      index = filename.lastIndexOf("/");
      String filename1 = filename.substring(index+1);

      if(flag) {

      rcommand = "cp"+" "+filename+".ps"+" "+probDir+"/"+filename1+".ps";
      String rcommand1 = "cp"+" "+filename+".jpg"+" "+probDir+"/"+filename1+".jpg";
      String rcommand2 = "cp"+" "+probDir+"/"+filename1+".jpg"+" "+webaccessDir+filename1+".jpg";

      String gcommand = masterServergspath+" -sDEVICE=jpeg -sOutputFile="+filename+".jpg"+" -dJPEGQ=95 -dNOPAUSE -q -dBATCH "+filename+".ps";

      String machine = cm.getCurrentSessionProperty("machineName");
      String command = cm.getCurrentSessionProperty("Vtkexecpath");
      command += " "+cm.getCurrentSessionProperty("Directory")+scriptname;

      //sj.execLocalCommand(command);
      sj.execRemoteCommand(machine,userName,command,"rsh");

      try {
	   Thread.sleep(500);
      } catch(InterruptedException e) {}
	
      sj.execRemoteCommand(machine,userName,gcommand,"rsh");

      sj.execRemoteCommand(machine,masterServerOwner,rcommand,"rsh");
      sj.execRemoteCommand(machine,masterServerOwner,rcommand1,"rsh");
      sj.execLocalCommand(rcommand2);

      } else {

      rcommand = "cp"+" "+filename+".ps"+" "+probDir+"/"+filename1+".ps";
      String rcommand1 = "cp"+" "+filename+".jpg"+" "+probDir+"/"+filename1+".jpg";

      String gcommand = slaveServergspath+" -sDEVICE=jpeg -sOutputFile="+filename+".jpg"+" -dJPEGQ=95 -dNOPAUSE -q -dBATCH "+filename+".ps";

      String machine = cm.getCurrentSessionProperty("machineName");

      String command = "#!/bin/sh \n";
      command += cm.getCurrentSessionProperty("Vtkexecpath");
      command += " -display NULL < "+probDir+scriptname+" > "+probDir+"/scriptmatlab.out";

      byte buffer1[] = command.getBytes();
        try {
	    rf.open(probDir+"/scriptmatlab.command","rw");
            rf.putBlock(buffer1);
            rf.close();
        }catch (Exception ex) { 
            rf.close(); 
        }
      String chmodCmd = "chmod 755 "+probDir+"/scriptmatlab.command";
      sj.execLocalCommand(chmodCmd);
      sj.execLocalCommand(probDir+"/scriptmatlab.command");

      sj.execLocalCommand(gcommand);
      sj.execLocalCommand(rcommand);
      sj.execLocalCommand(rcommand1);

      String rcommand2 = "scp"+" "+userName+"@"+machine+":"+probDir+"/"+filename1+".jpg"+" "+"/tmp/"+filename1+".jpg";
      String rcommand3 = "cp"+" "+"/tmp/"+filename1+".jpg"+" "+webaccessDir+filename1+".jpg";

      submitJob sj_master=modserver.getSubmitJob();
      String sjout1 = sj_master.execRemoteCommand(openHostname,userName,rcommand2,"rsh");
      System.out.println("SCP: "+sjout1);

      /*
      try {
	   Thread.sleep(1000);
      } catch(InterruptedException e) {}
      */
	
      String sjout2 = sj_master.execRemoteCommand(openHostname,masterServerOwner,rcommand3,"rsh");
      System.out.println("CP: "+sjout2);
      }
	
      String psname = filename1+".ps";
      String jpegname = filename1+".jpg";
      String ps = cm.getCurrentSessionProperty("PostScript");
      String ps1 = ps.trim();
      String jpegimage = cm.getCurrentSessionProperty("JPEGimage");
      String jpegimage1 = jpegimage.trim();
      boolean namecheckflag = true;
      String token1 = null;

      if(ps1.equals(new String())) cm.setCurrentSessionProperty("PostScript", psname+"+");
      else {
         StringTokenizer st = new StringTokenizer(ps,"+");
	 while(st.hasMoreTokens()) {
	   token1 = st.nextToken();
	   if(token1.equals(psname)) {
		namecheckflag = false;
		break;
	   }
	 }
	 if(namecheckflag) {
	   ps+=psname+"+";
	   cm.setCurrentSessionProperty("PostScript", ps);
	 }
      }

      namecheckflag = true;

      if(jpegimage1.equals(new String())) cm.setCurrentSessionProperty("JPEGimage", jpegname+"+");
      else {
         StringTokenizer st = new StringTokenizer(jpegimage,"+");
	 while(st.hasMoreTokens()) {
	    token1 = st.nextToken();
	    if(token1.equals(jpegname)) {
		namecheckflag = false;
		break;
	    }
	 }
	 if(namecheckflag) {
	    jpegimage+=jpegname+"+";
	    cm.setCurrentSessionProperty("JPEGimage", jpegimage);
	 }
      }

      disp = url+filename1+".jpg";
   }
%>
<html>
<head>
<title>Image Generator</title></head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">

<%
   if(imgflag == null) { 
%>
<center>
<h2>Job Submitted For the Visualization</h2>
</center>
<%
   } else {
%>
<center>
<h2>Image Viewer</h2>
</center>

<%
   }

   if(collflag.equals("collab")) {

      String serverName = request.getServerName(); //"birch.csit.fsu.edu";//application.getServerName();
      int serverPort = request.getServerPort(); //8001; //application.getServerPort();
      System.out.println("Server Name: "+serverName);
      System.out.println("Server Port: "+serverPort);
      String urlname = "http://"+serverName+":"+String.valueOf(serverPort)+disp;
      org.omg.CORBA.Object m1 = null;
      Collaborator coll = null;
      //boolean usercheck = true;

      /*
      String eachuser = null;
      Enumeration activeUsers = CollabManager.hashKeys();
      while(activeUsers.hasMoreElements()) {
	 eachuser = (String)activeUsers.nextElement();
	 if(eachuser.equals(userName)) {
	    usercheck=false;
	    break;
	 }
      }
      */

      System.out.println("Join session");
      m1 = CollabManager.getCollabSession(userName);
      coll = CollaboratorHelper.narrow(m1);
      //coll.test();

      //if(usercheck) {
	   coll.setUserId(userName);
	   if(!CollabManager.getControlFlag()) {
	         CollabManager.setControlFlag(true);
	         CollabManager.setControlUser(userName);
	         coll.setIsMaster(true);
  	   }
	   else { 
	         out.println("<b>Somebody has already been controlled.<BR> You can not make it......<BR> Please register as the viewing mode. <br></b>");
	         CollabManager.removeCollSession(userName);
	         return;
	   }
      //} 

      CollabManager.setSharingURL(urlname);
      CollabManager.eventListeners(userName, "sharingPages");
      coll.runfireEvent("sharingPages", "webpage");
	
      coll.setEventFlag(false);
   }

   if(imgflag == null) { 
      String filename2 = cm.getCurrentSessionProperty("DataFileOne");
      index1 =  filename2.lastIndexOf("/");
      filename2 = filename2.substring(index1+1);
      index1 = filename2.lastIndexOf(".");
      if(index1 != -1) filename2 = filename2.substring(0,index1);
      System.out.println("Wname(Viz): "+filename2);
      windowname = filename2;
   } else {

      index1 = filename.lastIndexOf(".");
      if(index1 != -1) filename = filename.substring(0,index1);
      System.out.println("Wname(Img): "+filename);
      windowname = filename;
   }

%>

<script>
     VizWindow = window.open('<%= disp %>','<%= windowname %>','width=800,height=700,toolbar=0,menubar=1,location=0,resizable=1,status=1,scrollbars=1,directories=0');	
</script>

<% 
   if(imgflag == null) { 
%>
You have submitted the job for the visualization using <%= cm.getCurrentSessionProperty("VtkCode") %>.
If you have data files more than one, You can try to visualize them
at the second window.
<% 
   } else {
%>
The image is redisplayed which you have already worked on the
visualization at this session.

<%
   }
   //Leave session for user control
   if(collflag.equals("collab")) {
       CollabManager.removeEventListeners(userName, "sharingPages");
       CollabManager.removeCollSession(userName);
       CollabManager.setControlFlag(false);
   }

   if(imgflag == null) {    
%>

<jsp:include page="Vizsubmit.jsp" flush="true"/>

<%
   } else {
%>

<hr WIDTH="100%">
<jsp:include page="Main.jsp" flush="true"/>

<%
   }
%>

</body>
</html>

