package extensions.generic;
import org.escience.XSIL.*;
import java.util.*;

public class parseXMLList extends XSIL {

  //This is for the generic wrapper object, resourceML
  public Vector appLists;
  public Vector appListsName;

  //This is for Java3DViewer for the chemical molecule
  public Vector geometries;
  public Vector geometriesName;

  //This is for SVG WhiteBoard XSIL implementation
  public Vector svgchemical;
  public Vector svgchemicalName;

  //Contruct for the dydnamic invocation
  public void construct(){

    //GOW project, resourceML
    appLists = new Vector();
    appListsName = new Vector();
    
    //Molucule Viewer
    geometries = new Vector();
    geometriesName = new Vector();
    
    //SVG WhiteBoard
    svgchemical = new Vector();
    svgchemicalName = new Vector();        
    
    XSIL x;
    for(int i=0; i<getChildCount(); i++){
      x = getChild(i);
      if(x instanceof parseXMLDesc) {
        appLists.addElement((parseXMLDesc)x);
        appListsName.addElement(x.getName());
      }

      if(x instanceof Plot3D) {
        geometries.addElement((Plot3D)x);
        geometriesName.addElement(x.getName());
      }
            
      if(x instanceof SVGChemXSIL ) {
        svgchemical.addElement((SVGChemXSIL)x);
        svgchemicalName.addElement(x.getName());
      }
    }
  }

  //GOW project, resourceML
  public Vector getParseXMLappLists() {
    return appLists;
  }
  public Vector getParseXMLappListsName() {
    return appListsName;
  }

  //Molecule Viewer
  public Vector getParseXMLgeometries() {
    return geometries;
  }
  public Vector getParseXMLgeometriesName() {
    return geometriesName;
  }

  //SVG whiteBoard
  public Vector getParseXMLsvgchemical() {
    return svgchemical;
  }  
  public Vector getParseXMLsvgchemicalName() {
    return svgchemicalName;
  }

  public String toString() {
    String ret = super.toString();
    ret += " [" + appLists.size() + " parseXMLappListDesc]"+"\n";
    ret += " [" + geometries.size() + " geometries]";
    return ret;
  }

  public String toLongString(){
    String s = toString();
    return s + "\n";
  }
}


