import java.io.*;
import java.net.*;

import ice.storm.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

import org.w3c.dom.*;
import org.w3c.dom.html.*;
import org.w3c.dom.events.*;

// HTML4 pilot, doc, DOM impl
import ice.pilots.html4.*;
import java.util.Hashtable;

public class ClientViewer 
{
  
  InetAddress shost;
  int         sport;
  private StormBase base;

  public ClientViewer(String port){
    //String tfvalue = "8586";
    registerClient(port);
    
    ClientRecvChannel receiver = new ClientRecvChannel(ClientViewer.this,port);
    receiver.start();

    base = new StormBase();
    MyCallback mycb = new MyCallback();
    mycb.controlFlag = false;
    base.setCallback(mycb);
    
      
    String style = ":link {text-decoration: none;}";
      
    DStyleSheet us = ThePilot.getUserStyleSheet();
    CSSBuilder b = new CSSBuilder();
    try {
      b.build(us,new StringReader(style),null);
    }	
    catch(Exception ex) {}
      
    String loc = "";//"http://www.gatewayportal.org";
    //if (args.length>0) loc=args[0];
      
    base.renderContent(loc,null,"demo");

  }

  public void getHostNamePort() throws IOException{
    //hardcoding, need improve server information..................
    shost = InetAddress.getByName("magnolia.csit.fsu.edu");  
    sport = 8585;
  }

    public void registerClient(String port){

	Socket socket = null;
	BufferedOutputStream ds = null;    
    
	try{
	    getHostNamePort();
	    socket = new Socket(shost,sport);
	    ds = new BufferedOutputStream(socket.getOutputStream());
	}catch(Exception e){        
	    System.out.println("err");//
	}

	String datatype = null;
	byte[] databyte = null;
	String iport = port+"\n";

	try{    
	    System.out.println("Viewer: Begin write ...........");
	    datatype = "0\n";
	    databyte = datatype.getBytes();
	    ds.write(databyte, 0, databyte.length);
	    ds.flush();

	    databyte = iport.getBytes();
	    ds.write(databyte, 0, databyte.length);
	    ds.flush();    
	    System.out.println("Viewer: End write");        
	    ds.close();
	    socket.close();
	}catch(Exception e){        
	    e.printStackTrace();
	    System.out.println("err");
	}
    }
  
  
  public synchronized void displayFromThread(String data){
    base.renderContent(data,null,"demo");
  }

  public static void main(String[] args)
  {
    
    if(args.length < 1) {
      System.out.println("Usage: java ClientViewer port");
      System.exit(0);
    }

    String port = args[0];
    new ClientViewer(port);

  }
  
}









