package EDU.syr.npac.Gateway;

import java.net.*;
import java.io.*;
import WebFlow.*;
import org.omg.CORBA.*;
import WebFlow.FileBrowser.*;

public class FBListener1 implements FileBrowserListener
{
    private gw applet;
    private FileBrowser FileBrowser;
    private ORB orb;
    
    FBListener(ORB aOrb, gw aApplet, FileBrowser aFileBrowser) {
	orb = aOrb;
	applet = aApplet;
	FileBrowser = aFileBrowser;
    }
    
    public void upload(String dest, String source){
	System.out.println("upload, dest=" + dest + ", source=" + source); 
	String servlet = "http://" + applet.jhost + ":" + applet.jport + "/servlets/GWMoveFile?";
	try {
	    String pageurl=servlet + "command=upload&dest="+dest+"&src="+source+"&rf_ior=" + orb.object_to_string(applet.getRemoteFile());
	    System.out.println(pageurl); 
	    URL docURL= new URL(pageurl);
	    applet.getAppletContext().showDocument(docURL,"GatewayHTML");
	} catch (MalformedURLException me) {System.out.println(me);}
    }
    
    public void download(String dest, String source){
	System.out.println("download, dest=" + dest + ", source=" + source);
	String servlet = "http://" + applet.jhost + ":" + applet.jport + "/servlets/GWMoveFile?";
	try {
	    String pageurl=servlet + "command=download&dest="+dest+"&src="+source+"&rf_ior=" + orb.object_to_string(applet.getRemoteFile());
	    System.out.println(pageurl); 
	    URL docURL= new URL(pageurl);
	    applet.getAppletContext().showDocument(docURL,"GatewayHTML");
	} catch (MalformedURLException me) {System.out.println(me);}
    }
    
    public void view(String full_name, String file_name) {
	URL docURL = null;
	String destFile="/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/tmp/"+file_name; 
	org.omg.CORBA.StringHolder dest = new org.omg.CORBA.StringHolder(destFile);
	FileBrowser.copyFile(full_name, dest);
	int index = dest.value.lastIndexOf('/');
	if(index != -1)
	       file_name = dest.value.substring(index + 1);
	else file_name = dest.value;
	System.out.println("fileCopied to " + destFile);
	try {
	    String pageurl= "http://" + applet.jhost + ":" + applet.jport + "/tmp/"+file_name;
	    System.out.println("url to show is: " + pageurl);
	    docURL = new URL(pageurl);
	} catch (MalformedURLException me) {System.out.println(me);}
	applet.getAppletContext().showDocument(docURL,"GatewayHTML");
    }
}
