package EDU.syr.npac.Gateway;

   import org.omg.CORBA.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import javax.swing.*; 
   import java.net.*;
   import WebFlow.*;
   import WebFlow.event.*;
   import WebFlow.xml.*;
   import WebFlow.gscript.*;
   import WebFlow.hashtable.*;
   import java.io.*;
   import java.net.*;
   import java.util.*;

   public class GatewayContext
   {
      private ORB orb;
      private WebFlowContext parent;
      private WebFlowContext thisContext;
      private String cname;
      private ContextData contextHash;

     public GatewayContext(WebFlowContext parent, String cname) {
       this.parent=parent;
       this.cname=cname;
       try {
       thisContext=WebFlowContextHelper.narrow(parent.addNewContext(cname));
       contextHash=
         ContextDataHelper.narrow(thisContext.addNewModule("ContextData"));
       } catch (Exception e) {
          System.out.println(e+ "while creating context "+cname);
       }
     }

     public WebFlowContext getContext(){
       return thisContext;
     }

     public WebFlowContext getParent(){
       return parent;
     }

     public void setParam(String name, String value){
       contextHash.setParam(name,value);
     }

     public String getParam(String name){
       return contextHash.getParam(name);  
     }
   }










