package EDU.syr.npac.Gateway;

   import java.net.*;
   import java.io.*;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
//   import EDU.syr.npac.frontend.*;
   import WebFlow.*;
   import org.omg.CORBA.*;
   import WebFlow.FileBrowser.*;

   public class TabbedPane extends JTabbedPane
   {  

      public TaskPanel taskP;
      public UserPanel userPanel; 
      gw applet;
      String userName,fileRoot,host;
      private ORB orb;
      private FileBrowserCtr FileBrowser=null;


      public TabbedPane(gw applet, String userName, String fileRoot, 
                        String host) {

	  this.applet=applet;
	  this.userName=userName;
	  this.fileRoot=fileRoot;
	  this.host=host;
	  orb = applet.getORB(); 

	  /* cannot do anything untill server is up */ 
	  int TimeOut = 100;
	  WebFlowContext sv = null;
	  boolean non_existent=true; 
	 while(TimeOut>0) {
	   try{
             sv = applet.getSlaves(host);
             non_existent=sv._non_existent();
             if(non_existent) {
               TimeOut--;
	     }
             else {
               TimeOut=-1;
	     }  
             waitForServer(100);
	   } catch (Exception exx) {
               System.out.println(exx);
               TimeOut--;
	   }
	 } 
      waitForServer(100);  //give a chance to start services

      userPanel = new UserPanel(applet,userName);
//      //FileBrowser = new FileBrowserCtr(applet,0,fileRoot);
//      System.out.println("Host: "+host+" start file browser"); 
      
      FileBrowser = new FileBrowserCtr("/", applet.getFileBrowser(), new FBListener(orb, applet, applet.getFileBrowser()));
      labelPanel dummyFB = new labelPanel(host); 
//      //      mpJobPanel JobStatus = new mpJobPanel(this,"Job Status"); 
      labelPanel JobStatus = new labelPanel("Job Status"); 
      //taskP = new TaskPanel(applet);

      addTab("User Space",userPanel); 
      //      addTab("Files",dummyFB); 
      addTab("Files",FileBrowser); 
      addTab("Jobs",JobStatus); 
      addTab("Task",taskP);
//      setSelectedComponent(userPanel); 
      System.out.println("Tabbed pane is constructed");
     }

    public synchronized void waitForServer(long delay){
	try {
           wait(delay);
	} catch(InterruptedException e){
		 System.out.println("Intrrupted exc :"+e);
	}
    }

   }






