package EDU.syr.npac.Gateway;

   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.util.*;
   import java.applet.*;
   import java.net.*;
   import WebFlow.*;
   import WebFlow.event.*;

public class UserPanel extends JPanel {

 public gw applet;
 private String userContextName;
 private Font f1,f2;
 public  String root;
 private String[] hostnames;
 private JButton[] buttons;
 private int n;
 private AppletContext ac;
 private String URLstring;      // SlaveServer servlet 
 private URL url;

  public UserPanel(gw applet, String userContextName) {
  this.applet = applet;
  this.userContextName=this.userContextName;
  ac=applet.getAppletContext();
  String user=applet.UserName;
  int l=user.length();
  user=user.substring(0,l-1); 
  URLstring = "http://"+applet.jhost+":"+applet.jport+"/servlets/SlaveServer";
  URLstring += "?UserContext="+user;
  URLstring += "&DISPLAY="+applet.Display;
  URLstring += "&pw=wiQB5o7t";
  URLstring += "&UsrConfDir=/npac/home/webflow/WEBFLOW/BeanContext_2.2/QS/";
  URLstring += "&jroot=/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/";
  URLstring += "&jhost="+applet.jhost;
  URLstring += "&jport="+applet.jport;
  URLstring += "&IOR="+applet.IOR;  
  URLstring += "&RelMasterIOR=/IOR/master.txt";

  f1=new Font("Helvetica",Font.ITALIC,12); 
  f2=new Font("Helvetica",Font.BOLD,12);
  root=applet.getRootname(); 
  setLayout(new GridLayout(8,1));
  add(new JLabel("user: "+userContextName,JLabel.CENTER));
  add(new JLabel(" "));
  add(new JLabel("root: "+root,JLabel.CENTER));
  add(new JLabel(" "));

  n=gw.hostnames.length;
  buttons = new JButton[n];

  ActionListener Blistener = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      String what = e.getActionCommand().toString();
       int idx = getHostIndex(what);
       buttons[idx].setFont(f2);    
       startNewSlave(idx,what);
       setHost(what,idx); 
    }
  };

  for(int i=0; i<n; i++) {
    buttons[i] = new JButton(gw.hostnames[i]);
    buttons[i].setFont(f1);
    if(applet.connectedHosts[i]) buttons[i].setFont(f2);   
    buttons[i].addActionListener(Blistener);
    add(buttons[i]);
  }
  }

  public void setHost(String host, int j){

    //  for(int i=0; i<n; i++) {
    // applet.cards[i].userPanel.buttons[j].setFont(f2);
    //}
   applet.addCard(host);
   applet.showCard(host);
   applet.setHostname(host);
   applet.setConnectedHost(host);
  }

  public int getHostIndex(String what){
     return applet.getHostIndex(what);
  }
   public void startNewSlave(int idx, String what) {   
      if(!applet.connectedHosts[idx]){
         try {
          url = new URL(URLstring+"&HOST="+what);
          ac.showDocument(url,"GatewayHTML");
          } 
         catch (Exception exx) {System.out.println(exx);}

         /* now get its reference */
         WebFlowContext uc=applet.getUserContext();
         org.omg.CORBA.Object[] SlaveServers = uc.toArray();
         for(int i=0; i<SlaveServers.length; i++) {
           BeanContextChild bbc=BeanContextChildHelper.narrow(SlaveServers[i]);
           String SlaveName = bbc.getObjectID();
           if(SlaveName.indexOf(what)>-1) {
             WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers[i]);
             applet.setSlaves(what,sl);
	   }
	 }
      }
   }
}







