package EDU.syr.npac.Gateway;

   import org.omg.CORBA.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import javax.swing.*; 
   import java.net.*;
   import EDU.syr.npac.frontend.*;
   import WebFlow.*;
   import WebFlow.event.*;
   import WebFlow.xml.*;
   import WebFlow.gscript.*;
   import WebFlow.hashtable.*;
   import java.io.*;
   import java.net.*;
   import java.util.*;

   public class gw extends JApplet
   {
      private int appCount_ = 0;
      private ORB orb;
      public String userName;
      public String IOR;
      private CardLayout card = new CardLayout();
      public JPanel  cP;
      private String pageurl;
      private URL docURL;
      private navigator nv;
      public AppletContext ac;
      private WebFlowContext ws = null;
      public WebFlowContext uc= null;
      private WebFlowContext ProjectContext = null;
      private WebFlowContext SessionContext = null;
      public String jhost;
      public String jport;
      public String relMasterIOR;
      public String IorUrl;
      private String hostname,rootname;
      public String Display;  
      private JTextField hostLabel; 
      public static String[] hostnames;       
      public String[] fileRoot;
      public boolean[] connectedHosts;
      public TabbedPane[] cards;
      private int n;
      private Hashtable Slaves;
      private Hashtable ht;
      private Hashtable HTMLform;
      private int FormLength;
      private String[] FormElementNames;
      private String[] FormElementValues;
      private int currentPage;
      private ContextData userHash;
      private gScript gscript;
      private XmlServer parser;
      private String ServletDir="http://osprey4.npac.syr.edu:8001/servlets/";
      private String usersDir = "/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/DESCRIPTORS/USER/";
      private String ContextDataIOR, gScriptIOR, XmlServerIOR;
      private String ApplicationName;
      private Vector AppContextList, AppContextNames;
      private ContextData ProjectContextData, SessionContextData;
      private String ProjectName, SessionName;
      private String ProjContextName, SessionContextName;
      private boolean debug=true;
      private boolean isOK;

      public void init() {

      Slaves = new Hashtable();
      AppContextNames = new Vector();

      n=4;
      hostnames = new String[n];
      hostnames[0] = "osprey2.npac.syr.edu";
      hostnames[1] = "osprey3.npac.syr.edu";
      hostnames[2] = "osprey4.npac.syr.edu";
      hostnames[3] = "osprey7.npac.syr.edu";

      fileRoot = new String[n];
      fileRoot[0]="/tmp";
      fileRoot[1]="/tmp";
      fileRoot[2]="/npac/home/webflow/QSData";
      fileRoot[3]="/tmp";

      HTMLform = new Hashtable(); 

      ht = new Hashtable();
        for (int i=0; i<4; i++) {
        ht.put(gw.hostnames[i],new Integer(i));
      } 



      connectedHosts = new boolean[n];
       
      String UC = getParameter("userContext");
      if(UC == null) {
         System.err.println("user name not defined.");
         stop();
      }
      else {
         userName = UC;
         System.err.println("user name = "+userName);
      } 

      jhost = getParameter("jhost");
      jport = getParameter("jport"); 
      relMasterIOR = "/"+getParameter("relMasterIOR");

      rootname = getParameter("host");
      hostname = rootname;

      Display = getParameter("DISPLAY");
      System.out.println("Display set to: "+Display);

      IorUrl = "http://"+jhost+":"+jport+relMasterIOR;
      System.out.println("IorUrl = "+IorUrl); 

      for(int i=0; i<n; i++) {
        if(hostnames[i].equals(rootname)) {
           connectedHosts[i]=true;
	}
        else {
           connectedHosts[i]=false;
	}
      }

      orb = ORB.init(this, new java.util.Properties());
      setUserContext(IorUrl,UC);

      /* add XML server */
      org.omg.CORBA.Object oxml = uc.addNewModule("XmlServer");
      XmlServerIOR=orb.object_to_string(oxml);
      parser = XmlServerHelper.narrow(oxml);
      parser.test();
      /* add UserHashtable */
      org.omg.CORBA.Object ohash = uc.addNewModule("ContextData");
      ContextDataIOR = orb.object_to_string(ohash);
      userHash = ContextDataHelper.narrow(ohash);
      userHash.test(); 
      /* add GaussianScript */
      org.omg.CORBA.Object og = uc.addNewModule("gScript");
      gScriptIOR = orb.object_to_string(og);
      gscript = gScriptHelper.narrow(og);
      gscript.test(); 

      nv = new navigator(this,userName);
      nv.setSize(400,150);

      System.out.println("navigator created"); 
      ac=getAppletContext();

      java.awt.Container c = getContentPane();
      getContentPane().setLayout(new BorderLayout());

      JPanel upperPanel = new JPanel();
      upperPanel.setLayout(new BorderLayout());

      JPanel bP = new JPanel();
      bP.setLayout(new GridLayout(2,2));
      JButton b1 = new JButton("Home");
      JButton b2 = new JButton("Navigator");
      JButton b3 = new JButton("Logout");
      JButton b4 = new JButton("About");

      bP.add(b1);
      bP.add(b2);
      bP.add(b3);
      bP.add(b4);

      hostLabel= new JTextField(hostname,25);
      hostLabel.setEditable(false);

      cP = new JPanel();
      cP.setLayout(card);

      System.out.println("create TabbedPane...");
     cards = new TabbedPane[n];

      System.out.println("TabbedPane created");

      for(int i=0; i<n; i++) { 
         cards[i]=null;
      } 

       System.out.println("add cards");
      addCard(rootname);      
       System.out.println("show card"); 
      showCard(rootname);

       System.out.println("make action listener");

      ActionListener Blistener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
          String what= e.getActionCommand().toString();
          if(what.equals("Navigator")) {
          nv.show();           
	  }
	  if(what.equals("Logout")) {
	    try {
              uc.removeMyself();
	    }
            catch(org.omg.CORBA.COMM_FAILURE exception) {
             System.out.println("user context deleted");
            pageurl="http://osprey4.npac.syr.edu:8001/PORTAL/Portal.html";
            try {
            docURL = new URL(pageurl);
            ac.showDocument(docURL);
            } catch (Exception ee) {System.out.println("Really? "+e);}
	    }
	  }
          if(what.equals("Home"))  {
               pageurl="http://osprey4.npac.syr.edu:8001/servlets/UserPage?userContext="+userName;
          try { 
              docURL=new URL(pageurl);
              showPage(docURL);
            } catch (Exception mo) {System.out.println(mo);}
	  }
	  if(what.equals("About")) {
            pageurl="http://www.npac.syr.edu/users/haupt/WebFlow/";
            try { 
              docURL=new URL(pageurl);
              showPage(docURL);
            } catch (MalformedURLException me) {System.out.println(me);}

	  }
      }
      };

       System.out.println("add action listener");
      b1.addActionListener(Blistener);
      b2.addActionListener(Blistener);
      b3.addActionListener(Blistener);
      b4.addActionListener(Blistener);

        System.out.println("add panels");

      upperPanel.add(BorderLayout.CENTER,bP);
      upperPanel.add(BorderLayout.SOUTH,hostLabel);
      c.add(BorderLayout.NORTH,upperPanel);
      c.add(BorderLayout.CENTER,cP);
      System.out.println("init completed");

      }
 


     public void showCard(String what){
      card.show(cP,what);
     }

     public void addCard(String host){
	 try {
      int idx=getHostIndex(host);
      cards[idx] = new TabbedPane(this,userName,fileRoot[idx],hostnames[idx]);
      cP.add(hostnames[idx],cards[idx]);
	 } catch (Exception e) {
              System.out.println(e+" while creating TabbedPane");
         }
     }

       public ORB getORB() {
         return orb;
       }


     public String getUserName() {
       return userName;

     }
     public void setUserName(String UC) {
       userName=UC;
     }

    public void showPage(URL docURL) {
    ac.showDocument(docURL,"GatewayHTML");
   }

     public void showNavigator(){
      nv.show();
	}

     public void setHostname(String host) {
       hostname = host;
       hostLabel.setText(host);
     }

     public String getHostname() {
       return hostname;
     }  

     public void setRootname(String host) {
       rootname = host;
     }

     public String getRootname() {
       return rootname;
     }  

     public void setConnectedHost(String host) {
       for (int i=0; i<n; i++) {
         if(hostnames[i].equals(host)) connectedHosts[i]=true;
       }
     }
    
    public WebFlowContext getUserContext() {
       return uc;
     }

     public void setSlaves(String host, WebFlowContext wc){
       Slaves.put(host,wc);
     }

     public WebFlowContext getSlaves(String host){
       WebFlowContext wc=(WebFlowContext)Slaves.get(host);
      return wc;
     }

     public int getHostIndex(String host){
     int idx = ((Integer)ht.get(host)).intValue();
     return idx;
   }
     public void listAppContexts() {
       AppContextList = makeListOfContexts(uc);     
       Enumeration l = AppContextList.elements();
       int numberOfElements = AppContextList.size();

       pageurl = ServletDir;
       int k=0;

       if(numberOfElements>0) {
          pageurl = ServletDir+"PSEappllist?n="+numberOfElements;
          while (l.hasMoreElements()){
           k++;
           WebFlowContext c = (WebFlowContext)l.nextElement();
           pageurl += "&c"+k+"="+c.getObjectID();
	  }
       }
       else {
          pageurl = ServletDir+"PSEappllistError";  
       }
       System.out.println(pageurl);
       callServlet(pageurl);
     }

     public Vector makeListOfContexts(WebFlowContext root) {
       // all contexts are returned, possibly of different kind!
      Vector list = new Vector();
      org.omg.CORBA.Object[] AppContextObjs=root.toArray();
      System.out.println("number of contexts === "+AppContextObjs.length);
      for(int i=0; i<AppContextObjs.length;i++) {
         WebFlow.BeanContextChild Something=null;
         Something=BeanContextChildHelper.narrow(AppContextObjs[i]);
         String ProjectContextName=Something.getObjectID();
         if(ProjectContextName.endsWith(".PC")) {
           WebFlowContext c = WebFlowContextHelper.narrow(AppContextObjs[i]);
           list.addElement(c);
	 }
      } 
      return list; 
     }


     public void setFormLength() {
      System.out.println("setFormLength: parameter needed!");
     }

     public void setFormLength(String nstring) {
      System.out.println("start setFormLenghth");
     int n=0;
       try {
         n=Integer.parseInt(nstring); 
	   }
       catch (Exception e) { System.out.println(e);} 
      FormLength = n;
      FormElementNames = new String[n];  
      FormElementValues = new String[n];
      System.out.println("(String) new form of length "+n);
     }

     public void addFormElement(int i, String name, String value) {
       FormElementNames[i]=name;
       FormElementValues[i]=value;
       System.out.println("add element: "+name+" = "+value);

       HTMLform.put(name,value);

       if(name.equals("page")) {
	 try {
            currentPage = Integer.parseInt(value);
	 }
	 catch (NumberFormatException nfe) {System.out.println(nfe);}
       }
     }


     public void forwardLink() {
      System.out.println("forwardLink called");
     }

     public void forwardLink(String page) {
      int i=0; 
       try {
         i = Integer.parseInt(page);
       } catch (Exception e) {System.out.println(e);} 
      currentPage = i;
      FormLength=0;
      System.out.println("?? process page "+currentPage); 
      forwardForm();
     }

     public void forwardForm() {
      System.out.println("forwardForm: #params = "+FormLength);
      
      for (int i=0; i<FormLength; i++) {
          System.out.println(FormElementNames[i]+" = "+FormElementValues[i]);
      }
      
      switch(currentPage) {

      case 0:
          pageurl=ServletDir+"PSEproblem";
          callServlet(pageurl);
          break;

      case 1:
	{
          //creates a new project  
          //returns select session page
 
          // read data from the HTML form

          System.out.println("start processing page 1");

          if(FormLength>0) {

          System.out.println("Form Lenght: "+FormLength);
          ProjContextName = (String)HTMLform.get("ProjectContextName");


          ProjContextName=removeSpaces(ProjContextName);
          ProjectName=setShortName(ProjContextName);

 
          System.out.println(ProjContextName);
          // format ProjContextName for display
           ProjectName = ProjContextName;
           int idx=ProjectName.lastIndexOf("/");
           ProjectName = ProjectName.substring(idx+1);

          System.out.println(ProjectName);
	   // make it easier to identify an ProjectContext
          ProjContextName += ".PC";

          // verify that this project name does not already exist 
          // to be done

          // set the project as the current one
          userHash.setParam("Project",ProjContextName);

          // create a new ProjectContext
          try {
          ProjectContext=WebFlowContextHelper
               .narrow(uc.addNewContext(ProjContextName)); 

          // add ContextData module to the newly created context
          ProjectContextData = 
            ContextDataHelper.narrow(ProjectContext.addNewModule("ContextData"));
          //  store Context name in the ContextData 
          //  ProjectName is fully qualified context name +.PC
          //  Project is what the user entered without spaces  

          ProjectContextData.setParam("ProjectName",ProjContextName); 
          ProjectContextData.setParam("Project",ProjectName); 
	  } catch (Exception e) { System.out.println(e);}

          // processing of form 1 completed
          if(debug) System.out.println("ProjectContext created");
	  }

          // call servlet that ask for application

          if(ProjectContextData!=null) {
	    if(ProjectContextData.containsKey("SimpleName")) {
              pageurl = ServletDir+"PSEapplication?Project="+ProjectName;
	    }
            else {
            pageurl = ServletDir+"PSEapplicationError";
            System.out.println("This should never happen: no SimpleName Key");
	    }
	  }
          else {
            pageurl = ServletDir+"PSEapplicationError";
	  }

	  //pageurl="http://dev1.ccl.net/cgi-bin/psetest?dupa=jas&baba=jaga";
          //pageurl="http://osprey4.npac.syr.edu:8001/psetest.html";
          //pageurl="http://osprey4.npac.syr.edu:8001/cgi-bin/psetest.cgi?dupa=jas&baba=jaga"; 
          callServlet(pageurl); 

          break;
	}

      case 11:
	{
	  // adds a new session to the ProjectContext  
          if(debug) System.out.println("start processing page 11");

          if(FormLength>0) {

          if(debug) System.out.println("Form Lenght: "+FormLength);
          SessionContextName = (String)HTMLform.get("SessionContextName");

          SessionContextName=removeSpaces(SessionContextName);   
          SessionName=setShortName(SessionContextName);
 	   // make it easier to identify an SessionContext
          SessionContextName += ".SC";

          // verify that this session name does not already exist 
          // to be done

          // set the project as the current one
          userHash.setParam("Session",SessionContextName);

          // create a new SessionContext
          try {
          SessionContext=WebFlowContextHelper
               .narrow(uc.addNewContext(SessionContextName));

          //  add ContextData module to newly created context
          SessionContextData = 
            ContextDataHelper.narrow(SessionContext.addNewModule("ContextData"));
          //  store Context name in the ContextData 
          //  SessionName is fully qualified context name +.SC
          //  Session is what the user entered without spaces (shortName)
          //  Project is the current project (shortName)  
          ProjectContextData.setParam("SessionName",SessionContextName); 
          ProjectContextData.setParam("Session",SessionName); 
          ProjectContextData.setParam("Project",ProjectName); 
	  } catch (Exception e) { System.out.println(e);}

          // processing of form 11 completed
          if(debug) System.out.println("SessionContext created");
	  }


          // now prepare for the next form
          // call servlet that asks for application(s)
          // servlet name is PSEapplication 
          // parameters: ProjectName, SessionName
          // eventually it will be replaced by PSE

          if(currentProject()) {
	    if(currentSession()) {
              if(sessionOfProject()) {
                  ProjectName=SessionContextData.getParam("Project");
                  SessionName=SessionContextData.getParam("Session"); 
                  pageurl=ServletDir+"PSEsession?Project="+ProjectName;  
                  pageurl+="&Session="+SessionName;
	      }
	    }
	  }

         callServlet(pageurl); 
         break; 
	}

      case 2: 
	{
	  // adds an application to the application contexts
          // returns select input page        

         String appl="";
	 if(FormLength>0) {
	   //you came from PSEapplication servlet
         appl = (String)HTMLform.get("application");
         int idx = appl.indexOf("."); 
         ApplicationName=appl.substring(0,idx);
         System.out.println("Application: "+ApplicationName); 
         ProjectContextData.setParam("Code",ApplicationName);
         ProjectContextData.setParam("ApplDesc",appl);
         System.out.println("Code and ApplDesc set");
	 }
         else {
          System.out.println("case:2 Oops! FormLength=0");
	 }	
         /*
         else {
           //you came from Select Project button
	   if(userHash.containsKey("ApplDesc")) {
                 appl = userHash.getParam("ApplDesc");
	    }
	    else { appl="";}
	  }
	  */

	 /*
	 // call Servlet that asks for machine
          if(ApplicationName.length()>0) {
             pageurl=ServletDir+"PSEcode?appl="+appl+"&xmlIOR="+XmlServerIOR;
          }
          else {
             pageurl = ServletDir+"PSEcodeError";
	  } 
	  */

         if(ProjectContext==null) {
	    // project is not defined
            pageurl = ServletDir+"PSEprojectError";
	 } 
         else {
           if(ProjectContextData.containsKey("SimpleName")) {
	      String SimpleName = ProjectContextData.getParam("SimpleName");
              System.out.println("SimpleName? "+SimpleName);
	      if(ProjectContextData.containsKey("Code")) {  
                 ApplicationName = ProjectContextData.getParam("Code");
                 System.out.println("case 2:OK"); 
                 // everything is OK; ask for input file
                 pageurl=ServletDir+"PSEinput?appl="+ApplicationName;
                 pageurl+="&Project="+SimpleName; 
	      }
              else {
	          // the application has not been selected
                  pageurl=ServletDir+"PSEinputError?appl="+SimpleName;
	      }
	   }
           else {
	      // the project has not been set up proprely
              System.out.println("This should never happen!!!");
              pageurl=ServletDir+"PSEprojectError";
	   }
	 }
          callServlet(pageurl);
          break;
	}             
      case 12:
	{
          // process select host page
          // returns select job page

         String userDir = usersDir+userName+"/";
         String inputFile = "";

         String machine="";
	 if(FormLength>0) {
           machine =  (String)HTMLform.get("target");
           ProjectContextData.setParam("target",machine);
	 }
	  else {
           if(ProjectContextData.containsKey("target")) {
                machine = ProjectContextData.getParam("target");
                System.out.println(machine);
	   }
	   else {
                System.out.println("Case 12: no target key");
                machine = "";
	   }
	  }

         if(ProjectContextData.containsKey("SimpleName")) {
           ProjectName=ProjectContextData.getParam("SimpleName");
	 }
         else System.out.println("Case 12: no SimpleName Key"); 


         if(ProjectContextData.containsKey("InputFile")) {
           inputFile=ProjectContextData.getParam("InputFile");
	 }
         else System.out.println("Case 12: no inputFile Key"); 

         if(ProjectContextData.containsKey("ApplDesc")) {
                 ApplicationName = ProjectContextData.getParam("ApplDesc");
         }
         else { 
                 ApplicationName="";
                 System.out.println("Case 12: no ApplDesc key");
	 }
               

         if(ApplicationName.length()>0) {
            if(machine.length()>0) { 
              pageurl = ServletDir+"PSEaTask?appl="+ApplicationName;
              pageurl += "&target="+machine;
              pageurl += "&inputFile="+inputFile;
              pageurl += "&userDir="+userDir;
              pageurl += "&xmlIOR="+XmlServerIOR;
              pageurl += "&Project="+ProjectName;  
	    }
            else {
              pageurl = ServletDir+"PSEinputError?appl="+ApplicationName;
	    }
	 }
         else {
              pageurl = ServletDir+"PSEcodeError";
	 } 

         callServlet(pageurl);
         break; 
	}          

      case 3:
	{
          // process select input
          // returns submit job page

         String inputFile; 
         System.out.println("start processing page3");
         inputFile = (String)HTMLform.get("InputFile");
         ProjectContextData.setParam("InputFile",inputFile);
         String appl=""; 
         
         if(ProjectContextData.containsKey("ApplDesc")) {
            appl=ProjectContextData.getParam("ApplDesc");
	 }
         else System.out.println("Case 3: no ApplDesc Key"); 
         
         if(ProjectContextData.containsKey("SimpleName")) {
           ProjectName=ProjectContextData.getParam("SimpleName");
	 }
         else System.out.println("Case 3: no SimpleName Key"); 

         if(ProjectContextData.containsKey("InputFile")) {
           inputFile=ProjectContextData.getParam("InputFile");
	 }
         else System.out.println("Case 3: no inputFile Key"); 

         pageurl= ServletDir+"PSEcode?appl="+appl+"&xmlIOR="+XmlServerIOR;
         pageurl += "&Project="+ProjectName;
         pageurl += "&inputFile="+inputFile;
         callServlet(pageurl);
         break;
	}          
      case 4:
	{
	  // generate ATD
         String inputFile="";
         String RSL=(String)HTMLform.get("RSL");
         String JobDir=(String)HTMLform.get("JobDir");
         if(ProjectContextData.containsKey("InputFile")) {
            inputFile=ProjectContextData.getParam("InputFile");
	 }
         else System.out.println("Case 4: no InputFile Key");
         String FullJobDir = usersDir+"/"+userName+"/"+JobDir;

         

           if(RSL.indexOf("script:")>-1) {
             System.out.println(RSL);
             gscript.createScript(FullJobDir+"/Gauss.txt",userName,inputFile,
             JobDir);

         String jobURL="http://"+jhost+":"+jport+"/DESCRIPTORS/USER/"+userName+"/"+JobDir+"/Gauss.txt";
             pageurl = ServletDir+"PSEscript?";
             pageurl += "JobDir="+FullJobDir+"&RSL=do_not_know_yet";
             pageurl += "&jobURL="+jobURL; 
	   }
           else {
             pageurl = ServletDir+"PSEsubmit?"; 
             pageurl += "JobDir="+JobDir+"&RSL="+RSL;
         pageurl="http://osprey4.npac.syr.edu:8001/PSE/result.html";
	   } 

          // submit
          callServlet(pageurl);
          break;
	}
	case 21: 
	  {
            // select ApplicationContext
           AppContextList = makeListOfContexts(uc);     
           Enumeration l = AppContextList.elements();
           int numberOfElements = AppContextList.size();

           ProjectContext = null; 
           
           if(numberOfElements>0) {
              while (l.hasMoreElements()){
                WebFlowContext c = (WebFlowContext)l.nextElement();
                String thisAppl = c.getObjectID();
                if(((String)HTMLform.get(thisAppl)).equals("true")) {
                ProjectContext = c;
                userHash.setParam("Project",thisAppl);               
	        }
	      }
	   }
           else {
               pageurl = ServletDir+"PSEappllistError";  
               callServlet(pageurl);
	   }
	   if(ProjectContext==null) {
              pageurl = ServletDir+"PSEappllistError1";
              callServlet(pageurl);
	   } 
            
          System.out.println("SelectedContext: "+ProjectContext.getObjectID());
          System.out.println("now set parameters");
          //find ProjectContextData
          ProjectContextData=null;
          org.omg.CORBA.Object[] ACobjs = ProjectContext.toArray();
               for(int i=0; i<ACobjs.length;i++) {
                 WebFlow.BeanContextChild Something=null;
                 Something=BeanContextChildHelper.narrow(ACobjs[i]);
		 if((Something.getObjectID()).indexOf("ContextData")>-1) {
                   ProjectContextData=ContextDataHelper.narrow(ACobjs[i]);
		 } 
	       }
	  if(ProjectContextData==null) {
            System.out.println("Context data not found!");
	  }
          else {
            if(ProjectContextData.containsKey("AppName")) {
               String aName = ProjectContextData.getParam("AppName");
               System.out.println("ApplicationContext name: "+aName);
               ProjectName = ProjectContextData.getParam("SimpleName");
               System.out.println("Application name: "+ProjectName);
	    }
            else {
               System.out.println("No AppName Key");
	    }                     
          pageurl = ServletDir+"PSEapplication?Project="+ProjectName;
          callServlet(pageurl); 
          break;	  }
	  }  
      case 35:
        { System.out.println("Hey, I got it!");
	} 
      default: 
	{ System.out.println("Oops, unknown case "+currentPage);} 
      } 
      
      System.out.println("--- end of forwardForm");
     }


     public void callServlet(String pageurl) {

	  try {
            System.out.println(pageurl);
            docURL = new URL(pageurl);
            ac.showDocument(docURL, "GatewayHTML");
          } catch (Exception ee) {System.out.println("Really? "+ee);}
     }

    public void setUserContext(String IorUrl, String userName) {
      uc=null;

      /* connect to the master */

      System.out.println(IorUrl);
      try {
      java.net.URL url = new java.net.URL(IorUrl);       
      InputStream istream;
      String ref = "";

      System.out.println("open stream");   
      try {
       istream = url.openStream();
       BufferedReader in = new BufferedReader(new InputStreamReader(istream));
       ref = in.readLine();
       istream.close();
  
        
      System.out.println("read:"+ref);   
       try {  
       org.omg.CORBA.Object MasterObj=orb.string_to_object(ref);
        if(MasterObj == null) {
          System.out.println("Master is null ??????");
        }
        else {
          System.out.println("MasterObj is OK");
        }
         
	 ws = WebFlowContextHelper.narrow(MasterObj);
        if(MasterObj == null) System.out.println("Oops: MasterObj is null!");
        System.out.println("Master narrowed");
     

       }catch(Exception e) {
         System.out.println("CORBA problem: "+e);
       }
      }
       catch(IOException e) { 
         System.out.println("stream problem: "+e);
      }
      }
      catch (Exception urle) {System.out.println("URL problem"+urle);}


      /* find the user context */

      org.omg.CORBA.Object[] SlaveServers = ws.toArray();
      for(int i=0; i<SlaveServers.length; i++) {
          System.out.println(i);
          WebFlow.BeanContextChild Something=null;
          Something =BeanContextChildHelper.narrow(SlaveServers[i]);
             if(Something.isWFServer()) {
               System.out.println("is a WebServer");            
               WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers[i]);
               String SlaveName = sl.getObjectID();
               if(SlaveName.indexOf(userName)>-1) {
                     uc=sl;
                     setSlaves(rootname,uc);
	       }
              System.out.println("endif");
	     }
      }

      if(uc._non_existent()) System.out.println("Oops: cannot connect to the user context !!!!");
      System.out.println("setUserContext completed");
      IOR=orb.object_to_string(uc);

      /* now check if any slaves are running */
       org.omg.CORBA.Object[] SlaveServers1 = uc.toArray();
       if(SlaveServers1.length>0) {
         for(int i=0; i<SlaveServers1.length; i++){
           System.out.println(i);
          WebFlow.BeanContextChild Something=null;
          Something =BeanContextChildHelper.narrow(SlaveServers1[i]);
              System.out.println(Something.getObjectID()); 
             if(Something.isWFServer()) {  
               System.out.println("is a WeBFlow server");           
              WebFlowContext bcc=WebFlowContextHelper.narrow(SlaveServers1[i]);
              String SlaveName = bcc.getObjectID();

                for(int j=0; j<n; j++) {
	          if(SlaveName.indexOf(userName+"./"+hostnames[j])>-1) {
                     WebFlowContext sl = WebFlowContextHelper.narrow(bcc);
                     setConnectedHost(hostnames[j]);
                     setSlaves(hostnames[j],sl);
	          }
		}
               System.out.println("for done");  
	     }
           System.out.println("isWFServer done");  
	 }
         System.out.println("for over childs done");
       }
    System.out.println("setUserContext completed");
    }


     // -------- utilities ---------------------------------------

          public String removeSpaces(String name){ 
          // if name contains spaces replace them by _
          String oldName = name; 
          while(oldName.indexOf(' ')>-1) {
            StringBuffer sb = new StringBuffer(oldName);
            int idx1=oldName.indexOf(' ');
            sb.setCharAt(idx1,'_');
            oldName=new String(sb); 
	   }
           String newName=oldName;
           return newName; 
          } 

          public String setShortName(String ContextName){
          // format ContextName for display
           String ShortName = ContextName;
           int idx=ShortName.lastIndexOf("/");
           ShortName = ShortName.substring(idx+1);
           return ShortName; 
	  }

      public boolean currentProject(){
          // what is the current project?
	  // return false if no current project
	  // WARNING: it operates on global variables 

          boolean x = false;   
          if(userHash==null) {
	     //this cannot happen! something is screwed up badly
             pageurl = ServletDir+"Error?where=currentProject";
             pageurl += "&what=noProjContextData";
	  }
          else {
	    if(userHash.containsKey("Project")) {
                ProjContextName=userHash.getParam("Project");
                if(ProjectContextData==null) { 
                   ProjectName=ProjectContextData.getParam("Project");
                   x=true; 
                }
                else {
                   pageurl = ServletDir+"Error?where=currentProject";
                   pageurl += "&what=noProjContextData";
	        }      
            }
            else {
	       // no current project        
                pageurl = ServletDir+"PSEprojectError";
	    }
	  }
        return x;
      }

      public boolean currentSession(){
          // what is the current session?
	  // return false if no current session
	  // WARNING: it operates on global variables 

          boolean x = false;   
          if(userHash==null) {
	     //this cannot happen! something is screwed up badly
             pageurl = ServletDir+"Error?where=currentSession";
             pageurl += "&what=no+userHash";
	  }
          else {
	    if(userHash.containsKey("Session")) {
                SessionContextName=userHash.getParam("Session");
                if(SessionContextData==null) { 
                   SessionName=SessionContextData.getParam("Session");
                   x=true; 
                }
                else {
                   pageurl = ServletDir+"Error?where=currentSession";
                   pageurl += "&what=no+SessionContextData";
	        }      
            }
            else {
	       // no current session        
                pageurl = ServletDir+"PSEsessionError?Project="+ProjectName;
	    }
	  }
        return x;
      }

      public boolean sessionOfProject(){
          // is the SessionContextData consistent with the userHash?
	  // if not this may mean that this SessionContexData belongs
	  // to other SessionContext
	  // returns false if not consistent
	  // WARNING: it operates on global variables 

          boolean x = false;
          if(SessionContextData==null) {
             pageurl = ServletDir+"Error?where=sessionOfProject";
             pageurl += "&what=no+SessionContextData";
	  }
          else {
             String sname=SessionContextData.getParam("SessionName"); 
             if(SessionContextName.equals(sname)) {
               String pname=SessionContextData.getParam("Project");
               if(pname.equals(ProjectName)) {
                  x=true; 
	       }
               else {     
                  pageurl = ServletDir+"Error?where=sessionOfProject";
                  pageurl += "&what=wrong+project+name";
                  System.out.println(ProjectName+" "+pname);
	       }
	     }
             else {
                pageurl = ServletDir+"Error?where=sessionOfProject";
                pageurl += "&what=wrong+session+context+name";
                System.out.println(SessionContextName+" "+sname);
	     } 
	  }
          return x;
      }

   }




