package EDU.syr.npac.frontend;


import java.awt.*;

import java.awt.event.*;

import EDU.auburn.VGJ.*;

import EDU.auburn.VGJ.gui.GraphWindow;

import org.omg.CORBA.*;

import WebFlow.*;

import WebFlow.QS.*;

import WebFlow.event.*;

import java.net.*;

import java.io.*;



public class controls2 extends controls {
  String what;

  String[] args;

  ORB orb;

  Editor edt;

  String ref;  

  boolean URLready;

  private Thread runner;
  int mversion;

  public controls2(String host, int port, GraphWindow GWindow, int n) {
  super(host,port,GWindow);
  System.err.println("start controls2");
  System.out.println("HOST="+host+" PORT="+port);  
  mversion = n+1;

  setLayout(new BorderLayout());
  setBackground(Color.white);
  Label l1 = new Label("Select editor",Label.CENTER);
  l1.setFont(new Font("SansSerif",Font.BOLD,14));
  add(BorderLayout.NORTH,l1);

  Panel ed = new Panel();
  ed.setLayout(new GridLayout(4,1));

  Choice ch = new Choice();
  ch.addItem("notepad");
  ch.addItem("emacs");

  ItemListener clistener =  new ItemListener() {

    public void itemStateChanged(ItemEvent e) {

      String what= e.getItem().toString();

      //setValue("EDIT"+what);

      edt.setEditor(what);
      //edt.run();
    }             
  };

  ch.addItemListener(clistener);
  ed.add(ch);
  ed.add(new Label(" ",Label.CENTER));
  //  Label l2 = new Label("2",Label.CENTER);
  //ed.add(l2);
  Button runButton = new Button("Run");

  ActionListener blistener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        edt.run();
      }
  };
  runButton.addActionListener(blistener);
  ed.add(runButton);
  ed.add(new Label("3 ",Label.CENTER));
  add(BorderLayout.CENTER,ed);

  }

    public static String  getIORFromURL(String url) {




	System.out.println("Slave WebFlow is getting IOR from url:"+url);




	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {




        URL u = new URL(url);
        // now turn the URL into a DataInputStream




        try {




          DataInputStream theHTML = new DataInputStream(u.openStream());




          try {
            while ((thisLine = theHTML.readLine()) != null) {
	    //System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;




            } // while loop ends here
          }  // end try

          catch (Exception e) {

	      //System.out.println("configReader:getIORfromURL:"+e);

          }

        } // end try

        catch (Exception e) {

	    //System.out.println("configReader:getIORfromURL:"+e);

        }



      } // end try

      catch (MalformedURLException e) {

        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");

        System.out.println("configReader:getIORfromURL:"+e);

      }

      

      return masterServerIOR;

     

    }



    public synchronized void waitForURL(){

        System.err.println("waiting... "+mversion);

	try {

           wait(2000);

	} catch(InterruptedException e){

		 System.out.println("Intrrupted exc :"+e);

	}

    }



  public void start(){

  if(runner==null){

      runner=new Thread(this);

      runner.start();

    }

  }



  public void stop(){

    if(runner!=null){

    runner.stop();

    runner=null;

    }

  }



    public void run() {

  /* get access to ORB */

  args = new String[1];

  //  args[0]="http://128.230.21.212:8001/IOR/master.txt";

  args[0]="http://134.164.35.154:8001/IOR/master.txt";

  System.out.println(args[0]);

    try {

    System.out.println("controls2: get applet...");

    VGJ a = GWindow.applet;

    System.out.println("controls2: get orb...");

    orb = a.getORB();

    //no, this comes from middle-tier String ref = a.getModRef("FileBrowser");
    //get it from the WebServer instead
//String webIOR = "http://128.230.21.212:8001/IOR/QS/EditFile"+mversion+".txt";
  String webIOR = "http://134.164.35.154:8001/IOR/QS/EditFile"+mversion+".txt";
  System.out.println(webIOR);
    // must wait till the file is written...
    // remember to delete it on exit!

    URLready = false;

  

    java.net.URL url = new java.net.URL(webIOR);

    InputStream istream;

  

 while(!URLready) {

    try {

      istream = url.openStream();

  		BufferedReader in = new BufferedReader(new InputStreamReader(istream));

  	 	ref = in.readLine();

  		istream.close();

                URLready = true;

      }

    catch(IOException e) {

      waitForURL();

      }

  }

    

    org.omg.CORBA.Object m_obj=orb.string_to_object(ref);

    if(m_obj == null) {

       System.out.println("m_obj is null ??????");

    }

    else {

       System.out.println("m_obj is OK");

    }

   
    edt = EditorHelper.narrow(m_obj);

    if(edt == null) throw new RuntimeException();

    System.out.println("controls2: Editor OK");

    }catch(Exception e) {

     System.out.println(e);

    }
   
    }
}









