package EDU.syr.npac.frontend;


import java.awt.*;
import java.awt.event.*;
import EDU.auburn.VGJ.*;
import EDU.auburn.VGJ.gui.GraphWindow;
import org.omg.CORBA.*;
import WebFlow.*;
import WebFlow.QS.*;
import WebFlow.event.*;
import java.net.*;
import java.io.*;

public class EditFileCtr extends controls {
  String what;
  Editor edt;
  boolean URLready;
  private Thread runner;
  int mversion;
  String IPaddress;

  public EditFileCtr(String host, int port, GraphWindow GWindow, int n) {
  super(host,port,GWindow);
  mversion = n+1;
  System.err.println("start EditFileCtr");
  System.out.println("HOST="+host+" PORT="+port);  

  setLayout(new BorderLayout());
  setBackground(Color.white);
  Label l1 = new Label("Select editor",Label.CENTER);
  l1.setFont(new Font("SansSerif",Font.BOLD,14));
  add(BorderLayout.NORTH,l1);

  Panel ed = new Panel();
  ed.setLayout(new GridLayout(4,1));

  Choice ch = new Choice();
  ch.addItem("notepad");
  ch.addItem("emacs");
  ch.addItem("remote emacs");
  ch.addItem("remote vi");
  ch.addItem("aga emacs");

  ItemListener clistener =  new ItemListener() {
    public void itemStateChanged(ItemEvent e) {
      String what= e.getItem().toString();
      //setValue("EDIT"+what);
      edt.setEditor(what);
      if(what.startsWith("remote")) {
        //find out what is the IP address to be used by X-windows
        try {
        InetAddress localHost = InetAddress.getLocalHost();
        IPaddress = localHost.getHostAddress();
        } catch (UnknownHostException uhe){System.err.println(uhe);}
        System.out.println("display="+IPaddress);
        edt.setDisplay(IPaddress);
      }
      //edt.run();
    }             
  };
  ch.addItemListener(clistener);
  ed.add(ch);
  ed.add(new Label(" ",Label.CENTER));
  //  Label l2 = new Label("2",Label.CENTER);
  //ed.add(l2);
  Button runButton = new Button("Run");

  ActionListener blistener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        edt.run();
      }
  };
  runButton.addActionListener(blistener);
  ed.add(runButton);
  ed.add(new Label("3 ",Label.CENTER));
  add(BorderLayout.CENTER,ed);

  }
  
  public synchronized void waitForURL(){
        System.err.println("EditFileCtr: waiting... "+mversion);
	try {
           wait(2000);
	} catch(InterruptedException e){
		 System.out.println("Intrrupted exc :"+e);
	}
    }

/*  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }*/

    public void run() {
  /* get access to ORB */
    try {
      String webIOR = Config.getHost() + "/IOR/QS/" + Config.getUserName() + "EditFile"+mversion+".txt";
      System.out.println("EditFileCtr is waiting for " + webIOR);
    // must wait till the file is written...
    // remember to delete it on exit!
      URLready = false;
      java.net.URL url = new java.net.URL(webIOR);
      InputStream istream;
      String ref = "";
  
        while(!URLready) {
          try {
            istream = url.openStream();
        		BufferedReader in = new BufferedReader(new InputStreamReader(istream));
        	 	ref = in.readLine();
        		istream.close();
            URLready = true;
            }
          catch(IOException e) {
            waitForURL();
            }
        }
          
        org.omg.CORBA.Object m_obj=Config.getORB().string_to_object(ref);
        if(m_obj == null) {
          System.out.println("EditFileCtr: m_obj is null ??????");
        }
        else {
          System.out.println("EditFileCtr: m_obj is OK");
        }
         
        edt = EditorHelper.narrow(m_obj);
        if(edt == null) throw new RuntimeException();
        System.out.println("EditFileCtr: Editor OK");
    }catch(Exception e) {
     System.out.println(e);
    }
   
    }
}



