package EDU.syr.npac.frontend;

import java.awt.*;
import java.awt.event.*;
import EDU.auburn.VGJ.*;
import EDU.auburn.VGJ.gui.GraphWindow;
import org.omg.CORBA.*;
import WebFlow.*;
import WebFlow.QS.*;
import WebFlow.event.*;
import java.net.*;
import java.io.*;

public class controls2 extends controls {
  
  String what;
  String[] args;
  ORB orb;
  Editor edt;
  String ref;  
  boolean URLready;
  private Thread runner;

  controls2(String host, int port, GraphWindow GWindow) {
  super(host,port,GWindow);
  System.err.println("start controls2");


  setLayout(new BorderLayout());
  setBackground(Color.blue);
  Label l1 = new Label("Select your editor",Label.CENTER);
  l1.setFont(new Font("SansSerif",Font.BOLD,14));
  add(BorderLayout.NORTH,l1);

  Panel ed = new Panel();
  ed.setLayout(new GridBagLayout());

  GridBagConstraints c = new GridBagConstraints();
  c.fill = GridBagConstraints.HORIZONTAL;
  c.insets = new Insets(5,5,5,5);

  c.gridx=0; c.gridy=0;
  ed.add(new Label(" "),c);
  c.gridx=0; c.gridy=1;
  ed.add(new Label(" "),c);
  c.gridx=0; c.gridy=2;
  ed.add(new Label(" "),c);

  c.gridx=0; c.gridy=3; c.gridwidth=1; c.gridheight=1;
  c.weightx = c.weighty = 1.0; 

  Label l2 = new Label("predefined",Label.CENTER);
  l2.setFont(new Font("SansSerif",Font.BOLD,12));
  ed.add(l2,c);

  c.gridx=0; c.gridy=4;

  Choice ch = new Choice();
  ch.addItem("notepad");
  ch.addItem("/usr/npac/bin/emacs");
  ch.addItem("/bin/vi");

  ItemListener clistener =  new ItemListener() {
    public void itemStateChanged(ItemEvent e) {
      String what= e.getItem().toString();
      //setValue("EDIT"+what);
      edt.run();
    }             
  };
  ch.addItemListener(clistener);
  ed.add(ch,c);

  c.gridx=0; c.gridy=5;
  ed.add(new Label(" "),c);

  c.gridx=0; c.gridy=6;

  Label l3 = new Label("or add your favorite",Label.CENTER);
  l3.setFont(new Font("SansSerif",Font.BOLD,12));
  ed.add(l3,c);

  c.gridx=0; c.gridy=7;
  TextField textfield = new TextField(20);
  textfield.addActionListener(new ActionListener() {
   public void actionPerformed(ActionEvent e) {
   what = ((TextField)e.getSource()).getText();
      setValue("EDIT"+what);
   }
   });
   ed.add(textfield,c);
   
   add(ed);

  }
    public static String  getIORFromURL(String url) {



	System.out.println("Slave WebFlow is getting IOR from url:"+url);



	String masterServerIOR="";



	String thisLine=null;



	//Open the URL for reading



      try {



        URL u = new URL(url);



        // now turn the URL into a DataInputStream



        try {



          DataInputStream theHTML = new DataInputStream(u.openStream());



          try {



            while ((thisLine = theHTML.readLine()) != null) {



              System.out.println("configReader:getIORfromURL:line"+thisLine);



		  masterServerIOR += thisLine;



            } // while loop ends here



          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
      
      return masterServerIOR;
     
    }

    public synchronized void waitForURL(){
        System.err.println("waiting...");
	try {
           wait(2000);
	} catch(InterruptedException e){
		 System.out.println("Intrrupted exc :"+e);
	}
    }

  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }

    public void run() {
  /* get access to ORB */
  args = new String[1];
  args[0]="http://128.230.21.212:8001/IOR/master.txt";
  System.out.println(args[0]);
    try {
    System.out.println("controls2: get applet...");
    VGJ a = GWindow.applet;
    System.out.println("controls2: get orb...");
    orb = a.getORB();

    //no, this comes from middle-tier String ref = a.getModRef("FileBrowser");
    //get it from the WebServer instead

    String webIOR = "http://128.230.21.212:8001/IOR/QS/EditFile.txt";

    // must wait till the file is written...
    // remember to delete it on exit!

    URLready = false;
  
    java.net.URL url = new java.net.URL(webIOR);
    InputStream istream;
  
 while(!URLready) {
    try {
      istream = url.openStream();
  		BufferedReader in = new BufferedReader(new InputStreamReader(istream));
  	 	ref = in.readLine();
  		istream.close();
                URLready = true;
      }
    catch(IOException e) {
      waitForURL();
      }
  }
    
    org.omg.CORBA.Object m_obj=orb.string_to_object(ref);
    if(m_obj == null) {
       System.out.println("m_obj is null ??????");
    }
    else {
       System.out.println("m_obj is OK");
    }

    edt = EditorHelper.narrow(m_obj);
    if(edt == null) throw new RuntimeException();
    System.out.println("controls2: Editor OK");
    }catch(Exception e) {
     System.out.println(e);
    }
    }
}



