package EDU.syr.npac.frontend;

import EDU.syr.npac.frontend.FileBrowserUtil.*;
import WebFlow.*;
import WebFlow.QS.*;
import java.util.*;
import WebFlow.event.*;
import EDU.auburn.VGJ.*;
import EDU.auburn.VGJ.gui.*;

import javax.swing.JTextArea;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.*;
import javax.swing.tree.*;

import org.omg.CORBA.*;

public class SaveAsCtr extends controls{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  Panel p;
  public static String InitialRootDir="/home/T11F/webflow/QSData";
  public String fileSeparator="/";
  int mversion;
  //Back-End module reference
  public SaveAs fileBrowser;
  String[] args;
  ORB orb;
  String user;
  String ref;
  boolean URLready;
  private Thread runner;

  public SaveAsCtr (String host, int port, GraphWindow GWindow, int n) {
    super(host,port,GWindow);
    mversion = n+1;
    //fileBrowser = FileBrowserHelper.narrow(FBmodule);
    SAFileTreeModel  root = new SAFileTreeModel(InitialRootDir,this);
    refreshFileBrowser(root ,InitialRootDir);
  }

 public void refreshFileBrowser(SAFileTreeModel  root,String rootName)
  {
    
    //remove all the components inside the Panel
    removeAll();
    
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setFont(new Font("Helvetica", Font.PLAIN, 14));
    setLayout(gridbag);

    SAselectedFile file_field = new SAselectedFile("",15,"file",this);
    
    SADirTree tree = new SADirTree(root,this);
    JScrollPane scrollPane = new JScrollPane(tree);
    tree.addMouseListener(file_field);
    tree.addTreeExpansionListener(root);
    root.addTreeModelListener(tree);
       
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridwidth = GridBagConstraints.REMAINDER;

     //Next row
    JLabel label = new JLabel("Enter Path and Folder Name :");
    gridbag.setConstraints(label, c);
    add(label);

    final SAselectedFile directory_field=new SAselectedFile(rootName,15,
					       	"directory",this);
    tree.addMouseListener(directory_field);
    directory_field.addActionListener(root);
    

    gridbag.setConstraints(directory_field, c);
    add(directory_field);

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(scrollPane, c);
    add(scrollPane);

    //Next row
    c.weightx = 0.0;
    c.weighty = 0.0;
    c.fill = GridBagConstraints.HORIZONTAL;
    label = new JLabel("Enter File Name :");
    gridbag.setConstraints(label, c);
    add(label);

    gridbag.setConstraints(file_field, c);
    add(file_field);

    //Erol modifications
    directory_field.addActionListener(file_field);
    tree.addTreeExpansionListener(directory_field);
    tree.addTreeExpansionListener(file_field);
    //Erol

    c.fill = GridBagConstraints.NONE;

    //Next Row
    c.fill = GridBagConstraints.NONE;
    Button button = new Button("OK");
    c.gridwidth = GridBagConstraints.RELATIVE;
    gridbag.setConstraints(button, c);
    add(button);
    button.addActionListener(file_field);

    button = new Button("Cancel");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(button, c);
    add(button);
  }

    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
	    //System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
	      //System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
	    //System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {


        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);


      }
     
      return masterServerIOR;


     
    }

    public synchronized void waitForURL(){


        System.err.println("waiting... "+mversion);


	try {


           wait(2000);


	} catch(InterruptedException e){


		 System.out.println("Intrrupted exc :"+e);


	}


    }



  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }

    public void run() {
  /* get access to ORB */
  args = new String[1];
  args[0]="http://osprey4.npac.syr.edu:8001/IOR/master.txt";
  System.out.println(args[0]);
    try {
    System.out.println("SaveAsCtr: get applet...");
    VGJ a = GWindow.applet;
    System.out.println("SaveAsCtr: get orb...");
    orb = a.getORB();
    user = a.getUserContext();

    //get it from the WebServer
 String webIOR = "http://osprey4.npac.syr.edu:8001/IOR/QS/"+user+"SaveAs"+mversion+".txt";
  System.out.println(webIOR);
    // must wait till the file is written...
    // remember to delete it on exit!

    URLready = false;

    java.net.URL url = new java.net.URL(webIOR);
    InputStream istream;
 
 while(!URLready) {
    try {
      istream = url.openStream();
  		BufferedReader in = new BufferedReader(new InputStreamReader(istream));
  	 	ref = in.readLine();
  		istream.close();
                URLready = true;
      }
    catch(IOException e) {
      waitForURL();
      }
  }
   
    org.omg.CORBA.Object m_obj=orb.string_to_object(ref);
    if(m_obj == null) {
       System.out.println("m_obj is null ??????");
    }
    else {
       System.out.println("m_obj is OK");
    }
   
    fileBrowser = SaveAsHelper.narrow(m_obj);
    if(fileBrowser == null) {
        System.out.println("narrow(m_obj=fileBrowser");}
    else {
        System.out.println("controls: SaveAs OK");
    }
    }catch(Exception e) {


     System.out.println(e);


    }
    }
}



