package EDU.syr.npac.frontend;

import WebFlow.*;
import WebFlow.QS.*;
import java.util.*;
import WebFlow.event.*;
import EDU.auburn.VGJ.gui.GraphWindow;
import EDU.auburn.VGJ.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;
import java.net.*;   

import org.omg.CORBA.*;

public class controls11 extends controls
{
 String input = null;
 String output = null;
 String message = null;
 String what = null;
 String[] args;
 String user;
 String ref;
 ORB orb;
 boolean URLready;
 int mversion;  
 GLOBUS globus;
  
 public controls11(String host, int port, GraphWindow GWindow, int n)
 {
  super(host,port,GWindow);
  mversion = n+1;
  System.out.println("start controls11");   
  
  globusControl();
 }
    
 public void globusControl() 
 {
  setLayout(new GridLayout(10, 1));
  setBackground(Color.cyan);

  JLabel l1 = new JLabel("GLOBUS interface",JLabel.CENTER);
  l1.setFont(new Font("Serif",Font.BOLD,14));
  add(l1); 
  add(new JLabel(" "));

  add(new Label("gatekeeper  ")); 

  Choice gkc = new Choice();
  gkc.addItem("osprey4.npac.syr.edu");
  gkc.addItem("osprey2.npac.syr.edu");
  ItemListener gkclistener =  new ItemListener() {
    public void itemStateChanged(ItemEvent e) {
      String what= e.getItem().toString();
    System.out.println("GLOBUS gatekeeper: "+what);
    globus.setGatekeeper(what);
    }             
  };
  gkc.addItemListener(gkclistener);
  add(gkc);

  add(new JLabel("Standard In-Output"));

  JPanel inoutPanel = new JPanel();
  inoutPanel.setLayout(new GridLayout(2, 2));
  JLabel inputLabel = new JLabel("stdin file name", JLabel.CENTER);
  JTextField inputField = new JTextField();
  inputField.setEditable(true);
  inputField.addActionListener(new ActionListener() 
  {
   public void actionPerformed(ActionEvent e) 
   {
    input = ((JTextField)e.getSource()).getText();
    System.out.println("GLOBUS input: "+input);
    globus.setInput(input);
   }
  });

  JLabel outputLabel = new JLabel("stdout file name", JLabel.CENTER);
  JTextField outputField = new JTextField();
  outputField.setEditable(true);
  outputField.addActionListener(new ActionListener() 
  {
   public void actionPerformed(ActionEvent e) 
   {
    output = ((JTextField)e.getSource()).getText();
    System.out.println("GLOBUS output: "+output);
    globus.setOutput(output);
   }
  });

  inoutPanel.add(inputLabel);
  inoutPanel.add(inputField);
  inoutPanel.add(outputLabel);
  inoutPanel.add(outputField);
  add(inoutPanel);

  add(new JLabel("executable"));

  JTextField textfield1 = new JTextField(10); 
  textfield1.setText("TEST");
  textfield1.addActionListener(new ActionListener() 
  {
   public void actionPerformed(ActionEvent e) 
   {
    message = ((JTextField)e.getSource()).getText();
    System.out.println("GLOBUS exec: "+message);
    globus.setExecutable(message);
   }
  });
  add(textfield1);

  add(new JLabel(" "));

  JButton sButton = new JButton("do it");
  sButton.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent ev) {
    System.out.println("button pressed");
    globus.run();
    }
   }
  );
  add(sButton);
  }


  public void run() 
  {
   /* get access to ORB */
   args = new String[1];
   args[0]="http://osprey4.npac.syr.edu:8001/IOR/master.txt";
   System.out.println(args[0]);
   try {
    VGJ a = GWindow.applet;
    orb = a.getORB();
    user = a.getUserContext();

   String webIOR = "http://osprey4.npac.syr.edu:8001/IOR/QS/"+user+"GLOBUS"+mversion+".txt";
   System.out.println(webIOR);
   // must wait till the file is written...
   // remember to delete it on exit!

   URLready = false;
   java.net.URL url = new java.net.URL(webIOR);
   InputStream istream;
   int timeOut = 0;

   while(!URLready) 
   {
    try {
      istream = url.openStream();
      BufferedReader in = new BufferedReader(new InputStreamReader(istream));
      ref = in.readLine();
      istream.close();
      URLready = true;
    }
    catch(IOException e) {
     waitForURL();
     timeOut++;
     if(timeOut>20) URLready=true;
    }
   }
    
   org.omg.CORBA.Object m_obj=orb.string_to_object(ref);
   if(m_obj == null) 
   {
    System.out.println("m_obj is null ??????");
   }
   else 
   {
    System.out.println("m_obj is OK");
   }
   
   globus = GLOBUSHelper.narrow(m_obj);
   if(globus == null) throw new RuntimeException();
   System.out.println("controls11: GLOBUS OK");
   }
   catch(Exception e) {
    System.out.println(e);
   }
   
   }
   public synchronized void waitForURL()
   {
    System.err.println("waiting... "+mversion);
    try {
     wait(2000);
    } 
    catch(InterruptedException e){
     System.out.println("Intrrupted exc :"+e);
    }
   }
}

/**************************************************************************
 *                               The End
 **************************************************************************/





