package EDU.syr.npac.frontend;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import EDU.auburn.VGJ.gui.*;
import javax.swing.*;

public class lowerPanel extends JPanel {

CardLayout card = new CardLayout();
controls[] modules;
String[] mnames;
int i,j;
public int maxn;
GraphWindow GWindow;
private int port;
private ControlFactory factory = ControlFactory.Instance();
  
 lowerPanel(GraphWindow GWindow, int maxn){

   super();
   this.maxn = maxn;
   this.GWindow = GWindow;
   setLayout(card);
   modules = new controls[maxn];

   }

  public void  showContents() {
   System.out.println("ShowContents called...");
   card.last(this);
   }

  public void  showContents(String what) {
   System.out.println("ShowContents called..."+what);
   card.show(this,what);
   }

  public void clean() {
    int i;
    for (i=0;i<maxn;i++) {
      if(modules[i] != null) {
        System.err.println("stop module "+i);
	modules[i].stop();
        modules[i]=null;
      }
    }
    removeAll();
  }

  public void startModules() {
    int i;
    for (i=0;i<maxn;i++) {
      if(modules[i] != null) {
        System.err.println("start module "+i);
	//modules[i].sayHello();
      }
    }
  }
  

    public void addcard(String what, String where, int n) {
	String cardname = what + "." + (n+1);
	System.out.println("addcard " + what + " as card no. " + n);
    
	modules[n] = factory.CreateControl(n, what, where, GWindow);

	System.out.println("card name is now " + cardname);
	add(cardname, modules[n]);
	System.out.println("end of card add ");
  }
}

















