package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class SendFile_dagger extends Template {

  String command;
  //  InputPort inport;
  OutputPort outport;
  String inFile, outFile;
  boolean flag;

  public MetaModule initialize() {
    
    System.err.println("initialize SendFile_dagger");
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    ID outputID = outport.getPortID();
    mm.putPortID(outport.getPortID());

    //inport = new InputPort("WFFileDescriptor");
    //ID inputID = inport.getPortID();
    //mm.putPortID(inport.getPortID());
 
    System.err.println("about to end init SendFile_dagger");
    return(mm);
    }



  public synchronized void run() {

    //no socket on remote host    CreateServerSocket();

        if(outport.isConnected()) {

             outFile = readFile("C:\\WMS\\webflow\\webflow.prj");  
             outport.send("/tmp/fromEdys.dat");
             outport.send(outFile);

        // more files to be added
             outport.send("done");

	     //remote!     socket.send("done");

        }
	else {
              System.err.println("Oops!! SendFile_dagger outport not connected");
              System.err.println("SendFile_dagger sending sygnal <done>");
              //remote! socket.send("done");
              outport.send("done");
              flag=false;
	}
  } 


    public void destroy() {

      //inport.destroyPort();
    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}


    public void update_value(String s) 
    {
      
      System.err.println("SendFile_dagger: I received message s="+s);
    }

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.err.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.err.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }


}





