package LMS.frontend;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import com.sun.java.swing.*;

public class layeredMapPanel extends JPanel
{

 BorderPanelTest parent_controls;
 MediaTracker tracker;
 String mapServer;
 lmsFrame frame;
 URL mapURL;
 Image usgsMap; 
 JApplet app;
 int mapID;

 public layeredMapPanel(lmsFrame frame, BorderPanelTest controls)
 {
 this.frame=frame;
 app=frame.app;
 parent_controls = controls;
 
 mapServer=frame.ServerURL;
 tracker = new MediaTracker(this);
 
 mapID=0;
 try{
    mapURL=new URL(mapServer+"/us.jpg"); 
    }
  catch (MalformedURLException e) {System.err.println(e);};

   System.err.println("get map: "+mapURL.toString());
   usgsMap=app.getImage(mapURL);
   if(usgsMap != null) {
     System.err.println("map found");}
   else {
     System.err.println("map not found!!!! ");}
   tracker.addImage(usgsMap,mapID);
   try {tracker.waitForID(mapID);} catch (InterruptedException e){;}; 
   System.err.println("map loaded");
   if(getParent()==null) {
     System.err.println("Oops, parent of layeredMapPanel not found");
   }
   else {
      getParent().repaint();
   }
}

  public void paint(Graphics g) {
   g.drawImage(usgsMap,0,0,this);
  
  }

  public void newMap(String mapName) {
  URL newURL;
  try{
    mapURL=new URL(mapServer+"/us.jpg"); 
    //mapURL=new URL("http://"+mapServer+"/"+mapName); 
    }
  catch (MalformedURLException e) {System.err.println(e);};

  usgsMap=app.getImage(mapURL);
   tracker.addImage(usgsMap,mapID);
   try {tracker.waitForID(mapID);} catch (InterruptedException e){;}; 
  repaint();
  }


  public void stop(){
    Graphics g=this.getGraphics();
    g.dispose();
    }
}







