package LMS.frontend;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;




public class testFrame extends JFrame implements Runnable, ItemListener, 
ActionListener, MouseListener
{

 Applet app;
 private boolean dataDEM, dataLU, dataWE, dataSO;
 private int N,S,W,E;


 public testFrame()
 {
 //app=app_;

 dataDEM=true;
 dataLU=false;
 dataWE=false;
 dataSO=false;
  
ActionListener mListener = new ActionListener() {
   public void actionPerformed(ActionEvent e) {
         dispose();
   }
  }; 
 
  MenuBar menubar = new MenuBar();

  Menu menuFile = new Menu("File");
  MenuItem exitItem = new MenuItem("close this window");
  exitItem.addActionListener(mListener);
  menuFile.add(exitItem);
  menubar.add(menuFile);


  setMenuBar(menubar);
  
   System.err.println("now show the frame"); 
   setSize(700,250);

   getContentPane().setLayout(new BorderLayout());
   //setBackground(Color.white);

   JPanel TitlePanel = new JPanel();
   getContentPane().add(TitlePanel,BorderLayout.NORTH);
   //add(TitlePanel,BorderLayout.NORTH);

   
   //TitlePanel.setBackground(Color.white);
   TitlePanel.setForeground(Color.blue);
   String LMStitle = new String("LMS Data Wizard");
   
   JLabel l1= new   JLabel(LMStitle,  JLabel.CENTER);
   l1.setFont(new Font("Serif",Font.BOLD,14));
   TitlePanel.add(l1); 
  
   
   JPanel CBoxBorder = new JPanel();
   CBoxBorder.setBorder(BorderFactory.createTitledBorder("select data type"));

    JPanel controls=new JPanel();
    JLabel labelx = new JLabel("Title Position:");
    //label.setFont(swing.boldFont);
    controls.add(labelx);
    JLabel labely = new JLabel("Title Position 2:");
    //label.setFont(swing.boldFont);
    controls.add(labely);


   
   JPanel CBoxPanel = new JPanel();
   CBoxPanel.setLayout(new GridLayout(1,4));
   
   Checkbox DEMcheckbox = new Checkbox("DEM",true);
   Checkbox LUcheckbox = new Checkbox("Land Use",false);
   Checkbox SOcheckbox = new Checkbox("Soils Texture",false);
   Checkbox WEcheckbox = new Checkbox("Weather Data",false);

  
   DEMcheckbox.addItemListener(this);
   LUcheckbox.addItemListener(this);
   SOcheckbox.addItemListener(this);
   WEcheckbox.addItemListener(this);
   CBoxPanel.add(DEMcheckbox);
   CBoxPanel.add(LUcheckbox);
   CBoxPanel.add(SOcheckbox);
   CBoxPanel.add(WEcheckbox);
    
   
   getContentPane().add(CBoxBorder,BorderLayout.CENTER);
   //add(CBoxBorder,BorderLayout.CENTER);

   CBoxBorder.add(controls);
   CBoxBorder.add(CBoxPanel); 


   JPanel RegionPanel = new JPanel();
   RegionPanel.setLayout(new BorderLayout());  

      JPanel CoordPanel = new JPanel();
      CoordPanel.setLayout(new GridLayout(1,2));

        JPanel NumberPanel = new JPanel();
        NumberPanel.setLayout(new BorderLayout());
          Label l2 = new   Label("Type in bounding box coordinates",   Label.CENTER);
        NumberPanel.add(l2, BorderLayout.NORTH);

           JPanel DataPanel = new JPanel();
   
           DataPanel.setLayout(new GridLayout(3,9));
             Label emptyLabel1 = new   Label(" ");
             Label emptyLabel2 = new   Label(" ");
             Label emptyLabel3 = new   Label(" ");
             Label emptyLabel4 = new   Label(" ");
             Label emptyLabel5 = new   Label(" ");
             Label emptyLabel6 = new   Label(" ");
             Label emptyLabel7 = new   Label(" ");
             Label emptyLabel8 = new   Label(" ");
             Label emptyLabel9 = new   Label(" ");
             Label emptyLabel10 = new   Label(" ");
             Label emptyLabel11 = new   Label(" ");
             Label emptyLabel12 = new   Label(" ");
             Label emptyLabel13 = new   Label(" ");


             Label LabelN = new   Label("N:",  Label.RIGHT);
             Label LabelS = new   Label("S:",  Label.RIGHT);
             Label LabelW = new   Label("W:",  Label.RIGHT);
             Label LabelE = new   Label("E:",  Label.RIGHT);
           TextField textN = new TextField(20);
           TextField textE = new TextField(20);
           TextField textS = new TextField(20);
           TextField textW = new TextField(20);
 
           DataPanel.add(emptyLabel1);
           DataPanel.add(emptyLabel2);
           DataPanel.add(LabelN);
           DataPanel.add(textN);
           DataPanel.add(emptyLabel3);
           DataPanel.add(emptyLabel4);
           DataPanel.add(emptyLabel11);

           DataPanel.add(LabelW);
           DataPanel.add(textW);
           DataPanel.add(emptyLabel5);
           DataPanel.add(emptyLabel6);
           DataPanel.add(LabelE);
           DataPanel.add(textE);
           DataPanel.add(emptyLabel12);


           DataPanel.add(emptyLabel7);
           DataPanel.add(emptyLabel8);
           DataPanel.add(LabelS);
           DataPanel.add(textS);
           DataPanel.add(emptyLabel9);
           DataPanel.add(emptyLabel10);
           DataPanel.add(emptyLabel13);


        NumberPanel.add(DataPanel, BorderLayout.CENTER);   

     CoordPanel.add(NumberPanel);
     
        JPanel GraphicPanel = new JPanel();
        GraphicPanel.setBackground(Color.lightGray);
        Button GraphButton = new Button("draw bounding box on a map");
        GraphButton.addActionListener(this);
        GraphicPanel.add(GraphButton);
      CoordPanel.add(GraphicPanel);

   RegionPanel.add(CoordPanel, BorderLayout.CENTER);

       JPanel ButtonPanel = new JPanel();
       Button startButton = new Button("get data");
       startButton.addActionListener(this);
       ButtonPanel.add(startButton);
       RegionPanel.add(ButtonPanel, BorderLayout.SOUTH);

   getContentPane().add(RegionPanel, BorderLayout.SOUTH);

   show();
   repaint();
 
}

  public void paint(Graphics g) {
   g.drawString("whatever",10,10);
  }

public void actionPerformed(ActionEvent e) { 
    System.err.println("button pressed");
   String action = e.getActionCommand();
   if(action.startsWith("get")) {
      if(dataDEM) System.err.println("DEM");
      if(dataLU) System.err.println("Land Use");
      if(dataSO) System.err.println("Soils Texture");
      if(dataWE) System.err.println("Weather Data");
   }
   else if(action.startsWith("draw")) {
      new testFrame();
   }
   else {
    System.err.println("testFrame: Oops unknown action");
   } 
 }
 
public void itemStateChanged(ItemEvent e) {
   String action =(String)e.getItem();
   int state = e.getStateChange();
   System.err.println("Checkbox "+action+":"+state);
   boolean newstate=false;
   if(state==1) {newstate=true;} else if(state==2) {newstate=false;}
   else {System.err.println("testFrame: Ooops! unknown state "+state);dispose();}
   
   if(action.equals("DEM")) dataDEM=newstate;
   if(action.equals("Land Use")) dataLU=newstate;
   if(action.equals("Soils Texture")) dataSO=newstate;
   if(action.equals("Weather Data")) dataWE=newstate;

      }

public void mouseClicked(MouseEvent e) {  
     int x = e.getX();
     int y = e.getY();
     System.err.println(x+","+y); 
}

  public void mouseEntered(MouseEvent e) {;}
  public void mouseExited(MouseEvent e) {;}
  public void mousePressed(MouseEvent e) {;}
  public void mouseReleased(MouseEvent e) {;}

 public void run()
{
   	java.awt.Scrollbar horizontalScrollbar;
}

}

class BorderLabel extends JLabel {
    public BorderLabel(String text, Border b) {
        super(text);
        setBorder(b);
        setHorizontalAlignment(SwingConstants.CENTER);
    }
}







