package webflow.modules.LMS;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class CUSC2D extends Template {
  InputPort inport;
  OutputPort outport;
  String targetFileName, editor, command;
  String thisSystem = "NT";
  String newmessage;
  String disp;
  int idx;

  public MetaModule initialize() {
    
    System.err.println("Initialize InputFile");
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");
    /* 
    outport = new OutputPort("WFFileDescriptor");
    mm.putPortID(outport.getPortID());
    */ 
    inport = new InputPort("String");
    mm.putPortID(inport.getPortID());

    System.err.println("about to end init InputFile");
    return(mm);
    }
  
  public synchronized void run() {
    
    //wait till you know the ip address of the display
    
     
    System.err.println("CUSC2D started"); 
    while(newmessage==null) {;}
    System.err.println("CUSC2D: set display to: "+newmessage);
    disp=newmessage.substring(4);

    while(true) {
      try {
             wait(1000);
      } catch (InterruptedException e){;}
        
      /* receive file Content from input port */
      System.err.println("CUSC2D: wait for input...");
      String content  = (String)inport.receive();
       

     if(thisSystem.equals("UNIX")) {  

               /* write to destination */
           targetFileName = "/tmp/cow1.proj"; 
           System.err.println("CUSC2D: write to "+targetFileName);
           writeFile(targetFileName,content);

              /* open it in emacs */
           editor = "/usr/npac/bin/emacs";   
           command = editor+" "+targetFileName+" -d "+disp+":0";
     }
      else if(thisSystem.equals("NT")) {

           /* write to destination */
            targetFileName = "C:\\Temp\\cow1.proj";
            System.err.println("CUSC2D: write to "+targetFileName);
            writeFile(targetFileName,content);

            /* open it in notepad */
            editor = "notepad";
            command = "cmd /C "+editor+" "+targetFileName;
     }  
      else {
            System.err.println("CUSC2D: Oops - unknown system");
     }
    
       try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
	     }
        catch (Exception e) {System.out.println("EditFile Error: "+e.toString());}


    }
  }
  
  
    
    public void destroy() {

    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) 
    {
      
      //String[] directory_contents=null;
      System.err.println("CUSCD2: update_value is CALLED with "+s);
      newmessage=s;
      
      if(s.equals("_make_connection")) {
       System.err.println("CONTROLS1 CONNECTED !!!");
      }
       /*
         else if (s.startsWith("SWING_REQ")){
	   System.err.println("I received DIR NAME:"+s);
	   
	   //received directory name for file browser
	   String dir = s.substring("SWING_REQ".length());
	   try{
	     directory_contents = list(dir,"");
	   }catch(InterruptedException e){
	   }
	   send_directory_contents(directory_contents);
	   dirflag = true;
	 }  
	 else if (s.startsWith("SWING_REPLY")){
	   targetFileName=s.substring("SWING_REPLY".length()); 
	   System.err.println("new message arrived: "+targetFileName);
	   flag=true;
	 }
      */
    }
    

  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.out.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.out.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

}	
    
    
    


