package webflow.modules.LMS;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class GetURLcontents extends Template {

  InputPort inport;
  OutputPort outport;
  
  boolean flag;
  public WFurl inData;
  WFFileDescriptor outData;
  URL url;
  InputStream in = null;
  OutputStream out = null;
  int bytes_read ;

  public MetaModule initialize() {
    
    System.err.println("initialize GetURLcontents");
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    mm.putPortID(outport.getPortID());

    inport = new InputPort("WFMapIndices");
    mm.putPortID(inport.getPortID());
    System.err.println("about to end init GetURLcontents");
    return(mm);
    }
  
  public  int setBytesRead(int bytes_read_)
  {
     bytes_read += bytes_read_ ;
     return bytes_read;
  }

  public synchronized void run() {
    
    System.err.println("GetURLcontents started");
    flag=false;

    
    while(true) {
    bytes_read = 0;

    System.err.println("GetURLcontents: wait for the input port data");

      inData = (WFurl)inport.receive();
      System.err.println("GetURLcontents: data received:");
      System.err.println("GetURLcontents: "+inData.getURL());

      try {
      url = new URL(inData.getURL());
      outData = new WFFileDescriptor(inData.getFileName(),"C:\\temp\\");
      System.err.println("save map as "+outData.getFileDirectory()+outData.getFileName());

      URLConnection urlcon = url.openConnection();
      in =urlcon.getInputStream();

      System.err.println("urlcon.getInputStream() - done");
      out = new FileOutputStream(outData.getFileDirectory()+outData.getFileName());
      int remoteFileLength = urlcon.getContentLength();

      System.err.println("send: "+outData.getFileDirectory()+outData.getFileName());

     socket.send(inData.getFileName());
      
      	//send file length
      socket.OUTStream().writeInt(remoteFileLength);

	System.err.println("fileLend are sent :"+remoteFileLength);



      byte[] buffer = new byte[4096];
      while(bytes_read < remoteFileLength) {
        int oneread = in.read(buffer);
        out.write(buffer,0,oneread);
        setBytesRead(oneread); 
        //socket.OUTStream().writeInt(setBytesRead(0));
	  socket.OUTStream().writeInt(oneread);
        //System.err.println("Outstream send "+oneread);
       } 
      }
      catch (Exception e) {System.err.println(e);}       
      /*
        finally {
        try{in.close(); out.close();} catch (Exception e){;}
      }
      */

      System.err.println("download completed...");   
      if(outport.isConnected()) {
         System.err.println("Ouput port connected - send data");
         outport.send(outData); 
      }
      else {
        System.err.println("Output Port is not connected!");
      }   

    }
  }
  
  
    
    public void destroy() {

    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) 
    {
      
      //      if (s.startsWith("MAPX")){
      System.err.println("I received message s="+s);
           	   
      // }  
      
    }
    

}	
    















