#package webflow.modules.LMS;

import java.util.*;
import java.net.*;
import java.io.*;


public class MapNames extends Object
{

   Vector list;

   public MapNames()
   {
      list = new Vector();
   }

   public  boolean 
   parse( String url)
   {
  
      URL address = null;
      DataInputStream file = null;
    
      try
      {
         address = new URL(url);

      } catch( MalformedURLException e)
        {
          System.err.println(" Can't create URL from the given path ");
           e.printStackTrace();
           return false;
        }

      try
      {

         if( address != null )
         {
	        file = new DataInputStream( address.openStream() );

         } else   System.err.println("MapNames: address is null");
     
      } catch(IOException e)
        {
           e.printStackTrace();
           return false;
        }

      if( file != null )
      {
         
         try
         {
	        String  map = null;
	        while( ( map = file.readLine() ) != null )
            {
              
	           StringTokenizer st = new StringTokenizer( map );
	       // We are expecting 5 element on the line */

             System.err.println("MapNames: #tokens="+st.countTokens());

               
                String name = st.nextToken();
                String N = st.nextToken();
                String S = st.nextToken();
                String W = st.nextToken();
                String E = st.nextToken();

             System.err.println("I read next line:");
             System.err.println(name+" "+E+" "+S+" "+W+" "+E);
	              
	        }// end of while
	
         } catch(IOException e)
           {
	          System.out.println(" Read error");
              e.printStackTrace();
	          return false;
           }
      }

      System.err.println(" I am out of parse() ");

      return true;

   }// end of parse()
 
 

 public static void main(String[] argv){
   MapListList list = new MapList();
   list.parse("file:c:\\DEM-1.txt");
   }


 }
  
}
