package webflow.modules.LMS;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class SendFile extends Template {
  InputPort inport;
  OutputPort outport;
  String targetFileName="C:\\WMS\\CowhoseCreek\\cow1\\cow.prj";
  boolean flag,dirflag;
  int idx;

  public MetaModule initialize() {
    
    System.err.println("Initialize SendFile");
    CreateServerSocket();
    System.err.println("Socket done SendFile");
    MetaModule mm = new MetaModule("mm");
    outport = new OutputPort("String");
    mm.putPortID(outport.getPortID());
    inport = new InputPort("WFFileDescriptor");
    mm.putPortID(inport.getPortID());
    System.err.println("about to end init SendFile");
    return(mm);
    }
  
  public synchronized void run() {
    
    flag=false;
    
    while(true) {
      try {
             wait(1000);
      } catch (InterruptedException e){;}
      //System.err.println("SendFile: wait for input");
      //WFFileDescriptor inFile = (WFFileDescriptor)inport.receive();
      //System.err.println("SendFile: input received"); 
      if (flag){
	/* read file from source */
      System.err.println("SendFile: read file");
	String content = readFile(targetFileName);
	/* send the file content through output port */
      System.err.println("SendFile: send it");
	if(outport.isConnected()){
	  outport.send(content);
	  flag = false;
	}
	
      }
    }
    
  }
  
  
    
    public void destroy() {

    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) 
    {
      
      String[] directory_contents=null;
      System.err.println("SendFile: update_value is CALLED with "+s);
      
      if(s.equals("_make_connection")) {
       System.err.println("SendFile CONNECTED !!!");
      }
         
	 else if (s.startsWith("SEND")){
	   //targetFileName=s.substring("SWING_REPLY".length()); 
	   System.err.println("SendFile: new message arrived: "+s);
	   flag=true;
	 }
      
    }
    


  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.out.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
 
      return new String(data);
   }

 /** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     System.out.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during writing file:"+e);
     }
   }

}	
    
    
    


