package WebFlow.Collaborator; 

import WebFlow.event.*; 
import WebFlow.*; 
import java.util.*; 
import java.io.*;
import java.lang.reflect.*;
import java.net.*;


public class CollaboratorImpl extends WebFlow.BeanContextChildSupport
                  implements CollaboratorOperations
{
    String msg_; 
    org.omg.CORBA.Object peer; 
    String filepath = "/a/birch.csit.fsu.edu/shared/home/cyoun/GATEWAY/apache1.3.12/WWW/GOW/SharingData/";
    FileInputStream fis, fis1;
    int blksize;
    boolean eventCaptureFlag;
    String UserId;
    int collab_mode;
    boolean isMaster;
   
    public CollaboratorImpl(org.omg.CORBA.Object peer , String msg) 
	throws WebFlow.NullPointerException
    {
	super(peer); 
	this.peer = peer ; 
	msg_ = msg ;
	blksize= 1024; //4 * 1024; 
	eventCaptureFlag = false;
	UserId = null;
	collab_mode = 0;
	isMaster = false;
    }   

    public String test() {
	return "Collaborator module is up!!!!!!!";
    }

    public void getEvent(org.omg.CORBA.Object to)
    {
	System.out.println("getEvent is called: CollaboratorImpl"); 
	
	collEvent gevt = collEventHelper.narrow(to); 	
	String eType = gevt.eventType();
	System.out.println("getEvent:Event Type: "+eType);
	setEventFlag(true);
	System.out.println("getEvent:UserID: "+getUserId());	
    }    

    public void writeJSP(String username) {
	String filename = null;
	String gfile = null;
	filename = filepath+username+"NEXT.jsp";

	try {
	    FileOutputStream fout = new FileOutputStream(filename);

	    try {
		byte[] buf = null;
		gfile =
		    "<HTML> \n"+
		    "<HEAD> \n"+
		    "<%@ page import=\"WebFlow.*\" %> \n"+
		    "<%@ page import=\"WebFlow.Collaborator.*\" %> \n"+
		    "<%@ page import=\"java.util.*\" %> \n"+
		    "<% \n"+
		    "org.omg.CORBA.Object m1 = null; \n"+
		    "Collaborator coll = null; \n"+
		    "String filename = \""+username+"\"; \n"+
		    "String filename1 = CollabManager.getEventName(filename); \n"+
		    "m1 = CollabManager.getCollaborator(filename); \n"+
		    "coll = CollaboratorHelper.narrow(m1); \n"+
		    "if(coll.getEventFlag()) { \n"+
		    " filename1 = CollabManager.getFileName(filename); \n"+
		    " CollabManager.setEventName(filename, filename1); \n"+
		    " coll.setEventFlag(false); \n"+
		    "} \n"+
		    "%> \n"+
		    "\n"+
		    "<META HTTP-EQUIV=REFRESH CONTENT=\"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/<%= filename1 %>.jsp"+"\"> \n"+
		    "<TITLE> The Viewing Page </TITLE> \n"+
		    "</HEAD> \n"+
		    "<BODY> \n"+
		    "<H3> The Viewing Page </H3> \n"+
		    "<h3>Please wait for pages from the control user.<h3> \n"+
		    "</BODY> </HTML> \n";
		
		buf = gfile.getBytes();
		fout.write(buf, 0, buf.length);
	   
	    } catch (Exception e) {
		System.out.println("writeJSP:"+e);
	    }
	    fout.flush();
	    fout.close();
	} catch (Exception e) {
	    System.out.println("writeJSP:"+e);
	}
    }

    public void writeJSPInitial(String username) {
	String filename = null;
	String gfile = null;
	filename = filepath+username+".jsp";

	try {
	    FileOutputStream fout = new FileOutputStream(filename);

	    try {
		byte[] buf = null;
		gfile =
		    "<HTML> \n"+
		    "<HEAD> \n"+
		    "<META HTTP-EQUIV=REFRESH CONTENT=\"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/"+username+"NEXT.jsp"+"\"> \n"+
		    "<TITLE> The Viewing Page </TITLE> \n"+
		    "</HEAD> \n"+
		    "<BODY> \n"+
		    "<H3> The Viewing Page </H3> \n"+
		    "<h3>Please wait for pages from the control user.<h3> \n"+
		    "</BODY> </HTML> \n";
		
		buf = gfile.getBytes();
		fout.write(buf, 0, buf.length);
	   
	    } catch (Exception e) {
		System.out.println("writeJSP:"+e);
	    }
	    fout.flush();
	    fout.close();
	} catch (Exception e) {
	    System.out.println("writeJSP:"+e);
	}
    }


    public void writeFile(String username, String urlname){

	String filename = null;
	filename = filepath+username+".jsp";

	try {
	    URL url = new URL(urlname);
	    try {
		FileOutputStream fout = new FileOutputStream(filename);

		try {
		    InputStream in = url.openStream();
		    byte[] buf = new byte[blksize];  // 4K buffer
		    int bytesRead;
		    while ((bytesRead = in.read(buf)) != -1) {
			fout.write(buf, 0, bytesRead);
		    }
		} catch (Exception e) {
		    System.out.println("writeFile:"+e);
		}
		fout.flush();
		fout.close();
	    } catch (Exception e) {
		System.out.println("writeFile:"+e);
	    }
	}catch (MalformedURLException e) {
	    System.out.println("writeFile:"+urlname);
	    System.out.println("writeFile:"+e);
	}
    }

    public void writePullFile(String username, String urlname){

	String filename = null;
	int index = 0;
	//String usernameOrg = null;

	if((index = username.lastIndexOf("NEXT")) != -1){
	    filename = filepath+username+".jsp";
	    username = username.substring(0,index);
	} else {
	    filename = filepath+username+".jsp";
	    //usernameOrg = username;
	} 

	try {
	    URL url = new URL(urlname);

	    try {

		/*
		URLConnection conn = url.openConnection();
		conn.setRequestProperty("Refresh",
					"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/"+username+".jsp");
		conn.connect();

		String holder="HTTP/1.0 200 OK \n";
		String key;
		int n=1;
		while((key=conn.getHeaderFieldKey(n)) !=null){
		    holder+=key+": "+
			conn.getHeaderField(key) +"\n";
		    n++;
		}
		System.out.println(holder);
		*/

		FileOutputStream fout = new FileOutputStream(filename);
		String tmp = null;
		String tmp1 = null;
		String tmp2 = null;
		String gscript = 
		    "<%@ page import=\"WebFlow.*\" %> \n"+
		    "<%@ page import=\"WebFlow.Collaborator.*\" %> \n"+
		    "<%@ page import=\"java.util.*\" %> \n"+
		    "<% \n"+
		    "org.omg.CORBA.Object m1 = null; \n"+
		    "Collaborator coll = null; \n"+
		    "String filename = \""+username+"\"; \n"+
		    "String filename1 = CollabManager.getEventName(filename); \n"+
		    "m1 = CollabManager.getCollaborator(filename); \n"+
		    "coll = CollaboratorHelper.narrow(m1); \n"+
		    "if(coll.getEventFlag()) { \n"+
		    " filename1 = CollabManager.getFileName(filename); \n"+
		    " CollabManager.setEventName(filename, filename1); \n"+
		    " coll.setEventFlag(false); \n"+
		    "} \n"+
		    "%> \n"+
		    "\n";

		//int index = 0;
		int bytesRead = 0;

		try {
		    //InputStream in = conn.getInputStream();
		    InputStream in = url.openStream();
		    byte[] buf = new byte[blksize];  // 4K buffer

		    bytesRead = in.read(buf);
		    tmp = new String(buf);
		    //tmp = tmp.toUpperCase();
		    //index = tmp.indexOf("HTTP-EQUIV");

		    if(tmp.indexOf("HTTP-EQUIV") != -1) {
			tmp1 = tmp.substring(0,tmp.indexOf("HTTP-EQUIV"));
			tmp2 = tmp.substring(tmp.indexOf("HTTP-EQUIV"), tmp.length());
			tmp2 = tmp2.substring(tmp2.indexOf(">")+1, tmp2.length());
			tmp = " HTTP-EQUIV=REFRESH CONTENT=\"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/<%= filename1 %>.jsp\">";
			tmp1 = tmp1.concat(tmp);
			tmp = tmp1.concat(tmp2);
		    }
		    else if(tmp.indexOf("HEAD") != -1) {
			tmp1 = tmp.substring(0,tmp.indexOf("HEAD")+4);
			tmp2 = tmp.substring(tmp.indexOf("HEAD")+4, tmp.length());
			tmp2 = tmp2.substring(tmp2.indexOf(">")+1, tmp2.length());
			tmp = "> <META HTTP-EQUIV=REFRESH CONTENT=\"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/<%= filename1 %>.jsp\">";
			tmp1 = tmp1.concat(tmp);
			tmp = tmp1.concat(tmp2);
		    }
		    else if(tmp.indexOf("http-equiv") != -1) {
			tmp1 = tmp.substring(0,tmp.indexOf("http-equiv"));
			tmp2 = tmp.substring(tmp.indexOf("http-equiv"), tmp.length());
			tmp2 = tmp2.substring(tmp2.indexOf(">")+1, tmp2.length());
			tmp = " HTTP-EQUIV=REFRESH CONTENT=\"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/<%= filename1 %>.jsp\">";
			tmp1 = tmp1.concat(tmp);
			tmp = tmp1.concat(tmp2);
		    }
		    else if(tmp.indexOf("head") != -1) {
			tmp1 = tmp.substring(0,tmp.indexOf("head")+4);
			tmp2 = tmp.substring(tmp.indexOf("head")+4, tmp.length());
			tmp2 = tmp2.substring(tmp2.indexOf(">")+1, tmp2.length());
			tmp = "> <META HTTP-EQUIV=REFRESH CONTENT=\"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/<%= filename1 %>.jsp\">";
			tmp1 = tmp1.concat(tmp);
			tmp = tmp1.concat(tmp2);
		    }

		    else {
			System.out.println("Could not find <HTTP-EQUIV>, <HEAD> tag in this file");
			tmp1 = "<META HTTP-EQUIV=REFRESH CONTENT=\"3; URL=http://birch.csit.fsu.edu:8001/GOW/SharingData/<%= filename1 %>.jsp\">";
			tmp = tmp.concat(tmp1);
		    }

		    //System.out.println("Check string: "+tmp);
		    tmp = gscript.concat(tmp);

		    buf = tmp.getBytes();
		    fout.write(buf, 0, buf.length);

		    while ((bytesRead = in.read(buf)) != -1) {
			fout.write(buf, 0, bytesRead);
		    }

		} catch (Exception e) {
		    System.out.println("writePullFile0:"+e);
		}
		fout.flush();
		fout.close();
	    } catch (Exception e) {
		System.out.println("writePullFile1:"+e);
	    }
	}catch (MalformedURLException e) {
	    System.out.println("writePullFile3:"+urlname);
	    System.out.println("writePullFile4:"+e);
	}
    }

    public boolean readFile(String username) {
	// A FileInputStream is for bytes
	String filename = null;
	filename = filepath+username+".jsp";
	fis = null;
	try {
	    fis = new FileInputStream(filename);
	}catch(Exception e) {
	    System.out.println("File Open Exception");
	    System.out.println(e);
	    return false;
	}
	return true;
    }

    public byte[] getBinaryBlock() {
	
	byte[] a = null; 
	byte[] buf = new byte[blksize];

	try {
	    System.out.println("getBinaryBlock ....."+getUserId());
	    if(fis==null) System.out.println("fis is null");
	    int icount = fis.read(buf);
	    System.out.println("icount="+icount);
	    if(icount == -1) {
		a = new byte[0];
		if(fis != null) fis.close();
	    }
	    else { 
		if(icount == blksize) a=buf;  //buffer filled
		else {
		    a = new byte[icount];
		    for(int i =0; i < icount; i++) a[i]=buf[i];
		}
	    }
	}
	catch(Exception e) {
	    System.out.println("IO Exception in getBlock");
	    System.out.println(e);
	}
	return a;    
    }

    public void runfireEvent(String eventID, String eventType) {
	collEvent cevt = new collEventImpl(getBeanContextChildPeer(),
					       eventType);
	fireEvent( eventID , cevt); 
	System.out.println("Event Generated.....");
    }

    public void setEventFlag(boolean flag) {
	eventCaptureFlag = flag;
    }

    public void setUserId(String username) {
	System.out.println("UserID: "+username);
	UserId = username;
    }

    public void setIsMaster(boolean flag) {
	System.out.println("Master/Slave setting: "+flag);
	isMaster = flag;
    }

    public void setCollabMode(int mode) {
	System.out.println("Collaborative Mode: "+mode);
	collab_mode = mode;
    }

    public boolean getEventFlag() {
	return eventCaptureFlag;
    }

    public String getUserId() {
	return UserId;
    }

    public boolean getIsMaster() {
	return isMaster;
    }

    public int getCollabMode() {
	return collab_mode;
    }

}

