// java wrapper for vtkAbstractTransform object
//

package vtk;
import vtk.*;

public class vtkAbstractTransform extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native double[] TransformPoint_2(double id0,double id1,double id2);
  public double[] TransformPoint(double id0,double id1,double id2)
    { return TransformPoint_2(id0,id1,id2); }

  private native double[] TransformPoint_3(double id0[]);
  public double[] TransformPoint(double id0[])
    { return TransformPoint_3(id0); }

  private native double[] TransformFloatPoint_4(double id0,double id1,double id2);
  public double[] TransformFloatPoint(double id0,double id1,double id2)
    { return TransformFloatPoint_4(id0,id1,id2); }

  private native double[] TransformFloatPoint_5(double id0[]);
  public double[] TransformFloatPoint(double id0[])
    { return TransformFloatPoint_5(id0); }

  private native double[] TransformDoublePoint_6(double id0,double id1,double id2);
  public double[] TransformDoublePoint(double id0,double id1,double id2)
    { return TransformDoublePoint_6(id0,id1,id2); }

  private native double[] TransformDoublePoint_7(double id0[]);
  public double[] TransformDoublePoint(double id0[])
    { return TransformDoublePoint_7(id0); }

  private native double[] TransformNormalAtPoint_8(double id0[],double id1[]);
  public double[] TransformNormalAtPoint(double id0[],double id1[])
    { return TransformNormalAtPoint_8(id0,id1); }

  private native double[] TransformDoubleNormalAtPoint_9(double id0[],double id1[]);
  public double[] TransformDoubleNormalAtPoint(double id0[],double id1[])
    { return TransformDoubleNormalAtPoint_9(id0,id1); }

  private native double[] TransformFloatNormalAtPoint_10(double id0[],double id1[]);
  public double[] TransformFloatNormalAtPoint(double id0[],double id1[])
    { return TransformFloatNormalAtPoint_10(id0,id1); }

  private native double[] TransformVectorAtPoint_11(double id0[],double id1[]);
  public double[] TransformVectorAtPoint(double id0[],double id1[])
    { return TransformVectorAtPoint_11(id0,id1); }

  private native double[] TransformDoubleVectorAtPoint_12(double id0[],double id1[]);
  public double[] TransformDoubleVectorAtPoint(double id0[],double id1[])
    { return TransformDoubleVectorAtPoint_12(id0,id1); }

  private native double[] TransformFloatVectorAtPoint_13(double id0[],double id1[]);
  public double[] TransformFloatVectorAtPoint(double id0[],double id1[])
    { return TransformFloatVectorAtPoint_13(id0,id1); }

  private native void TransformPoints_14(vtkPoints id0,vtkPoints id1);
  public void TransformPoints(vtkPoints id0,vtkPoints id1)
    { TransformPoints_14(id0,id1); }

  private native void TransformPointsNormalsVectors_15(vtkPoints id0,vtkPoints id1,vtkNormals id2,vtkNormals id3,vtkVectors id4,vtkVectors id5);
  public void TransformPointsNormalsVectors(vtkPoints id0,vtkPoints id1,vtkNormals id2,vtkNormals id3,vtkVectors id4,vtkVectors id5)
    { TransformPointsNormalsVectors_15(id0,id1,id2,id3,id4,id5); }

  private native vtkAbstractTransform GetInverse_16();
  public vtkAbstractTransform GetInverse()
    { return GetInverse_16(); }

  private native void SetInverse_17(vtkAbstractTransform id0);
  public void SetInverse(vtkAbstractTransform id0)
    { SetInverse_17(id0); }

  private native void DeepCopy_18(vtkAbstractTransform id0);
  public void DeepCopy(vtkAbstractTransform id0)
    { DeepCopy_18(id0); }

  private native void Update_19();
  public void Update()
    { Update_19(); }

  private native int CircuitCheck_20(vtkAbstractTransform id0);
  public int CircuitCheck(vtkAbstractTransform id0)
    { return CircuitCheck_20(id0); }

  private native int GetMTime_21();
  public int GetMTime()
    { return GetMTime_21(); }

  private native void UnRegister_22(vtkObject id0);
  public void UnRegister(vtkObject id0)
    { UnRegister_22(id0); }

  private native void Identity_23();
  public void Identity()
    { Identity_23(); }

  public vtkAbstractTransform() { super(); };

  protected vtkAbstractTransform(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
