// java wrapper for vtkCamera object
//

package vtk;
import vtk.*;

public class vtkCamera extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetPosition_2(double id0,double id1,double id2);
  public void SetPosition(double id0,double id1,double id2)
    { SetPosition_2(id0,id1,id2); }

  private native void SetPosition_3(double id0[]);
  public void SetPosition(double id0[])
    { SetPosition_3(id0); }

  private native double[] GetPosition_4();
  public double[] GetPosition()
    { return GetPosition_4(); }

  private native void SetFocalPoint_5(double id0,double id1,double id2);
  public void SetFocalPoint(double id0,double id1,double id2)
    { SetFocalPoint_5(id0,id1,id2); }

  private native void SetFocalPoint_6(double id0[]);
  public void SetFocalPoint(double id0[])
    { SetFocalPoint_6(id0); }

  private native double[] GetFocalPoint_7();
  public double[] GetFocalPoint()
    { return GetFocalPoint_7(); }

  private native void SetViewUp_8(double id0,double id1,double id2);
  public void SetViewUp(double id0,double id1,double id2)
    { SetViewUp_8(id0,id1,id2); }

  private native void SetViewUp_9(double id0[]);
  public void SetViewUp(double id0[])
    { SetViewUp_9(id0); }

  private native double[] GetViewUp_10();
  public double[] GetViewUp()
    { return GetViewUp_10(); }

  private native void OrthogonalizeViewUp_11();
  public void OrthogonalizeViewUp()
    { OrthogonalizeViewUp_11(); }

  private native void SetDistance_12(double id0);
  public void SetDistance(double id0)
    { SetDistance_12(id0); }

  private native double GetDistance_13();
  public double GetDistance()
    { return GetDistance_13(); }

  private native double[] GetDirectionOfProjection_14();
  public double[] GetDirectionOfProjection()
    { return GetDirectionOfProjection_14(); }

  private native void Dolly_15(double id0);
  public void Dolly(double id0)
    { Dolly_15(id0); }

  private native void SetRoll_16(double id0);
  public void SetRoll(double id0)
    { SetRoll_16(id0); }

  private native double GetRoll_17();
  public double GetRoll()
    { return GetRoll_17(); }

  private native void Roll_18(double id0);
  public void Roll(double id0)
    { Roll_18(id0); }

  private native void Azimuth_19(double id0);
  public void Azimuth(double id0)
    { Azimuth_19(id0); }

  private native void Yaw_20(double id0);
  public void Yaw(double id0)
    { Yaw_20(id0); }

  private native void Elevation_21(double id0);
  public void Elevation(double id0)
    { Elevation_21(id0); }

  private native void Pitch_22(double id0);
  public void Pitch(double id0)
    { Pitch_22(id0); }

  private native void SetParallelProjection_23(int id0);
  public void SetParallelProjection(int id0)
    { SetParallelProjection_23(id0); }

  private native int GetParallelProjection_24();
  public int GetParallelProjection()
    { return GetParallelProjection_24(); }

  private native void ParallelProjectionOn_25();
  public void ParallelProjectionOn()
    { ParallelProjectionOn_25(); }

  private native void ParallelProjectionOff_26();
  public void ParallelProjectionOff()
    { ParallelProjectionOff_26(); }

  private native void SetViewAngle_27(double id0);
  public void SetViewAngle(double id0)
    { SetViewAngle_27(id0); }

  private native double GetViewAngle_28();
  public double GetViewAngle()
    { return GetViewAngle_28(); }

  private native void SetParallelScale_29(double id0);
  public void SetParallelScale(double id0)
    { SetParallelScale_29(id0); }

  private native double GetParallelScale_30();
  public double GetParallelScale()
    { return GetParallelScale_30(); }

  private native void Zoom_31(double id0);
  public void Zoom(double id0)
    { Zoom_31(id0); }

  private native void SetClippingRange_32(double id0,double id1);
  public void SetClippingRange(double id0,double id1)
    { SetClippingRange_32(id0,id1); }

  private native void SetClippingRange_33(double id0[]);
  public void SetClippingRange(double id0[])
    { SetClippingRange_33(id0); }

  private native double[] GetClippingRange_34();
  public double[] GetClippingRange()
    { return GetClippingRange_34(); }

  private native void SetThickness_35(double id0);
  public void SetThickness(double id0)
    { SetThickness_35(id0); }

  private native double GetThickness_36();
  public double GetThickness()
    { return GetThickness_36(); }

  private native void SetWindowCenter_37(double id0,double id1);
  public void SetWindowCenter(double id0,double id1)
    { SetWindowCenter_37(id0,id1); }

  private native double[] GetWindowCenter_38();
  public double[] GetWindowCenter()
    { return GetWindowCenter_38(); }

  private native void SetObliqueAngles_39(double id0,double id1);
  public void SetObliqueAngles(double id0,double id1)
    { SetObliqueAngles_39(id0,id1); }

  private native double[] GetObliqueAngles_40();
  public double[] GetObliqueAngles()
    { return GetObliqueAngles_40(); }

  private native double[] GetViewPlaneNormal_41();
  public double[] GetViewPlaneNormal()
    { return GetViewPlaneNormal_41(); }

  private native void SetEyeAngle_42(double id0);
  public void SetEyeAngle(double id0)
    { SetEyeAngle_42(id0); }

  private native double GetEyeAngle_43();
  public double GetEyeAngle()
    { return GetEyeAngle_43(); }

  private native void SetFocalDisk_44(double id0);
  public void SetFocalDisk(double id0)
    { SetFocalDisk_44(id0); }

  private native double GetFocalDisk_45();
  public double GetFocalDisk()
    { return GetFocalDisk_45(); }

  private native vtkMatrix4x4 GetViewTransformMatrix_46();
  public vtkMatrix4x4 GetViewTransformMatrix()
    { return GetViewTransformMatrix_46(); }

  private native vtkMatrix4x4 GetPerspectiveTransformMatrix_47(double id0,double id1,double id2);
  public vtkMatrix4x4 GetPerspectiveTransformMatrix(double id0,double id1,double id2)
    { return GetPerspectiveTransformMatrix_47(id0,id1,id2); }

  private native vtkMatrix4x4 GetCompositePerspectiveTransformMatrix_48(double id0,double id1,double id2);
  public vtkMatrix4x4 GetCompositePerspectiveTransformMatrix(double id0,double id1,double id2)
    { return GetCompositePerspectiveTransformMatrix_48(id0,id1,id2); }

  private native void Render_49(vtkRenderer id0);
  public void Render(vtkRenderer id0)
    { Render_49(id0); }

  private native int GetViewingRaysMTime_50();
  public int GetViewingRaysMTime()
    { return GetViewingRaysMTime_50(); }

  private native void ViewingRaysModified_51();
  public void ViewingRaysModified()
    { ViewingRaysModified_51(); }

  private native double[] GetOrientation_52();
  public double[] GetOrientation()
    { return GetOrientation_52(); }

  private native double[] GetOrientationWXYZ_53();
  public double[] GetOrientationWXYZ()
    { return GetOrientationWXYZ_53(); }

  private native void SetViewPlaneNormal_54(double id0,double id1,double id2);
  public void SetViewPlaneNormal(double id0,double id1,double id2)
    { SetViewPlaneNormal_54(id0,id1,id2); }

  private native void SetViewPlaneNormal_55(double id0[]);
  public void SetViewPlaneNormal(double id0[])
    { SetViewPlaneNormal_55(id0); }

  private native void ComputeViewPlaneNormal_56();
  public void ComputeViewPlaneNormal()
    { ComputeViewPlaneNormal_56(); }

  private native vtkMatrix4x4 GetCameraLightTransformMatrix_57();
  public vtkMatrix4x4 GetCameraLightTransformMatrix()
    { return GetCameraLightTransformMatrix_57(); }

  private native vtkMatrix4x4 GetViewTransform_58();
  public vtkMatrix4x4 GetViewTransform()
    { return GetViewTransform_58(); }

  private native vtkMatrix4x4 GetPerspectiveTransform_59(double id0,double id1,double id2);
  public vtkMatrix4x4 GetPerspectiveTransform(double id0,double id1,double id2)
    { return GetPerspectiveTransform_59(id0,id1,id2); }

  private native vtkMatrix4x4 GetCompositePerspectiveTransform_60(double id0,double id1,double id2);
  public vtkMatrix4x4 GetCompositePerspectiveTransform(double id0,double id1,double id2)
    { return GetCompositePerspectiveTransform_60(id0,id1,id2); }

  public vtkCamera() { super(); };

  protected vtkCamera(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
