// java wrapper for vtkDataReader object
//

package vtk;
import vtk.*;

public class vtkDataReader extends vtkSource
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetFileName_2(String id0);
  public void SetFileName(String id0)
    { SetFileName_2(id0); }

  private native String GetFileName_3();
  public String GetFileName()
    { return GetFileName_3(); }

  private native int IsFileValid_4(String id0);
  public int IsFileValid(String id0)
    { return IsFileValid_4(id0); }

  private native int IsFileStructuredPoints_5();
  public int IsFileStructuredPoints()
    { return IsFileStructuredPoints_5(); }

  private native int IsFilePolyData_6();
  public int IsFilePolyData()
    { return IsFilePolyData_6(); }

  private native int IsFileStructuredGrid_7();
  public int IsFileStructuredGrid()
    { return IsFileStructuredGrid_7(); }

  private native int IsFileUnstructuredGrid_8();
  public int IsFileUnstructuredGrid()
    { return IsFileUnstructuredGrid_8(); }

  private native int IsFileRectilinearGrid_9();
  public int IsFileRectilinearGrid()
    { return IsFileRectilinearGrid_9(); }

  private native void SetInputString_10(String id0);
  public void SetInputString(String id0)
    { SetInputString_10(id0); }

  private native String GetInputString_11();
  public String GetInputString()
    { return GetInputString_11(); }

  private native void SetInputString_12(String id0,int id1);
  public void SetInputString(String id0,int id1)
    { SetInputString_12(id0,id1); }

  private native int GetInputStringLength_13();
  public int GetInputStringLength()
    { return GetInputStringLength_13(); }

  private native void SetBinaryInputString_14(byte id0[],int id1);

  public void SetBinaryInputString(byte id0[],int id1)
    { SetBinaryInputString_14(id0,id1); }

  private native String GetHeader_15();
  public String GetHeader()
    { return GetHeader_15(); }

  private native void SetReadFromInputString_16(int id0);
  public void SetReadFromInputString(int id0)
    { SetReadFromInputString_16(id0); }

  private native int GetReadFromInputString_17();
  public int GetReadFromInputString()
    { return GetReadFromInputString_17(); }

  private native void ReadFromInputStringOn_18();
  public void ReadFromInputStringOn()
    { ReadFromInputStringOn_18(); }

  private native void ReadFromInputStringOff_19();
  public void ReadFromInputStringOff()
    { ReadFromInputStringOff_19(); }

  private native int GetFileType_20();
  public int GetFileType()
    { return GetFileType_20(); }

  private native int GetNumberOfScalarsInFile_21();
  public int GetNumberOfScalarsInFile()
    { return GetNumberOfScalarsInFile_21(); }

  private native int GetNumberOfVectorsInFile_22();
  public int GetNumberOfVectorsInFile()
    { return GetNumberOfVectorsInFile_22(); }

  private native int GetNumberOfTensorsInFile_23();
  public int GetNumberOfTensorsInFile()
    { return GetNumberOfTensorsInFile_23(); }

  private native int GetNumberOfNormalsInFile_24();
  public int GetNumberOfNormalsInFile()
    { return GetNumberOfNormalsInFile_24(); }

  private native int GetNumberOfTCoordsInFile_25();
  public int GetNumberOfTCoordsInFile()
    { return GetNumberOfTCoordsInFile_25(); }

  private native int GetNumberOfFieldDataInFile_26();
  public int GetNumberOfFieldDataInFile()
    { return GetNumberOfFieldDataInFile_26(); }

  private native int GetNumberOfGhostLevelsInFile_27();
  public int GetNumberOfGhostLevelsInFile()
    { return GetNumberOfGhostLevelsInFile_27(); }

  private native String GetScalarsNameInFile_28(int id0);
  public String GetScalarsNameInFile(int id0)
    { return GetScalarsNameInFile_28(id0); }

  private native String GetVectorsNameInFile_29(int id0);
  public String GetVectorsNameInFile(int id0)
    { return GetVectorsNameInFile_29(id0); }

  private native String GetTensorsNameInFile_30(int id0);
  public String GetTensorsNameInFile(int id0)
    { return GetTensorsNameInFile_30(id0); }

  private native String GetNormalsNameInFile_31(int id0);
  public String GetNormalsNameInFile(int id0)
    { return GetNormalsNameInFile_31(id0); }

  private native String GetTCoordsNameInFile_32(int id0);
  public String GetTCoordsNameInFile(int id0)
    { return GetTCoordsNameInFile_32(id0); }

  private native String GetFieldDataNameInFile_33(int id0);
  public String GetFieldDataNameInFile(int id0)
    { return GetFieldDataNameInFile_33(id0); }

  private native String GetGhostLevelsNameInFile_34(int id0);
  public String GetGhostLevelsNameInFile(int id0)
    { return GetGhostLevelsNameInFile_34(id0); }

  private native void SetScalarsName_35(String id0);
  public void SetScalarsName(String id0)
    { SetScalarsName_35(id0); }

  private native String GetScalarsName_36();
  public String GetScalarsName()
    { return GetScalarsName_36(); }

  private native void SetVectorsName_37(String id0);
  public void SetVectorsName(String id0)
    { SetVectorsName_37(id0); }

  private native String GetVectorsName_38();
  public String GetVectorsName()
    { return GetVectorsName_38(); }

  private native void SetTensorsName_39(String id0);
  public void SetTensorsName(String id0)
    { SetTensorsName_39(id0); }

  private native String GetTensorsName_40();
  public String GetTensorsName()
    { return GetTensorsName_40(); }

  private native void SetGhostLevelsName_41(String id0);
  public void SetGhostLevelsName(String id0)
    { SetGhostLevelsName_41(id0); }

  private native String GetGhostLevelsName_42();
  public String GetGhostLevelsName()
    { return GetGhostLevelsName_42(); }

  private native void SetNormalsName_43(String id0);
  public void SetNormalsName(String id0)
    { SetNormalsName_43(id0); }

  private native String GetNormalsName_44();
  public String GetNormalsName()
    { return GetNormalsName_44(); }

  private native void SetTCoordsName_45(String id0);
  public void SetTCoordsName(String id0)
    { SetTCoordsName_45(id0); }

  private native String GetTCoordsName_46();
  public String GetTCoordsName()
    { return GetTCoordsName_46(); }

  private native void SetLookupTableName_47(String id0);
  public void SetLookupTableName(String id0)
    { SetLookupTableName_47(id0); }

  private native String GetLookupTableName_48();
  public String GetLookupTableName()
    { return GetLookupTableName_48(); }

  private native void SetFieldDataName_49(String id0);
  public void SetFieldDataName(String id0)
    { SetFieldDataName_49(id0); }

  private native String GetFieldDataName_50();
  public String GetFieldDataName()
    { return GetFieldDataName_50(); }

  private native int OpenVTKFile_51();
  public int OpenVTKFile()
    { return OpenVTKFile_51(); }

  private native int ReadHeader_52();
  public int ReadHeader()
    { return ReadHeader_52(); }

  private native int ReadCellData_53(vtkDataSet id0,int id1);
  public int ReadCellData(vtkDataSet id0,int id1)
    { return ReadCellData_53(id0,id1); }

  private native int ReadPointData_54(vtkDataSet id0,int id1);
  public int ReadPointData(vtkDataSet id0,int id1)
    { return ReadPointData_54(id0,id1); }

  private native int ReadPoints_55(vtkPointSet id0,int id1);
  public int ReadPoints(vtkPointSet id0,int id1)
    { return ReadPoints_55(id0,id1); }

  private native int ReadCoordinates_56(vtkRectilinearGrid id0,int id1,int id2);
  public int ReadCoordinates(vtkRectilinearGrid id0,int id1,int id2)
    { return ReadCoordinates_56(id0,id1,id2); }

  private native vtkDataArray ReadArray_57(String id0,int id1,int id2);
  public vtkDataArray ReadArray(String id0,int id1,int id2)
    { return ReadArray_57(id0,id1,id2); }

  private native vtkFieldData ReadFieldData_58();
  public vtkFieldData ReadFieldData()
    { return ReadFieldData_58(); }

  private native int Read_59(String id0);
  public int Read(String id0)
    { return Read_59(id0); }

  private native void CloseVTKFile_60();
  public void CloseVTKFile()
    { CloseVTKFile_60(); }

  private native String LowerCase_61(String id0);
  public String LowerCase(String id0)
    { return LowerCase_61(id0); }

  public vtkDataReader() { super(); };

  protected vtkDataReader(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
