// java wrapper for vtkDataSetAttributes object
//

package vtk;
import vtk.*;

public class vtkDataSetAttributes extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void Initialize_2();
  public void Initialize()
    { Initialize_2(); }

  private native void Update_3();
  public void Update()
    { Update_3(); }

  private native void PassData_4(vtkDataSetAttributes id0);
  public void PassData(vtkDataSetAttributes id0)
    { PassData_4(id0); }

  private native void PassNoReplaceData_5(vtkDataSetAttributes id0);
  public void PassNoReplaceData(vtkDataSetAttributes id0)
    { PassNoReplaceData_5(id0); }

  private native void CopyAllocate_6(vtkDataSetAttributes id0,int id1,int id2);
  public void CopyAllocate(vtkDataSetAttributes id0,int id1,int id2)
    { CopyAllocate_6(id0,id1,id2); }

  private native void CopyData_7(vtkDataSetAttributes id0,int id1,int id2);
  public void CopyData(vtkDataSetAttributes id0,int id1,int id2)
    { CopyData_7(id0,id1,id2); }

  private native void InterpolateAllocate_8(vtkDataSetAttributes id0,int id1,int id2);
  public void InterpolateAllocate(vtkDataSetAttributes id0,int id1,int id2)
    { InterpolateAllocate_8(id0,id1,id2); }

  private native void InterpolateEdge_9(vtkDataSetAttributes id0,int id1,int id2,int id3,double id4);
  public void InterpolateEdge(vtkDataSetAttributes id0,int id1,int id2,int id3,double id4)
    { InterpolateEdge_9(id0,id1,id2,id3,id4); }

  private native void InterpolateTime_10(vtkDataSetAttributes id0,vtkDataSetAttributes id1,int id2,double id3);
  public void InterpolateTime(vtkDataSetAttributes id0,vtkDataSetAttributes id1,int id2,double id3)
    { InterpolateTime_10(id0,id1,id2,id3); }

  private native void DeepCopy_11(vtkDataSetAttributes id0);
  public void DeepCopy(vtkDataSetAttributes id0)
    { DeepCopy_11(id0); }

  private native void ShallowCopy_12(vtkDataSetAttributes id0);
  public void ShallowCopy(vtkDataSetAttributes id0)
    { ShallowCopy_12(id0); }

  private native void Squeeze_13();
  public void Squeeze()
    { Squeeze_13(); }

  private native int GetMTime_14();
  public int GetMTime()
    { return GetMTime_14(); }

  private native void SetScalars_15(vtkScalars id0);
  public void SetScalars(vtkScalars id0)
    { SetScalars_15(id0); }

  private native vtkScalars GetScalars_16();
  public vtkScalars GetScalars()
    { return GetScalars_16(); }

  private native void SetVectors_17(vtkVectors id0);
  public void SetVectors(vtkVectors id0)
    { SetVectors_17(id0); }

  private native vtkVectors GetVectors_18();
  public vtkVectors GetVectors()
    { return GetVectors_18(); }

  private native void SetNormals_19(vtkNormals id0);
  public void SetNormals(vtkNormals id0)
    { SetNormals_19(id0); }

  private native vtkNormals GetNormals_20();
  public vtkNormals GetNormals()
    { return GetNormals_20(); }

  private native void SetGhostLevels_21(vtkGhostLevels id0);
  public void SetGhostLevels(vtkGhostLevels id0)
    { SetGhostLevels_21(id0); }

  private native vtkGhostLevels GetGhostLevels_22();
  public vtkGhostLevels GetGhostLevels()
    { return GetGhostLevels_22(); }

  private native void SetTCoords_23(vtkTCoords id0);
  public void SetTCoords(vtkTCoords id0)
    { SetTCoords_23(id0); }

  private native vtkTCoords GetTCoords_24();
  public vtkTCoords GetTCoords()
    { return GetTCoords_24(); }

  private native void SetTensors_25(vtkTensors id0);
  public void SetTensors(vtkTensors id0)
    { SetTensors_25(id0); }

  private native vtkTensors GetTensors_26();
  public vtkTensors GetTensors()
    { return GetTensors_26(); }

  private native void SetFieldData_27(vtkFieldData id0);
  public void SetFieldData(vtkFieldData id0)
    { SetFieldData_27(id0); }

  private native vtkFieldData GetFieldData_28();
  public vtkFieldData GetFieldData()
    { return GetFieldData_28(); }

  private native void SetCopyScalars_29(int id0);
  public void SetCopyScalars(int id0)
    { SetCopyScalars_29(id0); }

  private native int GetCopyScalars_30();
  public int GetCopyScalars()
    { return GetCopyScalars_30(); }

  private native void CopyScalarsOn_31();
  public void CopyScalarsOn()
    { CopyScalarsOn_31(); }

  private native void CopyScalarsOff_32();
  public void CopyScalarsOff()
    { CopyScalarsOff_32(); }

  private native void SetCopyVectors_33(int id0);
  public void SetCopyVectors(int id0)
    { SetCopyVectors_33(id0); }

  private native int GetCopyVectors_34();
  public int GetCopyVectors()
    { return GetCopyVectors_34(); }

  private native void CopyVectorsOn_35();
  public void CopyVectorsOn()
    { CopyVectorsOn_35(); }

  private native void CopyVectorsOff_36();
  public void CopyVectorsOff()
    { CopyVectorsOff_36(); }

  private native void SetCopyGhostLevels_37(int id0);
  public void SetCopyGhostLevels(int id0)
    { SetCopyGhostLevels_37(id0); }

  private native int GetCopyGhostLevels_38();
  public int GetCopyGhostLevels()
    { return GetCopyGhostLevels_38(); }

  private native void CopyGhostLevelsOn_39();
  public void CopyGhostLevelsOn()
    { CopyGhostLevelsOn_39(); }

  private native void CopyGhostLevelsOff_40();
  public void CopyGhostLevelsOff()
    { CopyGhostLevelsOff_40(); }

  private native void SetCopyNormals_41(int id0);
  public void SetCopyNormals(int id0)
    { SetCopyNormals_41(id0); }

  private native int GetCopyNormals_42();
  public int GetCopyNormals()
    { return GetCopyNormals_42(); }

  private native void CopyNormalsOn_43();
  public void CopyNormalsOn()
    { CopyNormalsOn_43(); }

  private native void CopyNormalsOff_44();
  public void CopyNormalsOff()
    { CopyNormalsOff_44(); }

  private native void SetCopyTCoords_45(int id0);
  public void SetCopyTCoords(int id0)
    { SetCopyTCoords_45(id0); }

  private native int GetCopyTCoords_46();
  public int GetCopyTCoords()
    { return GetCopyTCoords_46(); }

  private native void CopyTCoordsOn_47();
  public void CopyTCoordsOn()
    { CopyTCoordsOn_47(); }

  private native void CopyTCoordsOff_48();
  public void CopyTCoordsOff()
    { CopyTCoordsOff_48(); }

  private native void SetCopyTensors_49(int id0);
  public void SetCopyTensors(int id0)
    { SetCopyTensors_49(id0); }

  private native int GetCopyTensors_50();
  public int GetCopyTensors()
    { return GetCopyTensors_50(); }

  private native void CopyTensorsOn_51();
  public void CopyTensorsOn()
    { CopyTensorsOn_51(); }

  private native void CopyTensorsOff_52();
  public void CopyTensorsOff()
    { CopyTensorsOff_52(); }

  private native void SetCopyFieldData_53(int id0);
  public void SetCopyFieldData(int id0)
    { SetCopyFieldData_53(id0); }

  private native int GetCopyFieldData_54();
  public int GetCopyFieldData()
    { return GetCopyFieldData_54(); }

  private native void CopyFieldDataOn_55();
  public void CopyFieldDataOn()
    { CopyFieldDataOn_55(); }

  private native void CopyFieldDataOff_56();
  public void CopyFieldDataOff()
    { CopyFieldDataOff_56(); }

  private native int GetAnyEnabled_57();
  public int GetAnyEnabled()
    { return GetAnyEnabled_57(); }

  private native void CopyAllOn_58();
  public void CopyAllOn()
    { CopyAllOn_58(); }

  private native void CopyAllOff_59();
  public void CopyAllOff()
    { CopyAllOff_59(); }

  private native void CopyTuple_60(vtkDataArray id0,vtkDataArray id1,int id2,int id3);
  public void CopyTuple(vtkDataArray id0,vtkDataArray id1,int id2,int id3)
    { CopyTuple_60(id0,id1,id2,id3); }

  private native int GetActualMemorySize_61();
  public int GetActualMemorySize()
    { return GetActualMemorySize_61(); }

  public vtkDataSetAttributes() { super(); };

  protected vtkDataSetAttributes(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
