// java wrapper for vtkEncodedGradientEstimator object
//

package vtk;
import vtk.*;

public class vtkEncodedGradientEstimator extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetInput_2(vtkImageData id0);
  public void SetInput(vtkImageData id0)
    { SetInput_2(id0); }

  private native vtkImageData GetInput_3();
  public vtkImageData GetInput()
    { return GetInput_3(); }

  private native void SetGradientMagnitudeScale_4(double id0);
  public void SetGradientMagnitudeScale(double id0)
    { SetGradientMagnitudeScale_4(id0); }

  private native double GetGradientMagnitudeScale_5();
  public double GetGradientMagnitudeScale()
    { return GetGradientMagnitudeScale_5(); }

  private native void SetGradientMagnitudeBias_6(double id0);
  public void SetGradientMagnitudeBias(double id0)
    { SetGradientMagnitudeBias_6(id0); }

  private native double GetGradientMagnitudeBias_7();
  public double GetGradientMagnitudeBias()
    { return GetGradientMagnitudeBias_7(); }

  private native void SetBoundsClip_8(int id0);
  public void SetBoundsClip(int id0)
    { SetBoundsClip_8(id0); }

  private native int GetBoundsClip_9();
  public int GetBoundsClip()
    { return GetBoundsClip_9(); }

  private native void BoundsClipOn_10();
  public void BoundsClipOn()
    { BoundsClipOn_10(); }

  private native void BoundsClipOff_11();
  public void BoundsClipOff()
    { BoundsClipOff_11(); }

  private native void SetBounds_12(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetBounds(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetBounds_12(id0,id1,id2,id3,id4,id5); }

  private native void SetBounds_13(int id0[]);
  public void SetBounds(int id0[])
    { SetBounds_13(id0); }

  private native int[]  GetBounds_14();
  public int[]  GetBounds()
    { return GetBounds_14(); }

  private native void Update_15();
  public void Update()
    { Update_15(); }

  private native int GetEncodedNormalIndex_16(int id0);
  public int GetEncodedNormalIndex(int id0)
    { return GetEncodedNormalIndex_16(id0); }

  private native int GetEncodedNormalIndex_17(int id0,int id1,int id2);
  public int GetEncodedNormalIndex(int id0,int id1,int id2)
    { return GetEncodedNormalIndex_17(id0,id1,id2); }

  private native void SetNumberOfThreads_18(int id0);
  public void SetNumberOfThreads(int id0)
    { SetNumberOfThreads_18(id0); }

  private native int GetNumberOfThreads_19();
  public int GetNumberOfThreads()
    { return GetNumberOfThreads_19(); }

  private native void SetDirectionEncoder_20(vtkDirectionEncoder id0);
  public void SetDirectionEncoder(vtkDirectionEncoder id0)
    { SetDirectionEncoder_20(id0); }

  private native vtkDirectionEncoder GetDirectionEncoder_21();
  public vtkDirectionEncoder GetDirectionEncoder()
    { return GetDirectionEncoder_21(); }

  private native void SetComputeGradientMagnitudes_22(int id0);
  public void SetComputeGradientMagnitudes(int id0)
    { SetComputeGradientMagnitudes_22(id0); }

  private native int GetComputeGradientMagnitudes_23();
  public int GetComputeGradientMagnitudes()
    { return GetComputeGradientMagnitudes_23(); }

  private native void ComputeGradientMagnitudesOn_24();
  public void ComputeGradientMagnitudesOn()
    { ComputeGradientMagnitudesOn_24(); }

  private native void ComputeGradientMagnitudesOff_25();
  public void ComputeGradientMagnitudesOff()
    { ComputeGradientMagnitudesOff_25(); }

  private native void SetCylinderClip_26(int id0);
  public void SetCylinderClip(int id0)
    { SetCylinderClip_26(id0); }

  private native int GetCylinderClip_27();
  public int GetCylinderClip()
    { return GetCylinderClip_27(); }

  private native void CylinderClipOn_28();
  public void CylinderClipOn()
    { CylinderClipOn_28(); }

  private native void CylinderClipOff_29();
  public void CylinderClipOff()
    { CylinderClipOff_29(); }

  private native double GetLastUpdateTimeInSeconds_30();
  public double GetLastUpdateTimeInSeconds()
    { return GetLastUpdateTimeInSeconds_30(); }

  private native double GetLastUpdateTimeInCPUSeconds_31();
  public double GetLastUpdateTimeInCPUSeconds()
    { return GetLastUpdateTimeInCPUSeconds_31(); }

  private native int GetUseCylinderClip_32();
  public int GetUseCylinderClip()
    { return GetUseCylinderClip_32(); }

  private native void SetZeroNormalThreshold_33(double id0);
  public void SetZeroNormalThreshold(double id0)
    { SetZeroNormalThreshold_33(id0); }

  private native double GetZeroNormalThreshold_34();
  public double GetZeroNormalThreshold()
    { return GetZeroNormalThreshold_34(); }

  private native void SetZeroPad_35(int id0);
  public void SetZeroPad(int id0)
    { SetZeroPad_35(id0); }

  private native int GetZeroPad_36();
  public int GetZeroPad()
    { return GetZeroPad_36(); }

  private native void ZeroPadOn_37();
  public void ZeroPadOn()
    { ZeroPadOn_37(); }

  private native void ZeroPadOff_38();
  public void ZeroPadOff()
    { ZeroPadOff_38(); }

  private native int[]  GetInputSize_39();
  public int[]  GetInputSize()
    { return GetInputSize_39(); }

  private native double[] GetInputAspect_40();
  public double[] GetInputAspect()
    { return GetInputAspect_40(); }

  public vtkEncodedGradientEstimator() { super(); };

  protected vtkEncodedGradientEstimator(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
