// java wrapper for vtkGaussianSplatter object
//

package vtk;
import vtk.*;

public class vtkGaussianSplatter extends vtkDataSetToStructuredPointsFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void ComputeModelBounds_2();
  public void ComputeModelBounds()
    { ComputeModelBounds_2(); }

  private native void SetSampleDimensions_3(int id0,int id1,int id2);
  public void SetSampleDimensions(int id0,int id1,int id2)
    { SetSampleDimensions_3(id0,id1,id2); }

  private native int[]  GetSampleDimensions_4();
  public int[]  GetSampleDimensions()
    { return GetSampleDimensions_4(); }

  private native void SetRadius_5(double id0);
  public void SetRadius(double id0)
    { SetRadius_5(id0); }

  private native double GetRadius_6();
  public double GetRadius()
    { return GetRadius_6(); }

  private native void SetScaleFactor_7(double id0);
  public void SetScaleFactor(double id0)
    { SetScaleFactor_7(id0); }

  private native double GetScaleFactor_8();
  public double GetScaleFactor()
    { return GetScaleFactor_8(); }

  private native void SetExponentFactor_9(double id0);
  public void SetExponentFactor(double id0)
    { SetExponentFactor_9(id0); }

  private native double GetExponentFactor_10();
  public double GetExponentFactor()
    { return GetExponentFactor_10(); }

  private native void SetEccentricity_11(double id0);
  public void SetEccentricity(double id0)
    { SetEccentricity_11(id0); }

  private native double GetEccentricity_12();
  public double GetEccentricity()
    { return GetEccentricity_12(); }

  private native void SetModelBounds_13(double id0,double id1,double id2,double id3,double id4,double id5);
  public void SetModelBounds(double id0,double id1,double id2,double id3,double id4,double id5)
    { SetModelBounds_13(id0,id1,id2,id3,id4,id5); }

  private native void SetModelBounds_14(double id0[]);
  public void SetModelBounds(double id0[])
    { SetModelBounds_14(id0); }

  private native double[] GetModelBounds_15();
  public double[] GetModelBounds()
    { return GetModelBounds_15(); }

  private native void SetNormalWarping_16(int id0);
  public void SetNormalWarping(int id0)
    { SetNormalWarping_16(id0); }

  private native int GetNormalWarping_17();
  public int GetNormalWarping()
    { return GetNormalWarping_17(); }

  private native void NormalWarpingOn_18();
  public void NormalWarpingOn()
    { NormalWarpingOn_18(); }

  private native void NormalWarpingOff_19();
  public void NormalWarpingOff()
    { NormalWarpingOff_19(); }

  private native void SetScalarWarping_20(int id0);
  public void SetScalarWarping(int id0)
    { SetScalarWarping_20(id0); }

  private native int GetScalarWarping_21();
  public int GetScalarWarping()
    { return GetScalarWarping_21(); }

  private native void ScalarWarpingOn_22();
  public void ScalarWarpingOn()
    { ScalarWarpingOn_22(); }

  private native void ScalarWarpingOff_23();
  public void ScalarWarpingOff()
    { ScalarWarpingOff_23(); }

  private native void SetCapping_24(int id0);
  public void SetCapping(int id0)
    { SetCapping_24(id0); }

  private native int GetCapping_25();
  public int GetCapping()
    { return GetCapping_25(); }

  private native void CappingOn_26();
  public void CappingOn()
    { CappingOn_26(); }

  private native void CappingOff_27();
  public void CappingOff()
    { CappingOff_27(); }

  private native void SetCapValue_28(double id0);
  public void SetCapValue(double id0)
    { SetCapValue_28(id0); }

  private native double GetCapValue_29();
  public double GetCapValue()
    { return GetCapValue_29(); }

  private native void SetAccumulationMode_30(int id0);
  public void SetAccumulationMode(int id0)
    { SetAccumulationMode_30(id0); }

  private native int GetAccumulationMode_31();
  public int GetAccumulationMode()
    { return GetAccumulationMode_31(); }

  private native void SetAccumulationModeToMin_32();
  public void SetAccumulationModeToMin()
    { SetAccumulationModeToMin_32(); }

  private native void SetAccumulationModeToMax_33();
  public void SetAccumulationModeToMax()
    { SetAccumulationModeToMax_33(); }

  private native void SetAccumulationModeToSum_34();
  public void SetAccumulationModeToSum()
    { SetAccumulationModeToSum_34(); }

  private native String GetAccumulationModeAsString_35();
  public String GetAccumulationModeAsString()
    { return GetAccumulationModeAsString_35(); }

  public vtkGaussianSplatter() { super(); };

  protected vtkGaussianSplatter(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
