// java wrapper for vtkGenericCell object
//

package vtk;
import vtk.*;

public class vtkGenericCell extends vtkCell
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native vtkCell MakeObject_2();
  public vtkCell MakeObject()
    { return MakeObject_2(); }

  private native void ShallowCopy_3(vtkCell id0);
  public void ShallowCopy(vtkCell id0)
    { ShallowCopy_3(id0); }

  private native void DeepCopy_4(vtkCell id0);
  public void DeepCopy(vtkCell id0)
    { DeepCopy_4(id0); }

  private native int GetCellType_5();
  public int GetCellType()
    { return GetCellType_5(); }

  private native int GetCellDimension_6();
  public int GetCellDimension()
    { return GetCellDimension_6(); }

  private native int GetInterpolationOrder_7();
  public int GetInterpolationOrder()
    { return GetInterpolationOrder_7(); }

  private native int GetNumberOfEdges_8();
  public int GetNumberOfEdges()
    { return GetNumberOfEdges_8(); }

  private native int GetNumberOfFaces_9();
  public int GetNumberOfFaces()
    { return GetNumberOfFaces_9(); }

  private native vtkCell GetEdge_10(int id0);
  public vtkCell GetEdge(int id0)
    { return GetEdge_10(id0); }

  private native vtkCell GetFace_11(int id0);
  public vtkCell GetFace(int id0)
    { return GetFace_11(id0); }

  private native void Contour_12(double id0,vtkScalars id1,vtkPointLocator id2,vtkCellArray id3,vtkCellArray id4,vtkCellArray id5,vtkPointData id6,vtkPointData id7,vtkCellData id8,int id9,vtkCellData id10);
  public void Contour(double id0,vtkScalars id1,vtkPointLocator id2,vtkCellArray id3,vtkCellArray id4,vtkCellArray id5,vtkPointData id6,vtkPointData id7,vtkCellData id8,int id9,vtkCellData id10)
    { Contour_12(id0,id1,id2,id3,id4,id5,id6,id7,id8,id9,id10); }

  private native void Clip_13(double id0,vtkScalars id1,vtkPointLocator id2,vtkCellArray id3,vtkPointData id4,vtkPointData id5,vtkCellData id6,int id7,vtkCellData id8,int id9);
  public void Clip(double id0,vtkScalars id1,vtkPointLocator id2,vtkCellArray id3,vtkPointData id4,vtkPointData id5,vtkCellData id6,int id7,vtkCellData id8,int id9)
    { Clip_13(id0,id1,id2,id3,id4,id5,id6,id7,id8,id9); }

  private native int Triangulate_14(int id0,vtkIdList id1,vtkPoints id2);
  public int Triangulate(int id0,vtkIdList id1,vtkPoints id2)
    { return Triangulate_14(id0,id1,id2); }

  private native void SetCellType_15(int id0);
  public void SetCellType(int id0)
    { SetCellType_15(id0); }

  private native void SetCellTypeToEmptyCell_16();
  public void SetCellTypeToEmptyCell()
    { SetCellTypeToEmptyCell_16(); }

  private native void SetCellTypeToVertex_17();
  public void SetCellTypeToVertex()
    { SetCellTypeToVertex_17(); }

  private native void SetCellTypeToPolyVertex_18();
  public void SetCellTypeToPolyVertex()
    { SetCellTypeToPolyVertex_18(); }

  private native void SetCellTypeToLine_19();
  public void SetCellTypeToLine()
    { SetCellTypeToLine_19(); }

  private native void SetCellTypeToPolyLine_20();
  public void SetCellTypeToPolyLine()
    { SetCellTypeToPolyLine_20(); }

  private native void SetCellTypeToTriangle_21();
  public void SetCellTypeToTriangle()
    { SetCellTypeToTriangle_21(); }

  private native void SetCellTypeToTriangleStrip_22();
  public void SetCellTypeToTriangleStrip()
    { SetCellTypeToTriangleStrip_22(); }

  private native void SetCellTypeToPolygon_23();
  public void SetCellTypeToPolygon()
    { SetCellTypeToPolygon_23(); }

  private native void SetCellTypeToPixel_24();
  public void SetCellTypeToPixel()
    { SetCellTypeToPixel_24(); }

  private native void SetCellTypeToQuad_25();
  public void SetCellTypeToQuad()
    { SetCellTypeToQuad_25(); }

  private native void SetCellTypeToTetra_26();
  public void SetCellTypeToTetra()
    { SetCellTypeToTetra_26(); }

  private native void SetCellTypeToVoxel_27();
  public void SetCellTypeToVoxel()
    { SetCellTypeToVoxel_27(); }

  private native void SetCellTypeToHexahedron_28();
  public void SetCellTypeToHexahedron()
    { SetCellTypeToHexahedron_28(); }

  private native void SetCellTypeToWedge_29();
  public void SetCellTypeToWedge()
    { SetCellTypeToWedge_29(); }

  private native void SetCellTypeToPyramid_30();
  public void SetCellTypeToPyramid()
    { SetCellTypeToPyramid_30(); }

  public vtkGenericCell() { super(); };

  protected vtkGenericCell(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
