// java wrapper for vtkGlyphSource2D object
//

package vtk;
import vtk.*;

public class vtkGlyphSource2D extends vtkPolyDataSource
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetCenter_2(double id0,double id1,double id2);
  public void SetCenter(double id0,double id1,double id2)
    { SetCenter_2(id0,id1,id2); }

  private native void SetCenter_3(double id0[]);
  public void SetCenter(double id0[])
    { SetCenter_3(id0); }

  private native double[] GetCenter_4();
  public double[] GetCenter()
    { return GetCenter_4(); }

  private native void SetScale_5(double id0);
  public void SetScale(double id0)
    { SetScale_5(id0); }

  private native double GetScale_6();
  public double GetScale()
    { return GetScale_6(); }

  private native void SetScale2_7(double id0);
  public void SetScale2(double id0)
    { SetScale2_7(id0); }

  private native double GetScale2_8();
  public double GetScale2()
    { return GetScale2_8(); }

  private native void SetColor_9(double id0,double id1,double id2);
  public void SetColor(double id0,double id1,double id2)
    { SetColor_9(id0,id1,id2); }

  private native void SetColor_10(double id0[]);
  public void SetColor(double id0[])
    { SetColor_10(id0); }

  private native double[] GetColor_11();
  public double[] GetColor()
    { return GetColor_11(); }

  private native void SetFilled_12(int id0);
  public void SetFilled(int id0)
    { SetFilled_12(id0); }

  private native int GetFilled_13();
  public int GetFilled()
    { return GetFilled_13(); }

  private native void FilledOn_14();
  public void FilledOn()
    { FilledOn_14(); }

  private native void FilledOff_15();
  public void FilledOff()
    { FilledOff_15(); }

  private native void SetDash_16(int id0);
  public void SetDash(int id0)
    { SetDash_16(id0); }

  private native int GetDash_17();
  public int GetDash()
    { return GetDash_17(); }

  private native void DashOn_18();
  public void DashOn()
    { DashOn_18(); }

  private native void DashOff_19();
  public void DashOff()
    { DashOff_19(); }

  private native void SetCross_20(int id0);
  public void SetCross(int id0)
    { SetCross_20(id0); }

  private native int GetCross_21();
  public int GetCross()
    { return GetCross_21(); }

  private native void CrossOn_22();
  public void CrossOn()
    { CrossOn_22(); }

  private native void CrossOff_23();
  public void CrossOff()
    { CrossOff_23(); }

  private native void SetRotationAngle_24(double id0);
  public void SetRotationAngle(double id0)
    { SetRotationAngle_24(id0); }

  private native double GetRotationAngle_25();
  public double GetRotationAngle()
    { return GetRotationAngle_25(); }

  private native void RotationAngleOn_26();
  public void RotationAngleOn()
    { RotationAngleOn_26(); }

  private native void RotationAngleOff_27();
  public void RotationAngleOff()
    { RotationAngleOff_27(); }

  private native void SetGlyphType_28(int id0);
  public void SetGlyphType(int id0)
    { SetGlyphType_28(id0); }

  private native int GetGlyphType_29();
  public int GetGlyphType()
    { return GetGlyphType_29(); }

  private native void SetGlyphTypeToNone_30();
  public void SetGlyphTypeToNone()
    { SetGlyphTypeToNone_30(); }

  private native void SetGlyphTypeToVertex_31();
  public void SetGlyphTypeToVertex()
    { SetGlyphTypeToVertex_31(); }

  private native void SetGlyphTypeToDash_32();
  public void SetGlyphTypeToDash()
    { SetGlyphTypeToDash_32(); }

  private native void SetGlyphTypeToCross_33();
  public void SetGlyphTypeToCross()
    { SetGlyphTypeToCross_33(); }

  private native void SetGlyphTypeToThickCross_34();
  public void SetGlyphTypeToThickCross()
    { SetGlyphTypeToThickCross_34(); }

  private native void SetGlyphTypeToTriangle_35();
  public void SetGlyphTypeToTriangle()
    { SetGlyphTypeToTriangle_35(); }

  private native void SetGlyphTypeToSquare_36();
  public void SetGlyphTypeToSquare()
    { SetGlyphTypeToSquare_36(); }

  private native void SetGlyphTypeToCircle_37();
  public void SetGlyphTypeToCircle()
    { SetGlyphTypeToCircle_37(); }

  private native void SetGlyphTypeToDiamond_38();
  public void SetGlyphTypeToDiamond()
    { SetGlyphTypeToDiamond_38(); }

  private native void SetGlyphTypeToArrow_39();
  public void SetGlyphTypeToArrow()
    { SetGlyphTypeToArrow_39(); }

  private native void SetGlyphTypeToThickArrow_40();
  public void SetGlyphTypeToThickArrow()
    { SetGlyphTypeToThickArrow_40(); }

  private native void SetGlyphTypeToHookedArrow_41();
  public void SetGlyphTypeToHookedArrow()
    { SetGlyphTypeToHookedArrow_41(); }

  public vtkGlyphSource2D() { super(); };

  protected vtkGlyphSource2D(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
