// java wrapper for vtkHyperStreamline object
//

package vtk;
import vtk.*;

public class vtkHyperStreamline extends vtkDataSetToPolyDataFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetStartLocation_2(int id0,int id1,double id2,double id3,double id4);
  public void SetStartLocation(int id0,int id1,double id2,double id3,double id4)
    { SetStartLocation_2(id0,id1,id2,id3,id4); }

  private native void SetStartPosition_3(double id0,double id1,double id2);
  public void SetStartPosition(double id0,double id1,double id2)
    { SetStartPosition_3(id0,id1,id2); }

  private native void SetMaximumPropagationDistance_4(double id0);
  public void SetMaximumPropagationDistance(double id0)
    { SetMaximumPropagationDistance_4(id0); }

  private native double GetMaximumPropagationDistance_5();
  public double GetMaximumPropagationDistance()
    { return GetMaximumPropagationDistance_5(); }

  private native void IntegrateMajorEigenvector_6();
  public void IntegrateMajorEigenvector()
    { IntegrateMajorEigenvector_6(); }

  private native void IntegrateMediumEigenvector_7();
  public void IntegrateMediumEigenvector()
    { IntegrateMediumEigenvector_7(); }

  private native void IntegrateMinorEigenvector_8();
  public void IntegrateMinorEigenvector()
    { IntegrateMinorEigenvector_8(); }

  private native void SetIntegrationStepLength_9(double id0);
  public void SetIntegrationStepLength(double id0)
    { SetIntegrationStepLength_9(id0); }

  private native double GetIntegrationStepLength_10();
  public double GetIntegrationStepLength()
    { return GetIntegrationStepLength_10(); }

  private native void SetStepLength_11(double id0);
  public void SetStepLength(double id0)
    { SetStepLength_11(id0); }

  private native double GetStepLength_12();
  public double GetStepLength()
    { return GetStepLength_12(); }

  private native void SetIntegrationDirection_13(int id0);
  public void SetIntegrationDirection(int id0)
    { SetIntegrationDirection_13(id0); }

  private native int GetIntegrationDirection_14();
  public int GetIntegrationDirection()
    { return GetIntegrationDirection_14(); }

  private native void SetIntegrationDirectionToForward_15();
  public void SetIntegrationDirectionToForward()
    { SetIntegrationDirectionToForward_15(); }

  private native void SetIntegrationDirectionToBackward_16();
  public void SetIntegrationDirectionToBackward()
    { SetIntegrationDirectionToBackward_16(); }

  private native void SetIntegrationDirectionToIntegrateBothDirections_17();
  public void SetIntegrationDirectionToIntegrateBothDirections()
    { SetIntegrationDirectionToIntegrateBothDirections_17(); }

  private native void SetTerminalEigenvalue_18(double id0);
  public void SetTerminalEigenvalue(double id0)
    { SetTerminalEigenvalue_18(id0); }

  private native double GetTerminalEigenvalue_19();
  public double GetTerminalEigenvalue()
    { return GetTerminalEigenvalue_19(); }

  private native void SetNumberOfSides_20(int id0);
  public void SetNumberOfSides(int id0)
    { SetNumberOfSides_20(id0); }

  private native int GetNumberOfSides_21();
  public int GetNumberOfSides()
    { return GetNumberOfSides_21(); }

  private native void SetRadius_22(double id0);
  public void SetRadius(double id0)
    { SetRadius_22(id0); }

  private native double GetRadius_23();
  public double GetRadius()
    { return GetRadius_23(); }

  private native void SetLogScaling_24(int id0);
  public void SetLogScaling(int id0)
    { SetLogScaling_24(id0); }

  private native int GetLogScaling_25();
  public int GetLogScaling()
    { return GetLogScaling_25(); }

  private native void LogScalingOn_26();
  public void LogScalingOn()
    { LogScalingOn_26(); }

  private native void LogScalingOff_27();
  public void LogScalingOff()
    { LogScalingOff_27(); }

  public vtkHyperStreamline() { super(); };

  protected vtkHyperStreamline(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
