// java wrapper for vtkImageData object
//

package vtk;
import vtk.*;

public class vtkImageData extends vtkDataSet
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native vtkDataObject MakeObject_2();
  public vtkDataObject MakeObject()
    { return MakeObject_2(); }

  private native void CopyStructure_3(vtkDataSet id0);
  public void CopyStructure(vtkDataSet id0)
    { CopyStructure_3(id0); }

  private native int GetDataObjectType_4();
  public int GetDataObjectType()
    { return GetDataObjectType_4(); }

  private native void UpdateData_5();
  public void UpdateData()
    { UpdateData_5(); }

  private native int GetNumberOfCells_6();
  public int GetNumberOfCells()
    { return GetNumberOfCells_6(); }

  private native int GetNumberOfPoints_7();
  public int GetNumberOfPoints()
    { return GetNumberOfPoints_7(); }

  private native vtkCell GetCell_8(int id0);
  public vtkCell GetCell(int id0)
    { return GetCell_8(id0); }

  private native void GetCell_9(int id0,vtkGenericCell id1);
  public void GetCell(int id0,vtkGenericCell id1)
    { GetCell_9(id0,id1); }

  private native int FindPoint_10(double id0,double id1,double id2);
  public int FindPoint(double id0,double id1,double id2)
    { return FindPoint_10(id0,id1,id2); }

  private native int GetCellType_11(int id0);
  public int GetCellType(int id0)
    { return GetCellType_11(id0); }

  private native void GetCellPoints_12(int id0,vtkIdList id1);
  public void GetCellPoints(int id0,vtkIdList id1)
    { GetCellPoints_12(id0,id1); }

  private native void GetPointCells_13(int id0,vtkIdList id1);
  public void GetPointCells(int id0,vtkIdList id1)
    { GetPointCells_13(id0,id1); }

  private native void ComputeBounds_14();
  public void ComputeBounds()
    { ComputeBounds_14(); }

  private native int GetMaxCellSize_15();
  public int GetMaxCellSize()
    { return GetMaxCellSize_15(); }

  private native void SetDimensions_16(int id0,int id1,int id2);
  public void SetDimensions(int id0,int id1,int id2)
    { SetDimensions_16(id0,id1,id2); }

  private native int[]  GetDimensions_17();
  public int[]  GetDimensions()
    { return GetDimensions_17(); }

  private native void GetVoxelGradient_18(int id0,int id1,int id2,vtkScalars id3,vtkVectors id4);
  public void GetVoxelGradient(int id0,int id1,int id2,vtkScalars id3,vtkVectors id4)
    { GetVoxelGradient_18(id0,id1,id2,id3,id4); }

  private native int GetDataDimension_19();
  public int GetDataDimension()
    { return GetDataDimension_19(); }

  private native void SetAxisUpdateExtent_20(int id0,int id1,int id2);
  public void SetAxisUpdateExtent(int id0,int id1,int id2)
    { SetAxisUpdateExtent_20(id0,id1,id2); }

  private native void SetUpdateExtent_21(int id0,int id1,int id2);
  public void SetUpdateExtent(int id0,int id1,int id2)
    { SetUpdateExtent_21(id0,id1,id2); }

  private native void SetUpdateExtent_22(int id0,int id1);
  public void SetUpdateExtent(int id0,int id1)
    { SetUpdateExtent_22(id0,id1); }

  private native void SetUpdateExtent_23(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetUpdateExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetUpdateExtent_23(id0,id1,id2,id3,id4,id5); }

  private native void SetExtent_24(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetExtent_24(id0,id1,id2,id3,id4,id5); }

  private native int[]  GetExtent_25();
  public int[]  GetExtent()
    { return GetExtent_25(); }

  private native int GetEstimatedMemorySize_26();
  public int GetEstimatedMemorySize()
    { return GetEstimatedMemorySize_26(); }

  private native double GetScalarTypeMin_27();
  public double GetScalarTypeMin()
    { return GetScalarTypeMin_27(); }

  private native double GetScalarTypeMax_28();
  public double GetScalarTypeMax()
    { return GetScalarTypeMax_28(); }

  private native int GetScalarSize_29();
  public int GetScalarSize()
    { return GetScalarSize_29(); }

  private native double GetScalarComponentAsFloat_30(int id0,int id1,int id2,int id3);
  public double GetScalarComponentAsFloat(int id0,int id1,int id2,int id3)
    { return GetScalarComponentAsFloat_30(id0,id1,id2,id3); }

  private native void AllocateScalars_31();
  public void AllocateScalars()
    { AllocateScalars_31(); }

  private native vtkImageToStructuredPoints MakeImageToStructuredPoints_32();
  public vtkImageToStructuredPoints MakeImageToStructuredPoints()
    { return MakeImageToStructuredPoints_32(); }

  private native int GetActualMemorySize_33();
  public int GetActualMemorySize()
    { return GetActualMemorySize_33(); }

  private native void SetSpacing_34(double id0,double id1,double id2);
  public void SetSpacing(double id0,double id1,double id2)
    { SetSpacing_34(id0,id1,id2); }

  private native void SetSpacing_35(double id0[]);
  public void SetSpacing(double id0[])
    { SetSpacing_35(id0); }

  private native double[] GetSpacing_36();
  public double[] GetSpacing()
    { return GetSpacing_36(); }

  private native void SetOrigin_37(double id0,double id1,double id2);
  public void SetOrigin(double id0,double id1,double id2)
    { SetOrigin_37(id0,id1,id2); }

  private native void SetOrigin_38(double id0[]);
  public void SetOrigin(double id0[])
    { SetOrigin_38(id0); }

  private native double[] GetOrigin_39();
  public double[] GetOrigin()
    { return GetOrigin_39(); }

  private native void SetScalarType_40(int id0);
  public void SetScalarType(int id0)
    { SetScalarType_40(id0); }

  private native int GetScalarType_41();
  public int GetScalarType()
    { return GetScalarType_41(); }

  private native void SetNumberOfScalarComponents_42(int id0);
  public void SetNumberOfScalarComponents(int id0)
    { SetNumberOfScalarComponents_42(id0); }

  private native int GetNumberOfScalarComponents_43();
  public int GetNumberOfScalarComponents()
    { return GetNumberOfScalarComponents_43(); }

  private native void CopyTypeSpecificInformation_44(vtkDataObject id0);
  public void CopyTypeSpecificInformation(vtkDataObject id0)
    { CopyTypeSpecificInformation_44(id0); }

  private native void PrepareForNewData_45();
  public void PrepareForNewData()
    { PrepareForNewData_45(); }

  private native void ShallowCopy_46(vtkDataObject id0);
  public void ShallowCopy(vtkDataObject id0)
    { ShallowCopy_46(id0); }

  private native void DeepCopy_47(vtkDataObject id0);
  public void DeepCopy(vtkDataObject id0)
    { DeepCopy_47(id0); }

  private native vtkImageData UpdateAndReturnData_48();
  public vtkImageData UpdateAndReturnData()
    { return UpdateAndReturnData_48(); }

  public vtkImageData() { super(); };

  protected vtkImageData(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
