// java wrapper for vtkImageReader object
//

package vtk;
import vtk.*;

public class vtkImageReader extends vtkImageSource
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetFileName_2(String id0);
  public void SetFileName(String id0)
    { SetFileName_2(id0); }

  private native String GetFileName_3();
  public String GetFileName()
    { return GetFileName_3(); }

  private native void SetFilePrefix_4(String id0);
  public void SetFilePrefix(String id0)
    { SetFilePrefix_4(id0); }

  private native String GetFilePrefix_5();
  public String GetFilePrefix()
    { return GetFilePrefix_5(); }

  private native void SetFilePattern_6(String id0);
  public void SetFilePattern(String id0)
    { SetFilePattern_6(id0); }

  private native String GetFilePattern_7();
  public String GetFilePattern()
    { return GetFilePattern_7(); }

  private native void SetDataScalarType_8(int id0);
  public void SetDataScalarType(int id0)
    { SetDataScalarType_8(id0); }

  private native void SetDataScalarTypeToFloat_9();
  public void SetDataScalarTypeToFloat()
    { SetDataScalarTypeToFloat_9(); }

  private native void SetDataScalarTypeToDouble_10();
  public void SetDataScalarTypeToDouble()
    { SetDataScalarTypeToDouble_10(); }

  private native void SetDataScalarTypeToInt_11();
  public void SetDataScalarTypeToInt()
    { SetDataScalarTypeToInt_11(); }

  private native void SetDataScalarTypeToShort_12();
  public void SetDataScalarTypeToShort()
    { SetDataScalarTypeToShort_12(); }

  private native void SetDataScalarTypeToUnsignedShort_13();
  public void SetDataScalarTypeToUnsignedShort()
    { SetDataScalarTypeToUnsignedShort_13(); }

  private native void SetDataScalarTypeToUnsignedChar_14();
  public void SetDataScalarTypeToUnsignedChar()
    { SetDataScalarTypeToUnsignedChar_14(); }

  private native int GetDataScalarType_15();
  public int GetDataScalarType()
    { return GetDataScalarType_15(); }

  private native void SetNumberOfScalarComponents_16(int id0);
  public void SetNumberOfScalarComponents(int id0)
    { SetNumberOfScalarComponents_16(id0); }

  private native int GetNumberOfScalarComponents_17();
  public int GetNumberOfScalarComponents()
    { return GetNumberOfScalarComponents_17(); }

  private native void SetDataExtent_18(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetDataExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetDataExtent_18(id0,id1,id2,id3,id4,id5); }

  private native void SetDataExtent_19(int id0[]);
  public void SetDataExtent(int id0[])
    { SetDataExtent_19(id0); }

  private native int[]  GetDataExtent_20();
  public int[]  GetDataExtent()
    { return GetDataExtent_20(); }

  private native void SetDataVOI_21(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetDataVOI(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetDataVOI_21(id0,id1,id2,id3,id4,id5); }

  private native void SetDataVOI_22(int id0[]);
  public void SetDataVOI(int id0[])
    { SetDataVOI_22(id0); }

  private native int[]  GetDataVOI_23();
  public int[]  GetDataVOI()
    { return GetDataVOI_23(); }

  private native void SetFileDimensionality_24(int id0);
  public void SetFileDimensionality(int id0)
    { SetFileDimensionality_24(id0); }

  private native int GetFileDimensionality_25();
  public int GetFileDimensionality()
    { return GetFileDimensionality_25(); }

  private native void SetDataSpacing_26(double id0,double id1,double id2);
  public void SetDataSpacing(double id0,double id1,double id2)
    { SetDataSpacing_26(id0,id1,id2); }

  private native void SetDataSpacing_27(double id0[]);
  public void SetDataSpacing(double id0[])
    { SetDataSpacing_27(id0); }

  private native double[] GetDataSpacing_28();
  public double[] GetDataSpacing()
    { return GetDataSpacing_28(); }

  private native void SetDataOrigin_29(double id0,double id1,double id2);
  public void SetDataOrigin(double id0,double id1,double id2)
    { SetDataOrigin_29(id0,id1,id2); }

  private native void SetDataOrigin_30(double id0[]);
  public void SetDataOrigin(double id0[])
    { SetDataOrigin_30(id0); }

  private native double[] GetDataOrigin_31();
  public double[] GetDataOrigin()
    { return GetDataOrigin_31(); }

  private native int GetHeaderSize_32();
  public int GetHeaderSize()
    { return GetHeaderSize_32(); }

  private native int GetHeaderSize_33(int id0);
  public int GetHeaderSize(int id0)
    { return GetHeaderSize_33(id0); }

  private native void SetHeaderSize_34(int id0);
  public void SetHeaderSize(int id0)
    { SetHeaderSize_34(id0); }

  private native int GetDataMask_35();
  public int GetDataMask()
    { return GetDataMask_35(); }

  private native void SetDataMask_36(int id0);
  public void SetDataMask(int id0)
    { SetDataMask_36(id0); }

  private native void SetTransform_37(vtkTransform id0);
  public void SetTransform(vtkTransform id0)
    { SetTransform_37(id0); }

  private native vtkTransform GetTransform_38();
  public vtkTransform GetTransform()
    { return GetTransform_38(); }

  private native void SetDataByteOrderToBigEndian_39();
  public void SetDataByteOrderToBigEndian()
    { SetDataByteOrderToBigEndian_39(); }

  private native void SetDataByteOrderToLittleEndian_40();
  public void SetDataByteOrderToLittleEndian()
    { SetDataByteOrderToLittleEndian_40(); }

  private native int GetDataByteOrder_41();
  public int GetDataByteOrder()
    { return GetDataByteOrder_41(); }

  private native void SetDataByteOrder_42(int id0);
  public void SetDataByteOrder(int id0)
    { SetDataByteOrder_42(id0); }

  private native String GetDataByteOrderAsString_43();
  public String GetDataByteOrderAsString()
    { return GetDataByteOrderAsString_43(); }

  private native void SetSwapBytes_44(int id0);
  public void SetSwapBytes(int id0)
    { SetSwapBytes_44(id0); }

  private native int GetSwapBytes_45();
  public int GetSwapBytes()
    { return GetSwapBytes_45(); }

  private native void SwapBytesOn_46();
  public void SwapBytesOn()
    { SwapBytesOn_46(); }

  private native void SwapBytesOff_47();
  public void SwapBytesOff()
    { SwapBytesOff_47(); }

  private native void OpenFile_48();
  public void OpenFile()
    { OpenFile_48(); }

  private native void FileLowerLeftOn_49();
  public void FileLowerLeftOn()
    { FileLowerLeftOn_49(); }

  private native void FileLowerLeftOff_50();
  public void FileLowerLeftOff()
    { FileLowerLeftOff_50(); }

  private native int GetFileLowerLeft_51();
  public int GetFileLowerLeft()
    { return GetFileLowerLeft_51(); }

  private native void SetFileLowerLeft_52(int id0);
  public void SetFileLowerLeft(int id0)
    { SetFileLowerLeft_52(id0); }

  private native void ComputeInternalFileName_53(int id0);
  public void ComputeInternalFileName(int id0)
    { ComputeInternalFileName_53(id0); }

  private native String GetInternalFileName_54();
  public String GetInternalFileName()
    { return GetInternalFileName_54(); }

  public vtkImageReader() { super(); };

  protected vtkImageReader(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
