// java wrapper for vtkImageReslice object
//

package vtk;
import vtk.*;

public class vtkImageReslice extends vtkImageToImageFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetResliceAxes_2(vtkMatrix4x4 id0);
  public void SetResliceAxes(vtkMatrix4x4 id0)
    { SetResliceAxes_2(id0); }

  private native vtkMatrix4x4 GetResliceAxes_3();
  public vtkMatrix4x4 GetResliceAxes()
    { return GetResliceAxes_3(); }

  private native void SetResliceTransform_4(vtkAbstractTransform id0);
  public void SetResliceTransform(vtkAbstractTransform id0)
    { SetResliceTransform_4(id0); }

  private native vtkAbstractTransform GetResliceTransform_5();
  public vtkAbstractTransform GetResliceTransform()
    { return GetResliceTransform_5(); }

  private native void SetWrap_6(int id0);
  public void SetWrap(int id0)
    { SetWrap_6(id0); }

  private native int GetWrap_7();
  public int GetWrap()
    { return GetWrap_7(); }

  private native void WrapOn_8();
  public void WrapOn()
    { WrapOn_8(); }

  private native void WrapOff_9();
  public void WrapOff()
    { WrapOff_9(); }

  private native void SetMirror_10(int id0);
  public void SetMirror(int id0)
    { SetMirror_10(id0); }

  private native int GetMirror_11();
  public int GetMirror()
    { return GetMirror_11(); }

  private native void MirrorOn_12();
  public void MirrorOn()
    { MirrorOn_12(); }

  private native void MirrorOff_13();
  public void MirrorOff()
    { MirrorOff_13(); }

  private native void SetInterpolationMode_14(int id0);
  public void SetInterpolationMode(int id0)
    { SetInterpolationMode_14(id0); }

  private native int GetInterpolationMode_15();
  public int GetInterpolationMode()
    { return GetInterpolationMode_15(); }

  private native void SetInterpolationModeToNearestNeighbor_16();
  public void SetInterpolationModeToNearestNeighbor()
    { SetInterpolationModeToNearestNeighbor_16(); }

  private native void SetInterpolationModeToLinear_17();
  public void SetInterpolationModeToLinear()
    { SetInterpolationModeToLinear_17(); }

  private native void SetInterpolationModeToCubic_18();
  public void SetInterpolationModeToCubic()
    { SetInterpolationModeToCubic_18(); }

  private native String GetInterpolationModeAsString_19();
  public String GetInterpolationModeAsString()
    { return GetInterpolationModeAsString_19(); }

  private native void SetOptimization_20(int id0);
  public void SetOptimization(int id0)
    { SetOptimization_20(id0); }

  private native int GetOptimization_21();
  public int GetOptimization()
    { return GetOptimization_21(); }

  private native void OptimizationOn_22();
  public void OptimizationOn()
    { OptimizationOn_22(); }

  private native void OptimizationOff_23();
  public void OptimizationOff()
    { OptimizationOff_23(); }

  private native void SetBackgroundColor_24(double id0,double id1,double id2,double id3);
  public void SetBackgroundColor(double id0,double id1,double id2,double id3)
    { SetBackgroundColor_24(id0,id1,id2,id3); }

  private native void SetBackgroundColor_25(double id0[]);
  public void SetBackgroundColor(double id0[])
    { SetBackgroundColor_25(id0); }

  private native double[] GetBackgroundColor_26();
  public double[] GetBackgroundColor()
    { return GetBackgroundColor_26(); }

  private native void SetBackgroundLevel_27(double id0);
  public void SetBackgroundLevel(double id0)
    { SetBackgroundLevel_27(id0); }

  private native double GetBackgroundLevel_28();
  public double GetBackgroundLevel()
    { return GetBackgroundLevel_28(); }

  private native void SetOutputSpacing_29(double id0,double id1,double id2);
  public void SetOutputSpacing(double id0,double id1,double id2)
    { SetOutputSpacing_29(id0,id1,id2); }

  private native void SetOutputSpacing_30(double id0[]);
  public void SetOutputSpacing(double id0[])
    { SetOutputSpacing_30(id0); }

  private native double[] GetOutputSpacing_31();
  public double[] GetOutputSpacing()
    { return GetOutputSpacing_31(); }

  private native void SetOutputOrigin_32(double id0,double id1,double id2);
  public void SetOutputOrigin(double id0,double id1,double id2)
    { SetOutputOrigin_32(id0,id1,id2); }

  private native void SetOutputOrigin_33(double id0[]);
  public void SetOutputOrigin(double id0[])
    { SetOutputOrigin_33(id0); }

  private native double[] GetOutputOrigin_34();
  public double[] GetOutputOrigin()
    { return GetOutputOrigin_34(); }

  private native void SetOutputExtent_35(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetOutputExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetOutputExtent_35(id0,id1,id2,id3,id4,id5); }

  private native void SetOutputExtent_36(int id0[]);
  public void SetOutputExtent(int id0[])
    { SetOutputExtent_36(id0); }

  private native int[]  GetOutputExtent_37();
  public int[]  GetOutputExtent()
    { return GetOutputExtent_37(); }

  private native void SetOutputAlwaysCenteredOnInput_38(int id0);
  public void SetOutputAlwaysCenteredOnInput(int id0)
    { SetOutputAlwaysCenteredOnInput_38(id0); }

  private native int GetOutputAlwaysCenteredOnInput_39();
  public int GetOutputAlwaysCenteredOnInput()
    { return GetOutputAlwaysCenteredOnInput_39(); }

  private native void OutputAlwaysCenteredOnInputOn_40();
  public void OutputAlwaysCenteredOnInputOn()
    { OutputAlwaysCenteredOnInputOn_40(); }

  private native void OutputAlwaysCenteredOnInputOff_41();
  public void OutputAlwaysCenteredOnInputOff()
    { OutputAlwaysCenteredOnInputOff_41(); }

  private native int GetMTime_42();
  public int GetMTime()
    { return GetMTime_42(); }

  private native void SetInterpolate_43(int id0);
  public void SetInterpolate(int id0)
    { SetInterpolate_43(id0); }

  private native void InterpolateOn_44();
  public void InterpolateOn()
    { InterpolateOn_44(); }

  private native void InterpolateOff_45();
  public void InterpolateOff()
    { InterpolateOff_45(); }

  private native int GetInterpolate_46();
  public int GetInterpolate()
    { return GetInterpolate_46(); }

  public vtkImageReslice() { super(); };

  protected vtkImageReslice(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
