// java wrapper for vtkInteractorStyle object
//

package vtk;
import vtk.*;

public class vtkInteractorStyle extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetInteractor_2(vtkRenderWindowInteractor id0);
  public void SetInteractor(vtkRenderWindowInteractor id0)
    { SetInteractor_2(id0); }

  private native vtkRenderWindowInteractor GetInteractor_3();
  public vtkRenderWindowInteractor GetInteractor()
    { return GetInteractor_3(); }

  private native void FindPokedCamera_4(int id0,int id1);
  public void FindPokedCamera(int id0,int id1)
    { FindPokedCamera_4(id0,id1); }

  private native void FindPokedRenderer_5(int id0,int id1);
  public void FindPokedRenderer(int id0,int id1)
    { FindPokedRenderer_5(id0,id1); }

  private native void HighlightProp_6(vtkProp id0);
  public void HighlightProp(vtkProp id0)
    { HighlightProp_6(id0); }

  private native void HighlightActor2D_7(vtkActor2D id0);
  public void HighlightActor2D(vtkActor2D id0)
    { HighlightActor2D_7(id0); }

  private native void HighlightProp3D_8(vtkProp3D id0);
  public void HighlightProp3D(vtkProp3D id0)
    { HighlightProp3D_8(id0); }

  private native void SetPickColor_9(double id0,double id1,double id2);
  public void SetPickColor(double id0,double id1,double id2)
    { SetPickColor_9(id0,id1,id2); }

  private native void SetPickColor_10(double id0[]);
  public void SetPickColor(double id0[])
    { SetPickColor_10(id0); }

  private native double[] GetPickColor_11();
  public double[] GetPickColor()
    { return GetPickColor_11(); }

  private native void OnMouseMove_12(int id0,int id1,int id2,int id3);
  public void OnMouseMove(int id0,int id1,int id2,int id3)
    { OnMouseMove_12(id0,id1,id2,id3); }

  private native void OnLeftButtonDown_13(int id0,int id1,int id2,int id3);
  public void OnLeftButtonDown(int id0,int id1,int id2,int id3)
    { OnLeftButtonDown_13(id0,id1,id2,id3); }

  private native void OnLeftButtonUp_14(int id0,int id1,int id2,int id3);
  public void OnLeftButtonUp(int id0,int id1,int id2,int id3)
    { OnLeftButtonUp_14(id0,id1,id2,id3); }

  private native void OnMiddleButtonDown_15(int id0,int id1,int id2,int id3);
  public void OnMiddleButtonDown(int id0,int id1,int id2,int id3)
    { OnMiddleButtonDown_15(id0,id1,id2,id3); }

  private native void OnMiddleButtonUp_16(int id0,int id1,int id2,int id3);
  public void OnMiddleButtonUp(int id0,int id1,int id2,int id3)
    { OnMiddleButtonUp_16(id0,id1,id2,id3); }

  private native void OnRightButtonDown_17(int id0,int id1,int id2,int id3);
  public void OnRightButtonDown(int id0,int id1,int id2,int id3)
    { OnRightButtonDown_17(id0,id1,id2,id3); }

  private native void OnRightButtonUp_18(int id0,int id1,int id2,int id3);
  public void OnRightButtonUp(int id0,int id1,int id2,int id3)
    { OnRightButtonUp_18(id0,id1,id2,id3); }

  private native void OnChar_19(int id0,int id1,char id2,int id3);
  public void OnChar(int id0,int id1,char id2,int id3)
    { OnChar_19(id0,id1,id2,id3); }

  private native void OnKeyDown_20(int id0,int id1,char id2,int id3);
  public void OnKeyDown(int id0,int id1,char id2,int id3)
    { OnKeyDown_20(id0,id1,id2,id3); }

  private native void OnKeyUp_21(int id0,int id1,char id2,int id3);
  public void OnKeyUp(int id0,int id1,char id2,int id3)
    { OnKeyUp_21(id0,id1,id2,id3); }

  private native void OnKeyPress_22(int id0,int id1,char id2,String id3,int id4);
  public void OnKeyPress(int id0,int id1,char id2,String id3,int id4)
    { OnKeyPress_22(id0,id1,id2,id3,id4); }

  private native void OnKeyRelease_23(int id0,int id1,char id2,String id3,int id4);
  public void OnKeyRelease(int id0,int id1,char id2,String id3,int id4)
    { OnKeyRelease_23(id0,id1,id2,id3,id4); }

  private native void OnConfigure_24(int id0,int id1);
  public void OnConfigure(int id0,int id1)
    { OnConfigure_24(id0,id1); }

  private native void OnEnter_25(int id0,int id1,int id2,int id3);
  public void OnEnter(int id0,int id1,int id2,int id3)
    { OnEnter_25(id0,id1,id2,id3); }

  private native void OnLeave_26(int id0,int id1,int id2,int id3);
  public void OnLeave(int id0,int id1,int id2,int id3)
    { OnLeave_26(id0,id1,id2,id3); }

  private native void OnTimer_27();
  public void OnTimer()
    { OnTimer_27(); }

  private native void SetLeftButtonPressMethod_28(Object id0, String id1);
  public void SetLeftButtonPressMethod(Object id0, String id1)
    { SetLeftButtonPressMethod_28(id0,id1); }

  private native void SetLeftButtonReleaseMethod_29(Object id0, String id1);
  public void SetLeftButtonReleaseMethod(Object id0, String id1)
    { SetLeftButtonReleaseMethod_29(id0,id1); }

  private native void SetMiddleButtonPressMethod_30(Object id0, String id1);
  public void SetMiddleButtonPressMethod(Object id0, String id1)
    { SetMiddleButtonPressMethod_30(id0,id1); }

  private native void SetMiddleButtonReleaseMethod_31(Object id0, String id1);
  public void SetMiddleButtonReleaseMethod(Object id0, String id1)
    { SetMiddleButtonReleaseMethod_31(id0,id1); }

  private native void SetRightButtonPressMethod_32(Object id0, String id1);
  public void SetRightButtonPressMethod(Object id0, String id1)
    { SetRightButtonPressMethod_32(id0,id1); }

  private native void SetRightButtonReleaseMethod_33(Object id0, String id1);
  public void SetRightButtonReleaseMethod(Object id0, String id1)
    { SetRightButtonReleaseMethod_33(id0,id1); }

  public vtkInteractorStyle() { super(); };

  protected vtkInteractorStyle(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
