// java wrapper for vtkLightKit object
//

package vtk;
import vtk.*;

public class vtkLightKit extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetKeyLightIntensity_2(double id0);
  public void SetKeyLightIntensity(double id0)
    { SetKeyLightIntensity_2(id0); }

  private native double GetKeyLightIntensity_3();
  public double GetKeyLightIntensity()
    { return GetKeyLightIntensity_3(); }

  private native void SetKeyToFillRatio_4(double id0);
  public void SetKeyToFillRatio(double id0)
    { SetKeyToFillRatio_4(id0); }

  private native double GetKeyToFillRatio_5();
  public double GetKeyToFillRatio()
    { return GetKeyToFillRatio_5(); }

  private native void SetKeyToHeadRatio_6(double id0);
  public void SetKeyToHeadRatio(double id0)
    { SetKeyToHeadRatio_6(id0); }

  private native double GetKeyToHeadRatio_7();
  public double GetKeyToHeadRatio()
    { return GetKeyToHeadRatio_7(); }

  private native void SetKeyLightWarmth_8(double id0);
  public void SetKeyLightWarmth(double id0)
    { SetKeyLightWarmth_8(id0); }

  private native double GetKeyLightWarmth_9();
  public double GetKeyLightWarmth()
    { return GetKeyLightWarmth_9(); }

  private native void SetFillLightWarmth_10(double id0);
  public void SetFillLightWarmth(double id0)
    { SetFillLightWarmth_10(id0); }

  private native double GetFillLightWarmth_11();
  public double GetFillLightWarmth()
    { return GetFillLightWarmth_11(); }

  private native void SetHeadlightWarmth_12(double id0);
  public void SetHeadlightWarmth(double id0)
    { SetHeadlightWarmth_12(id0); }

  private native double GetHeadlightWarmth_13();
  public double GetHeadlightWarmth()
    { return GetHeadlightWarmth_13(); }

  private native double[] GetKeyLightColor_14();
  public double[] GetKeyLightColor()
    { return GetKeyLightColor_14(); }

  private native double[] GetFillLightColor_15();
  public double[] GetFillLightColor()
    { return GetFillLightColor_15(); }

  private native double[] GetHeadlightColor_16();
  public double[] GetHeadlightColor()
    { return GetHeadlightColor_16(); }

  private native void MaintainLuminanceOn_17();
  public void MaintainLuminanceOn()
    { MaintainLuminanceOn_17(); }

  private native void MaintainLuminanceOff_18();
  public void MaintainLuminanceOff()
    { MaintainLuminanceOff_18(); }

  private native int GetMaintainLuminance_19();
  public int GetMaintainLuminance()
    { return GetMaintainLuminance_19(); }

  private native void SetMaintainLuminance_20(int id0);
  public void SetMaintainLuminance(int id0)
    { SetMaintainLuminance_20(id0); }

  private native void SetKeyLightAngle_21(double id0,double id1);
  public void SetKeyLightAngle(double id0,double id1)
    { SetKeyLightAngle_21(id0,id1); }

  private native void SetKeyLightElevation_22(double id0);
  public void SetKeyLightElevation(double id0)
    { SetKeyLightElevation_22(id0); }

  private native void SetKeyLightAzimuth_23(double id0);
  public void SetKeyLightAzimuth(double id0)
    { SetKeyLightAzimuth_23(id0); }

  private native double[] GetKeyLightAngle_24();
  public double[] GetKeyLightAngle()
    { return GetKeyLightAngle_24(); }

  private native double GetKeyLightElevation_25();
  public double GetKeyLightElevation()
    { return GetKeyLightElevation_25(); }

  private native double GetKeyLightAzimuth_26();
  public double GetKeyLightAzimuth()
    { return GetKeyLightAzimuth_26(); }

  private native void SetFillLightAngle_27(double id0,double id1);
  public void SetFillLightAngle(double id0,double id1)
    { SetFillLightAngle_27(id0,id1); }

  private native void SetFillLightElevation_28(double id0);
  public void SetFillLightElevation(double id0)
    { SetFillLightElevation_28(id0); }

  private native void SetFillLightAzimuth_29(double id0);
  public void SetFillLightAzimuth(double id0)
    { SetFillLightAzimuth_29(id0); }

  private native double[] GetFillLightAngle_30();
  public double[] GetFillLightAngle()
    { return GetFillLightAngle_30(); }

  private native double GetFillLightElevation_31();
  public double GetFillLightElevation()
    { return GetFillLightElevation_31(); }

  private native double GetFillLightAzimuth_32();
  public double GetFillLightAzimuth()
    { return GetFillLightAzimuth_32(); }

  private native void AddLightsToRenderer_33(vtkRenderer id0);
  public void AddLightsToRenderer(vtkRenderer id0)
    { AddLightsToRenderer_33(id0); }

  private native void RemoveLightsFromRenderer_34(vtkRenderer id0);
  public void RemoveLightsFromRenderer(vtkRenderer id0)
    { RemoveLightsFromRenderer_34(id0); }

  private native void DeepCopy_35(vtkLightKit id0);
  public void DeepCopy(vtkLightKit id0)
    { DeepCopy_35(id0); }

  private native void Modified_36();
  public void Modified()
    { Modified_36(); }

  private native void Update_37();
  public void Update()
    { Update_37(); }

  public vtkLightKit() { super(); };

  protected vtkLightKit(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
