// java wrapper for vtkLinearTransform object
//

package vtk;
import vtk.*;

public class vtkLinearTransform extends vtkHomogeneousTransform
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native double[] TransformNormal_2(double id0,double id1,double id2);
  public double[] TransformNormal(double id0,double id1,double id2)
    { return TransformNormal_2(id0,id1,id2); }

  private native double[] TransformNormal_3(double id0[]);
  public double[] TransformNormal(double id0[])
    { return TransformNormal_3(id0); }

  private native double[] TransformFloatNormal_4(double id0,double id1,double id2);
  public double[] TransformFloatNormal(double id0,double id1,double id2)
    { return TransformFloatNormal_4(id0,id1,id2); }

  private native double[] TransformFloatNormal_5(double id0[]);
  public double[] TransformFloatNormal(double id0[])
    { return TransformFloatNormal_5(id0); }

  private native double[] TransformDoubleNormal_6(double id0,double id1,double id2);
  public double[] TransformDoubleNormal(double id0,double id1,double id2)
    { return TransformDoubleNormal_6(id0,id1,id2); }

  private native double[] TransformDoubleNormal_7(double id0[]);
  public double[] TransformDoubleNormal(double id0[])
    { return TransformDoubleNormal_7(id0); }

  private native double[] TransformVector_8(double id0,double id1,double id2);
  public double[] TransformVector(double id0,double id1,double id2)
    { return TransformVector_8(id0,id1,id2); }

  private native double[] TransformVector_9(double id0[]);
  public double[] TransformVector(double id0[])
    { return TransformVector_9(id0); }

  private native double[] TransformFloatVector_10(double id0,double id1,double id2);
  public double[] TransformFloatVector(double id0,double id1,double id2)
    { return TransformFloatVector_10(id0,id1,id2); }

  private native double[] TransformFloatVector_11(double id0[]);
  public double[] TransformFloatVector(double id0[])
    { return TransformFloatVector_11(id0); }

  private native double[] TransformDoubleVector_12(double id0,double id1,double id2);
  public double[] TransformDoubleVector(double id0,double id1,double id2)
    { return TransformDoubleVector_12(id0,id1,id2); }

  private native double[] TransformDoubleVector_13(double id0[]);
  public double[] TransformDoubleVector(double id0[])
    { return TransformDoubleVector_13(id0); }

  private native void TransformPoints_14(vtkPoints id0,vtkPoints id1);
  public void TransformPoints(vtkPoints id0,vtkPoints id1)
    { TransformPoints_14(id0,id1); }

  private native void TransformNormals_15(vtkNormals id0,vtkNormals id1);
  public void TransformNormals(vtkNormals id0,vtkNormals id1)
    { TransformNormals_15(id0,id1); }

  private native void TransformVectors_16(vtkVectors id0,vtkVectors id1);
  public void TransformVectors(vtkVectors id0,vtkVectors id1)
    { TransformVectors_16(id0,id1); }

  private native void TransformPointsNormalsVectors_17(vtkPoints id0,vtkPoints id1,vtkNormals id2,vtkNormals id3,vtkVectors id4,vtkVectors id5);
  public void TransformPointsNormalsVectors(vtkPoints id0,vtkPoints id1,vtkNormals id2,vtkNormals id3,vtkVectors id4,vtkVectors id5)
    { TransformPointsNormalsVectors_17(id0,id1,id2,id3,id4,id5); }

  private native vtkLinearTransform GetLinearInverse_18();
  public vtkLinearTransform GetLinearInverse()
    { return GetLinearInverse_18(); }

  public vtkLinearTransform() { super(); };

  protected vtkLinearTransform(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
