// java wrapper for vtkMultiProcessController object
//

package vtk;
import vtk.*;

public class vtkMultiProcessController extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetNumberOfProcesses_2(int id0);
  public void SetNumberOfProcesses(int id0)
    { SetNumberOfProcesses_2(id0); }

  private native int GetNumberOfProcesses_3();
  public int GetNumberOfProcesses()
    { return GetNumberOfProcesses_3(); }

  private native int GetLocalProcessId_4();
  public int GetLocalProcessId()
    { return GetLocalProcessId_4(); }

  private native vtkMultiProcessController GetGlobalController_5();
  public vtkMultiProcessController GetGlobalController()
    { return GetGlobalController_5(); }

  private native int Send_6(vtkDataObject id0,int id1,int id2);
  public int Send(vtkDataObject id0,int id1,int id2)
    { return Send_6(id0,id1,id2); }

  private native int Receive_7(vtkDataObject id0,int id1,int id2);
  public int Receive(vtkDataObject id0,int id1,int id2)
    { return Receive_7(id0,id1,id2); }

  private native void SetForceDeepCopy_8(int id0);
  public void SetForceDeepCopy(int id0)
    { SetForceDeepCopy_8(id0); }

  private native int GetForceDeepCopy_9();
  public int GetForceDeepCopy()
    { return GetForceDeepCopy_9(); }

  private native void ForceDeepCopyOn_10();
  public void ForceDeepCopyOn()
    { ForceDeepCopyOn_10(); }

  private native void ForceDeepCopyOff_11();
  public void ForceDeepCopyOff()
    { ForceDeepCopyOff_11(); }

  private native void TriggerRMI_12(int id0,String id1,int id2);
  public void TriggerRMI(int id0,String id1,int id2)
    { TriggerRMI_12(id0,id1,id2); }

  private native void TriggerRMI_13(int id0,int id1);
  public void TriggerRMI(int id0,int id1)
    { TriggerRMI_13(id0,id1); }

  private native void ProcessRMIs_14();
  public void ProcessRMIs()
    { ProcessRMIs_14(); }

  private native void SetBreakFlag_15(int id0);
  public void SetBreakFlag(int id0)
    { SetBreakFlag_15(id0); }

  private native int GetBreakFlag_16();
  public int GetBreakFlag()
    { return GetBreakFlag_16(); }

  private native double GetWriteTime_17();
  public double GetWriteTime()
    { return GetWriteTime_17(); }

  private native double GetReadTime_18();
  public double GetReadTime()
    { return GetReadTime_18(); }

  private native double GetSendWaitTime_19();
  public double GetSendWaitTime()
    { return GetSendWaitTime_19(); }

  private native double GetSendTime_20();
  public double GetSendTime()
    { return GetSendTime_20(); }

  private native double GetReceiveWaitTime_21();
  public double GetReceiveWaitTime()
    { return GetReceiveWaitTime_21(); }

  private native double GetReceiveTime_22();
  public double GetReceiveTime()
    { return GetReceiveTime_22(); }

  public vtkMultiProcessController() { super(); };

  protected vtkMultiProcessController(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
