// java wrapper for vtkPointLocator object
//

package vtk;
import vtk.*;

public class vtkPointLocator extends vtkLocator
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetDivisions_2(int id0,int id1,int id2);
  public void SetDivisions(int id0,int id1,int id2)
    { SetDivisions_2(id0,id1,id2); }

  private native void SetDivisions_3(int id0[]);
  public void SetDivisions(int id0[])
    { SetDivisions_3(id0); }

  private native int[]  GetDivisions_4();
  public int[]  GetDivisions()
    { return GetDivisions_4(); }

  private native void SetNumberOfPointsPerBucket_5(int id0);
  public void SetNumberOfPointsPerBucket(int id0)
    { SetNumberOfPointsPerBucket_5(id0); }

  private native int GetNumberOfPointsPerBucket_6();
  public int GetNumberOfPointsPerBucket()
    { return GetNumberOfPointsPerBucket_6(); }

  private native int FindClosestPoint_7(double id0[]);
  public int FindClosestPoint(double id0[])
    { return FindClosestPoint_7(id0); }

  private native int FindClosestPoint_8(double id0,double id1,double id2);
  public int FindClosestPoint(double id0,double id1,double id2)
    { return FindClosestPoint_8(id0,id1,id2); }

  private native int InitPointInsertion_9(vtkPoints id0,double id1[]);
  public int InitPointInsertion(vtkPoints id0,double id1[])
    { return InitPointInsertion_9(id0,id1); }

  private native int InitPointInsertion_10(vtkPoints id0,double id1[],int id2);
  public int InitPointInsertion(vtkPoints id0,double id1[],int id2)
    { return InitPointInsertion_10(id0,id1,id2); }

  private native void InsertPoint_11(int id0,double id1[]);
  public void InsertPoint(int id0,double id1[])
    { InsertPoint_11(id0,id1); }

  private native int InsertNextPoint_12(double id0[]);
  public int InsertNextPoint(double id0[])
    { return InsertNextPoint_12(id0); }

  private native int IsInsertedPoint_13(double id0,double id1,double id2);
  public int IsInsertedPoint(double id0,double id1,double id2)
    { return IsInsertedPoint_13(id0,id1,id2); }

  private native int IsInsertedPoint_14(double id0[]);
  public int IsInsertedPoint(double id0[])
    { return IsInsertedPoint_14(id0); }

  private native int FindClosestInsertedPoint_15(double id0[]);
  public int FindClosestInsertedPoint(double id0[])
    { return FindClosestInsertedPoint_15(id0); }

  private native void FindClosestNPoints_16(int id0,double id1[],vtkIdList id2);
  public void FindClosestNPoints(int id0,double id1[],vtkIdList id2)
    { FindClosestNPoints_16(id0,id1,id2); }

  private native void FindClosestNPoints_17(int id0,double id1,double id2,double id3,vtkIdList id4);
  public void FindClosestNPoints(int id0,double id1,double id2,double id3,vtkIdList id4)
    { FindClosestNPoints_17(id0,id1,id2,id3,id4); }

  private native void FindDistributedPoints_18(int id0,double id1[],vtkIdList id2,int id3);
  public void FindDistributedPoints(int id0,double id1[],vtkIdList id2,int id3)
    { FindDistributedPoints_18(id0,id1,id2,id3); }

  private native void FindDistributedPoints_19(int id0,double id1,double id2,double id3,vtkIdList id4,int id5);
  public void FindDistributedPoints(int id0,double id1,double id2,double id3,vtkIdList id4,int id5)
    { FindDistributedPoints_19(id0,id1,id2,id3,id4,id5); }

  private native void FindPointsWithinRadius_20(double id0,double id1[],vtkIdList id2);
  public void FindPointsWithinRadius(double id0,double id1[],vtkIdList id2)
    { FindPointsWithinRadius_20(id0,id1,id2); }

  private native void FindPointsWithinRadius_21(double id0,double id1,double id2,double id3,vtkIdList id4);
  public void FindPointsWithinRadius(double id0,double id1,double id2,double id3,vtkIdList id4)
    { FindPointsWithinRadius_21(id0,id1,id2,id3,id4); }

  private native void Initialize_22();
  public void Initialize()
    { Initialize_22(); }

  private native void FreeSearchStructure_23();
  public void FreeSearchStructure()
    { FreeSearchStructure_23(); }

  private native void BuildLocator_24();
  public void BuildLocator()
    { BuildLocator_24(); }

  private native void GenerateRepresentation_25(int id0,vtkPolyData id1);
  public void GenerateRepresentation(int id0,vtkPolyData id1)
    { GenerateRepresentation_25(id0,id1); }

  public vtkPointLocator() { super(); };

  protected vtkPointLocator(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
