// java wrapper for vtkProp3D object
//

package vtk;
import vtk.*;

public class vtkProp3D extends vtkProp
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void ShallowCopy_2(vtkProp id0);
  public void ShallowCopy(vtkProp id0)
    { ShallowCopy_2(id0); }

  private native void SetPosition_3(double id0,double id1,double id2);
  public void SetPosition(double id0,double id1,double id2)
    { SetPosition_3(id0,id1,id2); }

  private native void SetPosition_4(double id0[]);
  public void SetPosition(double id0[])
    { SetPosition_4(id0); }

  private native double[] GetPosition_5();
  public double[] GetPosition()
    { return GetPosition_5(); }

  private native void AddPosition_6(double id0,double id1,double id2);
  public void AddPosition(double id0,double id1,double id2)
    { AddPosition_6(id0,id1,id2); }

  private native void SetOrigin_7(double id0,double id1,double id2);
  public void SetOrigin(double id0,double id1,double id2)
    { SetOrigin_7(id0,id1,id2); }

  private native void SetOrigin_8(double id0[]);
  public void SetOrigin(double id0[])
    { SetOrigin_8(id0); }

  private native double[] GetOrigin_9();
  public double[] GetOrigin()
    { return GetOrigin_9(); }

  private native void SetScale_10(double id0,double id1,double id2);
  public void SetScale(double id0,double id1,double id2)
    { SetScale_10(id0,id1,id2); }

  private native void SetScale_11(double id0[]);
  public void SetScale(double id0[])
    { SetScale_11(id0); }

  private native double[] GetScale_12();
  public double[] GetScale()
    { return GetScale_12(); }

  private native void SetScale_13(double id0);
  public void SetScale(double id0)
    { SetScale_13(id0); }

  private native void SetUserTransform_14(vtkLinearTransform id0);
  public void SetUserTransform(vtkLinearTransform id0)
    { SetUserTransform_14(id0); }

  private native vtkLinearTransform GetUserTransform_15();
  public vtkLinearTransform GetUserTransform()
    { return GetUserTransform_15(); }

  private native void SetUserMatrix_16(vtkMatrix4x4 id0);
  public void SetUserMatrix(vtkMatrix4x4 id0)
    { SetUserMatrix_16(id0); }

  private native vtkMatrix4x4 GetUserMatrix_17();
  public vtkMatrix4x4 GetUserMatrix()
    { return GetUserMatrix_17(); }

  private native void GetMatrix_18(vtkMatrix4x4 id0);
  public void GetMatrix(vtkMatrix4x4 id0)
    { GetMatrix_18(id0); }

  private native double[] GetCenter_19();
  public double[] GetCenter()
    { return GetCenter_19(); }

  private native double[] GetXRange_20();
  public double[] GetXRange()
    { return GetXRange_20(); }

  private native double[] GetYRange_21();
  public double[] GetYRange()
    { return GetYRange_21(); }

  private native double[] GetZRange_22();
  public double[] GetZRange()
    { return GetZRange_22(); }

  private native double GetLength_23();
  public double GetLength()
    { return GetLength_23(); }

  private native void RotateX_24(double id0);
  public void RotateX(double id0)
    { RotateX_24(id0); }

  private native void RotateY_25(double id0);
  public void RotateY(double id0)
    { RotateY_25(id0); }

  private native void RotateZ_26(double id0);
  public void RotateZ(double id0)
    { RotateZ_26(id0); }

  private native void RotateWXYZ_27(double id0,double id1,double id2,double id3);
  public void RotateWXYZ(double id0,double id1,double id2,double id3)
    { RotateWXYZ_27(id0,id1,id2,id3); }

  private native void SetOrientation_28(double id0,double id1,double id2);
  public void SetOrientation(double id0,double id1,double id2)
    { SetOrientation_28(id0,id1,id2); }

  private native double[] GetOrientation_29();
  public double[] GetOrientation()
    { return GetOrientation_29(); }

  private native double[] GetOrientationWXYZ_30();
  public double[] GetOrientationWXYZ()
    { return GetOrientationWXYZ_30(); }

  private native void AddOrientation_31(double id0,double id1,double id2);
  public void AddOrientation(double id0,double id1,double id2)
    { AddOrientation_31(id0,id1,id2); }

  private native void PokeMatrix_32(vtkMatrix4x4 id0);
  public void PokeMatrix(vtkMatrix4x4 id0)
    { PokeMatrix_32(id0); }

  private native void InitPathTraversal_33();
  public void InitPathTraversal()
    { InitPathTraversal_33(); }

  private native vtkMatrix4x4 GetMatrix_34();
  public vtkMatrix4x4 GetMatrix()
    { return GetMatrix_34(); }

  private native vtkMatrix4x4 GetMatrixPointer_35();
  public vtkMatrix4x4 GetMatrixPointer()
    { return GetMatrixPointer_35(); }

  public vtkProp3D() { super(); };

  protected vtkProp3D(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
