// java wrapper for vtkProperty object
//

package vtk;
import vtk.*;

public class vtkProperty extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void DeepCopy_2(vtkProperty id0);
  public void DeepCopy(vtkProperty id0)
    { DeepCopy_2(id0); }

  private native void Render_3(vtkActor id0,vtkRenderer id1);
  public void Render(vtkActor id0,vtkRenderer id1)
    { Render_3(id0,id1); }

  private native void BackfaceRender_4(vtkActor id0,vtkRenderer id1);
  public void BackfaceRender(vtkActor id0,vtkRenderer id1)
    { BackfaceRender_4(id0,id1); }

  private native void SetInterpolation_5(int id0);
  public void SetInterpolation(int id0)
    { SetInterpolation_5(id0); }

  private native int GetInterpolation_6();
  public int GetInterpolation()
    { return GetInterpolation_6(); }

  private native void SetInterpolationToFlat_7();
  public void SetInterpolationToFlat()
    { SetInterpolationToFlat_7(); }

  private native void SetInterpolationToGouraud_8();
  public void SetInterpolationToGouraud()
    { SetInterpolationToGouraud_8(); }

  private native void SetInterpolationToPhong_9();
  public void SetInterpolationToPhong()
    { SetInterpolationToPhong_9(); }

  private native String GetInterpolationAsString_10();
  public String GetInterpolationAsString()
    { return GetInterpolationAsString_10(); }

  private native void SetRepresentation_11(int id0);
  public void SetRepresentation(int id0)
    { SetRepresentation_11(id0); }

  private native int GetRepresentation_12();
  public int GetRepresentation()
    { return GetRepresentation_12(); }

  private native void SetRepresentationToPoints_13();
  public void SetRepresentationToPoints()
    { SetRepresentationToPoints_13(); }

  private native void SetRepresentationToWireframe_14();
  public void SetRepresentationToWireframe()
    { SetRepresentationToWireframe_14(); }

  private native void SetRepresentationToSurface_15();
  public void SetRepresentationToSurface()
    { SetRepresentationToSurface_15(); }

  private native String GetRepresentationAsString_16();
  public String GetRepresentationAsString()
    { return GetRepresentationAsString_16(); }

  private native void SetColor_17(double id0,double id1,double id2);
  public void SetColor(double id0,double id1,double id2)
    { SetColor_17(id0,id1,id2); }

  private native double[] GetColor_18();
  public double[] GetColor()
    { return GetColor_18(); }

  private native void SetAmbient_19(double id0);
  public void SetAmbient(double id0)
    { SetAmbient_19(id0); }

  private native double GetAmbient_20();
  public double GetAmbient()
    { return GetAmbient_20(); }

  private native void SetDiffuse_21(double id0);
  public void SetDiffuse(double id0)
    { SetDiffuse_21(id0); }

  private native double GetDiffuse_22();
  public double GetDiffuse()
    { return GetDiffuse_22(); }

  private native void SetSpecular_23(double id0);
  public void SetSpecular(double id0)
    { SetSpecular_23(id0); }

  private native double GetSpecular_24();
  public double GetSpecular()
    { return GetSpecular_24(); }

  private native void SetSpecularPower_25(double id0);
  public void SetSpecularPower(double id0)
    { SetSpecularPower_25(id0); }

  private native double GetSpecularPower_26();
  public double GetSpecularPower()
    { return GetSpecularPower_26(); }

  private native void SetOpacity_27(double id0);
  public void SetOpacity(double id0)
    { SetOpacity_27(id0); }

  private native double GetOpacity_28();
  public double GetOpacity()
    { return GetOpacity_28(); }

  private native void SetAmbientColor_29(double id0,double id1,double id2);
  public void SetAmbientColor(double id0,double id1,double id2)
    { SetAmbientColor_29(id0,id1,id2); }

  private native void SetAmbientColor_30(double id0[]);
  public void SetAmbientColor(double id0[])
    { SetAmbientColor_30(id0); }

  private native double[] GetAmbientColor_31();
  public double[] GetAmbientColor()
    { return GetAmbientColor_31(); }

  private native void SetDiffuseColor_32(double id0,double id1,double id2);
  public void SetDiffuseColor(double id0,double id1,double id2)
    { SetDiffuseColor_32(id0,id1,id2); }

  private native void SetDiffuseColor_33(double id0[]);
  public void SetDiffuseColor(double id0[])
    { SetDiffuseColor_33(id0); }

  private native double[] GetDiffuseColor_34();
  public double[] GetDiffuseColor()
    { return GetDiffuseColor_34(); }

  private native void SetSpecularColor_35(double id0,double id1,double id2);
  public void SetSpecularColor(double id0,double id1,double id2)
    { SetSpecularColor_35(id0,id1,id2); }

  private native void SetSpecularColor_36(double id0[]);
  public void SetSpecularColor(double id0[])
    { SetSpecularColor_36(id0); }

  private native double[] GetSpecularColor_37();
  public double[] GetSpecularColor()
    { return GetSpecularColor_37(); }

  private native int GetEdgeVisibility_38();
  public int GetEdgeVisibility()
    { return GetEdgeVisibility_38(); }

  private native void SetEdgeVisibility_39(int id0);
  public void SetEdgeVisibility(int id0)
    { SetEdgeVisibility_39(id0); }

  private native void EdgeVisibilityOn_40();
  public void EdgeVisibilityOn()
    { EdgeVisibilityOn_40(); }

  private native void EdgeVisibilityOff_41();
  public void EdgeVisibilityOff()
    { EdgeVisibilityOff_41(); }

  private native void SetEdgeColor_42(double id0,double id1,double id2);
  public void SetEdgeColor(double id0,double id1,double id2)
    { SetEdgeColor_42(id0,id1,id2); }

  private native void SetEdgeColor_43(double id0[]);
  public void SetEdgeColor(double id0[])
    { SetEdgeColor_43(id0); }

  private native double[] GetEdgeColor_44();
  public double[] GetEdgeColor()
    { return GetEdgeColor_44(); }

  private native void SetLineWidth_45(double id0);
  public void SetLineWidth(double id0)
    { SetLineWidth_45(id0); }

  private native double GetLineWidth_46();
  public double GetLineWidth()
    { return GetLineWidth_46(); }

  private native void SetPointSize_47(double id0);
  public void SetPointSize(double id0)
    { SetPointSize_47(id0); }

  private native double GetPointSize_48();
  public double GetPointSize()
    { return GetPointSize_48(); }

  private native int GetBackfaceCulling_49();
  public int GetBackfaceCulling()
    { return GetBackfaceCulling_49(); }

  private native void SetBackfaceCulling_50(int id0);
  public void SetBackfaceCulling(int id0)
    { SetBackfaceCulling_50(id0); }

  private native void BackfaceCullingOn_51();
  public void BackfaceCullingOn()
    { BackfaceCullingOn_51(); }

  private native void BackfaceCullingOff_52();
  public void BackfaceCullingOff()
    { BackfaceCullingOff_52(); }

  private native int GetFrontfaceCulling_53();
  public int GetFrontfaceCulling()
    { return GetFrontfaceCulling_53(); }

  private native void SetFrontfaceCulling_54(int id0);
  public void SetFrontfaceCulling(int id0)
    { SetFrontfaceCulling_54(id0); }

  private native void FrontfaceCullingOn_55();
  public void FrontfaceCullingOn()
    { FrontfaceCullingOn_55(); }

  private native void FrontfaceCullingOff_56();
  public void FrontfaceCullingOff()
    { FrontfaceCullingOff_56(); }

  public vtkProperty() { super(); };

  protected vtkProperty(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
