// java wrapper for vtkRectilinearGrid object
//

package vtk;
import vtk.*;

public class vtkRectilinearGrid extends vtkDataSet
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native vtkDataObject MakeObject_2();
  public vtkDataObject MakeObject()
    { return MakeObject_2(); }

  private native int GetDataObjectType_3();
  public int GetDataObjectType()
    { return GetDataObjectType_3(); }

  private native void CopyStructure_4(vtkDataSet id0);
  public void CopyStructure(vtkDataSet id0)
    { CopyStructure_4(id0); }

  private native void Initialize_5();
  public void Initialize()
    { Initialize_5(); }

  private native int GetNumberOfCells_6();
  public int GetNumberOfCells()
    { return GetNumberOfCells_6(); }

  private native int GetNumberOfPoints_7();
  public int GetNumberOfPoints()
    { return GetNumberOfPoints_7(); }

  private native vtkCell GetCell_8(int id0);
  public vtkCell GetCell(int id0)
    { return GetCell_8(id0); }

  private native void GetCell_9(int id0,vtkGenericCell id1);
  public void GetCell(int id0,vtkGenericCell id1)
    { GetCell_9(id0,id1); }

  private native int FindPoint_10(double id0,double id1,double id2);
  public int FindPoint(double id0,double id1,double id2)
    { return FindPoint_10(id0,id1,id2); }

  private native int GetCellType_11(int id0);
  public int GetCellType(int id0)
    { return GetCellType_11(id0); }

  private native void GetCellPoints_12(int id0,vtkIdList id1);
  public void GetCellPoints(int id0,vtkIdList id1)
    { GetCellPoints_12(id0,id1); }

  private native void GetPointCells_13(int id0,vtkIdList id1);
  public void GetPointCells(int id0,vtkIdList id1)
    { GetPointCells_13(id0,id1); }

  private native void ComputeBounds_14();
  public void ComputeBounds()
    { ComputeBounds_14(); }

  private native int GetMaxCellSize_15();
  public int GetMaxCellSize()
    { return GetMaxCellSize_15(); }

  private native void GetCellNeighbors_16(int id0,vtkIdList id1,vtkIdList id2);
  public void GetCellNeighbors(int id0,vtkIdList id1,vtkIdList id2)
    { GetCellNeighbors_16(id0,id1,id2); }

  private native void SetDimensions_17(int id0,int id1,int id2);
  public void SetDimensions(int id0,int id1,int id2)
    { SetDimensions_17(id0,id1,id2); }

  private native int[]  GetDimensions_18();
  public int[]  GetDimensions()
    { return GetDimensions_18(); }

  private native int GetDataDimension_19();
  public int GetDataDimension()
    { return GetDataDimension_19(); }

  private native void SetXCoordinates_20(vtkScalars id0);
  public void SetXCoordinates(vtkScalars id0)
    { SetXCoordinates_20(id0); }

  private native vtkScalars GetXCoordinates_21();
  public vtkScalars GetXCoordinates()
    { return GetXCoordinates_21(); }

  private native void SetYCoordinates_22(vtkScalars id0);
  public void SetYCoordinates(vtkScalars id0)
    { SetYCoordinates_22(id0); }

  private native vtkScalars GetYCoordinates_23();
  public vtkScalars GetYCoordinates()
    { return GetYCoordinates_23(); }

  private native void SetZCoordinates_24(vtkScalars id0);
  public void SetZCoordinates(vtkScalars id0)
    { SetZCoordinates_24(id0); }

  private native vtkScalars GetZCoordinates_25();
  public vtkScalars GetZCoordinates()
    { return GetZCoordinates_25(); }

  private native void SetUpdateExtent_26(int id0,int id1,int id2);
  public void SetUpdateExtent(int id0,int id1,int id2)
    { SetUpdateExtent_26(id0,id1,id2); }

  private native void SetUpdateExtent_27(int id0,int id1);
  public void SetUpdateExtent(int id0,int id1)
    { SetUpdateExtent_27(id0,id1); }

  private native void SetUpdateExtent_28(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetUpdateExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetUpdateExtent_28(id0,id1,id2,id3,id4,id5); }

  private native void SetExtent_29(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetExtent_29(id0,id1,id2,id3,id4,id5); }

  private native int[]  GetExtent_30();
  public int[]  GetExtent()
    { return GetExtent_30(); }

  private native int GetActualMemorySize_31();
  public int GetActualMemorySize()
    { return GetActualMemorySize_31(); }

  private native void ShallowCopy_32(vtkDataObject id0);
  public void ShallowCopy(vtkDataObject id0)
    { ShallowCopy_32(id0); }

  private native void DeepCopy_33(vtkDataObject id0);
  public void DeepCopy(vtkDataObject id0)
    { DeepCopy_33(id0); }

  public vtkRectilinearGrid() { super(); };

  protected vtkRectilinearGrid(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
