// java wrapper for vtkStreamer object
//

package vtk;
import vtk.*;

public class vtkStreamer extends vtkDataSetToPolyDataFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetStartLocation_2(int id0,int id1,double id2,double id3,double id4);
  public void SetStartLocation(int id0,int id1,double id2,double id3,double id4)
    { SetStartLocation_2(id0,id1,id2,id3,id4); }

  private native void SetStartPosition_3(double id0,double id1,double id2);
  public void SetStartPosition(double id0,double id1,double id2)
    { SetStartPosition_3(id0,id1,id2); }

  private native double[] GetStartPosition_4();
  public double[] GetStartPosition()
    { return GetStartPosition_4(); }

  private native void SetSource_5(vtkDataSet id0);
  public void SetSource(vtkDataSet id0)
    { SetSource_5(id0); }

  private native vtkDataSet GetSource_6();
  public vtkDataSet GetSource()
    { return GetSource_6(); }

  private native void SetMaximumPropagationTime_7(double id0);
  public void SetMaximumPropagationTime(double id0)
    { SetMaximumPropagationTime_7(id0); }

  private native double GetMaximumPropagationTime_8();
  public double GetMaximumPropagationTime()
    { return GetMaximumPropagationTime_8(); }

  private native void SetIntegrationDirection_9(int id0);
  public void SetIntegrationDirection(int id0)
    { SetIntegrationDirection_9(id0); }

  private native int GetIntegrationDirection_10();
  public int GetIntegrationDirection()
    { return GetIntegrationDirection_10(); }

  private native void SetIntegrationDirectionToForward_11();
  public void SetIntegrationDirectionToForward()
    { SetIntegrationDirectionToForward_11(); }

  private native void SetIntegrationDirectionToBackward_12();
  public void SetIntegrationDirectionToBackward()
    { SetIntegrationDirectionToBackward_12(); }

  private native void SetIntegrationDirectionToIntegrateBothDirections_13();
  public void SetIntegrationDirectionToIntegrateBothDirections()
    { SetIntegrationDirectionToIntegrateBothDirections_13(); }

  private native String GetIntegrationDirectionAsString_14();
  public String GetIntegrationDirectionAsString()
    { return GetIntegrationDirectionAsString_14(); }

  private native void SetIntegrationStepLength_15(double id0);
  public void SetIntegrationStepLength(double id0)
    { SetIntegrationStepLength_15(id0); }

  private native double GetIntegrationStepLength_16();
  public double GetIntegrationStepLength()
    { return GetIntegrationStepLength_16(); }

  private native void SetSpeedScalars_17(int id0);
  public void SetSpeedScalars(int id0)
    { SetSpeedScalars_17(id0); }

  private native int GetSpeedScalars_18();
  public int GetSpeedScalars()
    { return GetSpeedScalars_18(); }

  private native void SpeedScalarsOn_19();
  public void SpeedScalarsOn()
    { SpeedScalarsOn_19(); }

  private native void SpeedScalarsOff_20();
  public void SpeedScalarsOff()
    { SpeedScalarsOff_20(); }

  private native void SetTerminalSpeed_21(double id0);
  public void SetTerminalSpeed(double id0)
    { SetTerminalSpeed_21(id0); }

  private native double GetTerminalSpeed_22();
  public double GetTerminalSpeed()
    { return GetTerminalSpeed_22(); }

  private native void SetVorticity_23(int id0);
  public void SetVorticity(int id0)
    { SetVorticity_23(id0); }

  private native int GetVorticity_24();
  public int GetVorticity()
    { return GetVorticity_24(); }

  private native void VorticityOn_25();
  public void VorticityOn()
    { VorticityOn_25(); }

  private native void VorticityOff_26();
  public void VorticityOff()
    { VorticityOff_26(); }

  private native void SetNumberOfThreads_27(int id0);
  public void SetNumberOfThreads(int id0)
    { SetNumberOfThreads_27(id0); }

  private native int GetNumberOfThreads_28();
  public int GetNumberOfThreads()
    { return GetNumberOfThreads_28(); }

  private native void SetSavePointInterval_29(double id0);
  public void SetSavePointInterval(double id0)
    { SetSavePointInterval_29(id0); }

  private native double GetSavePointInterval_30();
  public double GetSavePointInterval()
    { return GetSavePointInterval_30(); }

  private native void SetIntegrator_31(vtkInitialValueProblemSolver id0);
  public void SetIntegrator(vtkInitialValueProblemSolver id0)
    { SetIntegrator_31(id0); }

  private native vtkInitialValueProblemSolver GetIntegrator_32();
  public vtkInitialValueProblemSolver GetIntegrator()
    { return GetIntegrator_32(); }

  public vtkStreamer() { super(); };

  protected vtkStreamer(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
