// java wrapper for vtkStructuredGrid object
//

package vtk;
import vtk.*;

public class vtkStructuredGrid extends vtkPointSet
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native int GetDataObjectType_2();
  public int GetDataObjectType()
    { return GetDataObjectType_2(); }

  private native vtkDataObject MakeObject_3();
  public vtkDataObject MakeObject()
    { return MakeObject_3(); }

  private native void CopyStructure_4(vtkDataSet id0);
  public void CopyStructure(vtkDataSet id0)
    { CopyStructure_4(id0); }

  private native int GetNumberOfPoints_5();
  public int GetNumberOfPoints()
    { return GetNumberOfPoints_5(); }

  private native double[] GetPoint_6(int id0);
  public double[] GetPoint(int id0)
    { return GetPoint_6(id0); }

  private native vtkCell GetCell_7(int id0);
  public vtkCell GetCell(int id0)
    { return GetCell_7(id0); }

  private native void GetCell_8(int id0,vtkGenericCell id1);
  public void GetCell(int id0,vtkGenericCell id1)
    { GetCell_8(id0,id1); }

  private native int GetCellType_9(int id0);
  public int GetCellType(int id0)
    { return GetCellType_9(id0); }

  private native int GetNumberOfCells_10();
  public int GetNumberOfCells()
    { return GetNumberOfCells_10(); }

  private native void GetCellPoints_11(int id0,vtkIdList id1);
  public void GetCellPoints(int id0,vtkIdList id1)
    { GetCellPoints_11(id0,id1); }

  private native void GetPointCells_12(int id0,vtkIdList id1);
  public void GetPointCells(int id0,vtkIdList id1)
    { GetPointCells_12(id0,id1); }

  private native void Initialize_13();
  public void Initialize()
    { Initialize_13(); }

  private native int GetMaxCellSize_14();
  public int GetMaxCellSize()
    { return GetMaxCellSize_14(); }

  private native void GetCellNeighbors_15(int id0,vtkIdList id1,vtkIdList id2);
  public void GetCellNeighbors(int id0,vtkIdList id1,vtkIdList id2)
    { GetCellNeighbors_15(id0,id1,id2); }

  private native void SetDimensions_16(int id0,int id1,int id2);
  public void SetDimensions(int id0,int id1,int id2)
    { SetDimensions_16(id0,id1,id2); }

  private native int[]  GetDimensions_17();
  public int[]  GetDimensions()
    { return GetDimensions_17(); }

  private native int GetDataDimension_18();
  public int GetDataDimension()
    { return GetDataDimension_18(); }

  private native void BlankingOn_19();
  public void BlankingOn()
    { BlankingOn_19(); }

  private native void BlankingOff_20();
  public void BlankingOff()
    { BlankingOff_20(); }

  private native int GetBlanking_21();
  public int GetBlanking()
    { return GetBlanking_21(); }

  private native void BlankPoint_22(int id0);
  public void BlankPoint(int id0)
    { BlankPoint_22(id0); }

  private native void UnBlankPoint_23(int id0);
  public void UnBlankPoint(int id0)
    { UnBlankPoint_23(id0); }

  private native int IsPointVisible_24(int id0);
  public int IsPointVisible(int id0)
    { return IsPointVisible_24(id0); }

  private native void SetUpdateExtent_25(int id0,int id1,int id2);
  public void SetUpdateExtent(int id0,int id1,int id2)
    { SetUpdateExtent_25(id0,id1,id2); }

  private native void SetUpdateExtent_26(int id0,int id1);
  public void SetUpdateExtent(int id0,int id1)
    { SetUpdateExtent_26(id0,id1); }

  private native void SetUpdateExtent_27(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetUpdateExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetUpdateExtent_27(id0,id1,id2,id3,id4,id5); }

  private native void SetExtent_28(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetExtent_28(id0,id1,id2,id3,id4,id5); }

  private native int[]  GetExtent_29();
  public int[]  GetExtent()
    { return GetExtent_29(); }

  private native int GetActualMemorySize_30();
  public int GetActualMemorySize()
    { return GetActualMemorySize_30(); }

  private native void ShallowCopy_31(vtkDataObject id0);
  public void ShallowCopy(vtkDataObject id0)
    { ShallowCopy_31(id0); }

  private native void DeepCopy_32(vtkDataObject id0);
  public void DeepCopy(vtkDataObject id0)
    { DeepCopy_32(id0); }

  public vtkStructuredGrid() { super(); };

  protected vtkStructuredGrid(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
