// java wrapper for vtkTransform object
//

package vtk;
import vtk.*;

public class vtkTransform extends vtkLinearTransform
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void Identity_2();
  public void Identity()
    { Identity_2(); }

  private native void Inverse_3();
  public void Inverse()
    { Inverse_3(); }

  private native void Translate_4(double id0,double id1,double id2);
  public void Translate(double id0,double id1,double id2)
    { Translate_4(id0,id1,id2); }

  private native void Translate_5(double id0[]);
  public void Translate(double id0[])
    { Translate_5(id0); }

  private native void RotateWXYZ_6(double id0,double id1,double id2,double id3);
  public void RotateWXYZ(double id0,double id1,double id2,double id3)
    { RotateWXYZ_6(id0,id1,id2,id3); }

  private native void RotateWXYZ_7(double id0,double id1[]);
  public void RotateWXYZ(double id0,double id1[])
    { RotateWXYZ_7(id0,id1); }

  private native void RotateX_8(double id0);
  public void RotateX(double id0)
    { RotateX_8(id0); }

  private native void RotateY_9(double id0);
  public void RotateY(double id0)
    { RotateY_9(id0); }

  private native void RotateZ_10(double id0);
  public void RotateZ(double id0)
    { RotateZ_10(id0); }

  private native void Scale_11(double id0,double id1,double id2);
  public void Scale(double id0,double id1,double id2)
    { Scale_11(id0,id1,id2); }

  private native void Scale_12(double id0[]);
  public void Scale(double id0[])
    { Scale_12(id0); }

  private native void SetMatrix_13(vtkMatrix4x4 id0);
  public void SetMatrix(vtkMatrix4x4 id0)
    { SetMatrix_13(id0); }

  private native void SetMatrix_14(double id0[]);
  public void SetMatrix(double id0[])
    { SetMatrix_14(id0); }

  private native void Concatenate_15(vtkMatrix4x4 id0);
  public void Concatenate(vtkMatrix4x4 id0)
    { Concatenate_15(id0); }

  private native void Concatenate_16(double id0[]);
  public void Concatenate(double id0[])
    { Concatenate_16(id0); }

  private native void Concatenate_17(vtkLinearTransform id0);
  public void Concatenate(vtkLinearTransform id0)
    { Concatenate_17(id0); }

  private native void PreMultiply_18();
  public void PreMultiply()
    { PreMultiply_18(); }

  private native void PostMultiply_19();
  public void PostMultiply()
    { PostMultiply_19(); }

  private native double[] GetOrientation_20();
  public double[] GetOrientation()
    { return GetOrientation_20(); }

  private native double[] GetOrientationWXYZ_21();
  public double[] GetOrientationWXYZ()
    { return GetOrientationWXYZ_21(); }

  private native double[] GetPosition_22();
  public double[] GetPosition()
    { return GetPosition_22(); }

  private native double[] GetScale_23();
  public double[] GetScale()
    { return GetScale_23(); }

  private native void GetInverse_24(vtkMatrix4x4 id0);
  public void GetInverse(vtkMatrix4x4 id0)
    { GetInverse_24(id0); }

  private native void GetTranspose_25(vtkMatrix4x4 id0);
  public void GetTranspose(vtkMatrix4x4 id0)
    { GetTranspose_25(id0); }

  private native void Push_26();
  public void Push()
    { Push_26(); }

  private native void Pop_27();
  public void Pop()
    { Pop_27(); }

  private native void SetInput_28(vtkLinearTransform id0);
  public void SetInput(vtkLinearTransform id0)
    { SetInput_28(id0); }

  private native vtkLinearTransform GetInput_29();
  public vtkLinearTransform GetInput()
    { return GetInput_29(); }

  private native int CircuitCheck_30(vtkAbstractTransform id0);
  public int CircuitCheck(vtkAbstractTransform id0)
    { return CircuitCheck_30(id0); }

  private native vtkAbstractTransform GetInverse_31();
  public vtkAbstractTransform GetInverse()
    { return GetInverse_31(); }

  private native vtkAbstractTransform MakeTransform_32();
  public vtkAbstractTransform MakeTransform()
    { return MakeTransform_32(); }

  private native int GetMTime_33();
  public int GetMTime()
    { return GetMTime_33(); }

  private native void MultiplyPoints_34(vtkPoints id0,vtkPoints id1);
  public void MultiplyPoints(vtkPoints id0,vtkPoints id1)
    { MultiplyPoints_34(id0,id1); }

  private native void MultiplyVectors_35(vtkVectors id0,vtkVectors id1);
  public void MultiplyVectors(vtkVectors id0,vtkVectors id1)
    { MultiplyVectors_35(id0,id1); }

  private native void MultiplyNormals_36(vtkNormals id0,vtkNormals id1);
  public void MultiplyNormals(vtkNormals id0,vtkNormals id1)
    { MultiplyNormals_36(id0,id1); }

  private native void Transpose_37();
  public void Transpose()
    { Transpose_37(); }

  private native void SetPoint_38(double id0,double id1,double id2,double id3);
  public void SetPoint(double id0,double id1,double id2,double id3)
    { SetPoint_38(id0,id1,id2,id3); }

  private native void SetPoint_39(double id0[]);
  public void SetPoint(double id0[])
    { SetPoint_39(id0); }

  private native void SetDoublePoint_40(double id0,double id1,double id2,double id3);
  public void SetDoublePoint(double id0,double id1,double id2,double id3)
    { SetDoublePoint_40(id0,id1,id2,id3); }

  private native void SetDoublePoint_41(double id0[]);
  public void SetDoublePoint(double id0[])
    { SetDoublePoint_41(id0); }

  private native double[] GetPoint_42();
  public double[] GetPoint()
    { return GetPoint_42(); }

  private native void Multiply4x4_43(vtkMatrix4x4 id0,vtkMatrix4x4 id1,vtkMatrix4x4 id2);
  public void Multiply4x4(vtkMatrix4x4 id0,vtkMatrix4x4 id1,vtkMatrix4x4 id2)
    { Multiply4x4_43(id0,id1,id2); }

  public vtkTransform() { super(); };

  protected vtkTransform(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
