// java wrapper for vtkTubeFilter object
//

package vtk;
import vtk.*;

public class vtkTubeFilter extends vtkPolyDataToPolyDataFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetRadius_2(double id0);
  public void SetRadius(double id0)
    { SetRadius_2(id0); }

  private native double GetRadius_3();
  public double GetRadius()
    { return GetRadius_3(); }

  private native void SetVaryRadius_4(int id0);
  public void SetVaryRadius(int id0)
    { SetVaryRadius_4(id0); }

  private native int GetVaryRadius_5();
  public int GetVaryRadius()
    { return GetVaryRadius_5(); }

  private native void SetVaryRadiusToVaryRadiusOff_6();
  public void SetVaryRadiusToVaryRadiusOff()
    { SetVaryRadiusToVaryRadiusOff_6(); }

  private native void SetVaryRadiusToVaryRadiusByScalar_7();
  public void SetVaryRadiusToVaryRadiusByScalar()
    { SetVaryRadiusToVaryRadiusByScalar_7(); }

  private native void SetVaryRadiusToVaryRadiusByVector_8();
  public void SetVaryRadiusToVaryRadiusByVector()
    { SetVaryRadiusToVaryRadiusByVector_8(); }

  private native String GetVaryRadiusAsString_9();
  public String GetVaryRadiusAsString()
    { return GetVaryRadiusAsString_9(); }

  private native void SetNumberOfSides_10(int id0);
  public void SetNumberOfSides(int id0)
    { SetNumberOfSides_10(id0); }

  private native int GetNumberOfSides_11();
  public int GetNumberOfSides()
    { return GetNumberOfSides_11(); }

  private native void SetRadiusFactor_12(double id0);
  public void SetRadiusFactor(double id0)
    { SetRadiusFactor_12(id0); }

  private native double GetRadiusFactor_13();
  public double GetRadiusFactor()
    { return GetRadiusFactor_13(); }

  private native void SetDefaultNormal_14(double id0,double id1,double id2);
  public void SetDefaultNormal(double id0,double id1,double id2)
    { SetDefaultNormal_14(id0,id1,id2); }

  private native void SetDefaultNormal_15(double id0[]);
  public void SetDefaultNormal(double id0[])
    { SetDefaultNormal_15(id0); }

  private native double[] GetDefaultNormal_16();
  public double[] GetDefaultNormal()
    { return GetDefaultNormal_16(); }

  private native void SetUseDefaultNormal_17(int id0);
  public void SetUseDefaultNormal(int id0)
    { SetUseDefaultNormal_17(id0); }

  private native int GetUseDefaultNormal_18();
  public int GetUseDefaultNormal()
    { return GetUseDefaultNormal_18(); }

  private native void UseDefaultNormalOn_19();
  public void UseDefaultNormalOn()
    { UseDefaultNormalOn_19(); }

  private native void UseDefaultNormalOff_20();
  public void UseDefaultNormalOff()
    { UseDefaultNormalOff_20(); }

  private native void SetCapping_21(int id0);
  public void SetCapping(int id0)
    { SetCapping_21(id0); }

  private native int GetCapping_22();
  public int GetCapping()
    { return GetCapping_22(); }

  private native void CappingOn_23();
  public void CappingOn()
    { CappingOn_23(); }

  private native void CappingOff_24();
  public void CappingOff()
    { CappingOff_24(); }

  private native void SetOnRatio_25(int id0);
  public void SetOnRatio(int id0)
    { SetOnRatio_25(id0); }

  private native int GetOnRatio_26();
  public int GetOnRatio()
    { return GetOnRatio_26(); }

  private native void SetOffset_27(int id0);
  public void SetOffset(int id0)
    { SetOffset_27(id0); }

  private native int GetOffset_28();
  public int GetOffset()
    { return GetOffset_28(); }

  public vtkTubeFilter() { super(); };

  protected vtkTubeFilter(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
