// java wrapper for vtkViewport object
//

package vtk;
import vtk.*;

public class vtkViewport extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void AddProp_2(vtkProp id0);
  public void AddProp(vtkProp id0)
    { AddProp_2(id0); }

  private native vtkPropCollection GetProps_3();
  public vtkPropCollection GetProps()
    { return GetProps_3(); }

  private native void RemoveProp_4(vtkProp id0);
  public void RemoveProp(vtkProp id0)
    { RemoveProp_4(id0); }

  private native void AddActor2D_5(vtkProp id0);
  public void AddActor2D(vtkProp id0)
    { AddActor2D_5(id0); }

  private native void RemoveActor2D_6(vtkProp id0);
  public void RemoveActor2D(vtkProp id0)
    { RemoveActor2D_6(id0); }

  private native vtkActor2DCollection GetActors2D_7();
  public vtkActor2DCollection GetActors2D()
    { return GetActors2D_7(); }

  private native void SetBackground_8(double id0,double id1,double id2);
  public void SetBackground(double id0,double id1,double id2)
    { SetBackground_8(id0,id1,id2); }

  private native void SetBackground_9(double id0[]);
  public void SetBackground(double id0[])
    { SetBackground_9(id0); }

  private native double[] GetBackground_10();
  public double[] GetBackground()
    { return GetBackground_10(); }

  private native void SetAspect_11(double id0,double id1);
  public void SetAspect(double id0,double id1)
    { SetAspect_11(id0,id1); }

  private native void SetAspect_12(double id0[]);
  public void SetAspect(double id0[])
    { SetAspect_12(id0); }

  private native double[] GetAspect_13();
  public double[] GetAspect()
    { return GetAspect_13(); }

  private native void ComputeAspect_14();
  public void ComputeAspect()
    { ComputeAspect_14(); }

  private native void SetViewport_15(double id0,double id1,double id2,double id3);
  public void SetViewport(double id0,double id1,double id2,double id3)
    { SetViewport_15(id0,id1,id2,id3); }

  private native void SetViewport_16(double id0[]);
  public void SetViewport(double id0[])
    { SetViewport_16(id0); }

  private native double[] GetViewport_17();
  public double[] GetViewport()
    { return GetViewport_17(); }

  private native void SetDisplayPoint_18(double id0,double id1,double id2);
  public void SetDisplayPoint(double id0,double id1,double id2)
    { SetDisplayPoint_18(id0,id1,id2); }

  private native void SetDisplayPoint_19(double id0[]);
  public void SetDisplayPoint(double id0[])
    { SetDisplayPoint_19(id0); }

  private native double[] GetDisplayPoint_20();
  public double[] GetDisplayPoint()
    { return GetDisplayPoint_20(); }

  private native void SetViewPoint_21(double id0,double id1,double id2);
  public void SetViewPoint(double id0,double id1,double id2)
    { SetViewPoint_21(id0,id1,id2); }

  private native void SetViewPoint_22(double id0[]);
  public void SetViewPoint(double id0[])
    { SetViewPoint_22(id0); }

  private native double[] GetViewPoint_23();
  public double[] GetViewPoint()
    { return GetViewPoint_23(); }

  private native void SetWorldPoint_24(double id0,double id1,double id2,double id3);
  public void SetWorldPoint(double id0,double id1,double id2,double id3)
    { SetWorldPoint_24(id0,id1,id2,id3); }

  private native void SetWorldPoint_25(double id0[]);
  public void SetWorldPoint(double id0[])
    { SetWorldPoint_25(id0); }

  private native double[] GetWorldPoint_26();
  public double[] GetWorldPoint()
    { return GetWorldPoint_26(); }

  private native double[] GetCenter_27();
  public double[] GetCenter()
    { return GetCenter_27(); }

  private native int IsInViewport_28(int id0,int id1);
  public int IsInViewport(int id0,int id1)
    { return IsInViewport_28(id0,id1); }

  private native void SetStartRenderMethod_29(Object id0, String id1);
  public void SetStartRenderMethod(Object id0, String id1)
    { SetStartRenderMethod_29(id0,id1); }

  private native void SetEndRenderMethod_30(Object id0, String id1);
  public void SetEndRenderMethod(Object id0, String id1)
    { SetEndRenderMethod_30(id0,id1); }

  private native void DisplayToView_31();
  public void DisplayToView()
    { DisplayToView_31(); }

  private native void ViewToDisplay_32();
  public void ViewToDisplay()
    { ViewToDisplay_32(); }

  private native void WorldToView_33();
  public void WorldToView()
    { WorldToView_33(); }

  private native void ViewToWorld_34();
  public void ViewToWorld()
    { ViewToWorld_34(); }

  private native void DisplayToWorld_35();
  public void DisplayToWorld()
    { DisplayToWorld_35(); }

  private native void WorldToDisplay_36();
  public void WorldToDisplay()
    { WorldToDisplay_36(); }

  private native int[]  GetSize_37();
  public int[]  GetSize()
    { return GetSize_37(); }

  private native int[]  GetOrigin_38();
  public int[]  GetOrigin()
    { return GetOrigin_38(); }

  private native vtkAssemblyPath PickPropFrom_39(double id0,double id1,vtkPropCollection id2);
  public vtkAssemblyPath PickPropFrom(double id0,double id1,vtkPropCollection id2)
    { return PickPropFrom_39(id0,id1,id2); }

  private native double GetPickX_40();
  public double GetPickX()
    { return GetPickX_40(); }

  private native double GetPickY_41();
  public double GetPickY()
    { return GetPickY_41(); }

  private native int GetIsPicking_42();
  public int GetIsPicking()
    { return GetIsPicking_42(); }

  public vtkViewport() { super(); };

  protected vtkViewport(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
