// java wrapper for vtkXYPlotActor object
//

package vtk;
import vtk.*;

public class vtkXYPlotActor extends vtkActor2D
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void AddInput_2(vtkDataSet id0);
  public void AddInput(vtkDataSet id0)
    { AddInput_2(id0); }

  private native void RemoveInput_3(vtkDataSet id0);
  public void RemoveInput(vtkDataSet id0)
    { RemoveInput_3(id0); }

  private native vtkDataSetCollection GetInputList_4();
  public vtkDataSetCollection GetInputList()
    { return GetInputList_4(); }

  private native void SetPointComponent_5(int id0,int id1);
  public void SetPointComponent(int id0,int id1)
    { SetPointComponent_5(id0,id1); }

  private native int GetPointComponent_6(int id0);
  public int GetPointComponent(int id0)
    { return GetPointComponent_6(id0); }

  private native void SetXValues_7(int id0);
  public void SetXValues(int id0)
    { SetXValues_7(id0); }

  private native int GetXValues_8();
  public int GetXValues()
    { return GetXValues_8(); }

  private native void SetXValuesToIndex_9();
  public void SetXValuesToIndex()
    { SetXValuesToIndex_9(); }

  private native void SetXValuesToArcLength_10();
  public void SetXValuesToArcLength()
    { SetXValuesToArcLength_10(); }

  private native void SetXValuesToNormalizedArcLength_11();
  public void SetXValuesToNormalizedArcLength()
    { SetXValuesToNormalizedArcLength_11(); }

  private native void SetXValuesToValue_12();
  public void SetXValuesToValue()
    { SetXValuesToValue_12(); }

  private native String GetXValuesAsString_13();
  public String GetXValuesAsString()
    { return GetXValuesAsString_13(); }

  private native void AddDataObjectInput_14(vtkDataObject id0);
  public void AddDataObjectInput(vtkDataObject id0)
    { AddDataObjectInput_14(id0); }

  private native void RemoveDataObjectInput_15(vtkDataObject id0);
  public void RemoveDataObjectInput(vtkDataObject id0)
    { RemoveDataObjectInput_15(id0); }

  private native vtkDataObjectCollection GetDataObjectInputList_16();
  public vtkDataObjectCollection GetDataObjectInputList()
    { return GetDataObjectInputList_16(); }

  private native void SetDataObjectPlotMode_17(int id0);
  public void SetDataObjectPlotMode(int id0)
    { SetDataObjectPlotMode_17(id0); }

  private native int GetDataObjectPlotMode_18();
  public int GetDataObjectPlotMode()
    { return GetDataObjectPlotMode_18(); }

  private native void SetDataObjectPlotModeToRows_19();
  public void SetDataObjectPlotModeToRows()
    { SetDataObjectPlotModeToRows_19(); }

  private native void SetDataObjectPlotModeToColumns_20();
  public void SetDataObjectPlotModeToColumns()
    { SetDataObjectPlotModeToColumns_20(); }

  private native String GetDataObjectPlotModeAsString_21();
  public String GetDataObjectPlotModeAsString()
    { return GetDataObjectPlotModeAsString_21(); }

  private native void SetDataObjectXComponent_22(int id0,int id1);
  public void SetDataObjectXComponent(int id0,int id1)
    { SetDataObjectXComponent_22(id0,id1); }

  private native int GetDataObjectXComponent_23(int id0);
  public int GetDataObjectXComponent(int id0)
    { return GetDataObjectXComponent_23(id0); }

  private native void SetDataObjectYComponent_24(int id0,int id1);
  public void SetDataObjectYComponent(int id0,int id1)
    { SetDataObjectYComponent_24(id0,id1); }

  private native int GetDataObjectYComponent_25(int id0);
  public int GetDataObjectYComponent(int id0)
    { return GetDataObjectYComponent_25(id0); }

  private native void SetPlotColor_26(int id0,double id1,double id2,double id3);
  public void SetPlotColor(int id0,double id1,double id2,double id3)
    { SetPlotColor_26(id0,id1,id2,id3); }

  private native void SetPlotSymbol_27(int id0,vtkPolyData id1);
  public void SetPlotSymbol(int id0,vtkPolyData id1)
    { SetPlotSymbol_27(id0,id1); }

  private native vtkPolyData GetPlotSymbol_28(int id0);
  public vtkPolyData GetPlotSymbol(int id0)
    { return GetPlotSymbol_28(id0); }

  private native void SetPlotLabel_29(int id0,String id1);
  public void SetPlotLabel(int id0,String id1)
    { SetPlotLabel_29(id0,id1); }

  private native String GetPlotLabel_30(int id0);
  public String GetPlotLabel(int id0)
    { return GetPlotLabel_30(id0); }

  private native vtkLegendBoxActor GetLegendBoxActor_31();
  public vtkLegendBoxActor GetLegendBoxActor()
    { return GetLegendBoxActor_31(); }

  private native vtkGlyphSource2D GetGlyphSource_32();
  public vtkGlyphSource2D GetGlyphSource()
    { return GetGlyphSource_32(); }

  private native void SetTitle_33(String id0);
  public void SetTitle(String id0)
    { SetTitle_33(id0); }

  private native String GetTitle_34();
  public String GetTitle()
    { return GetTitle_34(); }

  private native void SetXTitle_35(String id0);
  public void SetXTitle(String id0)
    { SetXTitle_35(id0); }

  private native String GetXTitle_36();
  public String GetXTitle()
    { return GetXTitle_36(); }

  private native void SetYTitle_37(String id0);
  public void SetYTitle(String id0)
    { SetYTitle_37(id0); }

  private native String GetYTitle_38();
  public String GetYTitle()
    { return GetYTitle_38(); }

  private native void SetXRange_39(double id0,double id1);
  public void SetXRange(double id0,double id1)
    { SetXRange_39(id0,id1); }

  private native void SetXRange_40(double id0[]);
  public void SetXRange(double id0[])
    { SetXRange_40(id0); }

  private native double[] GetXRange_41();
  public double[] GetXRange()
    { return GetXRange_41(); }

  private native void SetYRange_42(double id0,double id1);
  public void SetYRange(double id0,double id1)
    { SetYRange_42(id0,id1); }

  private native void SetYRange_43(double id0[]);
  public void SetYRange(double id0[])
    { SetYRange_43(id0); }

  private native double[] GetYRange_44();
  public double[] GetYRange()
    { return GetYRange_44(); }

  private native void SetPlotRange_45(double id0,double id1,double id2,double id3);
  public void SetPlotRange(double id0,double id1,double id2,double id3)
    { SetPlotRange_45(id0,id1,id2,id3); }

  private native void SetNumberOfXLabels_46(int id0);
  public void SetNumberOfXLabels(int id0)
    { SetNumberOfXLabels_46(id0); }

  private native int GetNumberOfXLabels_47();
  public int GetNumberOfXLabels()
    { return GetNumberOfXLabels_47(); }

  private native void SetNumberOfYLabels_48(int id0);
  public void SetNumberOfYLabels(int id0)
    { SetNumberOfYLabels_48(id0); }

  private native int GetNumberOfYLabels_49();
  public int GetNumberOfYLabels()
    { return GetNumberOfYLabels_49(); }

  private native void SetNumberOfLabels_50(int id0);
  public void SetNumberOfLabels(int id0)
    { SetNumberOfLabels_50(id0); }

  private native void SetLegend_51(int id0);
  public void SetLegend(int id0)
    { SetLegend_51(id0); }

  private native int GetLegend_52();
  public int GetLegend()
    { return GetLegend_52(); }

  private native void LegendOn_53();
  public void LegendOn()
    { LegendOn_53(); }

  private native void LegendOff_54();
  public void LegendOff()
    { LegendOff_54(); }

  private native void SetLegendPosition_55(double id0,double id1);
  public void SetLegendPosition(double id0,double id1)
    { SetLegendPosition_55(id0,id1); }

  private native void SetLegendPosition_56(double id0[]);
  public void SetLegendPosition(double id0[])
    { SetLegendPosition_56(id0); }

  private native double[] GetLegendPosition_57();
  public double[] GetLegendPosition()
    { return GetLegendPosition_57(); }

  private native void SetLegendPosition2_58(double id0,double id1);
  public void SetLegendPosition2(double id0,double id1)
    { SetLegendPosition2_58(id0,id1); }

  private native void SetLegendPosition2_59(double id0[]);
  public void SetLegendPosition2(double id0[])
    { SetLegendPosition2_59(id0); }

  private native double[] GetLegendPosition2_60();
  public double[] GetLegendPosition2()
    { return GetLegendPosition2_60(); }

  private native void SetBold_61(int id0);
  public void SetBold(int id0)
    { SetBold_61(id0); }

  private native int GetBold_62();
  public int GetBold()
    { return GetBold_62(); }

  private native void BoldOn_63();
  public void BoldOn()
    { BoldOn_63(); }

  private native void BoldOff_64();
  public void BoldOff()
    { BoldOff_64(); }

  private native void SetItalic_65(int id0);
  public void SetItalic(int id0)
    { SetItalic_65(id0); }

  private native int GetItalic_66();
  public int GetItalic()
    { return GetItalic_66(); }

  private native void ItalicOn_67();
  public void ItalicOn()
    { ItalicOn_67(); }

  private native void ItalicOff_68();
  public void ItalicOff()
    { ItalicOff_68(); }

  private native void SetShadow_69(int id0);
  public void SetShadow(int id0)
    { SetShadow_69(id0); }

  private native int GetShadow_70();
  public int GetShadow()
    { return GetShadow_70(); }

  private native void ShadowOn_71();
  public void ShadowOn()
    { ShadowOn_71(); }

  private native void ShadowOff_72();
  public void ShadowOff()
    { ShadowOff_72(); }

  private native void SetFontFamily_73(int id0);
  public void SetFontFamily(int id0)
    { SetFontFamily_73(id0); }

  private native int GetFontFamily_74();
  public int GetFontFamily()
    { return GetFontFamily_74(); }

  private native void SetFontFamilyToArial_75();
  public void SetFontFamilyToArial()
    { SetFontFamilyToArial_75(); }

  private native void SetFontFamilyToCourier_76();
  public void SetFontFamilyToCourier()
    { SetFontFamilyToCourier_76(); }

  private native void SetFontFamilyToTimes_77();
  public void SetFontFamilyToTimes()
    { SetFontFamilyToTimes_77(); }

  private native void SetLabelFormat_78(String id0);
  public void SetLabelFormat(String id0)
    { SetLabelFormat_78(id0); }

  private native String GetLabelFormat_79();
  public String GetLabelFormat()
    { return GetLabelFormat_79(); }

  private native void SetBorder_80(int id0);
  public void SetBorder(int id0)
    { SetBorder_80(id0); }

  private native int GetBorder_81();
  public int GetBorder()
    { return GetBorder_81(); }

  private native int GetPlotPoints_82();
  public int GetPlotPoints()
    { return GetPlotPoints_82(); }

  private native void SetPlotPoints_83(int id0);
  public void SetPlotPoints(int id0)
    { SetPlotPoints_83(id0); }

  private native void PlotPointsOn_84();
  public void PlotPointsOn()
    { PlotPointsOn_84(); }

  private native void PlotPointsOff_85();
  public void PlotPointsOff()
    { PlotPointsOff_85(); }

  private native int GetPlotLines_86();
  public int GetPlotLines()
    { return GetPlotLines_86(); }

  private native void SetPlotLines_87(int id0);
  public void SetPlotLines(int id0)
    { SetPlotLines_87(id0); }

  private native void PlotLinesOn_88();
  public void PlotLinesOn()
    { PlotLinesOn_88(); }

  private native void PlotLinesOff_89();
  public void PlotLinesOff()
    { PlotLinesOff_89(); }

  private native void SetGlyphSize_90(double id0);
  public void SetGlyphSize(double id0)
    { SetGlyphSize_90(id0); }

  private native double GetGlyphSize_91();
  public double GetGlyphSize()
    { return GetGlyphSize_91(); }

  private native void ViewportToPlotCoordinate_92(vtkViewport id0);
  public void ViewportToPlotCoordinate(vtkViewport id0)
    { ViewportToPlotCoordinate_92(id0); }

  private native void SetPlotCoordinate_93(double id0,double id1);
  public void SetPlotCoordinate(double id0,double id1)
    { SetPlotCoordinate_93(id0,id1); }

  private native void SetPlotCoordinate_94(double id0[]);
  public void SetPlotCoordinate(double id0[])
    { SetPlotCoordinate_94(id0); }

  private native double[] GetPlotCoordinate_95();
  public double[] GetPlotCoordinate()
    { return GetPlotCoordinate_95(); }

  private native void PlotToViewportCoordinate_96(vtkViewport id0);
  public void PlotToViewportCoordinate(vtkViewport id0)
    { PlotToViewportCoordinate_96(id0); }

  private native void SetViewportCoordinate_97(double id0,double id1);
  public void SetViewportCoordinate(double id0,double id1)
    { SetViewportCoordinate_97(id0,id1); }

  private native void SetViewportCoordinate_98(double id0[]);
  public void SetViewportCoordinate(double id0[])
    { SetViewportCoordinate_98(id0); }

  private native double[] GetViewportCoordinate_99();
  public double[] GetViewportCoordinate()
    { return GetViewportCoordinate_99(); }

  private native int IsInPlot_100(vtkViewport id0,double id1,double id2);
  public int IsInPlot(vtkViewport id0,double id1,double id2)
    { return IsInPlot_100(id0,id1,id2); }

  private native int GetMTime_101();
  public int GetMTime()
    { return GetMTime_101(); }

  public vtkXYPlotActor() { super(); };

  protected vtkXYPlotActor(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
