<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>

<%
   String machine=request.getParameter("machineName");
   String userName=storeInfo.getTableVal("userName");
   ContextManager cm=ServerServlet.getContextManager(userName);
   cm.setCurrentProblemProperty("MachineName",machine);
   String execpath=
   	parseXML.getMatchTag(cm.getCurrentProblemProperty("Code"),
        cm.getCurrentProblemProperty("MachineName"),"ExecPath");

   String qsubpath=
	parseXML.getMatchTag(cm.getCurrentProblemProperty("Code"),	
        cm.getCurrentProblemProperty("MachineName"),"QsubPath");

   String NumOfInparam = parseXML.getNumberOfInParams(cm.getCurrentProblemProperty("Code"));
   String NumofOutfiles = parseXML.getNumberOfOutFiles(cm.getCurrentProblemProperty("Code"));
   String iostyle = parseXML.getIOStyle(cm.getCurrentProblemProperty("Code"));

   String workspace =
	parseXML.getMatchTag(cm.getCurrentProblemProperty("Code"),	
        cm.getCurrentProblemProperty("MachineName"),"WorkDir");

   // I have hardset the following parameters, but they should be
   // gathered from the user.
   cm.setCurrentProblemProperty("NNodes","2");
   cm.setCurrentProblemProperty("walltime","10:00:00");
   cm.setCurrentProblemProperty("queue","default");
   cm.setCurrentProblemProperty("shell","/bin/csh");
   cm.setCurrentProblemProperty("execpath",execpath);
   cm.setCurrentProblemProperty("qsubpath",qsubpath);
   cm.setCurrentProblemProperty("inputpath",
	"/a/birch.csit.fsu.edu/shared/home/cyoun/Ising/input1.dat");
   cm.setCurrentProblemProperty("outputpath",
	"/a/birch.csit.fsu.edu/shared/home/cyoun/Ising/output1.dat");   

   cm.setCurrentProblemProperty("IOStyle",iostyle);
   cm.setCurrentProblemProperty("WorkDir",workspace);
   cm.setCurrentProblemProperty("NumInParams",NumOfInparam);
   cm.setCurrentProblemProperty("NumOutFiles",NumofOutfiles);
   cm.setCurrentProblemProperty("inputParam","/a/birch.csit.fsu.edu/shared/home/cyoun/Ising/input1.dat");
   cm.setCurrentProblemProperty("outputFiles","/a/birch.csit.fsu.edu/shared/home/cyoun/Ising/output1.dat");
   cm.setCurrentProblemProperty("Account#","WP+WPASC00000003");	

   //Instantiate the createJobScript bean
   extensions.generic.createScript cjs = new extensions.generic.createDQS(cm);
   cjs.createFlagTable();
   cjs.createHeader();
   cjs.createCommands();
   cjs.writeScript();
	
%>
<html>
<body>
<h1>
Script Page
</h1>
You want to use the host <%= machine %>.
<br \>
<br>
At this point you should be prompted to upload your input file, or  
perhaps choose one from a repository.  For testing, however, I have hardcoded
this. 
<p>
The following are preassigned values used to create the queue script.  I 
store these in the ContextData.
<br>
Job Name: <%= cm.getCurrentProblemProperty("Name") %> <br>
Application: <%= cm.getCurrentProblemProperty("Code") %> <br>
Remote host: <%= cm.getCurrentProblemProperty("MachineName") %> <br>
Number of Nodes: <%= cm.getCurrentProblemProperty("NNodes") %> <br>
Walltime: <%= cm.getCurrentProblemProperty("walltime") %> <br> 
Queue: <%= cm.getCurrentProblemProperty("queue") %> <br>
Shell: <%= cm.getCurrentProblemProperty("shell") %> <br>
Full path to executable: <%= cm.getCurrentProblemProperty("execpath") %> <br>
<br>

Your job script has been created.  You can submit your job by pressing the 
button below. <br>

<form name="" Method="POST" action="/GOW/Generic/Page4.jsp">
<input type=submit name="submit" value="Submit Job">
</form>


</body>
</html>
