<%@ page info="Add the host name into the application." %>
<%@ page import="java.util.*" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>

<%
   String codeName=request.getParameter("codeName");
   Vector machineNames=parseXML.getHostListNames(codeName);
%>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.75 [en] (X11; U; IRIX 6.5 IP32) [Netscape]">
<SCRIPT LANGUAGE="JavaScript">
function checkForm(form) {

        for(var k = 0; k < form.elements.length; k++) {
          if(form.elements[k].value == "") {
                alert("Fill out ALL fields.")
                return false
          }
        }
        return true
}
</SCRIPT>
</head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">
<center>
<h2>
The Hostname Form for the Application</h2></center>
<form name="updateaddform" Method="POST" action="/GOW/servlet/WebFlow.Servlets.GOWAdminServlet" onSubmit="return checkForm(this)">
<input type="hidden" name="cmd" value="AdminChangeHost">

Please review the following information needed to update an application.
<p><b><i>Code: </i></b>
<b><%= codeName %> </b>
<input type="hidden" name=codeName value="<%= codeName %>">

<br><b><i>Number of Input Parameter: </i></b>
<b><%= parseXML.getNumberOfInParams(codeName)%> </b>
<input type=hidden name=numofinparam value="<%= parseXML.getNumberOfInParams(codeName) %>">

<br><b><i>Number of Input Files: </i></b>
<b><%=  parseXML.getNumberOfInFiles(codeName) %> </b>
<input type=hidden name=numofinfiles value="<%= parseXML.getNumberOfInFiles(codeName) %>">

<br><b><i>Number of Output Parameter: </i></b>
<b> <%= parseXML.getNumberOfOutParams(codeName) %> </b>
<input type=hidden name=numofoutparam value="<%= parseXML.getNumberOfOutParams(codeName) %>">

<br><b><i>Number of Output Files: </i></b>
<b><%= parseXML.getNumberOfOutFiles(codeName) %></b>
<input type=hidden name=numofoutfiles value="<%= parseXML.getNumberOfOutFiles(codeName) %>">

<br><b><i>IO Style: </i></b>
<b><%= parseXML.getIOStyle(codeName) %></b>
<input type=hidden name=iostyle value="<%= parseXML.getIOStyle(codeName) %>">

<%
	String tmp1;

        for(int j=0;j<machineNames.size();j++){ 
           tmp1=(String)machineNames.elementAt(j);
%>      
	        <p><b><i> <%= j+1 %>. Machine Name: </i></b>
		<b> <%= tmp1 %> </b><br>
                <input type=hidden name=machineName
                        value=<%= tmp1 %>>
<%
	   String queueType =
	      parseXML.getMatchTag(codeName, tmp1,"QueueType");
	   String execPath =
              parseXML.getMatchTag(codeName, tmp1,"ExecPath");
	   String workSpace =
              parseXML.getMatchTag(codeName, tmp1,"WorkDir");
	   String qsubPath =
	      parseXML.getMatchTag(codeName, tmp1,"QsubPath");
	   String classPath =
	      parseXML.getMatchTag(codeName, tmp1,"CLASSPATH");
%>
	  	<table border = 0>
		<td width = 30>
		&nbsp;
		</td> <td>	
	        <b><li>Queue Type: </b> <b><%= queueType %></b>
                <input type=hidden name=queuetype
                        value=<%= queueType %>>
	        <b><li>Exec Path: </b> <b><%= execPath %></b>
                <input type=hidden name=execpath
                        value=<%= execPath %>>
	        <b><li>Work Space: </b><b><%= workSpace %></b>
                <input type=hidden name=workspace
                        value=<%= workSpace %>>
	        <b><li>Qsub Path: </b> <b><%= qsubPath %></b>
                <input type=hidden name=qsubpath
                        value=<%= qsubPath %>>
	        <b><li>CLASSPATH: </b><b><%= classPath %></b>
                <input type=hidden name=classpath
                        value=<%= classPath %>>
<%
	Hashtable hash=parseXML.getEnvironHash(codeName,tmp1);	
	Enumeration en=hash.keys();
	while(en.hasMoreElements()) {
	   String key=(String)en.nextElement();
	   String tablename = tmp1+"+"+key;
%>
	        <b><li><%= key %>: </b><b><%= (String)hash.get(key) %></b>
                <input type=hidden name=<%= tablename %>
                        value=<%= (String)hash.get(key) %>>
<%
	}
%>
		</td>
		</table>
<%
        }

	Vector vtklist = parseXML.getVtkList(codeName);

        for(int j=0;j<vtklist.size();j++){ 
           tmp1 = (String)vtklist.elementAt(j);
	
%>      
	        <p><b><i> <%= j+1 %>. Vtk Name: </i></b>
                <input type=hidden name=vtkName
                        value=<%= tmp1 %>> <b><%= tmp1 %></b><br>
<%
	String vizhost = parseXML.getVtkHost(codeName, tmp1);
	String vizpath = parseXML.getVtkPath(codeName, tmp1);
%>
	  	<table border = 0>
		<td width = 30>
		&nbsp;
		</td> <td>	
	        <b><li>Vtk Host: </b> <b><%= vizhost %></b>
                <input type=hidden name=vtkhost
                        value=<%= vizhost %>>
	        <b><li>Vtk Path: </b> <b> <%= vizpath %> </b>
                <input type=hidden name=vtkpath
                        value=<%= vizpath %>>
		</td>
		</table>
<%
	}
%>

<p>Please add new hostname for this application.

	        <p><b><i>Machine Name: </i></b>
                <input type=text name=machineNametext size=20 maxlength=80
                        value=""> <br>
	  	<table border = 0>
		<td width = 30>
		&nbsp;
		</td> <td>	
	        <b><li>Queue Type: </b>
                <input type=text name=queuetypetext size=10 maxlength=50
                        value="">
	        <b><li>Exec Path: </b>
                <input type=text name=execpathtext size=25 maxlength=80
                        value=""> <b> Verify: </b>
		<input type=radio name=execpathverify value="Yes" > Yes
		<input type=radio name=execpathverify value="No" CHECKED > No
	        <b><li>Work Space: </b>
                <input type=text name=workspacetext size=25 maxlength=80
                        value=""> <b> Verify: </b>
		<input type=radio name=workdirverify value="Yes" > Yes
		<input type=radio name=workdirverify value="No" CHECKED > No
	        <b><li>Qsub Path: </b>
                <input type=text name=qsubpathtext size=25 maxlength=80
                        value=""> <b> Verify: </b>
		<input type=radio name=qsubverify value="Yes" > Yes
		<input type=radio name=qsubverify value="No" CHECKED > No
	        <b><li>Class Path: </b>
                <input type=text name=classpathtext size=25 maxlength=80
                        value=""> <b> Verify: </b>
		<input type=radio name=classpathverify value="Yes" > Yes
		<input type=radio name=classpathverify value="No" CHECKED > No
		</td>
		</table>

<p>
<input type=submit name="submit" value="Update">&nbsp;&nbsp;
<input type = "button" name="cancel" value="Cancel" onClick="self.location='/GOW/Generic/AdminXMLcancel.jsp';">
</form>
</body>
</html>





