<%@ page info="Collect info necessary to submit job script." %>
<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="java.util.Date" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="nameEncode" class="extensions.generic.nameEncodeBean" scope="session"/>
<jsp:useBean id="setprops" class="extensions.generic.setPropBean" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.75 [en] (X11; U; IRIX 6.5 IP32) [Netscape]">
<SCRIPT LANGUAGE="JavaScript">
function checkForm(form) {

	var flagchecked = 0;
	var flagchecked1 = 0

	for(var i = 0; i < form.shell.length; i++) {
	  if(form.shell[i].checked) {
		flagchecked = 1
		break		
	  }
	}
	if(flagchecked == 0) { 
		alert("Please choose your radio button(Shell)")
		return false }

	for(var j = 0; j < form.queue.length; j++) {
	  if(form.queue[j].checked) {
		flagchecked1 = 1
		break		
	  }
	}
	if(flagchecked1 == 0) { 
		alert("Please choose your radio button(Queue)")
		return false }

	for(var k = 0; k < form.elements.length; k++) {
	  if(form.elements[k].value == "") {
		alert("Fill out ALL fields.")
		return false
	  }
	}
	return true
}
</SCRIPT>
</head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">

<%
   String userName=storeInfo.getTableVal("userName");

   String slaveHostName = request.getParameter("machineName");
   storeInfo.setTablePair("hostName",slaveHostName);

   String slaveMachinename = storeInfo.getTableVal("slaveMachinename");

   ContextManager cm = null;
   if(!slaveHostName.equals(slaveMachinename)) { 	
      cm=modserver.getContextManager();
   } else {
      cm=modserver.getContextManagerForSlave();
   }

   setprops.setXML(parseXML);
   //setprops.setNE(nameEncode);
   setprops.setCM(cm);
   //setprops.setSI(storeInfo);

   //submitJob sj=ServerServlet.getSubmitJob(userName);

   String problemName=request.getParameter("problemName");
   //String problemName=storeInfo.getTableVal("problemName");
   problemName=nameEncode.encode(problemName);
   System.out.println("ProblemName: "+problemName);

   Date currentDate = new Date();
   long time = currentDate.getTime(); 
   String timestring = (new Long(time).toString());	
   String sessionName = "session"+timestring;

   cm.addNewProblem(problemName);
   storeInfo.setTablePair("problemName",problemName);

   //String webpath = application.getRealPath("/WEB-INF/");
   //String pdir = webpath+"Descriptors/users/JSPClient/gateway/"+problemName;
   //String sdir = webpath+"Descriptors/users/JSPClient/gateway/"+problemName+"/"+sessionName;
   //sj.execLocalCommand("/usr/local/bin/chmod 777 "+pdir);

   String problemNameContext = problemName+".PC";
   cm.addNewSession(problemNameContext,sessionName); 
   storeInfo.setTablePair("sessionName",sessionName);

   cm.selectSession(problemName,sessionName);
   System.out.println("sessionName: "+sessionName);

   setprops.setRequests(request);

   //sj.execLocalCommand("/usr/local/bin/chmod 777 "+sdir);

   //String code=request.getParameter("codeName");
   //cm.setCurrentSessionProperty("Code",code);
   //String machine=request.getParameter("machineName");
   //cm.setCurrentSessionProperty("MachineName",machine);
  
%>

<center>
<h2>
Job Script Input</h2></center>
<form name="QueueParams" Method="POST" action="/GOW/servlet/WebFlow.Servlets.GOWAdminServlet" onSubmit="return checkForm(this)">
<input type="hidden" name=codeType value="CodeSelection">
<input type="hidden" name="cmd" value="Submitted">

Please provide the following information needed to generate the queue script.
<p><b><i>Shell:</i></b><b><i></i></b>
<input type=radio name=shell value="/bin/csh"> /bin/csh
<input type=radio name=shell value="/bin/sh"> /bin/sh
<p><b><i>Queue:</i></b><b><i></i></b>
<input type=radio name=queue value="small"> small
<input type=radio name=queue value="medium"> medium
<input type=radio name=queue value="large"> large
<input type=radio name=queue value="default"> default
<p><b><i>WallTime (hh:mm:ss):</i></b><b><i></i></b>
<input type=text name=walltime size=10>
<p><b><i>Number of Nodes:</i></b><b><i></i></b>
<input type=text name=NNodes size=3 maxlength=3>
<p>The code you have selected takes <%= cm.getCurrentSessionProperty("NumberOfInFiles")%> input parameter(s).  See the code documentation for details.  
Please specify the location of the input file on the remote host, 
<%= cm.getCurrentSessionProperty("machineName") %>.
You can use the "Upload" button in the "Tools" area to transfer
your input file from your desktop to the remote host.
<br>&nbsp;

<%
        int limit1=Integer.parseInt(cm.getCurrentSessionProperty("NumberOfInFiles"));
        for(int i=0;i<limit1;i++) {
%>
Input File:
<input type=text name=inputpath size=25 maxlength=80>
<br>&nbsp;
<%
        }
%>

<p>This code requires <%= cm.getCurrentSessionProperty("NumberOfInParams")%> input pa
rameters on the command line.  Please provide them in the fields
below.  See the code documentation for details.
<br>&nbsp;
<%
        int limit2=Integer.parseInt(cm.getCurrentSessionProperty("NumberOfInParams"));
        for(int i=0;i<limit2;i++) {
%>
Input Parameter:
<input type=text name=inputparameter size=25 maxlength=80>
<br>&nbsp;                                                                    
<%
        }
%>

<p>
The application requires <%= cm.getCurrentSessionProperty("NumberOfOutParams") %> out
put parameter(s) on the command line.

<br>&nbsp;

<%
        int uplimit1=Integer.parseInt(cm.getCurrentSessionProperty("NumberOfOutParams"));
        for(int j=0;j<uplimit1;j++) {
%>
Output Parameter:
<input type=text name=outputparameter size=25 maxlength=80>
<br>
<%
        }
%>
<p>                     
Finally, the application generates <%= cm.getCurrentSessionProperty("NumberOfOutFiles") %> output file(s).  Please specify the full
path name of the directory on the HPC server where you would like this file
to be placed.  You can later download this file to your desktop with the
"File Browser" from the "Tools" area.
<br>&nbsp;

<%
        int uplimit2=Integer.parseInt(cm.getCurrentSessionProperty("NumberOfOutFiles"));
        for(int j=0;j<uplimit2;j++) {
%>
Output File:
<input type=text name=outputpath size=25 maxlength=80>
<br>
<%
        }
%>

<input type=submit name="submit" value="Make Selections">&nbsp;&nbsp;
<input type = "button" name="cancel" value="Cancel" onClick="self.location='/GOW/Generic/Main.jsp';">
</form>
</body>
</html>







