<%@ page info="The Welcome Page for initializing session beans, webflow modules, and entering different user tracks." %>
<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="java.util.*" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<%	
  String userName="gateway";
  storeInfo.setTablePair("userName",userName);

  String propspath = application.getRealPath("/WEB-INF/");
  propspath += "../Properties/Collab.properties";

  String slaveMachinename = null;
  String descRoot = null;
  String openHostname = null;
  String masterServerOwner = null;
  String masterServergspath = null;
  String slaveServergspath = null;
  String webDir = null;

  Properties props = new Properties();
  try {
      props.load(new FileInputStream(propspath));
      slaveMachinename=props.getProperty("slaveHostname");
      descRoot=props.getProperty("slavedescDir");
      openHostname = props.getProperty("openHostname");
      masterServerOwner = props.getProperty("masterServerOwner");
      masterServergspath = props.getProperty("masterServergspath");
      slaveServergspath = props.getProperty("slaveServergspath");
      webDir = props.getProperty("webDir");

      storeInfo.setTablePair("slaveMachinename",slaveMachinename);
      storeInfo.setTablePair("slavedescDir",descRoot);
      storeInfo.setTablePair("openHostname",openHostname);
      storeInfo.setTablePair("masterServerOwner",masterServerOwner);
      storeInfo.setTablePair("masterServergspath",masterServergspath);
      storeInfo.setTablePair("slaveServergspath",slaveServergspath);
      storeInfo.setTablePair("webDir",webDir);
  }
  catch(Exception ex) {
      System.out.println("Error reading:" + ex);
  }

%>
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.75 [en] (X11; U; IRIX 6.5 IP32) [Netscape]">
<title>GOW Main Page</title>
</head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">

<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session">	
<%
   String masterIOR=(HttpUtils.getRequestURL(request)).toString();
   masterIOR=masterIOR.substring(0,masterIOR.indexOf("/GOW"))
      +"/GOW/IOR/master.txt";
   modserver.init(masterIOR);
%>
</jsp:useBean>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session">
<%
 String xmlpath = application.getRealPath("/WEB-INF/src/generic/ApplDesc.xml");
 parseXML.init(xmlpath);
%>
</jsp:useBean>

<center>
<h2>
<font color="#000000">Welcome to the</font></h2></center>
<center>
<h2>
<font color="#000000">Gateway Computational Science Portal</font></h2></center>
<font color="#000000">The Gateway&nbsp;Science Portal is a tool for remotely
accessing computational science applications.&nbsp;&nbsp; For more information on the Gateway Project, please visit the our 
<a href="http://www.gatewayportal.org">web site</a>.
</font><font color="#000000"></font>

<jsp:include page="TrackNavigator.jsp" flush="true"/>

</form>
</body>
</html>

