<%@ page info="Make the script for the visualization." %>
<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="WebFlow.RemoteFile.*" %>
<%@ page import="WebFlow.RemoteFile.RemoteFilePackage.*" %>
<%@ page import="java.util.Date" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="getfile" class="extensions.generic.GetFileBean" scope="session"/>
<jsp:setProperty name="getfile" property="rootDir" value=""/> 
<jsp:useBean id="setprops" class="extensions.generic.setPropBean" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<%
   String userName=storeInfo.getTableVal("userName");
   String collcheck = request.getParameter("collchoice");
   String vizcomm = request.getParameter("vizsubmitcomm");
   System.out.println("VizScript: Vizcomm: "+vizcomm);
   String propspath = application.getRealPath("/WEB-INF/");
   propspath += "../Properties/Collab.properties";

   String problemName=storeInfo.getTableVal("problemName");
   String sessionName=storeInfo.getTableVal("sessionName");

   ContextManager cm = null;
   RemoteFile rf = null;
   boolean flag = false;

   String archiveType = storeInfo.getTableVal("archiveType");

   if(archiveType.equals("masterProblemname")) {
      	cm=modserver.getContextManager();
	flag = true;
   } else {
      	cm=modserver.getContextManagerForSlave();
	rf=modserver.getRemoteFileForSlave();
   }

   //ContextManager cm=modserver.getContextManager();
   //cm.selectSession(problemName,sessionName);
   setprops.setCM(cm);
   setprops.setRequests(request);

   //Setup the createScript bean and create the script.
   //Use a factory pattern here so that the queuing system
   //is determined by the user's selection.
   //System.out.println("Queue Type: "+cm.getCurrentSessionProperty("QueueType"));
	extensions.generic.createScript cjs = null;
	String scriptString="";
	String probDir = cm.getCurrentSessionProperty("Directory");
	String scripttype = cm.getCurrentSessionProperty("VtkCode");

	if(flag) {

	cjs=extensions.generic.scriptFactory.makeChild(cm.getCurrentSessionProperty("VtkType"),cm,userName);

 	cjs.setScriptProperties(propspath);
	cjs.createFlagTable();
	cjs.createHeader();
	cjs.createGnuplotCommands();
	cjs.writeScript();

	//Now grab the script and give the user a chance to edit it.
	//String scriptString="";
	//String probDir="Descriptors/users/JSPClient/"+userName+"/"+problemName+"/"+sessionName;
	//String scripttype = cm.getCurrentSessionProperty("VtkCode");
	if(scripttype.equalsIgnoreCase("gnuplot")) {
	   scriptString=getfile.fileToString(probDir+"/script.gnu");
	} else {
	   scriptString=getfile.fileToString(probDir+"/scriptmatlab.m");
	}

	} else {

	cjs=extensions.generic.scriptFactory.makeChild(cm.getCurrentSessionProperty("VtkType"),rf,cm,userName);

	cjs.setScriptProperties(propspath);
	cjs.createFlagTable();
	cjs.createHeader();
	cjs.createMatlabCommands();
	cjs.writeScriptRf();

	//Now grab the script and give the user a chance to edit it.
	//String probDir="Descriptors/users/JSPClient/"+userName+"/"+probName+"/"+sessionName;
	if(scripttype.equalsIgnoreCase("gnuplot")) {
	   probDir = probDir+"/script.gnu";
	} else {
	   probDir = probDir+"/scriptmatlab.m";
	}
	
        byte buffer[] = null;
        try {
           rf.open(probDir, "r"); //open remote file for reading
           buffer = rf.getBlock();
	   scriptString = new String(buffer);
           while(true) {
              if(buffer.length > 0) {
	         buffer = rf.getBlock();
		 scriptString += new String(buffer);
              }
              else throw new EOFFileException();
           }
        }catch(EOFFileException ex) {
            rf.close();
        }

	}

%>
<html>
<head><title>Edit Generated Script</title></head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">
<center>
<h2>Review Viz Script for <%= cm.getCurrentSessionProperty("VtkCode") %> </h2>
</center>
The following Viz script has been created for you.  You can modify 
it if you wish.  When you are finished, click the "Update Viz Script" button to commit your changes.
<center>
<form name=scriptString method=POST action="/GOW/servlet/WebFlow.Servlets.GOWAdminServlet">
<input type="hidden" name=collflag value="<%= collcheck %>">
<input type="hidden" name="cmd" value="VizReturnPage">

<textarea name=scriptString cols=40 rows=20>
<%= scriptString %>
</textarea>
</center>
<center>
<input type=submit name="submit" value="Update Viz Script" >&nbsp;&nbsp;
<input type = "button" name="cancel" value="Cancel" onClick="self.location='/GOW/Generic/Main.jsp';">
</center>
</form>
</body>
</html>
