package extensions.generic;

import java.awt.BorderLayout;
import java.awt.Frame;

import com.sun.j3d.utils.behaviors.picking.PickMouseBehavior;
import javax.media.j3d.*;
import javax.vecmath.*;

import java.awt.event.*;
import java.util.Enumeration;

//   SimpleBehaviorApp renders a single ColorCube
//   that rotates when any key is pressed.

public class pickObjectIdentity extends PickMouseBehavior{

        private TransformGroup targetTG;
        private WakeupCriterion AWTEventCondition;
        private Transform3D rotation = new Transform3D();
        private double angle = 0.0;

        public pickObjectIdentity(Canvas3D canvas, BranchGroup bg, Bounds bound, TransformGroup targetTG){
        	super(canvas, bg, bound);
            this.targetTG = targetTG;
            targetTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            targetTG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            targetTG.setCapability(Group.ALLOW_CHILDREN_WRITE);
            targetTG.setCapability(Group.ALLOW_CHILDREN_READ);
            targetTG.setCapability(Group.ALLOW_CHILDREN_EXTEND);
            targetTG.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
            targetTG.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
            AWTEventCondition = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);
        }

        // initialize the Behavior
        //     set initial wakeup condition
        //     called when behavior beacomes live
        public void initialize(){
            // set initial wakeup condition
            this.wakeupOn(AWTEventCondition);
        }

        // behave
        // called by Java 3D when appropriate stimulus occures
        public void processStimulus(Enumeration criteria){
            // decode event

            // do what is necessary
            //angle += 0.1;
            //rotation.rotY(angle);
            //targetTG.setTransform(rotation);
            //targetTG.getTransform(rotation)
            System.out.println("OK, Good try for picking object");
            this.wakeupOn(AWTEventCondition);
        }

	    public void updateScene(int xpos, int ypos) {
	       System.out.println("Updata Scene.......");
	    }	

}

