//**************************************
//     
// Name: Graphic Point Rotation
// Description:This code returns a point
//     rotated (angle) degrees around an origin
//     point (origin) from a tangent point (tan
//     ). This code comes in 3 functions and a 
//     class. The functions can be placed in an
//     y class necessary.
// By: 
//
// Inputs:Origin (The point to be rotate
//     d around)
Tangent (The point rotating from)
Angle (Destination Degrees from the tangent)
//
// Returns:The destination point.
//
//This code is copyrighted and has// limited warranties.Please see http://
//     www.1JavaStreet.com/xq/ASP/txtCodeId.194
//     1/lngWId.2/qx/vb/scripts/ShowCode.htm//for details.//**************************************
//     

// put the following 3 functions in the 
//     class that will use them.
// START 3 FUNCTIONS
	


    public Point rotation(Point origin, Point tangent, float angle){
    		double newX;
    		double newY;
    		float target_Angle;
    		float original_Angle;
    		double myNum;
    		float target_Length;
    	
    		// Polar axis is Y axis related to origin
    		
    		// Calculate Target length (equal to tangent length)
    		target_Length = (float)(Math.sqrt(Math.abs(origin.x - tangent.x) * Math.abs(origin.x - tangent.x) + Math.abs(origin.y - tangent.y) * Math.abs(origin.y - tangent.y)));		
    					
    		// Calculate target angle (relative to pole)


        		if (tangent.x == 0 && tangent.y == 0){
        			//point is at origin
        			return(origin);


            		}else if (tangent.x == origin.x && tangent.y < origin.y){
            			//point is on positive Y axis
            			original_Angle = 90;


                		}else if (tangent.x == origin.x && tangent.y > origin.y){
                			//point is on negative Y axis
                			original_Angle = 270;


                    		}else if (tangent.x > origin.x && tangent.y == origin.y){
                    			//point is on positive x axis
                    			original_Angle = 0;


                        		}else if (tangent.x < origin.x && tangent.y == origin.y){
                        			//point is on negative x axis
                        			original_Angle = 180;


                            		}else if (tangent.x > origin.x && tangent.y < origin.y){
                            			//point is in ++ area
                            			original_Angle = radiansToDegrees((float)((Math.atan( Math.abs(origin.y - tangent.y) / Math.abs(origin.x - tangent.x) )) ));


                                		}else if (tangent.x > origin.x && tangent.y > origin.y){
                                			//point is in +- area
                                			original_Angle = 360 - radiansToDegrees((float)((Math.atan( Math.abs(origin.y - tangent.y) / Math.abs(origin.x - tangent.x) )) ));


                                    		}else if (tangent.x < origin.x && tangent.y < origin.y){
                                    			//point is in -+ area
                                    			original_Angle = 180 - radiansToDegrees((float)((Math.atan( Math.abs(origin.y - tangent.y) / Math.abs(origin.x - tangent.x) )) ));


                                        		}else if (tangent.x < origin.x && tangent.y > origin.y){
                                        			//point is in -- area	
                                        			original_Angle = 180 + radiansToDegrees((float)((Math.atan( Math.abs(origin.y - tangent.y) / Math.abs(origin.x - tangent.x) )) ));


                                            		}else{
                                            			original_Angle = 180;
                                            		}
                                            						
                                            		target_Angle = original_Angle - angle;
                                            		// Convert new points polar coordinates to cartesian coordinates
                                            		
                                            		newX = target_Length * (Math.cos(degreesToRadians(target_Angle))) + origin.x;
                                            		newY = target_Length * (Math.sin(degreesToRadians(target_Angle))) * (-1) + origin.y ;
                                            		return new Point((int)(newX + 0.5), (int) (newY + 0.5));
                                            	}


                                                	public float radiansToDegrees(float radians){
                                                		float PI = (float)3.14;
                                                		return radians * (180 / PI);
                                                	}


                                                    	public float degreesToRadians(float degrees){
                                                    		float PI = (float)3.14;
                                                    		return degrees / (180 / PI);
                                                    	}
                                                    // END 3 FUNCTIONS
                                                    // Put this class in the source code of 
                                                    //     your application


                                                        class Point{
                                                        	int x;
                                                        	int y;


                                                            	Point(int myX, int myY){
                                                            		x = myX;
                                                            		y = myY;
                                                            	}


                                                                	public void draw(Graphics g){
                                                                		g.drawLine(x,y,x,y);
                                                                	}
                                                            }
