import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
//import java.applet.*;
import java.net.*;
import java.text.*;
import java.io.*;

public class CrpcFrame extends JInternalFrame {
  // GUI variables 
    private JButton Button1,Button2,Button3,Button4,Button5,Button6;
    private JButton Button7,Button8;
    private JTextField status;
    private int CurrentVariable;
    private JTextArea resultText, sc;
    private JProgressBar progress;
    private JScrollPane sp;
    private desktop a;
    private String Server=" ";
    String nextLine;
    String resultFile = "result.txt";
    private boolean debug = true;
    private static boolean ExecutionCompleted;
    private Thread exeA;
    private Thread exeB, exeC;
    private Thread exeP;
    private Thread exeRL, exeRR;
    private Thread exeS;

    private String CPcmd = null;
    private String CEcmd = null;
    private String ParssimSrc, ParssimHost, ParssimUser, WebserverDest;
    private String ExpressHost, ExpressUser, ExpressDest, RCPtype;
    private String RParssimSrc, RParssimHost, RParssimUser, RWebserverDest;
    private String selectedServer;

    private String job_id;

   public CrpcFrame(desktop a) {

   super("CRPC", true, true, true, true);
   this.a = a;
   ExecutionCompleted=false;


   //setupCopying();
   
  if(debug) System.out.println("build GUI");

  getContentPane().setLayout(new BorderLayout());
  
  JPanel left=new JPanel();           //input parameters
  JPanel right=new JPanel();          //results
  JPanel south=new JPanel();         //progress bar;

  getContentPane().add(left,BorderLayout.WEST);
  getContentPane().add(right,BorderLayout.CENTER);
  getContentPane().add(south,BorderLayout.SOUTH);

  if(debug) System.out.println("input parameters  (left panel)");

  JPanel up=new JPanel();             // label (logo)
  JPanel centerPanel = new JPanel();  // input params and scenarios
    //    Panel middle=new Panel();         // input params
  JPanel scenarios = new JPanel();    // scenarios
  JPanel bottom=new JPanel();         // action buttons

  left.setLayout(new BorderLayout());
  left.add(up,BorderLayout.NORTH);
  left.add(centerPanel,BorderLayout.CENTER);
  left.add(bottom,BorderLayout.SOUTH);

  centerPanel.setLayout(new BorderLayout()); 
    //centerPanel.add(middle,BorderLayout.CENTER);
  centerPanel.add(scenarios,BorderLayout.SOUTH);

  if(debug) System.out.println("MSU logo");
  up.setLayout(new BorderLayout());
  JLabel LogoLabel = new JLabel("CRPC Portal",JLabel.CENTER);
  LogoLabel.setFont(new Font("arun",Font.BOLD,30));
  up.add(LogoLabel,BorderLayout.CENTER);
  status=new JTextField("welcome!",20);
  up.add(status,BorderLayout.SOUTH);
    
  if(debug) System.out.println("input params");
  
  bottom.setLayout(new GridLayout(4,2,5,0));

  if(debug) System.out.println("action  buttons");
  Button1 = new JButton ("Run CRPC");
  bottom.add(Button1);
  Button2 = new JButton ("Run Parssim");
  bottom.add(Button2);
  Button3 = new JButton ("Copying File");
  bottom.add(Button3);
  Button4 = new JButton ("Run express");
  bottom.add(Button4);

  Button5 = new JButton ("Rm Remote");
  bottom.add(Button5);
  Button6 = new JButton ("Rm Local");
  bottom.add(Button6);
  Button7 = new JButton ("HELP");
  bottom.add(Button7);
  Button8 = new JButton ("STOP");
  bottom.add(Button8);

  if(debug) System.out.println("button action Events");

  Button1.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent ev) {
	      resultText.setText("");
	      setupParssim();
	      setupExpress();
	      setupCopying();

	      //Running "Parssim" for CRPC portal

	      //runIt("rsh -l pse oscbw.osc.edu /usr/local/pbs-2.2.11/bin/qsub /home/pse/CRPC/beowulf/job.qsub") ;
	      //runIt("rsh dirac.csit.fsu.edu rsh oscbw.osc.edu -l pse /usr/local/pbs-2.2.11/bin/qsub /home/pse/CRPC/beowulf/job.qsub") ;
	      //runIt(CPcmd);
	      runSubmit();

	      // Start to run "express" for CRPC portal
   
	      //runIt("xterm -title express -d magnolia.csit.fsu.edu:0 -e /home/scri97/users/cyoun/birch/XPcrpc/run_xp.sh");	
	      //runIt("rsh -l cyoun queso.csit.fsu.edu xterm -title express -d queso.csit.fsu.edu:0 -e /home.orig/cyoun/XPcrpc/run_xp.sh");	      
	      runIt(CEcmd);

	      // Data Transfer
	      /*
	      waitFor(10);

	      CrpcSendvel(RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest);
	      CrpcSendpres(RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest);
	      CrpcSendconc(RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest);
	      */
	  }
      });


     Button2.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
	      resultText.setText("");
	      setupParssim();
	      setupCopying();

	      //runIt("rsh -l pse oscbw.osc.edu /usr/local/pbs-2.2.11/bin/qsub /home/pse/CRPC/beowulf/job.qsub") ;
	      //runIt("rsh dirac.csit.fsu.edu rsh oscbw.osc.edu -l pse /usr/local/pbs-2.2.11/bin/qsub /home/pse/CRPC/beowulf/job.qsub") ;
	      //	      runIt(CPcmd);
	      runSubmit();
	}
     });


     Button3.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {

	    setupCopying();
	    resultText.setText("");

	    CrpcSendvel(RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest);
	    CrpcSendpres(RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest);
	    CrpcSendconc(RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest);	      
        }
	 });


     Button4.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
	      resultText.setText("");
	      //runIt("rsh -l cyoun queso.csit.fsu.edu xterm -title express -d queso.csit.fsu.edu:0 -e /home.orig/cyoun/XPcrpc/run_xp.sh");
	      //runIt("xterm -title express -d magnolia.csit.fsu.edu:0 -e /home/scri97/users/cyoun/birch/XPcrpc/run_xp.sh");	

	      setupExpress();
	      runIt(CEcmd);
        }
     });

  
     Button5.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent ev2) {

	      /*
	      String host = "oscbw.osc.edu";
	      String user = "pse";
	      */
	      setupServer();
	      setupRM();
	      resultText.setText("");

              RemoveRemote(RParssimHost, RParssimUser, RParssimSrc, RWebserverDest, selectedServer);
	  }
      });

     Button6.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent ev1) {

	      setupRM();
	      resultText.setText("");
	      
	      RemoveLocal(RWebserverDest);

	  }
      });

     Button7.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
          String helpfile="help.txt"; 
          printHelpFile(helpfile);
        }
     });

     Button8.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
	    //resultText.setText("Stopped.....\n");

	    Thread ta[] = new Thread[Thread.activeCount()];
	    int n = Thread.enumerate(ta);

	    for( int i=0; i < n; i++) {
		System.out.println("Thread "+ i + " is "+
				   ta[i].getName());
		/*
		if ((ta[i].getName()).equals("vel_files") ||(ta[i].getName()).equals("pres_files") || (ta[i].getName()).equals("conc_files") || (ta[i].getName()).equals("crpc_display") || (ta[i].getName()).equals("monitor")) 
		    ta[i].stop();
		*/
	    }
	    
	    System.exit(0);
        }
     });


     if(debug) System.out.println("do scroll pane");

     /* results (right panel) */

     // text area with Scrollbar

     /* replaced by swing
	Panel upright=new Panel(new FlowLayout());
	right.setLayout(new BorderLayout());
	right.add(upright,BorderLayout.CENTER);  
	resultText = new TextArea();
	resultText.setFont(new Font("Courier", Font.PLAIN, 12));
	right.add(resultText);   }
     */
     
     right.setLayout(new BorderLayout());
     resultText = new JTextArea();
     resultText.setFont(new Font("Courier", Font.PLAIN, 12));
     sp = new JScrollPane(resultText);
     right.add(sp,BorderLayout.CENTER);
     
     
     /*  progress = new JProgressBar(0,100);
	 progress.setPreferredSize(new Dimension(400,20));
	 south.add(progress); */
   } 
    
    public void printHelpFile(String helpfile) {

        String printinline = null;
	status.setText("Helping ...");
        resultText.setText("");     

        File hfile = new File(helpfile);
        if(hfile.exists()) {
          try {
                FileReader fr = new FileReader(hfile);
                BufferedReader in = new BufferedReader(fr);

                while ( (printinline = in.readLine()) != null ) 
                       resultText.append(printinline+"\n");
                in.close();
          }
          catch (Exception e) {System.out.println(e);} }

         else status.setText("Sorry, "+helpfile+" is NOT exist"); 
    }
    
    public void runIt(String command) {
	ExeCrpc ea = new ExeCrpc(status,resultText,sp,command,debug);
	exeA = new Thread(ea);
	exeA.start();
    }

    public void runSubmit() {
	CrpcSubmitJob ea = new CrpcSubmitJob(status,resultText,sp,CPcmd,RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest, debug);
	exeS = new Thread(ea);
	exeS.start();
    }
    
    /* for CRPC portal */
    public void CrpcSendvel(String RCPtype, String ParssimHost, String ParssimUser, String ParssimSrc, String WebserverDest, String ExpressHost, String ExpressUser, String ExpressDest) {
	CrpcDisplay ea = new CrpcDisplay(status,resultText,sp,"vel",RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest,debug);
	exeB = new Thread(ea);
	exeB.setName("vel_files");
	exeB.start();    
    }

    public void CrpcSendpres(String RCPtype, String ParssimHost, String ParssimUser, String ParssimSrc, String WebserverDest, String ExpressHost, String ExpressUser, String ExpressDest) {
	CrpcDisplay ea = new CrpcDisplay(status,resultText,sp,"pres",RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest,debug);
	exeP = new Thread(ea);
	exeP.setName("pres_files");
	exeP.start();    
    }

    public void CrpcSendconc(String RCPtype, String ParssimHost, String ParssimUser, String ParssimSrc, String WebserverDest, String ExpressHost, String ExpressUser, String ExpressDest) {
	CrpcDisplay ea = new CrpcDisplay(status,resultText,sp,"conc",RCPtype, ParssimHost, ParssimUser, ParssimSrc, WebserverDest, ExpressHost, ExpressUser, ExpressDest,debug);
	exeC = new Thread(ea);
	exeC.setName("conc_files");
	exeC.start();    
    }

    public void RemoveLocal(String webserverdest) {
	RMCrpc ea = new RMCrpc(status,resultText,sp, webserverdest,debug);
	exeRL = new Thread(ea);
	exeRL.start();
    }

    public void RemoveRemote(String RParssimHost, String RParssimUser, String RParssimSrc, String webserverdest, String selectedServer) {
	RMRCrpc ea = new RMRCrpc(status,resultText,sp, RParssimHost, RParssimUser, RParssimSrc,webserverdest, selectedServer, debug);
	exeRR = new Thread(ea);
	exeRR.start();
    }

    public synchronized void waitFor(long howLong){
	try {
	    wait(howLong);
	} catch (Exception e) { System.out.println(e);}
    }

    public static void setExecutionCompleted() {
	ExecutionCompleted=true;
    }

    public static boolean getExecutionCompleted() {
	return ExecutionCompleted;
    }

    
    public void setupCopying() {

	this.RCPtype = a.RCPtype;
	this.ParssimHost = a.ParssimHost;
	this.ParssimUser = a.ParssimUser;
	this.WebserverDest = a.WebserverDest;
	this.ParssimSrc = a.ParssimSrc;
	this.ExpressHost = a.ExpressHost;
	this.ExpressUser = a.ExpressUser;
	this.ExpressDest = a.ExpressDest;
    }

    public void setupParssim() {
	CPcmd = a.Pcmd;
    }

    public void setupExpress() {
	CEcmd = a.Ecmd;
    }

    public void setupRM() {
  
	this.RParssimHost = a.RParssimHost;
	this.RParssimUser = a.RParssimUser;
	this.RWebserverDest = a.RWebserverDest;
	this.RParssimSrc = a.RParssimSrc;
	
    }

    public void setupServer() {
	this.selectedServer = a.selectedServer;
    }    
}





















