import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class ParssimPanel extends JPanel {

String conf = ""; //display,confFile,iorFile,classpath,servletURL,hashtable
String params = null;
JTextField s;
    //ActionListener al;
JPanel pp;

String ConfDir = ""; 
String ConfFileName;
desktop d;
String selectedServer;

  public ParssimPanel(desktop d, String selectedServer) {

  this.d = d;
  this.selectedServer = selectedServer;

  s = new JTextField();
  params =" Command ";

  pp = new JPanel();
  //al = new ActionListener();
  
  ConfFileName = ConfDir+selectedServer+"P.conf";

  File conffile = new File(ConfFileName);
  if(conffile.exists()) {
    try {
      FileReader fr = new FileReader(conffile);
      BufferedReader in = new BufferedReader(fr);
      String nextline = in.readLine();
      in.close();
      conf = nextline;
      d.setParssimConfig(conf);
   }
    catch (Exception e) {System.out.println(e);}
  }  
  else {
    System.out.println("new configuration");
  }


  setLayout(new BorderLayout());

  JPanel ss = new JPanel();
  ss.setLayout(new GridLayout(1,1));

  JLabel l;
  
  pp = new JPanel();
  pp.setLayout(new BorderLayout());
  l = new JLabel(params);
  l.setFont(new Font("Courier", Font.BOLD, 12));
  l.setForeground(Color.black);
  pp.add(l,BorderLayout.WEST);
  s = new JTextField(conf,25);
  s.setPreferredSize(new Dimension(100,5));
  pp.add(s,BorderLayout.CENTER);
  ss.add(pp);  

  add(ss,BorderLayout.CENTER);
  
  JPanel bp = new JPanel();
  bp.setLayout(new GridLayout(1,2));
  JButton b1 = new JButton("Commit");
  b1.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent e) {
	commit();
	  }
      });
  bp.add(b1);

  JButton b2 = new JButton("Reset");
  b2.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent e) {
	      reset();
	  }
      });
  bp.add(b2);
  add(bp,BorderLayout.SOUTH);
  
  }

    public void commit() {
	
	conf=s.getText();  
	d.setParssimConfig(conf);
	try {    
	    FileWriter fw = new FileWriter(ConfFileName);
	    if(conf.length()<1) fw.write("null"); 
	    else fw.write(conf);
	    
	    fw.flush();
	    fw.close();
	} catch (Exception e) { System.out.println(e);}
    }

    public void reset() {
	conf="";
	s.setText("");
    }
}


