<%@ page info="Make a script for the job submit." %>
<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="WebFlow.RemoteFile.*" %>
<%@ page import="WebFlow.RemoteFile.RemoteFilePackage.*" %>
<%@ page import="java.util.Date" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="getfile" class="extensions.generic.GetFileBean" scope="session"/>
<jsp:setProperty name="getfile" property="rootDir" value=""/> 
<jsp:useBean id="setprops" class="extensions.generic.setPropBean" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<%
	String userName=storeInfo.getTableVal("userName");
	String probName=storeInfo.getTableVal("problemName");
	String codeType = request.getParameter("codeType");
	System.out.println("codeType: "+codeType);
	storeInfo.setTablePair("codeType",codeType);

	String sessionName = null;
	String propspath = application.getRealPath("/WEB-INF/");
	propspath += "../Properties/Collab.properties";

	/*
   	String NumOfInParam = null;
   	String NumOfOutFiles = null;
	String NumOfInFiles=null;
	String NumOfOutParams=null;
	*/	

	ContextManager cm = null;
	RemoteFile rf = null;
	boolean flag = false;

	if(codeType.equals("CodeSelection")) {

	   String slaveHostName = storeInfo.getTableVal("hostName");
	   String slaveMachinename =  storeInfo.getTableVal("slaveMachinename");

   	   if(!slaveHostName.equals(slaveMachinename)) { 	
       	      cm=modserver.getContextManager();
	      flag = true;
   	   } else {
      	      cm=modserver.getContextManagerForSlave();
	      rf=modserver.getRemoteFileForSlave();
   	   }

	   sessionName=storeInfo.getTableVal("sessionName");
 	   setprops.setCM(cm);
	   setprops.setRequests(request);

	} else {
   	   Date currentDate = new Date();
   	   long time = currentDate.getTime(); 
   	   String timestring = (new Long(time).toString());	
   	   sessionName = "session"+timestring;
           storeInfo.setTablePair("sessionName",sessionName);

	   String archiveType = storeInfo.getTableVal("archiveType");

   	   if(archiveType.equals("masterProblemname")) {
      		cm=modserver.getContextManager();
		flag = true;
   	   } else {
      		cm=modserver.getContextManagerForSlave();
	        rf=modserver.getRemoteFileForSlave();
   	   }

   	   cm.addSession(sessionName); 

	   setprops.setXML(parseXML);
 	   setprops.setCM(cm);
	   setprops.setRequests(request);

	}

	System.out.println("problemName: "+cm.getCurrentProblemProperty("Name"));
	setprops.setIOArrayRequests(request,true);

	//Setup the createScript bean and create the script.
	//Use a factory pattern here so that the queuing system
	//is determined by the user's selection.
	extensions.generic.createScript cjs = null;
	String scriptString="";
	String probDir = cm.getCurrentSessionProperty("Directory");

	if(flag) {

	cjs=extensions.generic.scriptFactory.makeChild(cm.getCurrentSessionProperty("QueueType"),cm,userName);

	cjs.setScriptProperties(propspath);
	cjs.createFlagTable();
	cjs.createHeader();
	cjs.createCommands();
	cjs.writeScript();

	//Now grab the script and give the user a chance to edit it.
	//String scriptString="";
	//String probDir="Descriptors/users/JSPClient/"+userName+"/"+probName+"/"+sessionName;
	scriptString=getfile.fileToString(probDir+"/job.script");

	} else {

	cjs=extensions.generic.scriptFactory.makeChild(cm.getCurrentSessionProperty("QueueType"),rf,cm,userName);

	cjs.setScriptProperties(propspath);
	cjs.createFlagTable();
	cjs.createHeader();
	cjs.createCommands();
	cjs.writeScriptRf();

	//Now grab the script and give the user a chance to edit it.
	//String probDir="Descriptors/users/JSPClient/"+userName+"/"+probName+"/"+sessionName;
	probDir = probDir+"/job.script";

	//String scriptString=getfile.fileToString(probDir+"/job.script");

        byte buffer[] = null;
        try {
           rf.open(probDir, "r"); //open remote file for reading
           buffer = rf.getBlock();
	   scriptString = new String(buffer);
           while(true) {
              if(buffer.length > 0) {
	         buffer = rf.getBlock();
		 scriptString += new String(buffer);
              }
              else throw new EOFFileException();
           }
        }catch(EOFFileException ex) {
            rf.close();
        }

	}

%>

<html>
<head><title>Edit Script</title></head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">
<center>
<h2>Submit Job</h2>
</center>
The following queue script has been created for you.  You can modify 
it if you wish.  When you are finished, click the "Update Script" button.  You
will then be able to run your job on the selected host 
using the "Submit Job" button on the tool bar.
<center>
<form name=scriptString method=POST action="/GOW/servlet/WebFlow.Servlets.GOWAdminServlet">
<input type="hidden" name="cmd" value="ReturnPage">
<textarea name=scriptString cols=40 rows=20>
<%= scriptString %>
</textarea>
</center>
<center>
<input type=submit name="submit" value="Update Script" >
<input type = "button" name="cancel" value="Cancel" onClick="self.location='/GOW/Generic/Main.jsp';">
</center>
</form>
</body>
</html>





