<%@ page info="View the visualization toolkit and data." %>
<%@ page import="WebFlow.*" %>
<%@ page import="WebFlow.ContextManager.*" %>
<%@ page import="WebFlow.submitJob.*" %>
<%@ page import="java.util.*" %>
<%@ page errorPage="/Generic/Error.jsp" %>

<jsp:useBean id="parseXML" class="extensions.generic.parseXMLBean" scope="session"/>
<jsp:useBean id="storeInfo" class="extensions.generic.jobInfoBean" scope="session"/>
<jsp:useBean id="getfile" class="extensions.generic.GetFileBean" scope="session"/>
<jsp:useBean id="setprops" class="extensions.generic.setPropBean" scope="session"/>
<jsp:useBean id="modserver" class="extensions.generic.moduleServerBean" scope="session"/>

<%
   //String userName=storeInfo.getTableVal("userName");
   String vizcomm = request.getParameter("vizsubmitcomm");
   //ContextManager cm=modserver.getContextManager();
   String archiveType = storeInfo.getTableVal("archiveType");

   ContextManager cm = null;
   if(archiveType.equals("masterProblemname")) {
      cm=modserver.getContextManager();
   } else {
      cm=modserver.getContextManagerForSlave();
   }   

   //cm.selectSession(problemName,sessionName);
   System.out.println("Vizsubmit: Vizcomm: "+vizcomm);

   //submitJob sj=modserver.getSubmitJob();

   String problemName = null;
   String sessionName = null;
   String NumOfOutFiles=cm.getCurrentSessionProperty("NumberOfOutFiles");
   String vtoolkit = null;

   if(vizcomm != null) {
      problemName=storeInfo.getTableVal("problemName");
      sessionName=storeInfo.getTableVal("sessionName");

      setprops.setCM(cm);
      setprops.setXML(parseXML);
      setprops.setRequests(request);

      //String outfile = request.getParameter("vizoutputfile");
      //cm.setCurrentSessionProperty("VizOutFile",outfile);

      //vtoolkit = request.getParameter("appName");
      //cm.setCurrentSessionProperty("VtkCode",vtoolkit);
      vtoolkit = cm.getCurrentSessionProperty("VtkCode");
      setprops.setIOArrayRequests(request,false);

   } else {
      vtoolkit = cm.getCurrentSessionProperty("VtkCode");
   }

%>

<html>
<head>
<SCRIPT LANGUAGE="JavaScript">
function checkForm(form) {

	var flagchecked = 0;

	if (form.DataFileOne.length != null) {
	for(var i = 0; i < form.DataFileOne.length; i++) {
	  if(form.DataFileOne[i].checked) {
		flagchecked = 1
		break		
	  }
	}
	if(flagchecked == 0) { 
		alert("Please choose your radio button")
		return false }
	} else {
	
	  if(!form.DataFileOne.checked) {
		alert("Please choose your radio button")
		return false } } 
	return true
}

</SCRIPT>

<title>Viewing Data</title></head>
<body bgcolor="#f2fae4" background="/GOW/images/bg1x.jpg">
<center>
<h2>Viewing data using <%= vtoolkit %></h2>
</center>
You have created the following data for the visualization.
Please provide the following information needed to generate the script.
<form name=scriptString method=POST action="/GOW/servlet/WebFlow.Servlets.GOWAdminServlet" onSubmit="return checkForm(this)">
<input type="hidden" name=vizsubmitcomm value=<%= vizcomm %>>
<input type="hidden" name="cmd" value="VizScript">

<p><li><b>Data Files:</b><br>
<%
        if(!NumOfOutFiles.equals("0")) {
           int uplimit3=Integer.parseInt(NumOfOutFiles);
           String outputpathList1 = cm.getCurrentSessionProperty("DataFiles");
           StringTokenizer st2 = new StringTokenizer(outputpathList1,"+");

           for(int j=0;j<uplimit3;j++) {
		String data = st2.nextToken();
		int index = data.lastIndexOf("/");
		String data1 = data.substring(index+1);
%>

<input type=radio name=DataFileOne value="<%= data %>" onClick="document.scriptString.collchoice[0].checked = true"> <%= data1 %><br>

<%
           }
        }
	
	if(vizcomm == null) {
%>            
<p><li><b>Output File for the visualization:</b>
<br>
Output File:
<input type=text name=VizOutFile size=25 maxlength=256>
<%      }   
%>

<%
   if(vtoolkit.equals("gnuplot")) {
%>

<p><li><b>Mode:</b>
<input type=radio name=psmode value="portrait" CHECKED > Portrait
<input type=radio name=psmode value="landscape"> Landscape
<input type=radio name=psmode value="eps"> eps

<p><li><b>Gnuplot Title:</b>
<input type="text" name=pstitle value="Set up the title" size=30 maxlength=50>

<p><li><b>Plot Title:</b>
<input type="text" name=psptitle value="Plot name" size=20 maxlength=50>

<p><li><b>X Label:</b>
<input type="text" name=xlabel value="X Label" size=20 maxlength=50>

<p><li><b>Y Label:</b>
<input type="text" name=ylabel value="Y Label" size=20 maxlength=50>

<p><li><b>Line Style:</b>
<input type=radio name=psls value="solid" CHECKED> Solid
<input type=radio name=psls value="dashed"> Dashed

<p><li><b>Data Style:</b>
<SELECT NAME="psds">
	<OPTION SELECTED VALUE="lines"> Lines
	<OPTION VALUE="points"> Points
	<OPTION VALUE="linespoints"> LinesPoints
	<OPTION VALUE="impulses"> Impulses
	<OPTION VALUE="dots"> Dots
	<OPTION VALUE="steps"> Steps
	<OPTION VALUE="fsteps"> Fsteps
	<OPTION VALUE="histeps"> Histeps
	<OPTION VALUE="errorbars"> Errorbars
	<OPTION VALUE="xerrorbars"> Xerrorbars
	<OPTION VALUE="yerrorbars"> Yerrorbars
	<OPTION VALUE="xyerrorbars"> Xyerrorbars
	<OPTION VALUE="boxes"> Boxes
	<OPTION VALUE="boxerrorbars"> Boxerrorbars
	<OPTION VALUE="boxxyerrorbars"> Boxxyerrorbars
	<OPTION VALUE="financebars"> Financebars
	<OPTION VALUE="candlesticks"> candlesticks
</SELECT>

<p><li><b>Point Type:</b>
<SELECT NAME="pspt">
	<OPTION SELECTED VALUE="1"> Pluses
	<OPTION VALUE="2"> Crosses
	<OPTION VALUE="3"> Asterisk
	<OPTION VALUE="4"> Squares
	<OPTION VALUE="5"> Filled Squares
	<OPTION VALUE="6"> Circles
	<OPTION VALUE="7"> Filled Circles
	<OPTION VALUE="8"> Upwards Triangles
	<OPTION VALUE="9"> Upwards Filled Triangles
	<OPTION VALUE="10"> Downwards Triangles
	<OPTION VALUE="11"> Downwards Filled Triangles
	<OPTION VALUE="12"> Diamonds
	<OPTION VALUE="13"> Filled Diamonds
	<OPTION VALUE="14"> House
	<OPTION VALUE="15"> Filled House

</SELECT>

<p><li><b>Color:</b>
<SELECT NAME="pscolor">
	<OPTION SELECTED VALUE="1"> Red
	<OPTION VALUE="2"> Light Green
	<OPTION VALUE="3"> Blue
	<OPTION VALUE="4"> Pink
	<OPTION VALUE="5"> Cyan
	<OPTION VALUE="6"> Yellow
	<OPTION VALUE="7"> Black
	<OPTION VALUE="8"> Magenta
	<OPTION VALUE="9"> Gray
</SELECT>

<p><li><b>Font Name:</b>
<SELECT NAME="psft">
	<OPTION VALUE="Arial"> Arial
	<OPTION VALUE="Arial-Italic"> Arial Italic
	<OPTION VALUE="Arial-Bold"> Arial Bold
	<OPTION VALUE="Arial-Bold-Italic"> Arial Bold Italic
	<OPTION SELECTED VALUE="Times-Roman"> Times Roman
	<OPTION VALUE="Times-Roman-Italic"> Times Roman Italic
	<OPTION VALUE="Times-Roman-Bold"> Times Roman Bold
	<OPTION VALUE="Times-Roman-Bold-Italic"> Times Roman Bold Italic
	<OPTION VALUE="Helvetica"> Helvetica
	<OPTION VALUE="Roman"> Roman
</SELECT>

<p><li><b>Font Size:</b>
<input type="text" name=psfs value="14" size=3 maxlength=3>

<%
   } else {
%>

<p><li><b>Matlab Title:</b>
<input type="text" name=pstitle value="Set up the title" size=30 maxlength=50>

<p><li><b>Plot Title:</b>
<input type="text" name=psptitle value="Plot name" size=20 maxlength=50>

<p><li><b>X Label:</b>
<input type="text" name=xlabel value="X Label" size=20 maxlength=50>

<p><li><b>Y Label:</b>
<input type="text" name=ylabel value="Y Label" size=20 maxlength=50>

<p><li><b>Line Style:</b>
<input type=radio name=psls value="-" CHECKED> Solid line
<input type=radio name=psls value="--"> Dashed line
<input type=radio name=psls value=":"> Dotted line
<input type=radio name=psls value="-."> Dash-dot line
<input type=radio name=psls value="none"> None

<p><li><b>Line Width:</b>
<input type="text" name=pslw value="0.5" size=5 maxlength=5>

<p><li><b>Color:</b>
<SELECT NAME="pscolor">
	<OPTION SELECTED VALUE="r"> Red
	<OPTION VALUE="g"> Green
	<OPTION VALUE="b"> Blue
	<OPTION VALUE="c"> Cyan
	<OPTION VALUE="y"> Yellow
	<OPTION VALUE="m"> Magenta
	<OPTION VALUE="k"> Black
	<OPTION VALUE="w"> White
</SELECT>

<p><li><b>Marker Type(points):</b>
<SELECT NAME="psmt">
	<OPTION SELECTED VALUE="o"> Circle
	<OPTION VALUE="+"> Plus sign
	<OPTION VALUE="*"> Asterisk
	<OPTION VALUE="."> Point
	<OPTION VALUE="x"> Cross
	<OPTION VALUE="s"> Square
	<OPTION VALUE="d"> Diamond
	<OPTION VALUE="^"> Upward pointing triangle
	<OPTION VALUE="v"> Downward pointing triangle
	<OPTION VALUE=">"> Right pointing triangle
	<OPTION VALUE="<"> Left pointing triangle
	<OPTION VALUE="p"> Five-pointed star(pentagram)
	<OPTION VALUE="h"> Six-pointed star(hexagram)
	<OPTION VALUE="none"> None
</SELECT>

<p><li><b>Marker Size:</b>
<input type="text" name=psms value="6" size=3 maxlength=5>

<p><li><b>Marker Edge Color:</b>
<SELECT NAME="psmecolor">
	<OPTION SELECTED VALUE="k"> Black
	<OPTION VALUE="g"> Green
	<OPTION VALUE="b"> Blue
	<OPTION VALUE="c"> Cyan
	<OPTION VALUE="y"> Yellow
	<OPTION VALUE="m"> Magenta
	<OPTION VALUE="r"> Red
	<OPTION VALUE="w"> White
</SELECT>

<p><li><b>Marker Face Color:</b>
<SELECT NAME="psmfcolor">
	<OPTION SELECTED VALUE="r"> Red
	<OPTION VALUE="g"> Green
	<OPTION VALUE="b"> Blue
	<OPTION VALUE="c"> Cyan
	<OPTION VALUE="y"> Yellow
	<OPTION VALUE="m"> Magenta
	<OPTION VALUE="k"> Black
	<OPTION VALUE="w"> White
</SELECT>

<%
   }
%>

<hr WIDTH=100%>
     <input type=radio name="collchoice" value="noncollab" > <b> Non-collaboration </b>
     <input type=radio name="collchoice" value="collab" > <b> Collaboration </b>
<hr WIDTH="100%"> 

<p>
<input type=submit name="open" value="Make Selection">&nbsp;&nbsp;
<input type = "button" name="cancel" value="Cancel" onClick="self.location='/GOW/Generic/Main.jsp';">

</form>
</body>
</html>





