/**
 * Program: SVGWBDraw.java
 * Writes image onto a screen.
 */

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
//import org.apache.batik.dom;

//import org.apache.batik.apps.svgviewer.Application;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.dom.svg.SVGDocumentFactory;
import org.xml.sax.InputSource;
import org.apache.batik.util.awt.svg.SVGGraphics2D;
import org.apache.batik.dom.svg.SVGOMDocument;
import org.w3c.dom.*;
import org.apache.batik.util.SVGConstants;

public class SVGWBDraw extends WhiteBoardComp {    
  protected Main main;
  protected ViewerFrame vf;
  protected SVGOMDocument drawdoc;

  protected int xpart=1, ypart=1;

  public SVGWBDraw (Main main){
    super();
    this.main=main;
    vf=main.getViewerFrame();
  }

  public WhiteBoardComp getShape(){
    return this; 
  }
    
  public void test() {
    System.out.println("SVGWBDraw is available");
  }
    
  /**
   * Loads the text captured from the screen.
   */
  public void loadDataFile(String screenText) {
  }

  public void drawShape(SVGGraphics2D g2d,int i,int j) {
    writeSVG(g2d);
  }
    
  /**
   * Move the SVG document to memory and then fill out the 
   * local SVGOMDocument.
   */
  public void writeSVG(SVGGraphics2D g2d){
    drawdoc=writeSVGDocToMemory(g2d);
    SVGOMDocument drawdoc1=updateBaseDoc(drawdoc,vf.getTheDoc());
    vf.appendFragToDoc(vf.thecanvas,drawdoc1);
  }
    
  /**
   * This method initializes various objects.
   */
  public void init(){
  }

  public int getXPart() { return xpart; }
  public int getYPart() { return ypart; } 

}

