package extensions.generic;

import extensions.generic.*;
import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

public class CoordTxtFilter extends FileFilter {
    
    // Accept all directories and all xml files.
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            extension = s.substring(i+1).toLowerCase();
        }

	    if (extension != null) {
            if (extension.equals("txt")){
                    return true;
            } else {
                return false;
            }
    	}

        return false;
    }
    
    // The description of this filter
    public String getDescription() {
        return "Text Type(*.txt)";
    }
    	
}
