import org.escience.XSIL.*;
import java.io.*;

public class testXSIL extends XSIL {

    static XSIL root;

    public static void main(String args[]) throws IOException {
	if (args.length != 1) {
	    System.err.print("Usage: java extensions.Transform.listParam file.xml\n");
	    System.exit(1);
	}
	root = new XSIL(args[0]);
	//recurse(root);
	printParamList("Ising1");
    }
    
    public static void recurse(XSIL x) {
	for(int ichild=0; ichild < x.getChildCount(); ichild++){

	    System.out.println("ichild = "+ichild);
	    System.out.println("ichildt = "+ichild+"##"+x.getChildCount());
	    XSIL child = x.getChild(ichild);
	    if(child.getType().equals("Application"))
		System.out.println("Name: "+child.getName());
	    if(child instanceof Param ) {
		Param p = (Param)child;
		String pname = p.getName();
		String ptext = p.getText();
		System.out.println("Param num: "+pname+ptext);
	    }
	    if( child instanceof Table ) {
		Table t = (Table)child;
		String tname = t.getName();
		int    tcint  = t.getNColumn();
		int    trint  = t.getNRow();
		System.out.println("Table : "+tname+"##"+tcint+"##"+trint);
	    }
	    recurse(child);
	}
    }

    public static void printParamList ( String name ) {
	for(int ichild=0; ichild < root.getChildCount(); ichild++){
	    XSIL child = root.getChild(ichild);

	    System.out.println("ichild = "+ichild+"##"+root.getChildCount());

	    if(child.getName().equals(name)) {
		System.out.println("Name Param: "+child.getName());
		/*	if ( child instanceof Param ) {
		    String pname = ((Param)child).getName();
		    String ptext = ((Param)child).getText();
		    System.out.println("Param num: "+pname+ptext);
		    }*/

		for(int ichild1=0; ichild1 < child.getChildCount(); ichild1++){

		    System.out.println("ichild1 = "+ichild1);
		    System.out.println("ichildt1 = "+ichild1+"##"+child.getChildCount());
		    XSIL child1 = child.getChild(ichild1);
		    if(child1 instanceof Param ) {
			String pname1 = ((Param)child1).getName();
			String ptext1 = ((Param)child1).getText();
			System.out.println("Param num: "+pname1+ptext1);
		    }

		    if( child1 instanceof Table ) {
			Table t = (Table)child1;
			String tname = t.getName();
			int    tcint  = t.getNColumn();
			int    trint  = t.getNRow();
			System.out.println("Table : "+tname+"##"+tcint+"##"+trint);
			for(int i=0; i< t.getNColumn();i++) {
			    Column c;
			    c = t.getColumn(i);
			    System.out.println("Column: "+c.getName()+"###"+c.getType());
			    for(int j=0; j < t.getNRow(); j++) {
				String cc = c.getPrimArray().getString(j);
				System.out.println("Column: Value"+cc);	      		
			    }
			}
		    }
		}		
		break;
	    }
	}

    }
}





