//package EDU.syr.npac.Gateway;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import org.omg.CORBA.*;
import WebFlow.*;
import WebFlow.QS.*;
import WebFlow.event.*;
import EDU.auburn.VGJ.*;
import java.io.*;
import EDU.syr.npac.frontend.*;


public class mpJobPanel extends JPanel implements ActionListener {
  
  TextArea t1;
  FileBrowser fb;
  SimpleJob sj;
  Ising is;
  JPanel p1,p2,p3,p4,p5,p6;
  JButton b1;
  Choice c1,c2,c3;
  boolean URLtest;
  
  mpgw anApplet;

  String simple="SimpleJob";
  String ising="Ising";
  
  public mpJobPanel(mpgw anApplet,String s) {

    //Set up the display.
    this.anApplet=anApplet;
    this.setLayout(new GridLayout(0,1,10,10));

    p1=new JPanel();
    p2=new JPanel();
    p3=new JPanel();
    p4=new JPanel();
    p5=new JPanel();
    p6=new JPanel();
    
    add(p1);
    p1.setLayout(new GridLayout(0,1));
    p1.add(new JLabel("Available Jobs",JLabel.CENTER));

    c1=new Choice();
    c1.addItem(simple);
    c1.addItem(ising);
    p3.add(c1);

    c2=new Choice();
    c2.addItem("input1");
    c2.addItem("input2");
    c2.addItem("input3");
    p5.add(c2);

    c3=new Choice();
    c3.addItem("output1");
    c3.addItem("output2");
    c3.addItem("output3");
    p6.add(c3);
    
    p1.add(p3);
    p1.add(p5);
    p1.add(p6);

    p3=new JPanel();
    b1=new JButton("Submit");
    b1.addActionListener(this);
    p4.add(b1);
    p1.add(p4);

    add(p2);
    p2.add(new JLabel("Job Status",JLabel.CENTER));
    Panel p3=new Panel();
    t1=new TextArea(5,20);
    t1.setEditable(false);
    t1.setText("No jobs running\n");
    p3.add(t1);
    p2.add(p3);

  }
  
  public void actionPerformed(ActionEvent ev) {
    java.lang.Object source=ev.getSource();
    if(source==b1) {
      System.out.println("Button clicked");
      System.out.println("Selected Item: "+c1.getSelectedItem());
      
      t1.append("Running: "+c1.getSelectedItem()+"\n");
      if(c1.getSelectedItem().equals(simple)) {
	setup();
	sj.run();
      }
      else if(c1.getSelectedItem().equals(ising)) {
	//Run the Ising calculation as a thread so that you can
	//use other features.  
	setup();
	Thread t=new Thread() {
	  public void run() {
	    is.setIOFiles(c2.getSelectedItem(),c3.getSelectedItem());
	    is.run();

	  }
	};
	t.start();
	System.out.println("Thread running");
	//is.run();
      }
    }
  }
  
  public void setup() {
    
    try{
      //String webIOR="http://osprey4:8001/IOR/QS/brat.SimpleJob.txt";
      String webIOR="http://osprey4:8001/IOR/QS/brat."+c1.getSelectedItem()+".txt";
      System.out.println(webIOR);
      java.net.URL url=new java.net.URL(webIOR);

      InputStream istream;
      String ref="";
      URLtest=true;

      //Download contents of the URL to the stream.
      while(URLtest) {
	try{
	  istream=url.openStream();
	  BufferedReader in = new BufferedReader(new InputStreamReader(istream));

	  ref=in.readLine();
	  istream.close();
	  URLtest=false;
	  System.out.println(ref);
	}
	  catch(IOException e) {;}
      }
      
      org.omg.CORBA.Object my_object=anApplet.getORB().string_to_object(ref);
      if(c1.getSelectedItem().equals(simple)) {
	sj=SimpleJobHelper.narrow(my_object);
      }
      else if(c1.getSelectedItem().equals(ising)) {
	is=IsingHelper.narrow(my_object);
      }
      System.out.println("Made it to here again, you lucky devil...");
    }
    catch(Exception e) {
      System.out.println(e);
    }
  }
}

