//package EDU.syr.npac.Gateway; 

import org.omg.CORBA.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*; 
import java.net.*;
import EDU.syr.npac.frontend.*;
import WebFlow.QS.*;

public class mpgw extends JApplet
{
  private int appCount_ = 0;
  private String userContext;
  private CardLayout card = new CardLayout();
  JPanel  cP;
  private String pageurl;
  private URL docURL;
  AppletContext ac;
  private ORB orb;
  
  public void init() {
    
    String UC=getParameter("userContext");
    if(UC == null) {
      System.err.println("user context not defined.");
      stop();
    }
    else {
      userContext = UC;
      System.err.println("user contect = "+userContext);
    }
    
    orb = ORB.init(this, new java.util.Properties());
    
    java.awt.Container c = getContentPane();
    getContentPane().setLayout(new BorderLayout());
    
    JPanel bP = new JPanel();
    bP.setLayout(new GridLayout(2,2));
    JButton b1 = new JButton("Home");
    JButton b2 = new JButton("Navigator");
    JButton b3 = new JButton("Logout");
    JButton b4 = new JButton("About");
    
    bP.add(b1);
    bP.add(b2);
    bP.add(b3);
    bP.add(b4);
    
    JTabbedPane tabbedPane = new JTabbedPane();
    String fileRoot="/npac/home/webflow/QSData";
    mpJobPanel JobStatus = new mpJobPanel(this,"Job Status"); 
    tabbedPane.addTab("Jobs",JobStatus); 
    
    c.add(BorderLayout.NORTH,bP);
    c.add(BorderLayout.CENTER,tabbedPane);
  }
  
  
  void showCard(String what){
    card.show(cP,what);
  }
  
  public ORB getORB() {
    return orb;
  }

  public String getUserContext() {
    return userContext;
  }
  
  public void setUserContext(String UC) {
    userContext=UC;
  }
  
  public void showPage(URL docURL) {
    ac.showDocument(docURL,"GatewayHTML");
  }
  
}
