package EDU.syr.npac.frontend;

import EDU.syr.npac.frontend.FileBrowserUtil.*;
import WebFlow.*;
import WebFlow.QS.*;
import WebFlow.QS.FileBrowserHelper;
import java.util.*;
import WebFlow.event.*;
import EDU.auburn.VGJ.*;
import EDU.auburn.VGJ.gui.*;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.AppletContext;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.event.*;
import javax.swing.tree.*;

import org.omg.CORBA.*;
import EDU.syr.npac.Gateway.*;

public class FileBrowserCtr extends controls{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  Panel p;
  static public String InitialRootDir;
  public String fileSeparator="/";
  int mversion,xmlver;
  //Back-End module reference
  public FileBrowser fileBrowser;
  String[] args;
  ORB orb;
  String user;
  String ref;
  boolean URLready;
  private Thread runner;
  int ntry;
  boolean Gateway,xml;
  public boolean GatewayX;
  gw gwApplet=null;
  int sbh=2;
  private String CurrentFile,CurrentFileName,CurrentDirectory;
  URL docURL;
  private String webIOR; 
  public TaskPanel stp=null;
  private WebFlowContext WFserver=null;

  public FileBrowserCtr (String host, int port, GraphWindow GWindow, int n) {
    super(host,port,GWindow);
    mversion = n+1;
    Gateway=false;
    GatewayX=false;
    xml=false;
    InitialRootDir="/npac/home/webflow/QSData";
    System.out.println("QS");
    System.out.println("-----> MVERSION: "+mversion);
    //fileBrowser = FileBrowserHelper.narrow(FBmodule);
    FBFileTreeModel  root = new FBFileTreeModel(InitialRootDir,this);
    refreshFileBrowser(root ,InitialRootDir);
  }

  public FileBrowserCtr (gw gwApplet, int n, String InitialRootDir) {
    //super(host,port,GWindow);
    this.gwApplet=gwApplet;
    this.InitialRootDir = InitialRootDir;
    mversion = n+1;
    Gateway=true;
    GatewayX=false;
    xml=false;
    System.out.println("GATEWAY");
    System.out.println("-----> MVERSION: "+mversion);
    //fileBrowser = FileBrowserHelper.narrow(FBmodule);
    FBFileTreeModel  root = new FBFileTreeModel(InitialRootDir,this);
    refreshFileBrowser(root ,InitialRootDir);
    System.out.println("Gateway="+Gateway);
  }

  public FileBrowserCtr (gw gwApplet, String InitialRootDir, WebFlowContext s){
    this.gwApplet=gwApplet;
    this.InitialRootDir = InitialRootDir;
    WFserver=s;
    System.out.println("Start File Browser version X");
    mversion=0; //this is obsolete variable
    Gateway=true;
    GatewayX=true;
    xml=false;
    System.out.println(Gateway+" "+GatewayX+" "+xml);



   System.out.println("run GatewayX"); 
   orb=gwApplet.getORB();
   user = gwApplet.getUserName();

   System.out.println("user = "+user);
   /* find the module */
   org.omg.CORBA.Object[] Modules = WFserver.toArray();
   System.out.println("# objects: "+Modules.length); 
   for(int i=0; i<Modules.length; i++) {
      BeanContextChild bbc=BeanContextChildHelper.narrow(Modules[i]);
      String ModuleName = bbc.getObjectID();
      System.out.println(i+" "+ModuleName);
      if(ModuleName.indexOf("FileBrowser")>-1) {
             fileBrowser=FileBrowserHelper.narrow(Modules[i]);
             System.out.println("FileBrowser found");   
      }
   }
   System.out.println("end of loop");


    FBFileTreeModel  root = new FBFileTreeModel(InitialRootDir,this);
    refreshFileBrowser(root ,InitialRootDir);
    System.out.println(Gateway+" "+GatewayX+" "+xml);
    System.out.println("========================");
    System.out.println(" new generation of File Browser");
  }

  public FileBrowserCtr (gw gwApplet, String InitialRootDir, int xmlver,
                         TaskPanel stp) {
    //super(host,port,GWindow);
    this.gwApplet=gwApplet;
    this.InitialRootDir = InitialRootDir;
    this.xmlver = xmlver;
    mversion = 1;
    xml=true;
    Gateway=true;
    GatewayX=false;
    this.stp=stp;
    System.out.println("GATEWAY+XML");
    System.out.println("-----> MVERSION: "+mversion);
    if(stp==null) System.out.println("STP IS NULL!!!!");
    //fileBrowser = FileBrowserHelper.narrow(FBmodule);
    FBFileTreeModel  root = new FBFileTreeModel(InitialRootDir,this);
    refreshFileBrowser(root ,InitialRootDir);
    System.out.println("Gateway="+Gateway);
  }

 public void refreshFileBrowser(FBFileTreeModel  root,String rootName)
  {
    
    //remove all the components inside the Panel
    removeAll();
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setFont(new Font("Helvetica", Font.PLAIN, 14));
    setLayout(gridbag);

    FBselectedFile file_field = new FBselectedFile("",15,"file",this);
    FBDirTree tree = new FBDirTree(root,this);
    JScrollPane scrollPane = new JScrollPane(tree);
    tree.addMouseListener(file_field);
    tree.addTreeExpansionListener(root);
    root.addTreeModelListener(tree);
      
    JLabel label = new JLabel("Enter Path and Folder Name :");

     //Row 0

    addComponent(this,label,0,0,GridBagConstraints.REMAINDER,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);

    final FBselectedFile directory_field=new FBselectedFile(rootName,15,
					       	"directory",this);
    tree.addMouseListener(directory_field);
    directory_field.addActionListener(root);
    

    // Row 1

    addComponent(this,directory_field,0,1,GridBagConstraints.REMAINDER,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);


    // Row 2 
    scrollPane.setSize(150,300);

    addComponent(this,scrollPane,0,2,GridBagConstraints.REMAINDER,
        sbh, GridBagConstraints.BOTH,
        GridBagConstraints.CENTER,1);

    // Row 3

    label = new JLabel("Enter File Name :");

    addComponent(this,label,0,sbh+2,GridBagConstraints.REMAINDER,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);

    // Row 4

    addComponent(this,file_field,0,sbh+3,GridBagConstraints.REMAINDER,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);

    //Erol modifications
    directory_field.addActionListener(file_field);
    tree.addTreeExpansionListener(directory_field);
    tree.addTreeExpansionListener(file_field);
    //Erol

    // Row 5

    JButton button1 = new JButton("OK");
    button1.addActionListener(file_field);


    addComponent(this,button1,0,sbh+4,1,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.WEST,0);

    if(Gateway) {
      JButton button2 = new JButton("View");
      ActionListener blistener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          System.out.println("current file is "+CurrentFile);
          String destFile="/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/tmp/"+CurrentFileName; 
	  fileBrowser.copyFile(CurrentFile,destFile);
          System.out.println("fileCopied to "+destFile);
          AppletContext ac=gwApplet.getAppletContext();
            try {
            String pageurl="http://osprey4.npac.syr.edu:8001/tmp/"+CurrentFileName;
            docURL= new URL(pageurl);
            } catch (MalformedURLException me) {System.out.println(me);}
            ac.showDocument(docURL,"GatewayHTML");  
        }
      };
      button2.addActionListener(blistener);
      addComponent(this,button2,1,sbh+4,1,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.WEST,0);

      if(xml) {
       JButton button3 = new JButton("Done"); 

       ActionListener b3listener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          System.out.println("current file "+CurrentFile);
          if(stp==null) System.out.println("stp is null!");
          stp.setCurrentFile(CurrentFile);
          System.out.println("now show card1"); 
          stp.showCard("card1");
	}
       };    
       button3.addActionListener(b3listener);
       addComponent(this,button3,2,sbh+4,1,1,
        GridBagConstraints.BOTH,GridBagConstraints.CENTER,0);

      } else {

       JButton buttonE = new JButton("Edit");

       ActionListener bElistener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          System.out.println("current file is "+CurrentFile);
          String destFile="/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/tmp/EditFile.edt"; 
	  fileBrowser.copyFile(CurrentFile,destFile);
          System.out.println("fileCopied to "+destFile);
          AppletContext ac=gwApplet.getAppletContext();
            try {
            String pageurl="http://osprey4.npac.syr.edu:8001/tmp/"+CurrentFileName;
            docURL= new URL(pageurl);
            } catch (MalformedURLException me) {System.out.println(me);}
            ac.showDocument(docURL,"GatewayHTML");  
        }
      };
      buttonE.addActionListener(bElistener);
    addComponent(this,buttonE,2,sbh+4,1,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.WEST,0);

       JButton button4 = new JButton("ULoad");

       ActionListener b4listener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          System.out.println("current file is "+CurrentFile);
          Frame dummyFrame = new Frame("dummy frame");
          FileDialog fd = new FileDialog(dummyFrame,"upload file",FileDialog.LOAD);
          fd.setDirectory("C:\\");
          fd.show();
          String source=fd.getDirectory()+fd.getFile();
          System.out.println("source="+source);
          AppletContext ac=gwApplet.getAppletContext();
            try {
            System.out.println("now call servlet");
            String pageurl="http://osprey4.npac.syr.edu:8001/servlets/MoveFile?command=upload&dest="+CurrentFile+"&src="+source+"&UserContext="+user;
            System.out.println(pageurl); 
            docURL= new URL(pageurl);
            } catch (MalformedURLException me) {System.out.println(me);}
            ac.showDocument(docURL,"GatewayHTML");  
        }
      };
      button4.addActionListener(b4listener);
    addComponent(this,button4,0,sbh+5,1,1,
        GridBagConstraints.NONE,GridBagConstraints.CENTER,0);


       JButton button5 = new JButton("DLoad");

       ActionListener b5listener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          System.out.println("current file is "+CurrentFile);
          Frame dummyFrame = new Frame("dummy frame");
          FileDialog fdd = new FileDialog(dummyFrame,"download file",FileDialog.SAVE);
          fdd.setDirectory("C:\\");
          fdd.setFile(CurrentFileName);
          fdd.show();
          String destination=fdd.getDirectory()+fdd.getFile();
          System.out.println("destination="+destination);
          AppletContext ac=gwApplet.getAppletContext();
            try {
            String pageurl="http://osprey4.npac.syr.edu:8001/servlets/MoveFile?command=download&dest="+destination+"&src="+CurrentFile+"&UserContext="+user;
            System.out.println(pageurl); 
            docURL= new URL(pageurl);
            } catch (MalformedURLException me) {System.out.println(me);}
            ac.showDocument(docURL,"GatewayHTML");  
        }
      };
      button5.addActionListener(b5listener);
    addComponent(this,button5,1,sbh+5,1,GridBagConstraints.REMAINDER,
        GridBagConstraints.NONE,GridBagConstraints.CENTER,0);

       JButton buttonD = new JButton("Del");

       ActionListener bDlistener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          System.out.println("current file is "+CurrentFile);
        }
      };
      buttonD.addActionListener(bDlistener);
    addComponent(this,buttonD,2,sbh+5,1,1,
        GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);
      }
    }
  }
    public void addComponent(java.awt.Container container, Component component,
     int gridx, int gridy, int gridwidth, int gridheight, int fill,
     int anchor, int weight) {
      
     LayoutManager lm =container.getLayout();
     GridBagConstraints gbc = new GridBagConstraints();
     gbc.gridx = gridx;
     gbc.gridy = gridy;
     gbc.gridwidth = gridwidth;
     gbc.gridheight = gridheight;
     gbc.fill = fill;
     gbc.anchor = anchor;
     if(weight>0) {
      gbc.weightx=1.0; 
      gbc.weighty=1.0;
     } 
     container.add(component,gbc);
    }

    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
	    //System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
	      //System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
	    //System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");


        System.out.println("configReader:getIORfromURL:"+e);


      }
     
      return masterServerIOR;
     
    }

    public synchronized void waitForURL(){
        System.err.println("waiting... "+mversion);
	try {
           wait(3000);
	} catch(InterruptedException e){
		 System.out.println("Intrrupted exc :"+e);
	}
    }

  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }

    public void run() {
  /* get access to ORB */
  System.out.println("Gateway="+Gateway);
  System.out.println("GatewayX="+GatewayX);
  //args = new String[1];
  //args[0]="http://osprey4.npac.syr.edu:8001/IOR/QSmaster.txt";
  //  System.out.println(args[0]);


  if(GatewayX) {
   System.out.println("GatewayX: do nothing");
  }
  else {
   System.out.println("run regular Gateway"); 
    try {

      if(Gateway) {
       orb = gwApplet.getORB();
       user = gwApplet.getUserName();
      }
      else {
       System.out.println("FileBrowserCtr: get applet...");
       VGJ a = GWindow.applet;
       System.out.println("FileBrowserCtr: get orb...");
       orb = a.getORB();
       user = a.getUserContext();
      }



      webIOR = Config.getHost();
      if(Gateway) {
	if(xml) {
            webIOR = "http://osprey4.npac.syr.edu:8001/IOR/QS/"+user+"XMLFileBrowser"+".txt";
	} else {
            webIOR = "http://osprey4.npac.syr.edu:8001/IOR/QS/"+user+"FileBrowser"+".txt";
	}
      }
      else {
           webIOR = webIOR + "/IOR/QS/"+user+"FileBrowser"+mversion+".txt";
      }
  System.out.println("wait for "+webIOR);
  System.out.println(webIOR);
    // must wait till the file is written...
    // remember to delete it on exit!

    URLready = false;

    java.net.URL url = new java.net.URL(webIOR);
    InputStream istream;

 ntry=0;
 while(!URLready) {
    ntry++;
    try {
      URLConnection urlconn=url.openConnection(); 
      urlconn.setUseCaches(false);
      
      //      istream = url.openStream();
      istream = urlconn.getInputStream();
      BufferedReader in = new BufferedReader(new InputStreamReader(istream));
      ref = in.readLine();
      istream.close();
      URLready = true;
      }
    catch(IOException e) {
	if(ntry<20) {
          waitForURL();
	}
        else {
         System.err.println(e);
         break;
	}
    }
  }
    System.out.println(ref);
    org.omg.CORBA.Object m_obj=orb.string_to_object(ref);


    if(m_obj == null) {
       System.out.println("m_obj is null ??????");


    }
    else {
       System.out.println("m_obj is OK");
    }
   
    System.out.println("narrow fileBrowser"); 
    fileBrowser = WebFlow.QS.FileBrowserHelper.narrow(m_obj);
    if(fileBrowser == null) {
        System.out.println("narrow(m_obj=fileBrowser");}
    else {
        System.out.println("controls: FileBrowser OK");
    }
    }catch(Exception e) {
     System.out.println(e);
    }
  }
  }
   
  public String getCurrentFile(){
       return CurrentFile;
  }

  public void setCurrentFile(String x){
        CurrentFile = x;
        int i = x.lastIndexOf("/");
        if(i<0) i=x.lastIndexOf("\\");
        CurrentFileName = x.substring(i+1);
        CurrentDirectory = x.substring(0,i);
        System.out.println("file name: "+CurrentFileName); 
        System.out.println("dir name : "+CurrentDirectory); 
        System.out.println("file     : "+CurrentFile); 
  }

}

