package GEM;

//WebFlow Project, Leader Tom Haupt
//Farhad Mamedbekov, Summer 99

//Gem Demo Applet , implemented with the swing components
//Requires Swing set.  For Netscape, it is envisage 
// to have the swing on the client machine
//Starts arbitraryly system process as CORBA client
//package WebFlow.Exec; 

import WebFlow.*; 
import WebFlow.Exec.*;
import WebFlow.event.*; 
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.util.*;


import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;

//for Stack class
import java.util.*;

//for SWING set interface
import javax.swing.*;


public class gemdemo extends JApplet 
                         implements ActionListener {

  //cariables that are extracted from the envoking HTML
  //allows changing configuration by changing HTML PARAM only
  protected String Display;
  protected String masterURL;
  protected String cmd_line;
  protected JTextField  editParam;
  protected JButton submitButton = new JButton ("Submit Job");



///////////////////////////////////////////////////////////////  
//                Function Declaration
///////////////////////////////////////////////////////////////

  //draws the user interface
  public void init() { 
    System.out.println("start!");

    /*
      try  {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);
         String[] args = new String[1];
         ORB orb = ORB.init(this, props);

         System.out.println("orb created");
      } 
      catch (Exception e) System.out.println(e);
  */

    setParameters();
    editParam = new JTextField(cmd_line);
    
    getContentPane().setLayout( new BorderLayout()); 
    getContentPane().add(editParam, BorderLayout.NORTH);
    submitButton.addActionListener(this);
    getContentPane().add(submitButton, BorderLayout.SOUTH);
    
  }   //init

  public String sameOrBlank(String s)  {
     if (s==null)
       return "";
     return s;
  }

  public void setParameters()  {
    cmd_line = sameOrBlank(getParameter("cmd_line")); 
    masterURL  = sameOrBlank(getParameter("MasterIorFile"));
  }

  //If the button is pressed envokes the process
  public void actionPerformed(ActionEvent e)  {      
      cmd_line = editParam.getText();
      configReader config ; 
      System.out.println("create orb");

      try  {
        ORB orb = ORB.init(this, new java.util.Properties());
         //  Create ORB
	//         Properties props = System.getProperties();
	//         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        // props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	//  System.setProperties(props);
	 //         String[] args = new String[1];
         //args[0] = new String("");
	//          ORB orb = ORB.init(this, props);

         System.out.println("orb created");
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL);
         String ref = getIORFromURL(masterURL); 
         System.out.println("REF: "+ref);

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         

         System.out.println("attach event"); 
          org.omg.CORBA.Object p1 = ws.addNewModule("Exec"); 
         System.out.println("narrow"); 
          Exec script = ExecHelper.narrow(p1);
   
         System.out.println("Run");
         System.out.println(cmd_line); 
          script.run(cmd_line );

      } 
      catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex);
        System.err.println(ex.getMessage());
        ex.printStackTrace();
        System.exit(1);
      }     
  }    //actionPerformed

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url);
   String masterServerIOR ="";
   String thisLine = null ;

   // Open the URL for reading  
   try{
        URL u = new URL(url); 
        // now turn the URL into a DataInputStream

        try{
          DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ;
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ;
   }
}
