package LMS.backend;

import java.util.*;
import java.lang.*;
import webflow.backend.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;
import webflow.modules.Templates.*;
import webflow.modules.LMS.WFurl;
import webflow.modules.QuantumSimulations.WFFileDescriptor;

public class runWMS extends Template {

  String command;
  String thisSystem="NT";
  //String thisSystem="Unix";

  public MetaModule initialize() {
    
    System.err.println("initialize runWMS");
    MetaModule mm = new MetaModule("mm");
    System.err.println("about to end init runWMS");
    return(mm);
    }



  public synchronized void run() {

    CreateServerSocket();

    System.err.println("runWMS started");

    if(thisSystem.equals("Unix")) {
      command="/usr/people/tom/WMS/wms";
    }
    else if (thisSystem.equals("NT")) {
      command="cmd /C C:\\WMS\\wms";
    } 
    else {
     System.err.println("runWMS: unknown System: "+thisSystem);
    }

    System.err.println("runWMS: "+command);

        try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
        }
        catch (Exception e) {System.out.println("WMS Error: "+e.toString());}

    socket.send("done");

  }
    public void destroy() {

    //inport.destroyPort();
     //outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}


    public void update_value(String s) 
    {
      
      System.err.println("runWMS: I received message s="+s);
    }
}
