package LMS.frontend;

import com.sun.java.swing.*;

import java.awt.Panel;
import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Font;
import java.awt.event.*;
import java.awt.Checkbox;
import java.awt.Button;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import java.util.*;
import java.net.*;
import java.io.*;

//import EDU.syr.npac.frontend.connector; (replaced by a local copy)
//import webflow.appletsocket.*; (replace by a local copy)

import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import webflow.backend.*;


public class BorderPanel extends JPanel implements ItemListener, 
ActionListener     {
 

  lmsFrame frame;
  private SMreply _smreply;
  private SMreply _connect;
  String hostName; 
  String ClientID;
  int portNumber;
  String smURL;
  ClientSocket socket; 

  int port;
  DataOutputStream dos;
  DataInputStream dis;
  boolean connected;
  boolean completed;
  MonitorProgress mP;

private boolean dataDEM, dataLU, dataWE, dataSO;
private int N,S,W,E;
Double dN,dS,dE,dW;
String Ncoord,Scoord,Wcoord,Ecoord;
boolean stopIt;

    public BorderPanel(lmsFrame frame)    {

    this.frame=frame;

 /* initialize backend */

hostName = frame.hostName;
portNumber  = frame.portNumber;
ClientID = frame.ClientID;
smURL = frame.SM_URL;

System.err.println("smURL="+smURL);

      _smreply=requestInit("LMS.backend.getMap",hostName);
      if(_smreply != null) {
           System.err.println("received reply from requestInit"); 
      }
      else {
           System.err.println("SOMETHING WENT WRONG !!!!!!!!!!!!!!");
      }

/* this will be needed to connect modules 
      Vector tmpPortList = _smreply.getPortList();
      int tmpListLenght = tmpPortList.size();
*/

      SMreply runnit=runModules();

      System.err.println("backend started!");    

      /* now make a socket connection */

      new connector(this,hostName);
     

    dataDEM=true;
    dataLU=false;
    dataWE=false;
    dataSO=false;
    Ncoord=null;
    Scoord=null;
    Wcoord=null;
    Ecoord=null;    
    stopIt=true;

    mP = new MonitorProgress(this);
    mP.start();

    setLayout(new BorderLayout());
    //setBorder(BorderFactory.createTitledBorder("my frame"));

    
 // -------------- title panel ------------------NORTH----------------------  

   JPanel TitlePanel = new JPanel();
   
   TitlePanel.setForeground(Color.blue);
   String LMStitle = new String("LMS Data Wizard");
   
   JLabel l1= new   JLabel(LMStitle,  JLabel.CENTER);
   l1.setFont(new Font("Serif",Font.BOLD,14));
   TitlePanel.add(l1); 
   add(TitlePanel,BorderLayout.NORTH);    

// --------------- center panel ---------------- CENTER ---------------------

   JPanel CenterPanel = new JPanel();
   CenterPanel.setLayout(new BorderLayout());
   /* contains checkbox (north) and data (center) panels */

 // ............ checkbox panel ..............CENTER.NORTH ....................
   
   JPanel CBoxBorder = new JPanel();
   CBoxBorder.setBorder(BorderFactory.createTitledBorder("select data type"));

   
   JPanel CBoxPanel = new JPanel();
   CBoxPanel.setLayout(new GridLayout(1,4));
   
   Checkbox DEMcheckbox = new Checkbox("DEM",true);
   Checkbox LUcheckbox = new Checkbox("Land Use",false);
   Checkbox SOcheckbox = new Checkbox("Soils Texture",false);
   Checkbox WEcheckbox = new Checkbox("Weather Data",false);

  
   DEMcheckbox.addItemListener(this);
   LUcheckbox.addItemListener(this);
   SOcheckbox.addItemListener(this);
   WEcheckbox.addItemListener(this);
   CBoxPanel.add(DEMcheckbox);
   CBoxPanel.add(LUcheckbox);
   CBoxPanel.add(SOcheckbox);
   CBoxPanel.add(WEcheckbox);
    
   CBoxBorder.add(CBoxPanel); 
   CenterPanel.add(CBoxBorder,BorderLayout.CENTER);

   //  ............. data panel ............. CENTER.CENTER ..............

   JPanel RegionBorder = new JPanel();
   RegionBorder.setLayout(new BorderLayout());
   RegionBorder.setBorder(BorderFactory.createTitledBorder("select region"));

   JPanel RegionPanel = new JPanel();
   RegionPanel.setLayout(new BorderLayout());  

   /* 
   topmost: RegionBorder  (border)
            RegionPanel    
            CoordPanel    (after all changes seems to be useless to have 
                           both Region and Coord)  
                           contains two panels:  NumberPanel and GraphicPanel
   */

   JPanel CoordPanel = new JPanel();
   CoordPanel.setLayout(new BorderLayout());

   // **************** Number Panel ************* CENTER.CENTER.WEST ************
     JPanel NumberPanel = new JPanel();
     NumberPanel.setLayout(new BorderLayout());

         JPanel Labels1Panel = new JPanel();
         Labels1Panel.setLayout(new GridLayout(2,1));     
 
         JLabel l2 = new   JLabel("Type in bounding box coordinates",   JLabel.CENTER);
         JLabel l3 = new   JLabel("  ");
         Labels1Panel.add(l2);  
         Labels1Panel.add(l3);
     NumberPanel.add(Labels1Panel, BorderLayout.NORTH);

     JPanel DataPanel = new JPanel();

     DataPanel.setLayout(new GridLayout(3,9));
     JLabel emptyLabel1 = new   JLabel(" ");
     JLabel emptyLabel2 = new   JLabel(" ");
     JLabel emptyLabel3 = new   JLabel(" ");
     JLabel emptyLabel4 = new   JLabel(" ");
     JLabel emptyLabel5 = new   JLabel(" ");
     JLabel emptyLabel6 = new   JLabel(" ");
     JLabel emptyLabel7 = new   JLabel(" ");
     JLabel emptyLabel8 = new   JLabel(" ");
     JLabel emptyLabel9 = new   JLabel(" ");
     JLabel emptyLabel10 = new   JLabel(" ");
     JLabel emptyLabel11 = new   JLabel(" ");
     JLabel emptyLabel12 = new   JLabel(" ");
     JLabel emptyLabel13 = new   JLabel(" ");

     JLabel LabelN = new   JLabel("N:",  JLabel.RIGHT);
     JLabel LabelS = new   JLabel("S:",  JLabel.RIGHT);
     JLabel LabelW = new   JLabel("W:",  JLabel.RIGHT);
     JLabel LabelE = new   JLabel("E:",  JLabel.RIGHT);
     JTextField textN = new JTextField(5);
     JTextField textE = new JTextField(5);
     JTextField textS = new JTextField(5);
     JTextField textW = new JTextField(5);

     ActionListener ListenerW = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("WEST "+e.getActionCommand());
        Wcoord=e.getActionCommand();
       }
     }; 
     ActionListener ListenerE = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("EAST "+e.getActionCommand());
        Ecoord=e.getActionCommand();
       }
     }; 
     ActionListener ListenerS = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("SOUTH "+e.getActionCommand());
        Scoord=e.getActionCommand();
       }
     }; 
     ActionListener ListenerN = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("NORTH "+e.getActionCommand());
        Ncoord=e.getActionCommand();
       }
     }; 




     textN.addActionListener(ListenerN);
     textE.addActionListener(ListenerE);
     textS.addActionListener(ListenerS);
     textW.addActionListener(ListenerW);
 
           DataPanel.add(emptyLabel1);
           DataPanel.add(emptyLabel2);
           DataPanel.add(LabelN);
           DataPanel.add(textN);
           DataPanel.add(emptyLabel3);
           DataPanel.add(emptyLabel4);
           DataPanel.add(emptyLabel11);

           DataPanel.add(LabelW);
           DataPanel.add(textW);
           DataPanel.add(emptyLabel5);
           DataPanel.add(emptyLabel6);
           DataPanel.add(LabelE);
           DataPanel.add(textE);
           DataPanel.add(emptyLabel12);


           DataPanel.add(emptyLabel7);
           DataPanel.add(emptyLabel8);
           DataPanel.add(LabelS);
           DataPanel.add(textS);
           DataPanel.add(emptyLabel9);
           DataPanel.add(emptyLabel10);
           DataPanel.add(emptyLabel13);





     NumberPanel.add(DataPanel, BorderLayout.CENTER);   

     CoordPanel.add(NumberPanel,BorderLayout.CENTER);

 // **************** Graphic Panel ************* CENTER.CENTER.EAST ************

     JPanel GraphicPanel = new JPanel();
     GraphicPanel.setLayout(new GridLayout(4,1));

     JLabel ll1 = new   JLabel(" or draw bounding box on a map",   JLabel.CENTER);
     JLabel ll2 = new   JLabel("  ");
     JLabel ll3 = new   JLabel("  ");
     JLabel ll4 = new   JLabel("  ");
     JLabel ll5 = new   JLabel("  ");

     GraphicPanel.add(ll1);  
     GraphicPanel.add(ll2);
     //GraphicPanel.add(ll3);
     Button GraphButton = new Button("show map");
     GraphButton.addActionListener(this);
     GraphicPanel.add(GraphButton);
     GraphicPanel.add(ll4);
     //GraphicPanel.add(ll5);

     CoordPanel.add(GraphicPanel, BorderLayout.EAST);

   RegionPanel.add(CoordPanel, BorderLayout.CENTER);
   RegionBorder.add(RegionPanel);
   CenterPanel.add(RegionBorder,BorderLayout.SOUTH);

   add(CenterPanel,BorderLayout.CENTER);

// ------------ button panel ----------------- SOUTH ---------------------

   JPanel ButtonPanel = new JPanel();
   JButton startButton = new JButton("get data");
   startButton.addActionListener(this);
   ButtonPanel.add(startButton);
   add(ButtonPanel, BorderLayout.SOUTH);

   }


public void actionPerformed(ActionEvent e) { 
    stopIt=false;
    System.err.println("button pressed");
    String action = e.getActionCommand();
    if(action.startsWith("get")) {
      if(dataDEM) System.err.println("DEM");
      if(dataLU) System.err.println("Land Use");
      if(dataSO) System.err.println("Soils Texture");
      if(dataWE) System.err.println("Weather Data");
      if(!(dataDEM || dataLU || dataSO || dataWE)) {
        // Oops no data are requested !?
       JOptionPane pane = new JOptionPane("No data type selected!",JOptionPane.ERROR_MESSAGE); 
       JDialog dialog = pane.createDialog(this,"Error");
       dialog.show();
       stopIt=true;
       } 
      
      if(stopIt) return;

      if(Ncoord != null) System.err.println("N"+Ncoord);
      else System.err.println("N undefined");         
      if(Wcoord != null) System.err.println("W"+Wcoord);
      else System.err.println("W undefined");
      if(Ecoord != null) System.err.println("E"+Ecoord);
      else System.err.println("E undefined");
      if(Scoord != null) System.err.println("S"+Scoord);
      else System.err.println("S undefined");
      if((Ncoord==null) && (Wcoord==null) && (Ecoord==null) && (Scoord==null)) {
      JOptionPane pane1 = new JOptionPane("Bounding box undefined (press enter after entering data)",JOptionPane.ERROR_MESSAGE);
      JDialog dialog1 = pane1.createDialog(this,"Error");
      dialog1.show();
      stopIt=true;
      }
      if(stopIt) return;

      parseCoord(Ncoord,Wcoord,Ecoord,Scoord);
      System.err.println("StopIt? "+stopIt);

      if(stopIt) return;
         System.err.println(N+" "+W+" "+E+" "+S);
      if(N<S) BBoxError1();
      if(E>W) BBoxError2();
      if(stopIt) return;
       System.err.println("So far so good...");
       String message="getMapS"+S+"N"+N+"E"+E+"W"+W;
       System.err.println("message="+message);
       setValue(message);
       System.err.println("message sent");
    /* now it is time to receive messages for the monitor */
       while(!message.equals("END")) {
         message=socket.receive();
         System.err.println("message for monitor received: "+message);
         mP.wct.setMessage(message);
       }
    }
   else if(action.startsWith("show")) {
      new mapFrame(frame,this);
   }
   else {
    System.err.println("DataWizard: Oops unknown action "+action);
    
   } 

}

public void itemStateChanged(ItemEvent e) {
   String action =(String)e.getItem();
   int state = e.getStateChange();
   System.err.println("Checkbox "+action+":"+state);
   boolean newstate=false;
   if(state==1) {newstate=true;} else if(state==2) {newstate=false;}
   else {System.err.println("DataWizard: Ooops! unknown state "+state);}
   
   if(action.equals("DEM")) dataDEM=newstate;
   if(action.equals("Land Use")) dataLU=newstate;
   if(action.equals("Soils Texture")) dataSO=newstate;
   if(action.equals("Weather Data")) dataWE=newstate;
   
 }

 void parseCoord(String Ncoord, String Wcoord, String Ecoord, String Scoord) {
   try{
    dN = new Double(Ncoord);
   }
   catch(NumberFormatException e) {parseError(Ncoord);}
   if(!stopIt) N = dN.intValue();
try{
    dW = new Double(Wcoord);
   }
   catch(NumberFormatException e) {parseError(Wcoord);}
   if(!stopIt) W = dW.intValue();
try{
    dE = new Double(Ecoord);
   }
   catch(NumberFormatException e) {parseError(Ecoord);}
   if(!stopIt) E = dE.intValue();
try{
    dS = new Double(Scoord);
   }
   catch(NumberFormatException e) {parseError(Scoord);}
   if(!stopIt) S = dS.intValue();
 }

void parseError(String coord) {
  stopIt=true;
  JOptionPane pane3 = new JOptionPane("incorrect data: "+coord,JOptionPane.ERROR_MESSAGE); 
  JDialog dialog3 = pane3.createDialog(this,"Error");
  dialog3.show();
}
void BBoxError1() {
  stopIt=true;
  JOptionPane pane4 = new JOptionPane("negative height of BBox",JOptionPane.ERROR_MESSAGE); 
  JDialog dialog4 = pane4.createDialog(this,"Error");
  dialog4.show();
}
void BBoxError2() {
  stopIt=true;
  JOptionPane pane5 = new JOptionPane("negatice width of BBox",JOptionPane.ERROR_MESSAGE); 
  JDialog dialog5 = pane5.createDialog(this,"Error");
  dialog5.show();
}


  // adopted from WebEeditor

  /**
  * <ol>
  *  <li> Open an Url connection to the SessionManager Object
  *  <li> Tell her your ClientId, new_module request and the name of the module.
  *  <li> Wait its response.
  *  <li> If the first word of first line is OK, this means that 
  *       she got the message and everything is ok. Then read the
  *       port number from the second line to read the result of the
  *       operation.
  * </ol>
  *
  */

  SMreply requestFromServer(String request) {

    SMreply reply = null;
    int current_portNumber = -1;

    if(request==null) return null;

    try
    {
      System.err.println("start requestFromServer");
      //Added by Erol for chache problem
      Date dt = new Date ();
      String tmp = Long.toString(dt.getTime());
      request = request+"&time="+tmp;
      System.err.println("request: "+request);
           
      URL myReq = new URL(request);
      
      try
      {
        DataInputStream dis = new DataInputStream( myReq.openStream() );
        
        String status = dis.readLine();
        StringTokenizer STstatus = new StringTokenizer(status);
        
   System.err.println(" I read status :"+status);

        if( STstatus.countTokens() > 0 &&  
            STstatus.nextElement().equals("OK")  )
        {
          String SportNumber = dis.readLine();
          System.err.println(" I read SportNumber:"+SportNumber);
          
          current_portNumber = Integer.parseInt(SportNumber); 

        } else return reply;

      } catch ( IOException e)
        {
           System.err.println("IOException is raised!");
           e.printStackTrace();
           return reply;
        }

    } catch ( MalformedURLException mue)
      {
        System.err.println(" MalformedURLException is raised!");
        mue.printStackTrace();
        return reply;
      } 
 
    /** If port number is invalid exit */
    if( current_portNumber < 1 ) return reply;

    System.err.println("port number seems to be OK");

    Socket Csocket = null;
    DataInputStream  Cdin  = null;
    DataOutputStream Cdout = null;

    try
    {
      Csocket = new Socket(hostName, current_portNumber );

      Cdin = new DataInputStream( Csocket.getInputStream() );

      Cdout = new DataOutputStream( Csocket.getOutputStream() );

    } catch( UnknownHostException e)
      {
         System.err.println("UnknownHostException" + e +" raised!");
         e.printStackTrace(); 
         return reply;
      }
      catch( IOException e)
      {
         System.err.println("IOException (2)" + e + " raised!");
         e.printStackTrace(); 
         return reply;
      }
       
    System.err.println("create empty reply");   
    reply = new SMreply();
    System.err.println("created empty reply");   

    try
    {
      reply.fromStream(Cdin);
      System.err.println("got reply?"); 
      System.err.println("reply? "+reply.getStatus()+" x");

      if(reply.getStatus() == SMreply.ERROR) 
       	System.err.println( reply.getDescription());

    } catch( NullPointerException e)
      {
         System.err.println("NullPointerException vo requestInit" + e);
         e.printStackTrace();
         return null;
      }

    System.err.println("ready to return from requestFromServer");
    return reply;

  }// end of requestFromServer()

  /**
  * Initialize the module
  */
  public SMreply 
  requestInit(String moduleClassName, String moduleHost)
  //  requestInit(ModuleTreeItem m)
  { 
     String myreq = new String(smURL+"?cmd=new_module&ClientID="+
                               ClientID+"&name="+moduleClassName);

     System.err.println("req(InitModule):"+ myreq);

/*
     ntotal++;
     if(ntotal>10) {System.out.println("too many modules!!!!!!!!!!!!!!!");}
     int lastdot = moduleClassName.lastIndexOf(".")+1;
     String mname = moduleClassName.substring(lastdot);
     System.out.println("---> HASH of "+mname);
     Integer r1 = (Integer)FEclasses.ModuleNames.get(mname);
     System.out.println("R1: "+r1+" of "+ntotal);
     
     if(r1 != null) {
         int r2 = r1.intValue();
         am.addNewModule(ntotal,r2,mname,moduleHost);
     }
     else {
        am.addNewModule(ntotal,0,mname,moduleHost);
     }

     System.out.println("End of requestInit ");
 */

     return requestFromServer(myreq); 

  }// end of requestInit()


  /**
  */
  public SMreply
  connect(ID from, ID to, ID fromModule, ID toModule )
  {
    String req = new String(smURL+"?cmd=connect&ClientID="+ClientID);
    req += "&fromStr="+from.getString();
    req += "&fromVal="+from.getInt();
    req += "&toStr="+to.getString();
    req += "&toVal="+to.getInt();
    req += "&mIDfromStr="+fromModule.getString();
    req += "&mIDfromVal="+fromModule.getInt();
    req += "&mIDtoStr="+toModule.getString();
    req += "&mIDtoVal="+toModule.getInt();

    return requestFromServer( req );

  }// end of connect()

  /**
  * Runs all the modules in the current session
  */
  public SMreply
  runModules()
  {
     String req = new String(smURL+"?cmd=run_modules&ClientID="+ClientID);
     System.err.println("runRequest="+req);
     return requestFromServer(req);

  }// end of run()

  /**
  * public version of SMreply destroy that is void (TH)
  */

  public void destroyAll() {
  _smreply = destroy();
  }    

  /**
  * Destroys all the modules in the current session
  */
  public SMreply
  destroy()
  {
    //    am.clean();
    //    ntotal=0;
    

     String req = new String(smURL+"?cmd=destroy_modules&ClientID="+ClientID);

     SMreply rett= requestFromServer(req);

     if( rett == null ) 
         rett = new SMreply(SMreply.ERROR,"Unkown");

     return rett ;

  }// end of destroy()

  public void setValue(String s) {
  System.out.println("setValue: "+s); 
  if(socket != null) {
        socket.send(s);
  }
  else {
        System.err.println("setValue failed!!!! - no socket available");
  }
  } 

  public void ConnectIt(String host, String msg) {
       System.out.println("ConnectIt to "+host);
       // first ask PortServer for the Port
       // you may wait for it till the module registers it

       int ntry=0;
       port = 0;
       while(port==0 & ntry<25) { 

       ntry++;
       // send request GET
       System.out.println("send request GET ("+ntry+")");

    try {
      Socket PSsocket = new Socket(host,5500);
      dos= new DataOutputStream(PSsocket.getOutputStream());
      dis= new DataInputStream(PSsocket.getInputStream());
      } catch(IOException e) {System.out.println(e.toString());}
    
      // String msg = "GET";  now it is an input argument
        int sl = msg.length();
        byte[] buf =new byte[sl];
        msg.getBytes(0,sl,buf,0); 
        System.out.println("Trying to send... "+msg);

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.out.println(e+" while sending GET");}

	  // get replay

        String replay = "";
        try{
           int ls=dis.readInt();
           byte buf1[] = new byte[ls];
           dis.read(buf1,0,ls);
           replay = new String(buf1,0,ls);
           System.out.println("I have received from PortServer: "+replay);
        } catch(IOException e){
          System.out.println(e+" while getting replay");
	  if(socket!=null) {socket.stop();}       //  stop();
        }
        Integer iport = new Integer(replay);
        port = iport.intValue();
      } // end of while look
 

       if(port != 0) {
         System.out.println("Try to connect to port :"+port+" at "+hostName);
         socket = new ClientSocket(this,hostName,port);
         connected=true;
       }
       else {
         System.out.println("Connection failed!");
       }
  } 



}

class connector implements Runnable {

  String localhost;
  String host;
  String remotehost;  

  private Thread runner;
  BorderPanel c;

  connector(BorderPanel c, String host){
  this.c=c;
  this.host = host;
  remotehost = null;
  start();
  }

  connector(BorderPanel c, String host, String remotehost){
  this.c=c;
  this.host = host;
  this.remotehost = remotehost;
  System.err.println("connector: connect to a remote host");
  start();
  }

  public void run(){ 
    if(remotehost != null) {
      c.ConnectIt(remotehost,"RGT"+host);  //Remote GeT
    }
    else {
      c.ConnectIt(host,"GET");
    }

    /* must be moved to run method because it won't work for remote modules
       since GET returns before PUT is issued
      try {
        InetAddress local = java.net.InetAddress.getLocalHost();
        localhost = local.getHostName();
        System.out.println("HOST: "+localhost);
       } catch(UnknownHostException e) {System.out.println(e);}
         catch(IOException e) {System.out.println(e);}
 
     c.setValue("DISP"+localhost);
     */
  }

  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }


}

