package LMS.frontend;

import com.sun.java.swing.*;

import java.awt.Panel;
import java.awt.Color;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Font;
import java.awt.event.*;
import java.awt.Checkbox;
import java.awt.Button;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;
import java.util.*;
import java.net.*;
import java.io.*;

//import EDU.syr.npac.frontend.connector; (replaced by a local copy)
//import webflow.appletsocket.*; (replace by a local copy)

import com.sun.java.swing.event.*;
import com.sun.java.swing.border.*;

import webflow.backend.*;


public class BorderPanelTest extends JPanel implements ItemListener, 
ActionListener     {
 

  lmsFrame frame;
  private SMreply _smreply;
  private SMreply _connect;
  String hostName; 
  String ClientID;
  int portNumber;
  String smURL;
  ClientSocket socket; 

  int port;
  DataOutputStream dos;
  DataInputStream dis;
  boolean connected;
  boolean completed;
  MonitorProgress mP;

private boolean dataDEM, dataLU, dataWE, dataSO;
private int N,S,W,E;
Double dN,dS,dE,dW;
String Ncoord,Scoord,Wcoord,Ecoord;
boolean stopIt;

    public BorderPanelTest(lmsFrame frame)    {

    this.frame=frame;


    dataDEM=true;
    dataLU=false;
    dataWE=false;
    dataSO=false;
    Ncoord=null;
    Scoord=null;
    Wcoord=null;
    Ecoord=null;    
    stopIt=true;

    setLayout(new BorderLayout());
    //setBorder(BorderFactory.createTitledBorder("my frame"));

    
 // -------------- title panel ------------------NORTH----------------------  

   JPanel TitlePanel = new JPanel();
   
   TitlePanel.setForeground(Color.blue);
   String LMStitle = new String("LMS Data Wizard");
   
   JLabel l1= new   JLabel(LMStitle,  JLabel.CENTER);
   l1.setFont(new Font("Serif",Font.BOLD,14));
   TitlePanel.add(l1); 
   add(TitlePanel,BorderLayout.NORTH);    

// --------------- center panel ---------------- CENTER ---------------------

   JPanel CenterPanel = new JPanel();
   CenterPanel.setLayout(new BorderLayout());
   /* contains checkbox (north) and data (center) panels */

 // ............ checkbox panel ..............CENTER.NORTH ....................
   
   JPanel CBoxBorder = new JPanel();
   CBoxBorder.setBorder(BorderFactory.createTitledBorder("select data type"));

   
   JPanel CBoxPanel = new JPanel();
   CBoxPanel.setLayout(new GridLayout(1,4));
   
   Checkbox DEMcheckbox = new Checkbox("DEM",true);
   Checkbox LUcheckbox = new Checkbox("Land Use",false);
   Checkbox SOcheckbox = new Checkbox("Soils Texture",false);
   Checkbox WEcheckbox = new Checkbox("Weather Data",false);

  
   DEMcheckbox.addItemListener(this);
   LUcheckbox.addItemListener(this);
   SOcheckbox.addItemListener(this);
   WEcheckbox.addItemListener(this);
   CBoxPanel.add(DEMcheckbox);
   CBoxPanel.add(LUcheckbox);
   CBoxPanel.add(SOcheckbox);
   CBoxPanel.add(WEcheckbox);
    
   CBoxBorder.add(CBoxPanel); 
   CenterPanel.add(CBoxBorder,BorderLayout.CENTER);

   //  ............. data panel ............. CENTER.CENTER ..............

   JPanel RegionBorder = new JPanel();
   RegionBorder.setLayout(new BorderLayout());
   RegionBorder.setBorder(BorderFactory.createTitledBorder("select region"));

   JPanel RegionPanel = new JPanel();
   RegionPanel.setLayout(new BorderLayout());  

   /* 
   topmost: RegionBorder  (border)
            RegionPanel    
            CoordPanel    (after all changes seems to be useless to have 
                           both Region and Coord)  
                           contains two panels:  NumberPanel and GraphicPanel
   */

   JPanel CoordPanel = new JPanel();
   CoordPanel.setLayout(new BorderLayout());

   // **************** Number Panel ************* CENTER.CENTER.WEST ************
     JPanel NumberPanel = new JPanel();
     NumberPanel.setLayout(new BorderLayout());

         JPanel Labels1Panel = new JPanel();
         Labels1Panel.setLayout(new GridLayout(2,1));     
 
         JLabel l2 = new   JLabel("Type in bounding box coordinates",   JLabel.CENTER);
         JLabel l3 = new   JLabel("  ");
         Labels1Panel.add(l2);  
         Labels1Panel.add(l3);
     NumberPanel.add(Labels1Panel, BorderLayout.NORTH);

     JPanel DataPanel = new JPanel();

     DataPanel.setLayout(new GridLayout(3,9));
     JLabel emptyLabel1 = new   JLabel(" ");
     JLabel emptyLabel2 = new   JLabel(" ");
     JLabel emptyLabel3 = new   JLabel(" ");
     JLabel emptyLabel4 = new   JLabel(" ");
     JLabel emptyLabel5 = new   JLabel(" ");
     JLabel emptyLabel6 = new   JLabel(" ");
     JLabel emptyLabel7 = new   JLabel(" ");
     JLabel emptyLabel8 = new   JLabel(" ");
     JLabel emptyLabel9 = new   JLabel(" ");
     JLabel emptyLabel10 = new   JLabel(" ");
     JLabel emptyLabel11 = new   JLabel(" ");
     JLabel emptyLabel12 = new   JLabel(" ");
     JLabel emptyLabel13 = new   JLabel(" ");

     JLabel LabelN = new   JLabel("N:",  JLabel.RIGHT);
     JLabel LabelS = new   JLabel("S:",  JLabel.RIGHT);
     JLabel LabelW = new   JLabel("W:",  JLabel.RIGHT);
     JLabel LabelE = new   JLabel("E:",  JLabel.RIGHT);
     JTextField textN = new JTextField(5);
     JTextField textE = new JTextField(5);
     JTextField textS = new JTextField(5);
     JTextField textW = new JTextField(5);

     ActionListener ListenerW = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("WEST "+e.getActionCommand());
        Wcoord=e.getActionCommand();
       }
     }; 
     ActionListener ListenerE = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("EAST "+e.getActionCommand());
        Ecoord=e.getActionCommand();
       }
     }; 
     ActionListener ListenerS = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("SOUTH "+e.getActionCommand());
        Scoord=e.getActionCommand();
       }
     }; 
     ActionListener ListenerN = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
        System.err.println("NORTH "+e.getActionCommand());
        Ncoord=e.getActionCommand();
       }
     }; 




     textN.addActionListener(ListenerN);
     textE.addActionListener(ListenerE);
     textS.addActionListener(ListenerS);
     textW.addActionListener(ListenerW);
 
           DataPanel.add(emptyLabel1);
           DataPanel.add(emptyLabel2);
           DataPanel.add(LabelN);
           DataPanel.add(textN);
           DataPanel.add(emptyLabel3);
           DataPanel.add(emptyLabel4);
           DataPanel.add(emptyLabel11);

           DataPanel.add(LabelW);
           DataPanel.add(textW);
           DataPanel.add(emptyLabel5);
           DataPanel.add(emptyLabel6);
           DataPanel.add(LabelE);
           DataPanel.add(textE);
           DataPanel.add(emptyLabel12);


           DataPanel.add(emptyLabel7);
           DataPanel.add(emptyLabel8);
           DataPanel.add(LabelS);
           DataPanel.add(textS);
           DataPanel.add(emptyLabel9);
           DataPanel.add(emptyLabel10);
           DataPanel.add(emptyLabel13);





     NumberPanel.add(DataPanel, BorderLayout.CENTER);   

     CoordPanel.add(NumberPanel,BorderLayout.CENTER);

 // **************** Graphic Panel ************* CENTER.CENTER.EAST ************

     JPanel GraphicPanel = new JPanel();
     GraphicPanel.setLayout(new GridLayout(4,1));

     JLabel ll1 = new   JLabel(" or draw bounding box on a map",   JLabel.CENTER);
     JLabel ll2 = new   JLabel("  ");
     JLabel ll3 = new   JLabel("  ");
     JLabel ll4 = new   JLabel("  ");
     JLabel ll5 = new   JLabel("  ");

     GraphicPanel.add(ll1);  
     GraphicPanel.add(ll2);
     //GraphicPanel.add(ll3);
     Button GraphButton = new Button("show map");
     GraphButton.addActionListener(this);
     GraphicPanel.add(GraphButton);
     GraphicPanel.add(ll4);
     //GraphicPanel.add(ll5);

     CoordPanel.add(GraphicPanel, BorderLayout.EAST);

   RegionPanel.add(CoordPanel, BorderLayout.CENTER);
   RegionBorder.add(RegionPanel);
   CenterPanel.add(RegionBorder,BorderLayout.SOUTH);

   add(CenterPanel,BorderLayout.CENTER);

// ------------ button panel ----------------- SOUTH ---------------------

   JPanel ButtonPanel = new JPanel();
   JButton startButton = new JButton("get data");
   startButton.addActionListener(this);
   ButtonPanel.add(startButton);
   add(ButtonPanel, BorderLayout.SOUTH);

   }


public void actionPerformed(ActionEvent e) { 
    stopIt=false;
    System.err.println("button pressed");
    String action = e.getActionCommand();
    if(action.startsWith("get")) {
      if(dataDEM) System.err.println("DEM");
      if(dataLU) System.err.println("Land Use");
      if(dataSO) System.err.println("Soils Texture");
      if(dataWE) System.err.println("Weather Data");
      if(!(dataDEM || dataLU || dataSO || dataWE)) {
        // Oops no data are requested !?
       JOptionPane pane = new JOptionPane("No data type selected!",JOptionPane.ERROR_MESSAGE); 
       JDialog dialog = pane.createDialog(this,"Error");
       dialog.show();
       stopIt=true;
       } 
      
      if(stopIt) return;

      if(Ncoord != null) System.err.println("N"+Ncoord);
      else System.err.println("N undefined");         
      if(Wcoord != null) System.err.println("W"+Wcoord);
      else System.err.println("W undefined");
      if(Ecoord != null) System.err.println("E"+Ecoord);
      else System.err.println("E undefined");
      if(Scoord != null) System.err.println("S"+Scoord);
      else System.err.println("S undefined");
      if((Ncoord==null) && (Wcoord==null) && (Ecoord==null) && (Scoord==null)) {
      JOptionPane pane1 = new JOptionPane("Bounding box undefined (press enter after entering data)",JOptionPane.ERROR_MESSAGE);
      JDialog dialog1 = pane1.createDialog(this,"Error");
      dialog1.show();
      stopIt=true;
      }
      if(stopIt) return;

      parseCoord(Ncoord,Wcoord,Ecoord,Scoord);
      System.err.println("StopIt? "+stopIt);

      if(stopIt) return;
         System.err.println(N+" "+W+" "+E+" "+S);
      if(N<S) BBoxError1();
      if(E>W) BBoxError2();
      if(stopIt) return;
       System.err.println("So far so good...");
       String message="getMapS"+S+"N"+N+"E"+E+"W"+W;
       System.err.println("message="+message);
    //   setValue(message);
       System.err.println("message sent");
    /* now it is time to receive messages for the monitor */
    /*   while(!message.equals("END")) {
         message=socket.receive();
         mP.wct.setMessage(message);
       }  */
    }
   else if(action.startsWith("show")) {
      new layeredMapFrame(frame,this);
   }
   else {
    System.err.println("DataWizard: Oops unknown action "+action);
    
   } 

}

public void itemStateChanged(ItemEvent e) {
   String action =(String)e.getItem();
   int state = e.getStateChange();
   System.err.println("Checkbox "+action+":"+state);
   boolean newstate=false;
   if(state==1) {newstate=true;} else if(state==2) {newstate=false;}
   else {System.err.println("DataWizard: Ooops! unknown state "+state);}
   
   if(action.equals("DEM")) dataDEM=newstate;
   if(action.equals("Land Use")) dataLU=newstate;
   if(action.equals("Soils Texture")) dataSO=newstate;
   if(action.equals("Weather Data")) dataWE=newstate;
   
 }

 void parseCoord(String Ncoord, String Wcoord, String Ecoord, String Scoord) {
   try{
    dN = new Double(Ncoord);
   }
   catch(NumberFormatException e) {parseError(Ncoord);}
   if(!stopIt) N = dN.intValue();
try{
    dW = new Double(Wcoord);
   }
   catch(NumberFormatException e) {parseError(Wcoord);}
   if(!stopIt) W = dW.intValue();
try{
    dE = new Double(Ecoord);
   }
   catch(NumberFormatException e) {parseError(Ecoord);}
   if(!stopIt) E = dE.intValue();
try{
    dS = new Double(Scoord);
   }
   catch(NumberFormatException e) {parseError(Scoord);}
   if(!stopIt) S = dS.intValue();
 }

void parseError(String coord) {
  stopIt=true;
  JOptionPane pane3 = new JOptionPane("incorrect data: "+coord,JOptionPane.ERROR_MESSAGE); 
  JDialog dialog3 = pane3.createDialog(this,"Error");
  dialog3.show();
}
void BBoxError1() {
  stopIt=true;
  JOptionPane pane4 = new JOptionPane("negative height of BBox",JOptionPane.ERROR_MESSAGE); 
  JDialog dialog4 = pane4.createDialog(this,"Error");
  dialog4.show();
}
void BBoxError2() {
  stopIt=true;
  JOptionPane pane5 = new JOptionPane("negatice width of BBox",JOptionPane.ERROR_MESSAGE); 
  JDialog dialog5 = pane5.createDialog(this,"Error");
  dialog5.show();
}



}

