package LMS.frontend;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import com.sun.java.swing.*;

public class layeredMapPanel extends JPanel
{

 BorderPanelTest parent_controls;
 MediaTracker tracker;
 String mapServer;
 lmsFrame frame;
 URL mapURL;
 Image usgsMap; 
 JApplet app;
 int mapID;
 layeredMapFrame lF; 

 public layeredMapPanel(lmsFrame frame, BorderPanelTest controls, layeredMapFrame lF)
 {
 this.frame=frame;
 app=frame.app;
 parent_controls = controls;
 this.lF = lF; 
 
 mapServer=frame.ServerURL;
 tracker = new MediaTracker(this); 
 mapID=0;
 newMap("us.jpg");
}

public void newMap(String mapName) {
 try{
    mapURL=new URL(mapServer+"/maps/"+mapName); 
    }
  catch (MalformedURLException e) {System.err.println(e);};

   System.err.println("get map: "+mapURL.toString());
   usgsMap=app.getImage(mapURL);
   if(usgsMap != null) {
     System.err.println("map found");}
   else {
     System.err.println("map not found!!!! ");}
   tracker.addImage(usgsMap,mapID);
   try {tracker.waitForID(mapID);} catch (InterruptedException e){;}; 
   System.err.println("map loaded");
   repaint();
   mapID++;
   
}

  public void paint(Graphics g) {
   g.drawImage(usgsMap,0,0,this);
  
  }


  public void stop(){
    Graphics g=this.getGraphics();
    g.dispose();
    }

}







