package webflow.backend;

import java.util.*;
//import uci.graphedit.*;

/** This class is an abstraction of module as a member of the ModuleList */

public class ModuleListItem extends Object{

  protected String moduleName;
  protected String server;
  protected String moduleDescClass;
  
  /** Creates new ModuleListItem with given name, server and description
  *   of a module.
  */
  public ModuleListItem( String n, String s, String desc, String hostName ){
    
    moduleName = new String(n);

System.err.println("MLI: moduleName:" + moduleName);
System.err.println("HostName: " + hostName);
System.err.println("SSSSSSS  " + s);

    if (s.startsWith("localhost")) {
           int indexNum = s.indexOf(":");
       String port = s.substring(indexNum);
           String s1 = hostName + port;
           server = new String(s1);
    }
    else server = new String(s);

System.err.println("S_host: server" + server);

    moduleDescClass = new String( desc );

  }
  /** returns the name of the module. */
  public String getName(){ return moduleName; };

  /** returns the server on which the module is residing*/
  public String getServer(){ return server; }

  /** returns the class that represents the module.*/
  public String getModuleDescClass(){ return moduleDescClass; };

}/* End of class ModuleListItem */
