import java.io.*;
import java.awt.*;
import java.awt.image.*;
import com.sun.image.codec.jpeg.*;


public class JPEGTest {

    public static void main(String args[]) {
        /* $@IA2hBP>]$r:n$k(B */
        System.err.println("Preparing BufferedImage");
        BufferedImage img = new BufferedImage(100, 100,
                BufferedImage.TYPE_INT_RGB);
        Graphics2D g = img.createGraphics();

        /* $@IA2h$9$k(B */
        System.err.println("Drawing");
        g.setColor(Color.white);
        g.fillRect(0, 0, 100, 100);
        g.setColor(Color.gray);
        for (int i = 0; i < 50; i += 2) {
            g.drawLine(i, i, i, 100 - i);
            g.drawLine(i, 100 - i, 100 - i, 100 - i);
            g.drawLine(100 - i, 100 - i, 100 - i, i);
            g.drawLine(100 - i, i, i, i);
        }
        g.setFont(new Font("Serif", Font.PLAIN, 30));
        g.setColor(Color.red);
        g.drawString("JPEG", 15, 35);
        g.setFont(new Font("Serif", Font.PLAIN, 20));
        g.setColor(Color.black);
        g.drawString("Test", 12, 62);
        g.setColor(Color.green);
        g.drawString("Test1", 10, 60);
        g.setFont(new Font("SansSerif", Font.PLAIN, 18));
        g.setColor(Color.blue);
        g.drawString("Test2", 5, 85);

        /* $@%U%!%$%k$K=q$/(B */
        System.err.println("Writing to file");
        try {
            FileOutputStream out = new FileOutputStream("foo.jpg");
            JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(out);
            encoder.encode(img);
            out.close();
        }
        catch (Exception e) {
            e.printStackTrace();
        }

        System.err.println("Finished");
    }
}

