package EDU.syr.npac.frontend;


import java.awt.*;
import java.awt.event.*;
import EDU.auburn.VGJ.*;
import EDU.auburn.VGJ.gui.GraphWindow;
import org.omg.CORBA.*;
import WebFlow.*;
import WebFlow.QS.*;
import WebFlow.event.*;
import java.net.*;
import java.io.*;

public class SimpleJobCtr extends controls {
  String what;
  Editor edt;
  boolean URLready;
  private Thread runner;
  int mversion;
  String IPaddress;
  int ntry;

  public SimpleJobCtr(String host, int port, GraphWindow GWindow, int n) {
  super(host,port,GWindow);
  mversion = n+1;
  System.err.println("start SimpleJobCtr");
  System.out.println("HOST="+host+" PORT="+port);  

  setLayout(new BorderLayout());
  setBackground(Color.white);
  Label l1 = new Label("Simple Job",Label.CENTER);
  l1.setFont(new Font("SansSerif",Font.BOLD,14));
  add(BorderLayout.NORTH,l1);

  Panel ed = new Panel();
  ed.setLayout(new GridLayout(4,1));
  ed.add(new Label(" "));
  ed.add(new Label("This module",Label.CENTER));
  ed.add(new Label("copies",Label.CENTER));
  ed.add(new Label("input to output",Label.CENTER));
  add(BorderLayout.CENTER,ed);

  }
  
  public synchronized void waitForURL(){
        System.err.println("SimpleJobCtr: waiting... "+mversion);
	try {
           wait(2000);
	} catch(InterruptedException e){
		 System.out.println("Intrrupted exc :"+e);
	}
    }

/*  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }*/

    public void run() {
  /* get access to ORB */
    try {
      String webIOR = Config.getHost() + "/IOR/QS/" + Config.getUserName() + "SimpleJob"+mversion+".txt";
      System.out.println("SimpleJobCtr is waiting for " + webIOR);
    // must wait till the file is written...
    // remember to delete it on exit!
      URLready = false;
      java.net.URL url = new java.net.URL(webIOR);
      InputStream istream;
      String ref = "";
  
      ntry=0;
        while(!URLready) {
          ntry++; 
          try {
            istream = url.openStream();
        		BufferedReader in = new BufferedReader(new InputStreamReader(istream));
        	 	ref = in.readLine();
        		istream.close();
            URLready = true;
            }
          catch(IOException e) {
            if(ntry<20) {
              waitForURL();
            }
            else {
              break;
	    }
	  }
        }
          
        org.omg.CORBA.Object m_obj=Config.getORB().string_to_object(ref);
        if(m_obj == null) {
          System.out.println("SimpleJobCtr: m_obj is null ??????");
        }
        else {
          System.out.println("SimpleJobCtr: m_obj is OK");
        }
         
        edt = EditorHelper.narrow(m_obj);
        if(edt == null) throw new RuntimeException();
        System.out.println("SimpleJobCtr: Editor OK");
    }catch(Exception e) {
     System.out.println(e);
    }
   
    }
}




