// java wrapper for vtkColorTransferFunction object
//

package vtk;
import vtk.*;

public class vtkColorTransferFunction extends vtkScalarsToColors
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void DeepCopy_2(vtkColorTransferFunction id0);
  public void DeepCopy(vtkColorTransferFunction id0)
    { DeepCopy_2(id0); }

  private native int GetSize_3();
  public int GetSize()
    { return GetSize_3(); }

  private native void AddRGBPoint_4(double id0,double id1,double id2,double id3);
  public void AddRGBPoint(double id0,double id1,double id2,double id3)
    { AddRGBPoint_4(id0,id1,id2,id3); }

  private native void AddHSVPoint_5(double id0,double id1,double id2,double id3);
  public void AddHSVPoint(double id0,double id1,double id2,double id3)
    { AddHSVPoint_5(id0,id1,id2,id3); }

  private native void AddRGBSegment_6(double id0,double id1,double id2,double id3,double id4,double id5,double id6,double id7);
  public void AddRGBSegment(double id0,double id1,double id2,double id3,double id4,double id5,double id6,double id7)
    { AddRGBSegment_6(id0,id1,id2,id3,id4,id5,id6,id7); }

  private native void AddHSVSegment_7(double id0,double id1,double id2,double id3,double id4,double id5,double id6,double id7);
  public void AddHSVSegment(double id0,double id1,double id2,double id3,double id4,double id5,double id6,double id7)
    { AddHSVSegment_7(id0,id1,id2,id3,id4,id5,id6,id7); }

  private native void RemovePoint_8(double id0);
  public void RemovePoint(double id0)
    { RemovePoint_8(id0); }

  private native void RemoveAllPoints_9();
  public void RemoveAllPoints()
    { RemoveAllPoints_9(); }

  private native double[] GetColor_10(double id0);
  public double[] GetColor(double id0)
    { return GetColor_10(id0); }

  private native double GetRedValue_11(double id0);
  public double GetRedValue(double id0)
    { return GetRedValue_11(id0); }

  private native double GetGreenValue_12(double id0);
  public double GetGreenValue(double id0)
    { return GetGreenValue_12(id0); }

  private native double GetBlueValue_13(double id0);
  public double GetBlueValue(double id0)
    { return GetBlueValue_13(id0); }

  private native double[] GetRange_14();
  public double[] GetRange()
    { return GetRange_14(); }

  private native void SetClamping_15(int id0);
  public void SetClamping(int id0)
    { SetClamping_15(id0); }

  private native int GetClamping_16();
  public int GetClamping()
    { return GetClamping_16(); }

  private native void ClampingOn_17();
  public void ClampingOn()
    { ClampingOn_17(); }

  private native void ClampingOff_18();
  public void ClampingOff()
    { ClampingOff_18(); }

  private native void SetColorSpace_19(int id0);
  public void SetColorSpace(int id0)
    { SetColorSpace_19(id0); }

  private native void SetColorSpaceToRGB_20();
  public void SetColorSpaceToRGB()
    { SetColorSpaceToRGB_20(); }

  private native void SetColorSpaceToHSV_21();
  public void SetColorSpaceToHSV()
    { SetColorSpaceToHSV_21(); }

  private native int GetColorSpace_22();
  public int GetColorSpace()
    { return GetColorSpace_22(); }

  private native double[] GetValue_23(double id0);
  public double[] GetValue(double id0)
    { return GetValue_23(id0); }

  private native int GetTotalSize_24();
  public int GetTotalSize()
    { return GetTotalSize_24(); }

  private native int GetRedSize_25();
  public int GetRedSize()
    { return GetRedSize_25(); }

  private native int GetGreenSize_26();
  public int GetGreenSize()
    { return GetGreenSize_26(); }

  private native int GetBlueSize_27();
  public int GetBlueSize()
    { return GetBlueSize_27(); }

  private native void AddRedPoint_28(double id0,double id1);
  public void AddRedPoint(double id0,double id1)
    { AddRedPoint_28(id0,id1); }

  private native void AddGreenPoint_29(double id0,double id1);
  public void AddGreenPoint(double id0,double id1)
    { AddGreenPoint_29(id0,id1); }

  private native void AddBluePoint_30(double id0,double id1);
  public void AddBluePoint(double id0,double id1)
    { AddBluePoint_30(id0,id1); }

  private native void RemoveRedPoint_31(double id0);
  public void RemoveRedPoint(double id0)
    { RemoveRedPoint_31(id0); }

  private native void RemoveGreenPoint_32(double id0);
  public void RemoveGreenPoint(double id0)
    { RemoveGreenPoint_32(id0); }

  private native void RemoveBluePoint_33(double id0);
  public void RemoveBluePoint(double id0)
    { RemoveBluePoint_33(id0); }

  private native void RemoveRGBPoint_34(double id0);
  public void RemoveRGBPoint(double id0)
    { RemoveRGBPoint_34(id0); }

  private native void AddRedSegment_35(double id0,double id1,double id2,double id3);
  public void AddRedSegment(double id0,double id1,double id2,double id3)
    { AddRedSegment_35(id0,id1,id2,id3); }

  private native void AddGreenSegment_36(double id0,double id1,double id2,double id3);
  public void AddGreenSegment(double id0,double id1,double id2,double id3)
    { AddGreenSegment_36(id0,id1,id2,id3); }

  private native void AddBlueSegment_37(double id0,double id1,double id2,double id3);
  public void AddBlueSegment(double id0,double id1,double id2,double id3)
    { AddBlueSegment_37(id0,id1,id2,id3); }

  private native void SetRange_38(double id0,double id1);
  public void SetRange(double id0,double id1)
    { SetRange_38(id0,id1); }

  private native vtkPiecewiseFunction GetRedFunction_39();
  public vtkPiecewiseFunction GetRedFunction()
    { return GetRedFunction_39(); }

  private native vtkPiecewiseFunction GetGreenFunction_40();
  public vtkPiecewiseFunction GetGreenFunction()
    { return GetGreenFunction_40(); }

  private native vtkPiecewiseFunction GetBlueFunction_41();
  public vtkPiecewiseFunction GetBlueFunction()
    { return GetBlueFunction_41(); }

  public vtkColorTransferFunction() { super(); };

  protected vtkColorTransferFunction(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
