// java wrapper for vtkConnectivityFilter object
//

package vtk;
import vtk.*;

public class vtkConnectivityFilter extends vtkDataSetToUnstructuredGridFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetScalarConnectivity_2(int id0);
  public void SetScalarConnectivity(int id0)
    { SetScalarConnectivity_2(id0); }

  private native int GetScalarConnectivity_3();
  public int GetScalarConnectivity()
    { return GetScalarConnectivity_3(); }

  private native void ScalarConnectivityOn_4();
  public void ScalarConnectivityOn()
    { ScalarConnectivityOn_4(); }

  private native void ScalarConnectivityOff_5();
  public void ScalarConnectivityOff()
    { ScalarConnectivityOff_5(); }

  private native void SetScalarRange_6(double id0,double id1);
  public void SetScalarRange(double id0,double id1)
    { SetScalarRange_6(id0,id1); }

  private native void SetScalarRange_7(double id0[]);
  public void SetScalarRange(double id0[])
    { SetScalarRange_7(id0); }

  private native double[] GetScalarRange_8();
  public double[] GetScalarRange()
    { return GetScalarRange_8(); }

  private native void SetExtractionMode_9(int id0);
  public void SetExtractionMode(int id0)
    { SetExtractionMode_9(id0); }

  private native int GetExtractionMode_10();
  public int GetExtractionMode()
    { return GetExtractionMode_10(); }

  private native void SetExtractionModeToPointSeededRegions_11();
  public void SetExtractionModeToPointSeededRegions()
    { SetExtractionModeToPointSeededRegions_11(); }

  private native void SetExtractionModeToCellSeededRegions_12();
  public void SetExtractionModeToCellSeededRegions()
    { SetExtractionModeToCellSeededRegions_12(); }

  private native void SetExtractionModeToLargestRegion_13();
  public void SetExtractionModeToLargestRegion()
    { SetExtractionModeToLargestRegion_13(); }

  private native void SetExtractionModeToSpecifiedRegions_14();
  public void SetExtractionModeToSpecifiedRegions()
    { SetExtractionModeToSpecifiedRegions_14(); }

  private native void SetExtractionModeToClosestPointRegion_15();
  public void SetExtractionModeToClosestPointRegion()
    { SetExtractionModeToClosestPointRegion_15(); }

  private native void SetExtractionModeToAllRegions_16();
  public void SetExtractionModeToAllRegions()
    { SetExtractionModeToAllRegions_16(); }

  private native String GetExtractionModeAsString_17();
  public String GetExtractionModeAsString()
    { return GetExtractionModeAsString_17(); }

  private native void InitializeSeedList_18();
  public void InitializeSeedList()
    { InitializeSeedList_18(); }

  private native void AddSeed_19(int id0);
  public void AddSeed(int id0)
    { AddSeed_19(id0); }

  private native void DeleteSeed_20(int id0);
  public void DeleteSeed(int id0)
    { DeleteSeed_20(id0); }

  private native void InitializeSpecifiedRegionList_21();
  public void InitializeSpecifiedRegionList()
    { InitializeSpecifiedRegionList_21(); }

  private native void AddSpecifiedRegion_22(int id0);
  public void AddSpecifiedRegion(int id0)
    { AddSpecifiedRegion_22(id0); }

  private native void DeleteSpecifiedRegion_23(int id0);
  public void DeleteSpecifiedRegion(int id0)
    { DeleteSpecifiedRegion_23(id0); }

  private native void SetClosestPoint_24(double id0,double id1,double id2);
  public void SetClosestPoint(double id0,double id1,double id2)
    { SetClosestPoint_24(id0,id1,id2); }

  private native void SetClosestPoint_25(double id0[]);
  public void SetClosestPoint(double id0[])
    { SetClosestPoint_25(id0); }

  private native double[] GetClosestPoint_26();
  public double[] GetClosestPoint()
    { return GetClosestPoint_26(); }

  private native int GetNumberOfExtractedRegions_27();
  public int GetNumberOfExtractedRegions()
    { return GetNumberOfExtractedRegions_27(); }

  private native void SetColorRegions_28(int id0);
  public void SetColorRegions(int id0)
    { SetColorRegions_28(id0); }

  private native int GetColorRegions_29();
  public int GetColorRegions()
    { return GetColorRegions_29(); }

  private native void ColorRegionsOn_30();
  public void ColorRegionsOn()
    { ColorRegionsOn_30(); }

  private native void ColorRegionsOff_31();
  public void ColorRegionsOff()
    { ColorRegionsOff_31(); }

  private native void SetMaxRecursionDepth_32(int id0);
  public void SetMaxRecursionDepth(int id0)
    { SetMaxRecursionDepth_32(id0); }

  private native int GetMaxRecursionDepth_33();
  public int GetMaxRecursionDepth()
    { return GetMaxRecursionDepth_33(); }

  public vtkConnectivityFilter() { super(); };

  protected vtkConnectivityFilter(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
