// java wrapper for vtkDataObject object
//

package vtk;
import vtk.*;

public class vtkDataObject extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native vtkDataObject MakeObject_2();
  public vtkDataObject MakeObject()
    { return MakeObject_2(); }

  private native vtkSource GetSource_3();
  public vtkSource GetSource()
    { return GetSource_3(); }

  private native void SetSource_4(vtkSource id0);
  public void SetSource(vtkSource id0)
    { SetSource_4(id0); }

  private native int GetMTime_5();
  public int GetMTime()
    { return GetMTime_5(); }

  private native void Initialize_6();
  public void Initialize()
    { Initialize_6(); }

  private native void ReleaseData_7();
  public void ReleaseData()
    { ReleaseData_7(); }

  private native int ShouldIReleaseData_8();
  public int ShouldIReleaseData()
    { return ShouldIReleaseData_8(); }

  private native int GetDataReleased_9();
  public int GetDataReleased()
    { return GetDataReleased_9(); }

  private native void SetReleaseDataFlag_10(int id0);
  public void SetReleaseDataFlag(int id0)
    { SetReleaseDataFlag_10(id0); }

  private native int GetReleaseDataFlag_11();
  public int GetReleaseDataFlag()
    { return GetReleaseDataFlag_11(); }

  private native void ReleaseDataFlagOn_12();
  public void ReleaseDataFlagOn()
    { ReleaseDataFlagOn_12(); }

  private native void ReleaseDataFlagOff_13();
  public void ReleaseDataFlagOff()
    { ReleaseDataFlagOff_13(); }

  private native void SetGlobalReleaseDataFlag_14(int id0);
  public void SetGlobalReleaseDataFlag(int id0)
    { SetGlobalReleaseDataFlag_14(id0); }

  private native void GlobalReleaseDataFlagOn_15();
  public void GlobalReleaseDataFlagOn()
    { GlobalReleaseDataFlagOn_15(); }

  private native void GlobalReleaseDataFlagOff_16();
  public void GlobalReleaseDataFlagOff()
    { GlobalReleaseDataFlagOff_16(); }

  private native int GetGlobalReleaseDataFlag_17();
  public int GetGlobalReleaseDataFlag()
    { return GetGlobalReleaseDataFlag_17(); }

  private native void SetFieldData_18(vtkFieldData id0);
  public void SetFieldData(vtkFieldData id0)
    { SetFieldData_18(id0); }

  private native vtkFieldData GetFieldData_19();
  public vtkFieldData GetFieldData()
    { return GetFieldData_19(); }

  private native void UnRegister_20(vtkObject id0);
  public void UnRegister(vtkObject id0)
    { UnRegister_20(id0); }

  private native int GetNetReferenceCount_21();
  public int GetNetReferenceCount()
    { return GetNetReferenceCount_21(); }

  private native void Update_22();
  public void Update()
    { Update_22(); }

  private native void UpdateInformation_23();
  public void UpdateInformation()
    { UpdateInformation_23(); }

  private native void PropagateUpdateExtent_24();
  public void PropagateUpdateExtent()
    { PropagateUpdateExtent_24(); }

  private native void TriggerAsynchronousUpdate_25();
  public void TriggerAsynchronousUpdate()
    { TriggerAsynchronousUpdate_25(); }

  private native void UpdateData_26();
  public void UpdateData()
    { UpdateData_26(); }

  private native int GetEstimatedPipelineMemorySize_27();
  public int GetEstimatedPipelineMemorySize()
    { return GetEstimatedPipelineMemorySize_27(); }

  private native int GetEstimatedMemorySize_28();
  public int GetEstimatedMemorySize()
    { return GetEstimatedMemorySize_28(); }

  private native void SetUpdateExtent_29(int id0,int id1,int id2);
  public void SetUpdateExtent(int id0,int id1,int id2)
    { SetUpdateExtent_29(id0,id1,id2); }

  private native void SetUpdateExtent_30(int id0,int id1);
  public void SetUpdateExtent(int id0,int id1)
    { SetUpdateExtent_30(id0,id1); }

  private native void SetUpdateExtent_31(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetUpdateExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetUpdateExtent_31(id0,id1,id2,id3,id4,id5); }

  private native int[]  GetUpdateExtent_32();
  public int[]  GetUpdateExtent()
    { return GetUpdateExtent_32(); }

  private native int GetDataObjectType_33();
  public int GetDataObjectType()
    { return GetDataObjectType_33(); }

  private native int GetUpdateTime_34();
  public int GetUpdateTime()
    { return GetUpdateTime_34(); }

  private native void SetUpdateExtentToWholeExtent_35();
  public void SetUpdateExtentToWholeExtent()
    { SetUpdateExtentToWholeExtent_35(); }

  private native void SetPipelineMTime_36(int id0);
  public void SetPipelineMTime(int id0)
    { SetPipelineMTime_36(id0); }

  private native int GetPipelineMTime_37();
  public int GetPipelineMTime()
    { return GetPipelineMTime_37(); }

  private native int GetActualMemorySize_38();
  public int GetActualMemorySize()
    { return GetActualMemorySize_38(); }

  private native void CopyInformation_39(vtkDataObject id0);
  public void CopyInformation(vtkDataObject id0)
    { CopyInformation_39(id0); }

  private native void CopyTypeSpecificInformation_40(vtkDataObject id0);
  public void CopyTypeSpecificInformation(vtkDataObject id0)
    { CopyTypeSpecificInformation_40(id0); }

  private native void SetUpdatePiece_41(int id0);
  public void SetUpdatePiece(int id0)
    { SetUpdatePiece_41(id0); }

  private native void SetUpdateNumberOfPieces_42(int id0);
  public void SetUpdateNumberOfPieces(int id0)
    { SetUpdateNumberOfPieces_42(id0); }

  private native int GetUpdatePiece_43();
  public int GetUpdatePiece()
    { return GetUpdatePiece_43(); }

  private native int GetUpdateNumberOfPieces_44();
  public int GetUpdateNumberOfPieces()
    { return GetUpdateNumberOfPieces_44(); }

  private native void SetUpdateGhostLevel_45(int id0);
  public void SetUpdateGhostLevel(int id0)
    { SetUpdateGhostLevel_45(id0); }

  private native int GetUpdateGhostLevel_46();
  public int GetUpdateGhostLevel()
    { return GetUpdateGhostLevel_46(); }

  private native void SetWholeExtent_47(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetWholeExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetWholeExtent_47(id0,id1,id2,id3,id4,id5); }

  private native void SetWholeExtent_48(int id0[]);
  public void SetWholeExtent(int id0[])
    { SetWholeExtent_48(id0); }

  private native int[]  GetWholeExtent_49();
  public int[]  GetWholeExtent()
    { return GetWholeExtent_49(); }

  private native void DataHasBeenGenerated_50();
  public void DataHasBeenGenerated()
    { DataHasBeenGenerated_50(); }

  private native void PrepareForNewData_51();
  public void PrepareForNewData()
    { PrepareForNewData_51(); }

  private native void ShallowCopy_52(vtkDataObject id0);
  public void ShallowCopy(vtkDataObject id0)
    { ShallowCopy_52(id0); }

  private native void DeepCopy_53(vtkDataObject id0);
  public void DeepCopy(vtkDataObject id0)
    { DeepCopy_53(id0); }

  private native void SetLocality_54(double id0);
  public void SetLocality(double id0)
    { SetLocality_54(id0); }

  private native double GetLocality_55();
  public double GetLocality()
    { return GetLocality_55(); }

  private native void SetExtentTranslator_56(vtkExtentTranslator id0);
  public void SetExtentTranslator(vtkExtentTranslator id0)
    { SetExtentTranslator_56(id0); }

  private native vtkExtentTranslator GetExtentTranslator_57();
  public vtkExtentTranslator GetExtentTranslator()
    { return GetExtentTranslator_57(); }

  public vtkDataObject() { super(); };

  protected vtkDataObject(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
