// java wrapper for vtkDataSet object
//

package vtk;
import vtk.*;

public class vtkDataSet extends vtkDataObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void GetCellTypes_2(vtkCellTypes id0);
  public void GetCellTypes(vtkCellTypes id0)
    { GetCellTypes_2(id0); }

  private native void GetCellNeighbors_3(int id0,vtkIdList id1,vtkIdList id2);
  public void GetCellNeighbors(int id0,vtkIdList id1,vtkIdList id2)
    { GetCellNeighbors_3(id0,id1,id2); }

  private native int FindPoint_4(double id0,double id1,double id2);
  public int FindPoint(double id0,double id1,double id2)
    { return FindPoint_4(id0,id1,id2); }

  private native int GetMTime_5();
  public int GetMTime()
    { return GetMTime_5(); }

  private native vtkCellData GetCellData_6();
  public vtkCellData GetCellData()
    { return GetCellData_6(); }

  private native vtkPointData GetPointData_7();
  public vtkPointData GetPointData()
    { return GetPointData_7(); }

  private native void Squeeze_8();
  public void Squeeze()
    { Squeeze_8(); }

  private native void ComputeBounds_9();
  public void ComputeBounds()
    { ComputeBounds_9(); }

  private native double[] GetBounds_10();
  public double[] GetBounds()
    { return GetBounds_10(); }

  private native double[] GetCenter_11();
  public double[] GetCenter()
    { return GetCenter_11(); }

  private native double GetLength_12();
  public double GetLength()
    { return GetLength_12(); }

  private native void Initialize_13();
  public void Initialize()
    { Initialize_13(); }

  private native double[] GetScalarRange_14();
  public double[] GetScalarRange()
    { return GetScalarRange_14(); }

  private native int GetActualMemorySize_15();
  public int GetActualMemorySize()
    { return GetActualMemorySize_15(); }

  private native int GetDataObjectType_16();
  public int GetDataObjectType()
    { return GetDataObjectType_16(); }

  private native void ShallowCopy_17(vtkDataObject id0);
  public void ShallowCopy(vtkDataObject id0)
    { ShallowCopy_17(id0); }

  private native void DeepCopy_18(vtkDataObject id0);
  public void DeepCopy(vtkDataObject id0)
    { DeepCopy_18(id0); }

  private native void GetCellPoints_19(int id0,vtkIdList id1);
  public void GetCellPoints(int id0,vtkIdList id1)
    { GetCellPoints_19(id0,id1); }

  private native void GetPointCells_20(int id0,vtkIdList id1);
  public void GetPointCells(int id0,vtkIdList id1)
    { GetPointCells_20(id0,id1); }

  private native int GetDataSetType_21();
  public int GetDataSetType()
    { return GetDataSetType_21(); }

  public vtkDataSet() { super(); };

  protected vtkDataSet(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
