// java wrapper for vtkFieldData object
//

package vtk;
import vtk.*;

public class vtkFieldData extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void Initialize_2();
  public void Initialize()
    { Initialize_2(); }

  private native int Allocate_3(int id0,int id1);
  public int Allocate(int id0,int id1)
    { return Allocate_3(id0,id1); }

  private native vtkFieldData MakeObject_4();
  public vtkFieldData MakeObject()
    { return MakeObject_4(); }

  private native void SetNumberOfArrays_5(int id0);
  public void SetNumberOfArrays(int id0)
    { SetNumberOfArrays_5(id0); }

  private native void SetArray_6(int id0,vtkDataArray id1);
  public void SetArray(int id0,vtkDataArray id1)
    { SetArray_6(id0,id1); }

  private native int GetNumberOfArrays_7();
  public int GetNumberOfArrays()
    { return GetNumberOfArrays_7(); }

  private native vtkDataArray GetArray_8(int id0);
  public vtkDataArray GetArray(int id0)
    { return GetArray_8(id0); }

  private native int AddArray_9(vtkDataArray id0);
  public int AddArray(vtkDataArray id0)
    { return AddArray_9(id0); }

  private native int AddArray_10(vtkDataArray id0,String id1);
  public int AddArray(vtkDataArray id0,String id1)
    { return AddArray_10(id0,id1); }

  private native int AddReplaceArray_11(vtkDataArray id0,String id1);
  public int AddReplaceArray(vtkDataArray id0,String id1)
    { return AddReplaceArray_11(id0,id1); }

  private native int AddNoReplaceArray_12(vtkDataArray id0,String id1);
  public int AddNoReplaceArray(vtkDataArray id0,String id1)
    { return AddNoReplaceArray_12(id0,id1); }

  private native vtkDataArray GetArray_13(String id0);
  public vtkDataArray GetArray(String id0)
    { return GetArray_13(id0); }

  private native void SetArrayName_14(int id0,String id1);
  public void SetArrayName(int id0,String id1)
    { SetArrayName_14(id0,id1); }

  private native String GetArrayName_15(int id0);
  public String GetArrayName(int id0)
    { return GetArrayName_15(id0); }

  private native int GetNumberOfComponents_16();
  public int GetNumberOfComponents()
    { return GetNumberOfComponents_16(); }

  private native int GetNumberOfTuples_17();
  public int GetNumberOfTuples()
    { return GetNumberOfTuples_17(); }

  private native void SetNumberOfTuples_18(int id0);
  public void SetNumberOfTuples(int id0)
    { SetNumberOfTuples_18(id0); }

  private native double GetComponent_19(int id0,int id1);
  public double GetComponent(int id0,int id1)
    { return GetComponent_19(id0,id1); }

  private native void SetComponent_20(int id0,int id1,double id2);
  public void SetComponent(int id0,int id1,double id2)
    { SetComponent_20(id0,id1,id2); }

  private native void InsertComponent_21(int id0,int id1,double id2);
  public void InsertComponent(int id0,int id1,double id2)
    { InsertComponent_21(id0,id1,id2); }

  private native void DeepCopy_22(vtkFieldData id0);
  public void DeepCopy(vtkFieldData id0)
    { DeepCopy_22(id0); }

  private native void ShallowCopy_23(vtkFieldData id0);
  public void ShallowCopy(vtkFieldData id0)
    { ShallowCopy_23(id0); }

  private native void Squeeze_24();
  public void Squeeze()
    { Squeeze_24(); }

  private native void Reset_25();
  public void Reset()
    { Reset_25(); }

  private native void GetField_26(vtkIdList id0,vtkFieldData id1);
  public void GetField(vtkIdList id0,vtkFieldData id1)
    { GetField_26(id0,id1); }

  private native int GetActualMemorySize_27();
  public int GetActualMemorySize()
    { return GetActualMemorySize_27(); }

  public vtkFieldData() { super(); };

  protected vtkFieldData(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
