// java wrapper for vtkImageMandelbrotSource object
//

package vtk;
import vtk.*;

public class vtkImageMandelbrotSource extends vtkImageSource
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetWholeExtent_2(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetWholeExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetWholeExtent_2(id0,id1,id2,id3,id4,id5); }

  private native int[]  GetWholeExtent_3();
  public int[]  GetWholeExtent()
    { return GetWholeExtent_3(); }

  private native void SetProjectionAxes_4(int id0,int id1,int id2);
  public void SetProjectionAxes(int id0,int id1,int id2)
    { SetProjectionAxes_4(id0,id1,id2); }

  private native void SetProjectionAxes_5(int id0[]);
  public void SetProjectionAxes(int id0[])
    { SetProjectionAxes_5(id0); }

  private native int[]  GetProjectionAxes_6();
  public int[]  GetProjectionAxes()
    { return GetProjectionAxes_6(); }

  private native void SetOriginCX_7(double id0,double id1,double id2,double id3);
  public void SetOriginCX(double id0,double id1,double id2,double id3)
    { SetOriginCX_7(id0,id1,id2,id3); }

  private native void SetOriginCX_8(double id0[]);
  public void SetOriginCX(double id0[])
    { SetOriginCX_8(id0); }

  private native double[] GetOriginCX_9();
  public double[] GetOriginCX()
    { return GetOriginCX_9(); }

  private native void SetSampleCX_10(double id0,double id1,double id2,double id3);
  public void SetSampleCX(double id0,double id1,double id2,double id3)
    { SetSampleCX_10(id0,id1,id2,id3); }

  private native void SetSampleCX_11(double id0[]);
  public void SetSampleCX(double id0[])
    { SetSampleCX_11(id0); }

  private native double[] GetSampleCX_12();
  public double[] GetSampleCX()
    { return GetSampleCX_12(); }

  private native void SetMaximumNumberOfIterations_13(int id0);
  public void SetMaximumNumberOfIterations(int id0)
    { SetMaximumNumberOfIterations_13(id0); }

  private native int GetMaximumNumberOfIterations_14();
  public int GetMaximumNumberOfIterations()
    { return GetMaximumNumberOfIterations_14(); }

  private native void Zoom_15(double id0);
  public void Zoom(double id0)
    { Zoom_15(id0); }

  private native void Pan_16(double id0,double id1,double id2);
  public void Pan(double id0,double id1,double id2)
    { Pan_16(id0,id1,id2); }

  private native void CopyOriginAndSample_17(vtkImageMandelbrotSource id0);
  public void CopyOriginAndSample(vtkImageMandelbrotSource id0)
    { CopyOriginAndSample_17(id0); }

  private native void SetSample_18(double id0);
  public void SetSample(double id0)
    { SetSample_18(id0); }

  public vtkImageMandelbrotSource() { super(); };

  protected vtkImageMandelbrotSource(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
