// java wrapper for vtkImageMapper object
//

package vtk;
import vtk.*;

public class vtkImageMapper extends vtkMapper2D
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native int GetMTime_2();
  public int GetMTime()
    { return GetMTime_2(); }

  private native void SetColorWindow_3(double id0);
  public void SetColorWindow(double id0)
    { SetColorWindow_3(id0); }

  private native double GetColorWindow_4();
  public double GetColorWindow()
    { return GetColorWindow_4(); }

  private native void SetColorLevel_5(double id0);
  public void SetColorLevel(double id0)
    { SetColorLevel_5(id0); }

  private native double GetColorLevel_6();
  public double GetColorLevel()
    { return GetColorLevel_6(); }

  private native void SetInput_7(vtkImageData id0);
  public void SetInput(vtkImageData id0)
    { SetInput_7(id0); }

  private native vtkImageData GetInput_8();
  public vtkImageData GetInput()
    { return GetInput_8(); }

  private native void SetZSlice_9(int id0);
  public void SetZSlice(int id0)
    { SetZSlice_9(id0); }

  private native int GetZSlice_10();
  public int GetZSlice()
    { return GetZSlice_10(); }

  private native int GetWholeZMin_11();
  public int GetWholeZMin()
    { return GetWholeZMin_11(); }

  private native int GetWholeZMax_12();
  public int GetWholeZMax()
    { return GetWholeZMax_12(); }

  private native void RenderStart_13(vtkViewport id0,vtkActor2D id1);
  public void RenderStart(vtkViewport id0,vtkActor2D id1)
    { RenderStart_13(id0,id1); }

  private native double GetColorShift_14();
  public double GetColorShift()
    { return GetColorShift_14(); }

  private native double GetColorScale_15();
  public double GetColorScale()
    { return GetColorScale_15(); }

  private native void SetRenderToRectangle_16(int id0);
  public void SetRenderToRectangle(int id0)
    { SetRenderToRectangle_16(id0); }

  private native int GetRenderToRectangle_17();
  public int GetRenderToRectangle()
    { return GetRenderToRectangle_17(); }

  private native void RenderToRectangleOn_18();
  public void RenderToRectangleOn()
    { RenderToRectangleOn_18(); }

  private native void RenderToRectangleOff_19();
  public void RenderToRectangleOff()
    { RenderToRectangleOff_19(); }

  private native void SetUseCustomExtents_20(int id0);
  public void SetUseCustomExtents(int id0)
    { SetUseCustomExtents_20(id0); }

  private native int GetUseCustomExtents_21();
  public int GetUseCustomExtents()
    { return GetUseCustomExtents_21(); }

  private native void UseCustomExtentsOn_22();
  public void UseCustomExtentsOn()
    { UseCustomExtentsOn_22(); }

  private native void UseCustomExtentsOff_23();
  public void UseCustomExtentsOff()
    { UseCustomExtentsOff_23(); }

  private native void SetCustomDisplayExtents_24(int id0[]);
  public void SetCustomDisplayExtents(int id0[])
    { SetCustomDisplayExtents_24(id0); }

  private native int[]  GetCustomDisplayExtents_25();
  public int[]  GetCustomDisplayExtents()
    { return GetCustomDisplayExtents_25(); }

  public vtkImageMapper() { super(); };

  protected vtkImageMapper(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
