// java wrapper for vtkImageViewer object
//

package vtk;
import vtk.*;

public class vtkImageViewer extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native String GetWindowName_2();
  public String GetWindowName()
    { return GetWindowName_2(); }

  private native void Render_3();
  public void Render()
    { Render_3(); }

  private native void SetInput_4(vtkImageData id0);
  public void SetInput(vtkImageData id0)
    { SetInput_4(id0); }

  private native vtkImageData GetInput_5();
  public vtkImageData GetInput()
    { return GetInput_5(); }

  private native int GetWholeZMin_6();
  public int GetWholeZMin()
    { return GetWholeZMin_6(); }

  private native int GetWholeZMax_7();
  public int GetWholeZMax()
    { return GetWholeZMax_7(); }

  private native int GetZSlice_8();
  public int GetZSlice()
    { return GetZSlice_8(); }

  private native void SetZSlice_9(int id0);
  public void SetZSlice(int id0)
    { SetZSlice_9(id0); }

  private native double GetColorWindow_10();
  public double GetColorWindow()
    { return GetColorWindow_10(); }

  private native double GetColorLevel_11();
  public double GetColorLevel()
    { return GetColorLevel_11(); }

  private native void SetColorWindow_12(double id0);
  public void SetColorWindow(double id0)
    { SetColorWindow_12(id0); }

  private native void SetColorLevel_13(double id0);
  public void SetColorLevel(double id0)
    { SetColorLevel_13(id0); }

  private native int GetGrayScaleHint_14();
  public int GetGrayScaleHint()
    { return GetGrayScaleHint_14(); }

  private native void SetGrayScaleHint_15(int id0);
  public void SetGrayScaleHint(int id0)
    { SetGrayScaleHint_15(id0); }

  private native void GrayScaleHintOn_16();
  public void GrayScaleHintOn()
    { GrayScaleHintOn_16(); }

  private native void GrayScaleHintOff_17();
  public void GrayScaleHintOff()
    { GrayScaleHintOff_17(); }

  private native void SetPosition_18(int id0,int id1);
  public void SetPosition(int id0,int id1)
    { SetPosition_18(id0,id1); }

  private native void SetSize_19(int id0,int id1);
  public void SetSize(int id0,int id1)
    { SetSize_19(id0,id1); }

  private native vtkImageWindow GetImageWindow_20();
  public vtkImageWindow GetImageWindow()
    { return GetImageWindow_20(); }

  private native vtkImageMapper GetImageMapper_21();
  public vtkImageMapper GetImageMapper()
    { return GetImageMapper_21(); }

  private native vtkImager GetImager_22();
  public vtkImager GetImager()
    { return GetImager_22(); }

  private native vtkActor2D GetActor2D_23();
  public vtkActor2D GetActor2D()
    { return GetActor2D_23(); }

  public vtkImageViewer() { super(); };

  protected vtkImageViewer(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
