// java wrapper for vtkImplicitModeller object
//

package vtk;
import vtk.*;

public class vtkImplicitModeller extends vtkDataSetToStructuredPointsFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native double ComputeModelBounds_2(vtkDataSet id0);
  public double ComputeModelBounds(vtkDataSet id0)
    { return ComputeModelBounds_2(id0); }

  private native int[]  GetSampleDimensions_3();
  public int[]  GetSampleDimensions()
    { return GetSampleDimensions_3(); }

  private native void SetSampleDimensions_4(int id0,int id1,int id2);
  public void SetSampleDimensions(int id0,int id1,int id2)
    { SetSampleDimensions_4(id0,id1,id2); }

  private native void SetMaximumDistance_5(double id0);
  public void SetMaximumDistance(double id0)
    { SetMaximumDistance_5(id0); }

  private native double GetMaximumDistance_6();
  public double GetMaximumDistance()
    { return GetMaximumDistance_6(); }

  private native void SetModelBounds_7(double id0,double id1,double id2,double id3,double id4,double id5);
  public void SetModelBounds(double id0,double id1,double id2,double id3,double id4,double id5)
    { SetModelBounds_7(id0,id1,id2,id3,id4,id5); }

  private native void SetModelBounds_8(double id0[]);
  public void SetModelBounds(double id0[])
    { SetModelBounds_8(id0); }

  private native double[] GetModelBounds_9();
  public double[] GetModelBounds()
    { return GetModelBounds_9(); }

  private native void SetAdjustBounds_10(int id0);
  public void SetAdjustBounds(int id0)
    { SetAdjustBounds_10(id0); }

  private native int GetAdjustBounds_11();
  public int GetAdjustBounds()
    { return GetAdjustBounds_11(); }

  private native void AdjustBoundsOn_12();
  public void AdjustBoundsOn()
    { AdjustBoundsOn_12(); }

  private native void AdjustBoundsOff_13();
  public void AdjustBoundsOff()
    { AdjustBoundsOff_13(); }

  private native void SetAdjustDistance_14(double id0);
  public void SetAdjustDistance(double id0)
    { SetAdjustDistance_14(id0); }

  private native double GetAdjustDistance_15();
  public double GetAdjustDistance()
    { return GetAdjustDistance_15(); }

  private native void SetCapping_16(int id0);
  public void SetCapping(int id0)
    { SetCapping_16(id0); }

  private native int GetCapping_17();
  public int GetCapping()
    { return GetCapping_17(); }

  private native void CappingOn_18();
  public void CappingOn()
    { CappingOn_18(); }

  private native void CappingOff_19();
  public void CappingOff()
    { CappingOff_19(); }

  private native void SetCapValue_20(double id0);
  public void SetCapValue(double id0)
    { SetCapValue_20(id0); }

  private native double GetCapValue_21();
  public double GetCapValue()
    { return GetCapValue_21(); }

  private native void SetProcessMode_22(int id0);
  public void SetProcessMode(int id0)
    { SetProcessMode_22(id0); }

  private native int GetProcessMode_23();
  public int GetProcessMode()
    { return GetProcessMode_23(); }

  private native void SetProcessModeToPerVoxel_24();
  public void SetProcessModeToPerVoxel()
    { SetProcessModeToPerVoxel_24(); }

  private native void SetProcessModeToPerCell_25();
  public void SetProcessModeToPerCell()
    { SetProcessModeToPerCell_25(); }

  private native String GetProcessModeAsString_26();
  public String GetProcessModeAsString()
    { return GetProcessModeAsString_26(); }

  private native void SetLocatorMaxLevel_27(int id0);
  public void SetLocatorMaxLevel(int id0)
    { SetLocatorMaxLevel_27(id0); }

  private native int GetLocatorMaxLevel_28();
  public int GetLocatorMaxLevel()
    { return GetLocatorMaxLevel_28(); }

  private native void SetNumberOfThreads_29(int id0);
  public void SetNumberOfThreads(int id0)
    { SetNumberOfThreads_29(id0); }

  private native int GetNumberOfThreads_30();
  public int GetNumberOfThreads()
    { return GetNumberOfThreads_30(); }

  private native void StartAppend_31();
  public void StartAppend()
    { StartAppend_31(); }

  private native void Append_32(vtkDataSet id0);
  public void Append(vtkDataSet id0)
    { Append_32(id0); }

  private native void EndAppend_33();
  public void EndAppend()
    { EndAppend_33(); }

  private native void UpdateData_34(vtkDataObject id0);
  public void UpdateData(vtkDataObject id0)
    { UpdateData_34(id0); }

  public vtkImplicitModeller() { super(); };

  protected vtkImplicitModeller(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
