// java wrapper for vtkLODProp3D object
//

package vtk;
import vtk.*;

public class vtkLODProp3D extends vtkProp3D
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native double[] GetBounds_2();
  public double[] GetBounds()
    { return GetBounds_2(); }

  private native int RequiresRayCasting_3();
  public int RequiresRayCasting()
    { return RequiresRayCasting_3(); }

  private native int RequiresRenderingIntoImage_4();
  public int RequiresRenderingIntoImage()
    { return RequiresRenderingIntoImage_4(); }

  private native int AddLOD_5(vtkMapper id0,vtkProperty id1,vtkTexture id2,double id3);
  public int AddLOD(vtkMapper id0,vtkProperty id1,vtkTexture id2,double id3)
    { return AddLOD_5(id0,id1,id2,id3); }

  private native int AddLOD_6(vtkMapper id0,vtkProperty id1,double id2);
  public int AddLOD(vtkMapper id0,vtkProperty id1,double id2)
    { return AddLOD_6(id0,id1,id2); }

  private native int AddLOD_7(vtkMapper id0,vtkTexture id1,double id2);
  public int AddLOD(vtkMapper id0,vtkTexture id1,double id2)
    { return AddLOD_7(id0,id1,id2); }

  private native int AddLOD_8(vtkMapper id0,double id1);
  public int AddLOD(vtkMapper id0,double id1)
    { return AddLOD_8(id0,id1); }

  private native int AddLOD_9(vtkVolumeMapper id0,vtkVolumeProperty id1,double id2);
  public int AddLOD(vtkVolumeMapper id0,vtkVolumeProperty id1,double id2)
    { return AddLOD_9(id0,id1,id2); }

  private native int AddLOD_10(vtkVolumeMapper id0,double id1);
  public int AddLOD(vtkVolumeMapper id0,double id1)
    { return AddLOD_10(id0,id1); }

  private native void RemoveLOD_11(int id0);
  public void RemoveLOD(int id0)
    { RemoveLOD_11(id0); }

  private native void SetLODProperty_12(int id0,vtkProperty id1);
  public void SetLODProperty(int id0,vtkProperty id1)
    { SetLODProperty_12(id0,id1); }

  private native void SetLODProperty_13(int id0,vtkVolumeProperty id1);
  public void SetLODProperty(int id0,vtkVolumeProperty id1)
    { SetLODProperty_13(id0,id1); }

  private native void SetLODMapper_14(int id0,vtkMapper id1);
  public void SetLODMapper(int id0,vtkMapper id1)
    { SetLODMapper_14(id0,id1); }

  private native void SetLODMapper_15(int id0,vtkVolumeMapper id1);
  public void SetLODMapper(int id0,vtkVolumeMapper id1)
    { SetLODMapper_15(id0,id1); }

  private native void SetLODTexture_16(int id0,vtkTexture id1);
  public void SetLODTexture(int id0,vtkTexture id1)
    { SetLODTexture_16(id0,id1); }

  private native void EnableLOD_17(int id0);
  public void EnableLOD(int id0)
    { EnableLOD_17(id0); }

  private native void DisableLOD_18(int id0);
  public void DisableLOD(int id0)
    { DisableLOD_18(id0); }

  private native void SetLODLevel_19(int id0,double id1);
  public void SetLODLevel(int id0,double id1)
    { SetLODLevel_19(id0,id1); }

  private native double GetLODLevel_20(int id0);
  public double GetLODLevel(int id0)
    { return GetLODLevel_20(id0); }

  private native double GetLODIndexLevel_21(int id0);
  public double GetLODIndexLevel(int id0)
    { return GetLODIndexLevel_21(id0); }

  private native double GetLODEstimatedRenderTime_22(int id0);
  public double GetLODEstimatedRenderTime(int id0)
    { return GetLODEstimatedRenderTime_22(id0); }

  private native double GetLODIndexEstimatedRenderTime_23(int id0);
  public double GetLODIndexEstimatedRenderTime(int id0)
    { return GetLODIndexEstimatedRenderTime_23(id0); }

  private native void SetAutomaticLODSelection_24(int id0);
  public void SetAutomaticLODSelection(int id0)
    { SetAutomaticLODSelection_24(id0); }

  private native int GetAutomaticLODSelection_25();
  public int GetAutomaticLODSelection()
    { return GetAutomaticLODSelection_25(); }

  private native void AutomaticLODSelectionOn_26();
  public void AutomaticLODSelectionOn()
    { AutomaticLODSelectionOn_26(); }

  private native void AutomaticLODSelectionOff_27();
  public void AutomaticLODSelectionOff()
    { AutomaticLODSelectionOff_27(); }

  private native void SetSelectedLODID_28(int id0);
  public void SetSelectedLODID(int id0)
    { SetSelectedLODID_28(id0); }

  private native int GetSelectedLODID_29();
  public int GetSelectedLODID()
    { return GetSelectedLODID_29(); }

  private native int GetLastRenderedLODID_30();
  public int GetLastRenderedLODID()
    { return GetLastRenderedLODID_30(); }

  private native void GetActors_31(vtkPropCollection id0);
  public void GetActors(vtkPropCollection id0)
    { GetActors_31(id0); }

  private native void SetPickMethod_32(Object id0, String id1);
  public void SetPickMethod(Object id0, String id1)
    { SetPickMethod_32(id0,id1); }

  private native void SetSelectedPickLODID_33(int id0);
  public void SetSelectedPickLODID(int id0)
    { SetSelectedPickLODID_33(id0); }

  private native int GetSelectedPickLODID_34();
  public int GetSelectedPickLODID()
    { return GetSelectedPickLODID_34(); }

  private native void SetAutomaticPickLODSelection_35(int id0);
  public void SetAutomaticPickLODSelection(int id0)
    { SetAutomaticPickLODSelection_35(id0); }

  private native int GetAutomaticPickLODSelection_36();
  public int GetAutomaticPickLODSelection()
    { return GetAutomaticPickLODSelection_36(); }

  private native void AutomaticPickLODSelectionOn_37();
  public void AutomaticPickLODSelectionOn()
    { AutomaticPickLODSelectionOn_37(); }

  private native void AutomaticPickLODSelectionOff_38();
  public void AutomaticPickLODSelectionOff()
    { AutomaticPickLODSelectionOff_38(); }

  private native void ShallowCopy_39(vtkProp id0);
  public void ShallowCopy(vtkProp id0)
    { ShallowCopy_39(id0); }

  public vtkLODProp3D() { super(); };

  protected vtkLODProp3D(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
