// java wrapper for vtkLinearExtrusionFilter object
//

package vtk;
import vtk.*;

public class vtkLinearExtrusionFilter extends vtkPolyDataToPolyDataFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetExtrusionType_2(int id0);
  public void SetExtrusionType(int id0)
    { SetExtrusionType_2(id0); }

  private native int GetExtrusionType_3();
  public int GetExtrusionType()
    { return GetExtrusionType_3(); }

  private native void SetExtrusionTypeToVectorExtrusion_4();
  public void SetExtrusionTypeToVectorExtrusion()
    { SetExtrusionTypeToVectorExtrusion_4(); }

  private native void SetExtrusionTypeToNormalExtrusion_5();
  public void SetExtrusionTypeToNormalExtrusion()
    { SetExtrusionTypeToNormalExtrusion_5(); }

  private native void SetExtrusionTypeToPointExtrusion_6();
  public void SetExtrusionTypeToPointExtrusion()
    { SetExtrusionTypeToPointExtrusion_6(); }

  private native void SetCapping_7(int id0);
  public void SetCapping(int id0)
    { SetCapping_7(id0); }

  private native int GetCapping_8();
  public int GetCapping()
    { return GetCapping_8(); }

  private native void CappingOn_9();
  public void CappingOn()
    { CappingOn_9(); }

  private native void CappingOff_10();
  public void CappingOff()
    { CappingOff_10(); }

  private native void SetLowerCap_11(int id0);
  public void SetLowerCap(int id0)
    { SetLowerCap_11(id0); }

  private native int GetLowerCap_12();
  public int GetLowerCap()
    { return GetLowerCap_12(); }

  private native void LowerCapOn_13();
  public void LowerCapOn()
    { LowerCapOn_13(); }

  private native void LowerCapOff_14();
  public void LowerCapOff()
    { LowerCapOff_14(); }

  private native void SetUpperCap_15(int id0);
  public void SetUpperCap(int id0)
    { SetUpperCap_15(id0); }

  private native int GetUpperCap_16();
  public int GetUpperCap()
    { return GetUpperCap_16(); }

  private native void UpperCapOn_17();
  public void UpperCapOn()
    { UpperCapOn_17(); }

  private native void UpperCapOff_18();
  public void UpperCapOff()
    { UpperCapOff_18(); }

  private native void SetScaleFactor_19(double id0);
  public void SetScaleFactor(double id0)
    { SetScaleFactor_19(id0); }

  private native double GetScaleFactor_20();
  public double GetScaleFactor()
    { return GetScaleFactor_20(); }

  private native void SetVector_21(double id0,double id1,double id2);
  public void SetVector(double id0,double id1,double id2)
    { SetVector_21(id0,id1,id2); }

  private native void SetVector_22(double id0[]);
  public void SetVector(double id0[])
    { SetVector_22(id0); }

  private native double[] GetVector_23();
  public double[] GetVector()
    { return GetVector_23(); }

  private native void SetExtrusionPoint_24(double id0,double id1,double id2);
  public void SetExtrusionPoint(double id0,double id1,double id2)
    { SetExtrusionPoint_24(id0,id1,id2); }

  private native void SetExtrusionPoint_25(double id0[]);
  public void SetExtrusionPoint(double id0[])
    { SetExtrusionPoint_25(id0); }

  private native double[] GetExtrusionPoint_26();
  public double[] GetExtrusionPoint()
    { return GetExtrusionPoint_26(); }

  public vtkLinearExtrusionFilter() { super(); };

  protected vtkLinearExtrusionFilter(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
