// java wrapper for vtkMapper object
//

package vtk;
import vtk.*;

public class vtkMapper extends vtkAbstractMapper3D
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void ShallowCopy_2(vtkMapper id0);
  public void ShallowCopy(vtkMapper id0)
    { ShallowCopy_2(id0); }

  private native int GetMTime_3();
  public int GetMTime()
    { return GetMTime_3(); }

  private native void ReleaseGraphicsResources_4(vtkWindow id0);
  public void ReleaseGraphicsResources(vtkWindow id0)
    { ReleaseGraphicsResources_4(id0); }

  private native void SetLookupTable_5(vtkScalarsToColors id0);
  public void SetLookupTable(vtkScalarsToColors id0)
    { SetLookupTable_5(id0); }

  private native vtkScalarsToColors GetLookupTable_6();
  public vtkScalarsToColors GetLookupTable()
    { return GetLookupTable_6(); }

  private native void CreateDefaultLookupTable_7();
  public void CreateDefaultLookupTable()
    { CreateDefaultLookupTable_7(); }

  private native void SetScalarVisibility_8(int id0);
  public void SetScalarVisibility(int id0)
    { SetScalarVisibility_8(id0); }

  private native int GetScalarVisibility_9();
  public int GetScalarVisibility()
    { return GetScalarVisibility_9(); }

  private native void ScalarVisibilityOn_10();
  public void ScalarVisibilityOn()
    { ScalarVisibilityOn_10(); }

  private native void ScalarVisibilityOff_11();
  public void ScalarVisibilityOff()
    { ScalarVisibilityOff_11(); }

  private native void SetColorMode_12(int id0);
  public void SetColorMode(int id0)
    { SetColorMode_12(id0); }

  private native int GetColorMode_13();
  public int GetColorMode()
    { return GetColorMode_13(); }

  private native void SetColorModeToDefault_14();
  public void SetColorModeToDefault()
    { SetColorModeToDefault_14(); }

  private native void SetColorModeToMapScalars_15();
  public void SetColorModeToMapScalars()
    { SetColorModeToMapScalars_15(); }

  private native void SetColorModeToLuminance_16();
  public void SetColorModeToLuminance()
    { SetColorModeToLuminance_16(); }

  private native String GetColorModeAsString_17();
  public String GetColorModeAsString()
    { return GetColorModeAsString_17(); }

  private native void SetImmediateModeRendering_18(int id0);
  public void SetImmediateModeRendering(int id0)
    { SetImmediateModeRendering_18(id0); }

  private native int GetImmediateModeRendering_19();
  public int GetImmediateModeRendering()
    { return GetImmediateModeRendering_19(); }

  private native void ImmediateModeRenderingOn_20();
  public void ImmediateModeRenderingOn()
    { ImmediateModeRenderingOn_20(); }

  private native void ImmediateModeRenderingOff_21();
  public void ImmediateModeRenderingOff()
    { ImmediateModeRenderingOff_21(); }

  private native void SetGlobalImmediateModeRendering_22(int id0);
  public void SetGlobalImmediateModeRendering(int id0)
    { SetGlobalImmediateModeRendering_22(id0); }

  private native void GlobalImmediateModeRenderingOn_23();
  public void GlobalImmediateModeRenderingOn()
    { GlobalImmediateModeRenderingOn_23(); }

  private native void GlobalImmediateModeRenderingOff_24();
  public void GlobalImmediateModeRenderingOff()
    { GlobalImmediateModeRenderingOff_24(); }

  private native int GetGlobalImmediateModeRendering_25();
  public int GetGlobalImmediateModeRendering()
    { return GetGlobalImmediateModeRendering_25(); }

  private native void SetScalarRange_26(double id0,double id1);
  public void SetScalarRange(double id0,double id1)
    { SetScalarRange_26(id0,id1); }

  private native void SetScalarRange_27(double id0[]);
  public void SetScalarRange(double id0[])
    { SetScalarRange_27(id0); }

  private native double[] GetScalarRange_28();
  public double[] GetScalarRange()
    { return GetScalarRange_28(); }

  private native void Update_29();
  public void Update()
    { Update_29(); }

  private native vtkScalars GetColors_30();
  public vtkScalars GetColors()
    { return GetColors_30(); }

  private native void SetScalarMode_31(int id0);
  public void SetScalarMode(int id0)
    { SetScalarMode_31(id0); }

  private native int GetScalarMode_32();
  public int GetScalarMode()
    { return GetScalarMode_32(); }

  private native void SetScalarModeToDefault_33();
  public void SetScalarModeToDefault()
    { SetScalarModeToDefault_33(); }

  private native void SetScalarModeToUsePointData_34();
  public void SetScalarModeToUsePointData()
    { SetScalarModeToUsePointData_34(); }

  private native void SetScalarModeToUseCellData_35();
  public void SetScalarModeToUseCellData()
    { SetScalarModeToUseCellData_35(); }

  private native String GetScalarModeAsString_36();
  public String GetScalarModeAsString()
    { return GetScalarModeAsString_36(); }

  private native void SetResolveCoincidentTopology_37(int id0);
  public void SetResolveCoincidentTopology(int id0)
    { SetResolveCoincidentTopology_37(id0); }

  private native int GetResolveCoincidentTopology_38();
  public int GetResolveCoincidentTopology()
    { return GetResolveCoincidentTopology_38(); }

  private native void SetResolveCoincidentTopologyToDefault_39();
  public void SetResolveCoincidentTopologyToDefault()
    { SetResolveCoincidentTopologyToDefault_39(); }

  private native void SetResolveCoincidentTopologyToOff_40();
  public void SetResolveCoincidentTopologyToOff()
    { SetResolveCoincidentTopologyToOff_40(); }

  private native void SetResolveCoincidentTopologyToPolygonOffset_41();
  public void SetResolveCoincidentTopologyToPolygonOffset()
    { SetResolveCoincidentTopologyToPolygonOffset_41(); }

  private native void SetResolveCoincidentTopologyToShiftZBuffer_42();
  public void SetResolveCoincidentTopologyToShiftZBuffer()
    { SetResolveCoincidentTopologyToShiftZBuffer_42(); }

  private native void SetResolveCoincidentTopologyZShift_43(double id0);
  public void SetResolveCoincidentTopologyZShift(double id0)
    { SetResolveCoincidentTopologyZShift_43(id0); }

  private native double GetResolveCoincidentTopologyZShift_44();
  public double GetResolveCoincidentTopologyZShift()
    { return GetResolveCoincidentTopologyZShift_44(); }

  private native void SetRenderTime_45(double id0);
  public void SetRenderTime(double id0)
    { SetRenderTime_45(id0); }

  private native double GetRenderTime_46();
  public double GetRenderTime()
    { return GetRenderTime_46(); }

  private native vtkDataSet GetInputAsDataSet_47();
  public vtkDataSet GetInputAsDataSet()
    { return GetInputAsDataSet_47(); }

  public vtkMapper() { super(); };

  protected vtkMapper(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
