// java wrapper for vtkMath object
//

package vtk;
import vtk.*;

public class vtkMath extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native double Pi_2();
  public double Pi()
    { return Pi_2(); }

  private native double DegreesToRadians_3();
  public double DegreesToRadians()
    { return DegreesToRadians_3(); }

  private native double DoubleDegreesToRadians_4();
  public double DoubleDegreesToRadians()
    { return DoubleDegreesToRadians_4(); }

  private native double Dot_5(double id0[],double id1[]);
  public double Dot(double id0[],double id1[])
    { return Dot_5(id0,id1); }

  private native double Norm_6(double id0[]);
  public double Norm(double id0[])
    { return Norm_6(id0); }

  private native double Distance2BetweenPoints_7(double id0[],double id1[]);
  public double Distance2BetweenPoints(double id0[],double id1[])
    { return Distance2BetweenPoints_7(id0,id1); }

  private native double Dot2D_8(double id0[],double id1[]);
  public double Dot2D(double id0[],double id1[])
    { return Dot2D_8(id0,id1); }

  private native double Norm2D_9(double id0[]);
  public double Norm2D(double id0[])
    { return Norm2D_9(id0); }

  private native double Determinant2x2_10(double id0[],double id1[]);
  public double Determinant2x2(double id0[],double id1[])
    { return Determinant2x2_10(id0,id1); }

  private native double Determinant2x2_11(double id0,double id1,double id2,double id3);
  public double Determinant2x2(double id0,double id1,double id2,double id3)
    { return Determinant2x2_11(id0,id1,id2,id3); }

  private native double Determinant3x3_12(double id0[],double id1[],double id2[]);
  public double Determinant3x3(double id0[],double id1[],double id2[])
    { return Determinant3x3_12(id0,id1,id2); }

  private native double Determinant3x3_13(double id0,double id1,double id2,double id3,double id4,double id5,double id6,double id7,double id8);
  public double Determinant3x3(double id0,double id1,double id2,double id3,double id4,double id5,double id6,double id7,double id8)
    { return Determinant3x3_13(id0,id1,id2,id3,id4,id5,id6,id7,id8); }

  private native void RandomSeed_14(int id0);
  public void RandomSeed(int id0)
    { RandomSeed_14(id0); }

  private native double Random_15();
  public double Random()
    { return Random_15(); }

  private native double Random_16(double id0,double id1);
  public double Random(double id0,double id1)
    { return Random_16(id0,id1); }

  private native double[] SolveCubic_17(double id0,double id1,double id2,double id3);
  public double[] SolveCubic(double id0,double id1,double id2,double id3)
    { return SolveCubic_17(id0,id1,id2,id3); }

  private native double[] SolveQuadratic_18(double id0,double id1,double id2);
  public double[] SolveQuadratic(double id0,double id1,double id2)
    { return SolveQuadratic_18(id0,id1,id2); }

  public vtkMath() { super(); };

  protected vtkMath(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
