// java wrapper for vtkMatrix4x4 object
//

package vtk;
import vtk.*;

public class vtkMatrix4x4 extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void DeepCopy_2(vtkMatrix4x4 id0);
  public void DeepCopy(vtkMatrix4x4 id0)
    { DeepCopy_2(id0); }

  private native void DeepCopy_3(double id0[]);
  public void DeepCopy(double id0[])
    { DeepCopy_3(id0); }

  private native void Zero_4();
  public void Zero()
    { Zero_4(); }

  private native void Identity_5();
  public void Identity()
    { Identity_5(); }

  private native void Invert_6(vtkMatrix4x4 id0,vtkMatrix4x4 id1);
  public void Invert(vtkMatrix4x4 id0,vtkMatrix4x4 id1)
    { Invert_6(id0,id1); }

  private native void Invert_7();
  public void Invert()
    { Invert_7(); }

  private native void Transpose_8(vtkMatrix4x4 id0,vtkMatrix4x4 id1);
  public void Transpose(vtkMatrix4x4 id0,vtkMatrix4x4 id1)
    { Transpose_8(id0,id1); }

  private native void Transpose_9();
  public void Transpose()
    { Transpose_9(); }

  private native double[] MultiplyPoint_10(double id0[]);
  public double[] MultiplyPoint(double id0[])
    { return MultiplyPoint_10(id0); }

  private native double[] MultiplyFloatPoint_11(double id0[]);
  public double[] MultiplyFloatPoint(double id0[])
    { return MultiplyFloatPoint_11(id0); }

  private native double[] MultiplyDoublePoint_12(double id0[]);
  public double[] MultiplyDoublePoint(double id0[])
    { return MultiplyDoublePoint_12(id0); }

  private native void Multiply4x4_13(vtkMatrix4x4 id0,vtkMatrix4x4 id1,vtkMatrix4x4 id2);
  public void Multiply4x4(vtkMatrix4x4 id0,vtkMatrix4x4 id1,vtkMatrix4x4 id2)
    { Multiply4x4_13(id0,id1,id2); }

  private native void Adjoint_14(vtkMatrix4x4 id0,vtkMatrix4x4 id1);
  public void Adjoint(vtkMatrix4x4 id0,vtkMatrix4x4 id1)
    { Adjoint_14(id0,id1); }

  private native double Determinant_15();
  public double Determinant()
    { return Determinant_15(); }

  private native void SetElement_16(int id0,int id1,double id2);
  public void SetElement(int id0,int id1,double id2)
    { SetElement_16(id0,id1,id2); }

  private native double GetElement_17(int id0,int id1);
  public double GetElement(int id0,int id1)
    { return GetElement_17(id0,id1); }

  public vtkMatrix4x4() { super(); };

  protected vtkMatrix4x4(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
