// java wrapper for vtkObjectFactory object
//

package vtk;
import vtk.*;

public class vtkObjectFactory extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native vtkObject CreateInstance_2(String id0);
  public vtkObject CreateInstance(String id0)
    { return CreateInstance_2(id0); }

  private native void ReHash_3();
  public void ReHash()
    { ReHash_3(); }

  private native void RegisterFactory_4(vtkObjectFactory id0);
  public void RegisterFactory(vtkObjectFactory id0)
    { RegisterFactory_4(id0); }

  private native void UnRegisterFactory_5(vtkObjectFactory id0);
  public void UnRegisterFactory(vtkObjectFactory id0)
    { UnRegisterFactory_5(id0); }

  private native void UnRegisterAllFactories_6();
  public void UnRegisterAllFactories()
    { UnRegisterAllFactories_6(); }

  private native vtkObjectFactoryCollection GetRegisteredFactories_7();
  public vtkObjectFactoryCollection GetRegisteredFactories()
    { return GetRegisteredFactories_7(); }

  private native int GetNumberOfOverrides_8();
  public int GetNumberOfOverrides()
    { return GetNumberOfOverrides_8(); }

  private native String GetClassOverrideName_9(int id0);
  public String GetClassOverrideName(int id0)
    { return GetClassOverrideName_9(id0); }

  private native String GetClassOverrideWithName_10(int id0);
  public String GetClassOverrideWithName(int id0)
    { return GetClassOverrideWithName_10(id0); }

  private native int GetEnableFlag_11(int id0);
  public int GetEnableFlag(int id0)
    { return GetEnableFlag_11(id0); }

  private native String GetDescription_12(int id0);
  public String GetDescription(int id0)
    { return GetDescription_12(id0); }

  private native void SetEnableFlag_13(int id0,String id1,String id2);
  public void SetEnableFlag(int id0,String id1,String id2)
    { SetEnableFlag_13(id0,id1,id2); }

  private native int GetEnableFlag_14(String id0,String id1);
  public int GetEnableFlag(String id0,String id1)
    { return GetEnableFlag_14(id0,id1); }

  private native void Disable_15(String id0);
  public void Disable(String id0)
    { Disable_15(id0); }

  private native String GetLibraryPath_16();
  public String GetLibraryPath()
    { return GetLibraryPath_16(); }

  public vtkObjectFactory() { super(); };

  protected vtkObjectFactory(int dmy) { super(dmy); };
  protected native void   VTKCastInit();

}
