// java wrapper for vtkPolyData object
//

package vtk;
import vtk.*;

public class vtkPolyData extends vtkPointSet
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native vtkDataObject MakeObject_2();
  public vtkDataObject MakeObject()
    { return MakeObject_2(); }

  private native int GetDataObjectType_3();
  public int GetDataObjectType()
    { return GetDataObjectType_3(); }

  private native void CopyStructure_4(vtkDataSet id0);
  public void CopyStructure(vtkDataSet id0)
    { CopyStructure_4(id0); }

  private native int GetNumberOfCells_5();
  public int GetNumberOfCells()
    { return GetNumberOfCells_5(); }

  private native vtkCell GetCell_6(int id0);
  public vtkCell GetCell(int id0)
    { return GetCell_6(id0); }

  private native void GetCell_7(int id0,vtkGenericCell id1);
  public void GetCell(int id0,vtkGenericCell id1)
    { GetCell_7(id0,id1); }

  private native int GetCellType_8(int id0);
  public int GetCellType(int id0)
    { return GetCellType_8(id0); }

  private native void GetCellNeighbors_9(int id0,vtkIdList id1,vtkIdList id2);
  public void GetCellNeighbors(int id0,vtkIdList id1,vtkIdList id2)
    { GetCellNeighbors_9(id0,id1,id2); }

  private native void CopyCells_10(vtkPolyData id0,vtkIdList id1,vtkPointLocator id2);
  public void CopyCells(vtkPolyData id0,vtkIdList id1,vtkPointLocator id2)
    { CopyCells_10(id0,id1,id2); }

  private native void GetCellPoints_11(int id0,vtkIdList id1);
  public void GetCellPoints(int id0,vtkIdList id1)
    { GetCellPoints_11(id0,id1); }

  private native void GetPointCells_12(int id0,vtkIdList id1);
  public void GetPointCells(int id0,vtkIdList id1)
    { GetPointCells_12(id0,id1); }

  private native void ComputeBounds_13();
  public void ComputeBounds()
    { ComputeBounds_13(); }

  private native void Squeeze_14();
  public void Squeeze()
    { Squeeze_14(); }

  private native int GetMaxCellSize_15();
  public int GetMaxCellSize()
    { return GetMaxCellSize_15(); }

  private native void SetVerts_16(vtkCellArray id0);
  public void SetVerts(vtkCellArray id0)
    { SetVerts_16(id0); }

  private native vtkCellArray GetVerts_17();
  public vtkCellArray GetVerts()
    { return GetVerts_17(); }

  private native void SetLines_18(vtkCellArray id0);
  public void SetLines(vtkCellArray id0)
    { SetLines_18(id0); }

  private native vtkCellArray GetLines_19();
  public vtkCellArray GetLines()
    { return GetLines_19(); }

  private native void SetPolys_20(vtkCellArray id0);
  public void SetPolys(vtkCellArray id0)
    { SetPolys_20(id0); }

  private native vtkCellArray GetPolys_21();
  public vtkCellArray GetPolys()
    { return GetPolys_21(); }

  private native void SetStrips_22(vtkCellArray id0);
  public void SetStrips(vtkCellArray id0)
    { SetStrips_22(id0); }

  private native vtkCellArray GetStrips_23();
  public vtkCellArray GetStrips()
    { return GetStrips_23(); }

  private native int GetNumberOfVerts_24();
  public int GetNumberOfVerts()
    { return GetNumberOfVerts_24(); }

  private native int GetNumberOfLines_25();
  public int GetNumberOfLines()
    { return GetNumberOfLines_25(); }

  private native int GetNumberOfPolys_26();
  public int GetNumberOfPolys()
    { return GetNumberOfPolys_26(); }

  private native int GetNumberOfStrips_27();
  public int GetNumberOfStrips()
    { return GetNumberOfStrips_27(); }

  private native void Allocate_28(int id0,int id1);
  public void Allocate(int id0,int id1)
    { Allocate_28(id0,id1); }

  private native int InsertNextCell_29(int id0,vtkIdList id1);
  public int InsertNextCell(int id0,vtkIdList id1)
    { return InsertNextCell_29(id0,id1); }

  private native void Reset_30();
  public void Reset()
    { Reset_30(); }

  private native void BuildCells_31();
  public void BuildCells()
    { BuildCells_31(); }

  private native void BuildLinks_32();
  public void BuildLinks()
    { BuildLinks_32(); }

  private native void DeleteCells_33();
  public void DeleteCells()
    { DeleteCells_33(); }

  private native void DeleteLinks_34();
  public void DeleteLinks()
    { DeleteLinks_34(); }

  private native void GetCellEdgeNeighbors_35(int id0,int id1,int id2,vtkIdList id3);
  public void GetCellEdgeNeighbors(int id0,int id1,int id2,vtkIdList id3)
    { GetCellEdgeNeighbors_35(id0,id1,id2,id3); }

  private native int IsTriangle_36(int id0,int id1,int id2);
  public int IsTriangle(int id0,int id1,int id2)
    { return IsTriangle_36(id0,id1,id2); }

  private native int IsEdge_37(int id0,int id1);
  public int IsEdge(int id0,int id1)
    { return IsEdge_37(id0,id1); }

  private native int IsPointUsedByCell_38(int id0,int id1);
  public int IsPointUsedByCell(int id0,int id1)
    { return IsPointUsedByCell_38(id0,id1); }

  private native void ReplaceCellPoint_39(int id0,int id1,int id2);
  public void ReplaceCellPoint(int id0,int id1,int id2)
    { ReplaceCellPoint_39(id0,id1,id2); }

  private native void ReverseCell_40(int id0);
  public void ReverseCell(int id0)
    { ReverseCell_40(id0); }

  private native void DeletePoint_41(int id0);
  public void DeletePoint(int id0)
    { DeletePoint_41(id0); }

  private native void DeleteCell_42(int id0);
  public void DeleteCell(int id0)
    { DeleteCell_42(id0); }

  private native void RemoveCellReference_43(int id0);
  public void RemoveCellReference(int id0)
    { RemoveCellReference_43(id0); }

  private native void AddCellReference_44(int id0);
  public void AddCellReference(int id0)
    { AddCellReference_44(id0); }

  private native void RemoveReferenceToCell_45(int id0,int id1);
  public void RemoveReferenceToCell(int id0,int id1)
    { RemoveReferenceToCell_45(id0,id1); }

  private native void AddReferenceToCell_46(int id0,int id1);
  public void AddReferenceToCell(int id0,int id1)
    { AddReferenceToCell_46(id0,id1); }

  private native void ResizeCellList_47(int id0,int id1);
  public void ResizeCellList(int id0,int id1)
    { ResizeCellList_47(id0,id1); }

  private native void Initialize_48();
  public void Initialize()
    { Initialize_48(); }

  private native void SetUpdateExtent_49(int id0,int id1,int id2);
  public void SetUpdateExtent(int id0,int id1,int id2)
    { SetUpdateExtent_49(id0,id1,id2); }

  private native void SetUpdateExtent_50(int id0,int id1);
  public void SetUpdateExtent(int id0,int id1)
    { SetUpdateExtent_50(id0,id1); }

  private native int[]  GetUpdateExtent_51();
  public int[]  GetUpdateExtent()
    { return GetUpdateExtent_51(); }

  private native void SetUpdateExtent_52(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetUpdateExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetUpdateExtent_52(id0,id1,id2,id3,id4,id5); }

  private native int GetPiece_53();
  public int GetPiece()
    { return GetPiece_53(); }

  private native int GetNumberOfPieces_54();
  public int GetNumberOfPieces()
    { return GetNumberOfPieces_54(); }

  private native int GetGhostLevel_55();
  public int GetGhostLevel()
    { return GetGhostLevel_55(); }

  private native int GetActualMemorySize_56();
  public int GetActualMemorySize()
    { return GetActualMemorySize_56(); }

  private native void ShallowCopy_57(vtkDataObject id0);
  public void ShallowCopy(vtkDataObject id0)
    { ShallowCopy_57(id0); }

  private native void DeepCopy_58(vtkDataObject id0);
  public void DeepCopy(vtkDataObject id0)
    { DeepCopy_58(id0); }

  public vtkPolyData() { super(); };

  protected vtkPolyData(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
