// java wrapper for vtkPolyDataConnectivityFilter object
//

package vtk;
import vtk.*;

public class vtkPolyDataConnectivityFilter extends vtkPolyDataToPolyDataFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetScalarConnectivity_2(int id0);
  public void SetScalarConnectivity(int id0)
    { SetScalarConnectivity_2(id0); }

  private native int GetScalarConnectivity_3();
  public int GetScalarConnectivity()
    { return GetScalarConnectivity_3(); }

  private native void ScalarConnectivityOn_4();
  public void ScalarConnectivityOn()
    { ScalarConnectivityOn_4(); }

  private native void ScalarConnectivityOff_5();
  public void ScalarConnectivityOff()
    { ScalarConnectivityOff_5(); }

  private native void SetScalarRange_6(double id0[]);
  public void SetScalarRange(double id0[])
    { SetScalarRange_6(id0); }

  private native double[] GetScalarRange_7();
  public double[] GetScalarRange()
    { return GetScalarRange_7(); }

  private native void SetExtractionMode_8(int id0);
  public void SetExtractionMode(int id0)
    { SetExtractionMode_8(id0); }

  private native int GetExtractionMode_9();
  public int GetExtractionMode()
    { return GetExtractionMode_9(); }

  private native void SetExtractionModeToPointSeededRegions_10();
  public void SetExtractionModeToPointSeededRegions()
    { SetExtractionModeToPointSeededRegions_10(); }

  private native void SetExtractionModeToCellSeededRegions_11();
  public void SetExtractionModeToCellSeededRegions()
    { SetExtractionModeToCellSeededRegions_11(); }

  private native void SetExtractionModeToLargestRegion_12();
  public void SetExtractionModeToLargestRegion()
    { SetExtractionModeToLargestRegion_12(); }

  private native void SetExtractionModeToSpecifiedRegions_13();
  public void SetExtractionModeToSpecifiedRegions()
    { SetExtractionModeToSpecifiedRegions_13(); }

  private native void SetExtractionModeToClosestPointRegion_14();
  public void SetExtractionModeToClosestPointRegion()
    { SetExtractionModeToClosestPointRegion_14(); }

  private native void SetExtractionModeToAllRegions_15();
  public void SetExtractionModeToAllRegions()
    { SetExtractionModeToAllRegions_15(); }

  private native String GetExtractionModeAsString_16();
  public String GetExtractionModeAsString()
    { return GetExtractionModeAsString_16(); }

  private native void InitializeSeedList_17();
  public void InitializeSeedList()
    { InitializeSeedList_17(); }

  private native void AddSeed_18(int id0);
  public void AddSeed(int id0)
    { AddSeed_18(id0); }

  private native void DeleteSeed_19(int id0);
  public void DeleteSeed(int id0)
    { DeleteSeed_19(id0); }

  private native void InitializeSpecifiedRegionList_20();
  public void InitializeSpecifiedRegionList()
    { InitializeSpecifiedRegionList_20(); }

  private native void AddSpecifiedRegion_21(int id0);
  public void AddSpecifiedRegion(int id0)
    { AddSpecifiedRegion_21(id0); }

  private native void DeleteSpecifiedRegion_22(int id0);
  public void DeleteSpecifiedRegion(int id0)
    { DeleteSpecifiedRegion_22(id0); }

  private native void SetClosestPoint_23(double id0,double id1,double id2);
  public void SetClosestPoint(double id0,double id1,double id2)
    { SetClosestPoint_23(id0,id1,id2); }

  private native void SetClosestPoint_24(double id0[]);
  public void SetClosestPoint(double id0[])
    { SetClosestPoint_24(id0); }

  private native double[] GetClosestPoint_25();
  public double[] GetClosestPoint()
    { return GetClosestPoint_25(); }

  private native int GetNumberOfExtractedRegions_26();
  public int GetNumberOfExtractedRegions()
    { return GetNumberOfExtractedRegions_26(); }

  private native void SetColorRegions_27(int id0);
  public void SetColorRegions(int id0)
    { SetColorRegions_27(id0); }

  private native int GetColorRegions_28();
  public int GetColorRegions()
    { return GetColorRegions_28(); }

  private native void ColorRegionsOn_29();
  public void ColorRegionsOn()
    { ColorRegionsOn_29(); }

  private native void ColorRegionsOff_30();
  public void ColorRegionsOff()
    { ColorRegionsOff_30(); }

  private native void SetMaxRecursionDepth_31(int id0);
  public void SetMaxRecursionDepth(int id0)
    { SetMaxRecursionDepth_31(id0); }

  private native int GetMaxRecursionDepth_32();
  public int GetMaxRecursionDepth()
    { return GetMaxRecursionDepth_32(); }

  public vtkPolyDataConnectivityFilter() { super(); };

  protected vtkPolyDataConnectivityFilter(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
