// java wrapper for vtkPolyDataMapper2D object
//

package vtk;
import vtk.*;

public class vtkPolyDataMapper2D extends vtkMapper2D
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetInput_2(vtkPolyData id0);
  public void SetInput(vtkPolyData id0)
    { SetInput_2(id0); }

  private native vtkPolyData GetInput_3();
  public vtkPolyData GetInput()
    { return GetInput_3(); }

  private native void SetLookupTable_4(vtkScalarsToColors id0);
  public void SetLookupTable(vtkScalarsToColors id0)
    { SetLookupTable_4(id0); }

  private native vtkScalarsToColors GetLookupTable_5();
  public vtkScalarsToColors GetLookupTable()
    { return GetLookupTable_5(); }

  private native void CreateDefaultLookupTable_6();
  public void CreateDefaultLookupTable()
    { CreateDefaultLookupTable_6(); }

  private native void SetScalarVisibility_7(int id0);
  public void SetScalarVisibility(int id0)
    { SetScalarVisibility_7(id0); }

  private native int GetScalarVisibility_8();
  public int GetScalarVisibility()
    { return GetScalarVisibility_8(); }

  private native void ScalarVisibilityOn_9();
  public void ScalarVisibilityOn()
    { ScalarVisibilityOn_9(); }

  private native void ScalarVisibilityOff_10();
  public void ScalarVisibilityOff()
    { ScalarVisibilityOff_10(); }

  private native void SetColorMode_11(int id0);
  public void SetColorMode(int id0)
    { SetColorMode_11(id0); }

  private native int GetColorMode_12();
  public int GetColorMode()
    { return GetColorMode_12(); }

  private native void SetColorModeToDefault_13();
  public void SetColorModeToDefault()
    { SetColorModeToDefault_13(); }

  private native void SetColorModeToMapScalars_14();
  public void SetColorModeToMapScalars()
    { SetColorModeToMapScalars_14(); }

  private native void SetColorModeToLuminance_15();
  public void SetColorModeToLuminance()
    { SetColorModeToLuminance_15(); }

  private native String GetColorModeAsString_16();
  public String GetColorModeAsString()
    { return GetColorModeAsString_16(); }

  private native void SetScalarRange_17(double id0,double id1);
  public void SetScalarRange(double id0,double id1)
    { SetScalarRange_17(id0,id1); }

  private native void SetScalarRange_18(double id0[]);
  public void SetScalarRange(double id0[])
    { SetScalarRange_18(id0); }

  private native double[] GetScalarRange_19();
  public double[] GetScalarRange()
    { return GetScalarRange_19(); }

  private native vtkScalars GetColors_20();
  public vtkScalars GetColors()
    { return GetColors_20(); }

  private native int GetMTime_21();
  public int GetMTime()
    { return GetMTime_21(); }

  private native void SetTransformCoordinate_22(vtkCoordinate id0);
  public void SetTransformCoordinate(vtkCoordinate id0)
    { SetTransformCoordinate_22(id0); }

  private native vtkCoordinate GetTransformCoordinate_23();
  public vtkCoordinate GetTransformCoordinate()
    { return GetTransformCoordinate_23(); }

  private native void ShallowCopy_24(vtkPolyDataMapper2D id0);
  public void ShallowCopy(vtkPolyDataMapper2D id0)
    { ShallowCopy_24(id0); }

  public vtkPolyDataMapper2D() { super(); };

  protected vtkPolyDataMapper2D(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
