// java wrapper for vtkRenderWindow object
//

package vtk;
import vtk.*;

public class vtkRenderWindow extends vtkWindow
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void AddRenderer_2(vtkRenderer id0);
  public void AddRenderer(vtkRenderer id0)
    { AddRenderer_2(id0); }

  private native void RemoveRenderer_3(vtkRenderer id0);
  public void RemoveRenderer(vtkRenderer id0)
    { RemoveRenderer_3(id0); }

  private native String GetRenderLibrary_4();
  public String GetRenderLibrary()
    { return GetRenderLibrary_4(); }

  private native vtkRendererCollection GetRenderers_5();
  public vtkRendererCollection GetRenderers()
    { return GetRenderers_5(); }

  private native void Render_6();
  public void Render()
    { Render_6(); }

  private native void Start_7();
  public void Start()
    { Start_7(); }

  private native void Frame_8();
  public void Frame()
    { Frame_8(); }

  private native void CopyResultFrame_9();
  public void CopyResultFrame()
    { CopyResultFrame_9(); }

  private native vtkRenderWindowInteractor MakeRenderWindowInteractor_10();
  public vtkRenderWindowInteractor MakeRenderWindowInteractor()
    { return MakeRenderWindowInteractor_10(); }

  private native void HideCursor_11();
  public void HideCursor()
    { HideCursor_11(); }

  private native void ShowCursor_12();
  public void ShowCursor()
    { ShowCursor_12(); }

  private native void SetFullScreen_13(int id0);
  public void SetFullScreen(int id0)
    { SetFullScreen_13(id0); }

  private native int GetFullScreen_14();
  public int GetFullScreen()
    { return GetFullScreen_14(); }

  private native void FullScreenOn_15();
  public void FullScreenOn()
    { FullScreenOn_15(); }

  private native void FullScreenOff_16();
  public void FullScreenOff()
    { FullScreenOff_16(); }

  private native void SetBorders_17(int id0);
  public void SetBorders(int id0)
    { SetBorders_17(id0); }

  private native int GetBorders_18();
  public int GetBorders()
    { return GetBorders_18(); }

  private native void BordersOn_19();
  public void BordersOn()
    { BordersOn_19(); }

  private native void BordersOff_20();
  public void BordersOff()
    { BordersOff_20(); }

  private native int GetStereoCapableWindow_21();
  public int GetStereoCapableWindow()
    { return GetStereoCapableWindow_21(); }

  private native void StereoCapableWindowOn_22();
  public void StereoCapableWindowOn()
    { StereoCapableWindowOn_22(); }

  private native void StereoCapableWindowOff_23();
  public void StereoCapableWindowOff()
    { StereoCapableWindowOff_23(); }

  private native void SetStereoCapableWindow_24(int id0);
  public void SetStereoCapableWindow(int id0)
    { SetStereoCapableWindow_24(id0); }

  private native int GetStereoRender_25();
  public int GetStereoRender()
    { return GetStereoRender_25(); }

  private native void SetStereoRender_26(int id0);
  public void SetStereoRender(int id0)
    { SetStereoRender_26(id0); }

  private native void StereoRenderOn_27();
  public void StereoRenderOn()
    { StereoRenderOn_27(); }

  private native void StereoRenderOff_28();
  public void StereoRenderOff()
    { StereoRenderOff_28(); }

  private native void SetPointSmoothing_29(int id0);
  public void SetPointSmoothing(int id0)
    { SetPointSmoothing_29(id0); }

  private native int GetPointSmoothing_30();
  public int GetPointSmoothing()
    { return GetPointSmoothing_30(); }

  private native void PointSmoothingOn_31();
  public void PointSmoothingOn()
    { PointSmoothingOn_31(); }

  private native void PointSmoothingOff_32();
  public void PointSmoothingOff()
    { PointSmoothingOff_32(); }

  private native void SetLineSmoothing_33(int id0);
  public void SetLineSmoothing(int id0)
    { SetLineSmoothing_33(id0); }

  private native int GetLineSmoothing_34();
  public int GetLineSmoothing()
    { return GetLineSmoothing_34(); }

  private native void LineSmoothingOn_35();
  public void LineSmoothingOn()
    { LineSmoothingOn_35(); }

  private native void LineSmoothingOff_36();
  public void LineSmoothingOff()
    { LineSmoothingOff_36(); }

  private native void SetPolygonSmoothing_37(int id0);
  public void SetPolygonSmoothing(int id0)
    { SetPolygonSmoothing_37(id0); }

  private native int GetPolygonSmoothing_38();
  public int GetPolygonSmoothing()
    { return GetPolygonSmoothing_38(); }

  private native void PolygonSmoothingOn_39();
  public void PolygonSmoothingOn()
    { PolygonSmoothingOn_39(); }

  private native void PolygonSmoothingOff_40();
  public void PolygonSmoothingOff()
    { PolygonSmoothingOff_40(); }

  private native int GetStereoType_41();
  public int GetStereoType()
    { return GetStereoType_41(); }

  private native void SetStereoType_42(int id0);
  public void SetStereoType(int id0)
    { SetStereoType_42(id0); }

  private native void SetStereoTypeToCrystalEyes_43();
  public void SetStereoTypeToCrystalEyes()
    { SetStereoTypeToCrystalEyes_43(); }

  private native void SetStereoTypeToRedBlue_44();
  public void SetStereoTypeToRedBlue()
    { SetStereoTypeToRedBlue_44(); }

  private native void SetStereoTypeToInterlaced_45();
  public void SetStereoTypeToInterlaced()
    { SetStereoTypeToInterlaced_45(); }

  private native void SetStereoTypeToLeft_46();
  public void SetStereoTypeToLeft()
    { SetStereoTypeToLeft_46(); }

  private native void SetStereoTypeToRight_47();
  public void SetStereoTypeToRight()
    { SetStereoTypeToRight_47(); }

  private native void SetStereoTypeToDresden_48();
  public void SetStereoTypeToDresden()
    { SetStereoTypeToDresden_48(); }

  private native String GetStereoTypeAsString_49();
  public String GetStereoTypeAsString()
    { return GetStereoTypeAsString_49(); }

  private native void StereoUpdate_50();
  public void StereoUpdate()
    { StereoUpdate_50(); }

  private native void StereoMidpoint_51();
  public void StereoMidpoint()
    { StereoMidpoint_51(); }

  private native void StereoRenderComplete_52();
  public void StereoRenderComplete()
    { StereoRenderComplete_52(); }

  private native void WindowRemap_53();
  public void WindowRemap()
    { WindowRemap_53(); }

  private native void SetSwapBuffers_54(int id0);
  public void SetSwapBuffers(int id0)
    { SetSwapBuffers_54(id0); }

  private native int GetSwapBuffers_55();
  public int GetSwapBuffers()
    { return GetSwapBuffers_55(); }

  private native void SwapBuffersOn_56();
  public void SwapBuffersOn()
    { SwapBuffersOn_56(); }

  private native void SwapBuffersOff_57();
  public void SwapBuffersOff()
    { SwapBuffersOff_57(); }

  private native void SetFileName_58(String id0);
  public void SetFileName(String id0)
    { SetFileName_58(id0); }

  private native String GetFileName_59();
  public String GetFileName()
    { return GetFileName_59(); }

  private native void SaveImageAsPPM_60();
  public void SaveImageAsPPM()
    { SaveImageAsPPM_60(); }

  private native int OpenPPMImageFile_61();
  public int OpenPPMImageFile()
    { return OpenPPMImageFile_61(); }

  private native void WritePPMImageFile_62();
  public void WritePPMImageFile()
    { WritePPMImageFile_62(); }

  private native void ClosePPMImageFile_63();
  public void ClosePPMImageFile()
    { ClosePPMImageFile_63(); }

  private native int GetAAFrames_64();
  public int GetAAFrames()
    { return GetAAFrames_64(); }

  private native void SetAAFrames_65(int id0);
  public void SetAAFrames(int id0)
    { SetAAFrames_65(id0); }

  private native int GetFDFrames_66();
  public int GetFDFrames()
    { return GetFDFrames_66(); }

  private native void SetFDFrames_67(int id0);
  public void SetFDFrames(int id0)
    { SetFDFrames_67(id0); }

  private native int GetSubFrames_68();
  public int GetSubFrames()
    { return GetSubFrames_68(); }

  private native void SetSubFrames_69(int id0);
  public void SetSubFrames(int id0)
    { SetSubFrames_69(id0); }

  private native int GetNeverRendered_70();
  public int GetNeverRendered()
    { return GetNeverRendered_70(); }

  private native int GetAbortRender_71();
  public int GetAbortRender()
    { return GetAbortRender_71(); }

  private native void SetAbortRender_72(int id0);
  public void SetAbortRender(int id0)
    { SetAbortRender_72(id0); }

  private native int GetInAbortCheck_73();
  public int GetInAbortCheck()
    { return GetInAbortCheck_73(); }

  private native void SetInAbortCheck_74(int id0);
  public void SetInAbortCheck(int id0)
    { SetInAbortCheck_74(id0); }

  private native int CheckAbortStatus_75();
  public int CheckAbortStatus()
    { return CheckAbortStatus_75(); }

  private native int GetEventPending_76();
  public int GetEventPending()
    { return GetEventPending_76(); }

  private native void SetAbortCheckMethod_77(Object id0, String id1);
  public void SetAbortCheckMethod(Object id0, String id1)
    { SetAbortCheckMethod_77(id0,id1); }

  private native void SetDesiredUpdateRate_78(double id0);
  public void SetDesiredUpdateRate(double id0)
    { SetDesiredUpdateRate_78(id0); }

  private native double GetDesiredUpdateRate_79();
  public double GetDesiredUpdateRate()
    { return GetDesiredUpdateRate_79(); }

  private native int GetNumLayers_80();
  public int GetNumLayers()
    { return GetNumLayers_80(); }

  private native void SetNumLayers_81(int id0);
  public void SetNumLayers(int id0)
    { SetNumLayers_81(id0); }

  private native vtkRenderWindowInteractor GetInteractor_82();
  public vtkRenderWindowInteractor GetInteractor()
    { return GetInteractor_82(); }

  private native void SetInteractor_83(vtkRenderWindowInteractor id0);
  public void SetInteractor(vtkRenderWindowInteractor id0)
    { SetInteractor_83(id0); }

  private native void UnRegister_84(vtkObject id0);
  public void UnRegister(vtkObject id0)
    { UnRegister_84(id0); }

  private native void SetWindowInfo_85(String id0);
  public void SetWindowInfo(String id0)
    { SetWindowInfo_85(id0); }

  private native void MakeCurrent_86();
  public void MakeCurrent()
    { MakeCurrent_86(); }

  private native int GetDepthBufferSize_87();
  public int GetDepthBufferSize()
    { return GetDepthBufferSize_87(); }

  public vtkRenderWindow() { super(); };

  protected vtkRenderWindow(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
