// java wrapper for vtkRenderWindowInteractor object
//

package vtk;
import vtk.*;

public class vtkRenderWindowInteractor extends vtkObject
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void Initialize_2();
  public void Initialize()
    { Initialize_2(); }

  private native void UnRegister_3(vtkObject id0);
  public void UnRegister(vtkObject id0)
    { UnRegister_3(id0); }

  private native void Start_4();
  public void Start()
    { Start_4(); }

  private native void Enable_5();
  public void Enable()
    { Enable_5(); }

  private native void Disable_6();
  public void Disable()
    { Disable_6(); }

  private native int GetEnabled_7();
  public int GetEnabled()
    { return GetEnabled_7(); }

  private native void SetRenderWindow_8(vtkRenderWindow id0);
  public void SetRenderWindow(vtkRenderWindow id0)
    { SetRenderWindow_8(id0); }

  private native vtkRenderWindow GetRenderWindow_9();
  public vtkRenderWindow GetRenderWindow()
    { return GetRenderWindow_9(); }

  private native void UpdateSize_10(int id0,int id1);
  public void UpdateSize(int id0,int id1)
    { UpdateSize_10(id0,id1); }

  private native void SetSize_11(int id0,int id1);
  public void SetSize(int id0,int id1)
    { SetSize_11(id0,id1); }

  private native void SetSize_12(int id0[]);
  public void SetSize(int id0[])
    { SetSize_12(id0); }

  private native int[]  GetSize_13();
  public int[]  GetSize()
    { return GetSize_13(); }

  private native int CreateTimer_14(int id0);
  public int CreateTimer(int id0)
    { return CreateTimer_14(id0); }

  private native int DestroyTimer_15();
  public int DestroyTimer()
    { return DestroyTimer_15(); }

  private native void TerminateApp_16();
  public void TerminateApp()
    { TerminateApp_16(); }

  private native void SetInteractorStyle_17(vtkInteractorStyle id0);
  public void SetInteractorStyle(vtkInteractorStyle id0)
    { SetInteractorStyle_17(id0); }

  private native vtkInteractorStyle GetInteractorStyle_18();
  public vtkInteractorStyle GetInteractorStyle()
    { return GetInteractorStyle_18(); }

  private native void SetLightFollowCamera_19(int id0);
  public void SetLightFollowCamera(int id0)
    { SetLightFollowCamera_19(id0); }

  private native int GetLightFollowCamera_20();
  public int GetLightFollowCamera()
    { return GetLightFollowCamera_20(); }

  private native void LightFollowCameraOn_21();
  public void LightFollowCameraOn()
    { LightFollowCameraOn_21(); }

  private native void LightFollowCameraOff_22();
  public void LightFollowCameraOff()
    { LightFollowCameraOff_22(); }

  private native void SetEventPosition_23(int id0,int id1);
  public void SetEventPosition(int id0,int id1)
    { SetEventPosition_23(id0,id1); }

  private native void SetEventPosition_24(int id0[]);
  public void SetEventPosition(int id0[])
    { SetEventPosition_24(id0); }

  private native int[]  GetEventPosition_25();
  public int[]  GetEventPosition()
    { return GetEventPosition_25(); }

  private native void SetDesiredUpdateRate_26(double id0);
  public void SetDesiredUpdateRate(double id0)
    { SetDesiredUpdateRate_26(id0); }

  private native double GetDesiredUpdateRate_27();
  public double GetDesiredUpdateRate()
    { return GetDesiredUpdateRate_27(); }

  private native void SetStillUpdateRate_28(double id0);
  public void SetStillUpdateRate(double id0)
    { SetStillUpdateRate_28(id0); }

  private native double GetStillUpdateRate_29();
  public double GetStillUpdateRate()
    { return GetStillUpdateRate_29(); }

  private native int GetInitialized_30();
  public int GetInitialized()
    { return GetInitialized_30(); }

  private native void SetPicker_31(vtkAbstractPicker id0);
  public void SetPicker(vtkAbstractPicker id0)
    { SetPicker_31(id0); }

  private native vtkAbstractPicker GetPicker_32();
  public vtkAbstractPicker GetPicker()
    { return GetPicker_32(); }

  private native vtkAbstractPropPicker CreateDefaultPicker_33();
  public vtkAbstractPropPicker CreateDefaultPicker()
    { return CreateDefaultPicker_33(); }

  private native void SetStartPickMethod_34(Object id0, String id1);
  public void SetStartPickMethod(Object id0, String id1)
    { SetStartPickMethod_34(id0,id1); }

  private native void SetEndPickMethod_35(Object id0, String id1);
  public void SetEndPickMethod(Object id0, String id1)
    { SetEndPickMethod_35(id0,id1); }

  private native void SetUserMethod_36(Object id0, String id1);
  public void SetUserMethod(Object id0, String id1)
    { SetUserMethod_36(id0,id1); }

  private native void SetExitMethod_37(Object id0, String id1);
  public void SetExitMethod(Object id0, String id1)
    { SetExitMethod_37(id0,id1); }

  private native void ExitCallback_38();
  public void ExitCallback()
    { ExitCallback_38(); }

  private native void UserCallback_39();
  public void UserCallback()
    { UserCallback_39(); }

  private native void StartPickCallback_40();
  public void StartPickCallback()
    { StartPickCallback_40(); }

  private native void EndPickCallback_41();
  public void EndPickCallback()
    { EndPickCallback_41(); }

  private native void HideCursor_42();
  public void HideCursor()
    { HideCursor_42(); }

  private native void ShowCursor_43();
  public void ShowCursor()
    { ShowCursor_43(); }

  private native void Render_44();
  public void Render()
    { Render_44(); }

  public vtkRenderWindowInteractor() { super(); };

  protected vtkRenderWindowInteractor(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
