// java wrapper for vtkRenderer object
//

package vtk;
import vtk.*;

public class vtkRenderer extends vtkViewport
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void AddLight_2(vtkLight id0);
  public void AddLight(vtkLight id0)
    { AddLight_2(id0); }

  private native void AddActor_3(vtkProp id0);
  public void AddActor(vtkProp id0)
    { AddActor_3(id0); }

  private native void AddVolume_4(vtkProp id0);
  public void AddVolume(vtkProp id0)
    { AddVolume_4(id0); }

  private native void RemoveActor_5(vtkProp id0);
  public void RemoveActor(vtkProp id0)
    { RemoveActor_5(id0); }

  private native void RemoveVolume_6(vtkProp id0);
  public void RemoveVolume(vtkProp id0)
    { RemoveVolume_6(id0); }

  private native void RemoveLight_7(vtkLight id0);
  public void RemoveLight(vtkLight id0)
    { RemoveLight_7(id0); }

  private native vtkLightCollection GetLights_8();
  public vtkLightCollection GetLights()
    { return GetLights_8(); }

  private native vtkVolumeCollection GetVolumes_9();
  public vtkVolumeCollection GetVolumes()
    { return GetVolumes_9(); }

  private native vtkActorCollection GetActors_10();
  public vtkActorCollection GetActors()
    { return GetActors_10(); }

  private native void SetActiveCamera_11(vtkCamera id0);
  public void SetActiveCamera(vtkCamera id0)
    { SetActiveCamera_11(id0); }

  private native vtkCamera GetActiveCamera_12();
  public vtkCamera GetActiveCamera()
    { return GetActiveCamera_12(); }

  private native void AddCuller_13(vtkCuller id0);
  public void AddCuller(vtkCuller id0)
    { AddCuller_13(id0); }

  private native void RemoveCuller_14(vtkCuller id0);
  public void RemoveCuller(vtkCuller id0)
    { RemoveCuller_14(id0); }

  private native vtkCullerCollection GetCullers_15();
  public vtkCullerCollection GetCullers()
    { return GetCullers_15(); }

  private native void SetAmbient_16(double id0,double id1,double id2);
  public void SetAmbient(double id0,double id1,double id2)
    { SetAmbient_16(id0,id1,id2); }

  private native void SetAmbient_17(double id0[]);
  public void SetAmbient(double id0[])
    { SetAmbient_17(id0); }

  private native double[] GetAmbient_18();
  public double[] GetAmbient()
    { return GetAmbient_18(); }

  private native void SetAllocatedRenderTime_19(double id0);
  public void SetAllocatedRenderTime(double id0)
    { SetAllocatedRenderTime_19(id0); }

  private native double GetAllocatedRenderTime_20();
  public double GetAllocatedRenderTime()
    { return GetAllocatedRenderTime_20(); }

  private native double GetTimeFactor_21();
  public double GetTimeFactor()
    { return GetTimeFactor_21(); }

  private native void Render_22();
  public void Render()
    { Render_22(); }

  private native void Clear_23();
  public void Clear()
    { Clear_23(); }

  private native int VisibleActorCount_24();
  public int VisibleActorCount()
    { return VisibleActorCount_24(); }

  private native int VisibleVolumeCount_25();
  public int VisibleVolumeCount()
    { return VisibleVolumeCount_25(); }

  private native void CreateLight_26();
  public void CreateLight()
    { CreateLight_26(); }

  private native void ResetCameraClippingRange_27();
  public void ResetCameraClippingRange()
    { ResetCameraClippingRange_27(); }

  private native void ResetCameraClippingRange_28(double id0,double id1,double id2,double id3,double id4,double id5);
  public void ResetCameraClippingRange(double id0,double id1,double id2,double id3,double id4,double id5)
    { ResetCameraClippingRange_28(id0,id1,id2,id3,id4,id5); }

  private native void ResetCamera_29();
  public void ResetCamera()
    { ResetCamera_29(); }

  private native void ResetCamera_30(double id0,double id1,double id2,double id3,double id4,double id5);
  public void ResetCamera(double id0,double id1,double id2,double id3,double id4,double id5)
    { ResetCamera_30(id0,id1,id2,id3,id4,id5); }

  private native void SetRenderWindow_31(vtkRenderWindow id0);
  public void SetRenderWindow(vtkRenderWindow id0)
    { SetRenderWindow_31(id0); }

  private native vtkRenderWindow GetRenderWindow_32();
  public vtkRenderWindow GetRenderWindow()
    { return GetRenderWindow_32(); }

  private native vtkWindow GetVTKWindow_33();
  public vtkWindow GetVTKWindow()
    { return GetVTKWindow_33(); }

  private native int GetTwoSidedLighting_34();
  public int GetTwoSidedLighting()
    { return GetTwoSidedLighting_34(); }

  private native void SetTwoSidedLighting_35(int id0);
  public void SetTwoSidedLighting(int id0)
    { SetTwoSidedLighting_35(id0); }

  private native void TwoSidedLightingOn_36();
  public void TwoSidedLightingOn()
    { TwoSidedLightingOn_36(); }

  private native void TwoSidedLightingOff_37();
  public void TwoSidedLightingOff()
    { TwoSidedLightingOff_37(); }

  private native void SetBackingStore_38(int id0);
  public void SetBackingStore(int id0)
    { SetBackingStore_38(id0); }

  private native int GetBackingStore_39();
  public int GetBackingStore()
    { return GetBackingStore_39(); }

  private native void BackingStoreOn_40();
  public void BackingStoreOn()
    { BackingStoreOn_40(); }

  private native void BackingStoreOff_41();
  public void BackingStoreOff()
    { BackingStoreOff_41(); }

  private native void SetInteractive_42(int id0);
  public void SetInteractive(int id0)
    { SetInteractive_42(id0); }

  private native int GetInteractive_43();
  public int GetInteractive()
    { return GetInteractive_43(); }

  private native void InteractiveOn_44();
  public void InteractiveOn()
    { InteractiveOn_44(); }

  private native void InteractiveOff_45();
  public void InteractiveOff()
    { InteractiveOff_45(); }

  private native void SetLayer_46(int id0);
  public void SetLayer(int id0)
    { SetLayer_46(id0); }

  private native int GetLayer_47();
  public int GetLayer()
    { return GetLayer_47(); }

  private native int Transparent_48();
  public int Transparent()
    { return Transparent_48(); }

  private native void WorldToView_49();
  public void WorldToView()
    { WorldToView_49(); }

  private native void ViewToWorld_50();
  public void ViewToWorld()
    { ViewToWorld_50(); }

  private native vtkRayCaster GetRayCaster_51();
  public vtkRayCaster GetRayCaster()
    { return GetRayCaster_51(); }

  private native double GetZ_52(int id0,int id1);
  public double GetZ(int id0,int id1)
    { return GetZ_52(id0,id1); }

  private native void RenderOverlay_53();
  public void RenderOverlay()
    { RenderOverlay_53(); }

  private native int GetMTime_54();
  public int GetMTime()
    { return GetMTime_54(); }

  private native double GetLastRenderTimeInSeconds_55();
  public double GetLastRenderTimeInSeconds()
    { return GetLastRenderTimeInSeconds_55(); }

  private native void UnRegister_56(vtkObject id0);
  public void UnRegister(vtkObject id0)
    { UnRegister_56(id0); }

  private native int GetNumberOfPropsRenderedAsGeometry_57();
  public int GetNumberOfPropsRenderedAsGeometry()
    { return GetNumberOfPropsRenderedAsGeometry_57(); }

  private native vtkAssemblyPath PickProp_58(double id0,double id1);
  public vtkAssemblyPath PickProp(double id0,double id1)
    { return PickProp_58(id0,id1); }

  private native void SetLightFollowCamera_59(int id0);
  public void SetLightFollowCamera(int id0)
    { SetLightFollowCamera_59(id0); }

  private native int GetLightFollowCamera_60();
  public int GetLightFollowCamera()
    { return GetLightFollowCamera_60(); }

  private native void LightFollowCameraOn_61();
  public void LightFollowCameraOn()
    { LightFollowCameraOn_61(); }

  private native void LightFollowCameraOff_62();
  public void LightFollowCameraOff()
    { LightFollowCameraOff_62(); }

  public vtkRenderer() { super(); };

  protected vtkRenderer(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
