// java wrapper for vtkRuledSurfaceFilter object
//

package vtk;
import vtk.*;

public class vtkRuledSurfaceFilter extends vtkPolyDataToPolyDataFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetDistanceFactor_2(double id0);
  public void SetDistanceFactor(double id0)
    { SetDistanceFactor_2(id0); }

  private native double GetDistanceFactor_3();
  public double GetDistanceFactor()
    { return GetDistanceFactor_3(); }

  private native void SetOnRatio_4(int id0);
  public void SetOnRatio(int id0)
    { SetOnRatio_4(id0); }

  private native int GetOnRatio_5();
  public int GetOnRatio()
    { return GetOnRatio_5(); }

  private native void SetOffset_6(int id0);
  public void SetOffset(int id0)
    { SetOffset_6(id0); }

  private native int GetOffset_7();
  public int GetOffset()
    { return GetOffset_7(); }

  private native void SetCloseSurface_8(int id0);
  public void SetCloseSurface(int id0)
    { SetCloseSurface_8(id0); }

  private native int GetCloseSurface_9();
  public int GetCloseSurface()
    { return GetCloseSurface_9(); }

  private native void CloseSurfaceOn_10();
  public void CloseSurfaceOn()
    { CloseSurfaceOn_10(); }

  private native void CloseSurfaceOff_11();
  public void CloseSurfaceOff()
    { CloseSurfaceOff_11(); }

  private native void SetRuledMode_12(int id0);
  public void SetRuledMode(int id0)
    { SetRuledMode_12(id0); }

  private native int GetRuledMode_13();
  public int GetRuledMode()
    { return GetRuledMode_13(); }

  private native void SetRuledModeToResample_14();
  public void SetRuledModeToResample()
    { SetRuledModeToResample_14(); }

  private native void SetRuledModeToPointWalk_15();
  public void SetRuledModeToPointWalk()
    { SetRuledModeToPointWalk_15(); }

  private native String GetRuledModeAsString_16();
  public String GetRuledModeAsString()
    { return GetRuledModeAsString_16(); }

  private native void SetResolution_17(int id0,int id1);
  public void SetResolution(int id0,int id1)
    { SetResolution_17(id0,id1); }

  private native void SetResolution_18(int id0[]);
  public void SetResolution(int id0[])
    { SetResolution_18(id0); }

  private native int[]  GetResolution_19();
  public int[]  GetResolution()
    { return GetResolution_19(); }

  private native void SetPassLines_20(int id0);
  public void SetPassLines(int id0)
    { SetPassLines_20(id0); }

  private native int GetPassLines_21();
  public int GetPassLines()
    { return GetPassLines_21(); }

  private native void PassLinesOn_22();
  public void PassLinesOn()
    { PassLinesOn_22(); }

  private native void PassLinesOff_23();
  public void PassLinesOff()
    { PassLinesOff_23(); }

  public vtkRuledSurfaceFilter() { super(); };

  protected vtkRuledSurfaceFilter(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
