// java wrapper for vtkSmoothPolyDataFilter object
//

package vtk;
import vtk.*;

public class vtkSmoothPolyDataFilter extends vtkPolyDataToPolyDataFilter
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void SetConvergence_2(double id0);
  public void SetConvergence(double id0)
    { SetConvergence_2(id0); }

  private native double GetConvergence_3();
  public double GetConvergence()
    { return GetConvergence_3(); }

  private native void SetNumberOfIterations_4(int id0);
  public void SetNumberOfIterations(int id0)
    { SetNumberOfIterations_4(id0); }

  private native int GetNumberOfIterations_5();
  public int GetNumberOfIterations()
    { return GetNumberOfIterations_5(); }

  private native void SetRelaxationFactor_6(double id0);
  public void SetRelaxationFactor(double id0)
    { SetRelaxationFactor_6(id0); }

  private native double GetRelaxationFactor_7();
  public double GetRelaxationFactor()
    { return GetRelaxationFactor_7(); }

  private native void SetFeatureEdgeSmoothing_8(int id0);
  public void SetFeatureEdgeSmoothing(int id0)
    { SetFeatureEdgeSmoothing_8(id0); }

  private native int GetFeatureEdgeSmoothing_9();
  public int GetFeatureEdgeSmoothing()
    { return GetFeatureEdgeSmoothing_9(); }

  private native void FeatureEdgeSmoothingOn_10();
  public void FeatureEdgeSmoothingOn()
    { FeatureEdgeSmoothingOn_10(); }

  private native void FeatureEdgeSmoothingOff_11();
  public void FeatureEdgeSmoothingOff()
    { FeatureEdgeSmoothingOff_11(); }

  private native void SetFeatureAngle_12(double id0);
  public void SetFeatureAngle(double id0)
    { SetFeatureAngle_12(id0); }

  private native double GetFeatureAngle_13();
  public double GetFeatureAngle()
    { return GetFeatureAngle_13(); }

  private native void SetEdgeAngle_14(double id0);
  public void SetEdgeAngle(double id0)
    { SetEdgeAngle_14(id0); }

  private native double GetEdgeAngle_15();
  public double GetEdgeAngle()
    { return GetEdgeAngle_15(); }

  private native void SetBoundarySmoothing_16(int id0);
  public void SetBoundarySmoothing(int id0)
    { SetBoundarySmoothing_16(id0); }

  private native int GetBoundarySmoothing_17();
  public int GetBoundarySmoothing()
    { return GetBoundarySmoothing_17(); }

  private native void BoundarySmoothingOn_18();
  public void BoundarySmoothingOn()
    { BoundarySmoothingOn_18(); }

  private native void BoundarySmoothingOff_19();
  public void BoundarySmoothingOff()
    { BoundarySmoothingOff_19(); }

  private native void SetGenerateErrorScalars_20(int id0);
  public void SetGenerateErrorScalars(int id0)
    { SetGenerateErrorScalars_20(id0); }

  private native int GetGenerateErrorScalars_21();
  public int GetGenerateErrorScalars()
    { return GetGenerateErrorScalars_21(); }

  private native void GenerateErrorScalarsOn_22();
  public void GenerateErrorScalarsOn()
    { GenerateErrorScalarsOn_22(); }

  private native void GenerateErrorScalarsOff_23();
  public void GenerateErrorScalarsOff()
    { GenerateErrorScalarsOff_23(); }

  private native void SetGenerateErrorVectors_24(int id0);
  public void SetGenerateErrorVectors(int id0)
    { SetGenerateErrorVectors_24(id0); }

  private native int GetGenerateErrorVectors_25();
  public int GetGenerateErrorVectors()
    { return GetGenerateErrorVectors_25(); }

  private native void GenerateErrorVectorsOn_26();
  public void GenerateErrorVectorsOn()
    { GenerateErrorVectorsOn_26(); }

  private native void GenerateErrorVectorsOff_27();
  public void GenerateErrorVectorsOff()
    { GenerateErrorVectorsOff_27(); }

  private native void SetSource_28(vtkPolyData id0);
  public void SetSource(vtkPolyData id0)
    { SetSource_28(id0); }

  private native vtkPolyData GetSource_29();
  public vtkPolyData GetSource()
    { return GetSource_29(); }

  public vtkSmoothPolyDataFilter() { super(); };

  protected vtkSmoothPolyDataFilter(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
