// java wrapper for vtkSuperquadric object
//

package vtk;
import vtk.*;

public class vtkSuperquadric extends vtkImplicitFunction
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native double EvaluateFunction_2(double id0,double id1,double id2);
  public double EvaluateFunction(double id0,double id1,double id2)
    { return EvaluateFunction_2(id0,id1,id2); }

  private native void SetCenter_3(double id0,double id1,double id2);
  public void SetCenter(double id0,double id1,double id2)
    { SetCenter_3(id0,id1,id2); }

  private native void SetCenter_4(double id0[]);
  public void SetCenter(double id0[])
    { SetCenter_4(id0); }

  private native double[] GetCenter_5();
  public double[] GetCenter()
    { return GetCenter_5(); }

  private native void SetScale_6(double id0,double id1,double id2);
  public void SetScale(double id0,double id1,double id2)
    { SetScale_6(id0,id1,id2); }

  private native void SetScale_7(double id0[]);
  public void SetScale(double id0[])
    { SetScale_7(id0); }

  private native double[] GetScale_8();
  public double[] GetScale()
    { return GetScale_8(); }

  private native double GetThickness_9();
  public double GetThickness()
    { return GetThickness_9(); }

  private native void SetThickness_10(double id0);
  public void SetThickness(double id0)
    { SetThickness_10(id0); }

  private native double GetPhiRoundness_11();
  public double GetPhiRoundness()
    { return GetPhiRoundness_11(); }

  private native void SetPhiRoundness_12(double id0);
  public void SetPhiRoundness(double id0)
    { SetPhiRoundness_12(id0); }

  private native double GetThetaRoundness_13();
  public double GetThetaRoundness()
    { return GetThetaRoundness_13(); }

  private native void SetThetaRoundness_14(double id0);
  public void SetThetaRoundness(double id0)
    { SetThetaRoundness_14(id0); }

  private native void SetSize_15(double id0);
  public void SetSize(double id0)
    { SetSize_15(id0); }

  private native double GetSize_16();
  public double GetSize()
    { return GetSize_16(); }

  private native void ToroidalOn_17();
  public void ToroidalOn()
    { ToroidalOn_17(); }

  private native void ToroidalOff_18();
  public void ToroidalOff()
    { ToroidalOff_18(); }

  private native int GetToroidal_19();
  public int GetToroidal()
    { return GetToroidal_19(); }

  private native void SetToroidal_20(int id0);
  public void SetToroidal(int id0)
    { SetToroidal_20(id0); }

  public vtkSuperquadric() { super(); };

  protected vtkSuperquadric(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
