// java wrapper for vtkUnstructuredGrid object
//

package vtk;
import vtk.*;

public class vtkUnstructuredGrid extends vtkPointSet
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native int GetDataObjectType_2();
  public int GetDataObjectType()
    { return GetDataObjectType_2(); }

  private native void Allocate_3(int id0,int id1);
  public void Allocate(int id0,int id1)
    { Allocate_3(id0,id1); }

  private native int InsertNextCell_4(int id0,vtkIdList id1);
  public int InsertNextCell(int id0,vtkIdList id1)
    { return InsertNextCell_4(id0,id1); }

  private native void Reset_5();
  public void Reset()
    { Reset_5(); }

  private native vtkCellArray GetCells_6();
  public vtkCellArray GetCells()
    { return GetCells_6(); }

  private native vtkDataObject MakeObject_7();
  public vtkDataObject MakeObject()
    { return MakeObject_7(); }

  private native void CopyStructure_8(vtkDataSet id0);
  public void CopyStructure(vtkDataSet id0)
    { CopyStructure_8(id0); }

  private native int GetNumberOfCells_9();
  public int GetNumberOfCells()
    { return GetNumberOfCells_9(); }

  private native vtkCell GetCell_10(int id0);
  public vtkCell GetCell(int id0)
    { return GetCell_10(id0); }

  private native void GetCell_11(int id0,vtkGenericCell id1);
  public void GetCell(int id0,vtkGenericCell id1)
    { GetCell_11(id0,id1); }

  private native void GetCellPoints_12(int id0,vtkIdList id1);
  public void GetCellPoints(int id0,vtkIdList id1)
    { GetCellPoints_12(id0,id1); }

  private native void GetPointCells_13(int id0,vtkIdList id1);
  public void GetPointCells(int id0,vtkIdList id1)
    { GetPointCells_13(id0,id1); }

  private native int GetCellType_14(int id0);
  public int GetCellType(int id0)
    { return GetCellType_14(id0); }

  private native void Squeeze_15();
  public void Squeeze()
    { Squeeze_15(); }

  private native void Initialize_16();
  public void Initialize()
    { Initialize_16(); }

  private native int GetMaxCellSize_17();
  public int GetMaxCellSize()
    { return GetMaxCellSize_17(); }

  private native void BuildLinks_18();
  public void BuildLinks()
    { BuildLinks_18(); }

  private native vtkCellLinks GetCellLinks_19();
  public vtkCellLinks GetCellLinks()
    { return GetCellLinks_19(); }

  private native void RemoveReferenceToCell_20(int id0,int id1);
  public void RemoveReferenceToCell(int id0,int id1)
    { RemoveReferenceToCell_20(id0,id1); }

  private native void AddReferenceToCell_21(int id0,int id1);
  public void AddReferenceToCell(int id0,int id1)
    { AddReferenceToCell_21(id0,id1); }

  private native void ResizeCellList_22(int id0,int id1);
  public void ResizeCellList(int id0,int id1)
    { ResizeCellList_22(id0,id1); }

  private native void GetCellNeighbors_23(int id0,vtkIdList id1,vtkIdList id2);
  public void GetCellNeighbors(int id0,vtkIdList id1,vtkIdList id2)
    { GetCellNeighbors_23(id0,id1,id2); }

  private native void SetUpdateExtent_24(int id0,int id1,int id2);
  public void SetUpdateExtent(int id0,int id1,int id2)
    { SetUpdateExtent_24(id0,id1,id2); }

  private native void SetUpdateExtent_25(int id0,int id1);
  public void SetUpdateExtent(int id0,int id1)
    { SetUpdateExtent_25(id0,id1); }

  private native int[]  GetUpdateExtent_26();
  public int[]  GetUpdateExtent()
    { return GetUpdateExtent_26(); }

  private native void SetUpdateExtent_27(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetUpdateExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetUpdateExtent_27(id0,id1,id2,id3,id4,id5); }

  private native int GetPiece_28();
  public int GetPiece()
    { return GetPiece_28(); }

  private native int GetNumberOfPieces_29();
  public int GetNumberOfPieces()
    { return GetNumberOfPieces_29(); }

  private native int GetGhostLevel_30();
  public int GetGhostLevel()
    { return GetGhostLevel_30(); }

  private native int GetActualMemorySize_31();
  public int GetActualMemorySize()
    { return GetActualMemorySize_31(); }

  private native void ShallowCopy_32(vtkDataObject id0);
  public void ShallowCopy(vtkDataObject id0)
    { ShallowCopy_32(id0); }

  private native void DeepCopy_33(vtkDataObject id0);
  public void DeepCopy(vtkDataObject id0)
    { DeepCopy_33(id0); }

  public vtkUnstructuredGrid() { super(); };

  protected vtkUnstructuredGrid(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
