// java wrapper for vtkVideoSource object
//

package vtk;
import vtk.*;

public class vtkVideoSource extends vtkImageSource
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void Initialize_2();
  public void Initialize()
    { Initialize_2(); }

  private native void ReleaseSystemResources_3();
  public void ReleaseSystemResources()
    { ReleaseSystemResources_3(); }

  private native void Grab_4(int id0);
  public void Grab(int id0)
    { Grab_4(id0); }

  private native void Grab_5();
  public void Grab()
    { Grab_5(); }

  private native void Play_6();
  public void Play()
    { Play_6(); }

  private native void Stop_7();
  public void Stop()
    { Stop_7(); }

  private native int GetPlaying_8();
  public int GetPlaying()
    { return GetPlaying_8(); }

  private native void SetFrameRate_9(double id0);
  public void SetFrameRate(double id0)
    { SetFrameRate_9(id0); }

  private native double GetFrameRate_10();
  public double GetFrameRate()
    { return GetFrameRate_10(); }

  private native void SetFrameSize_11(int id0,int id1,int id2);
  public void SetFrameSize(int id0,int id1,int id2)
    { SetFrameSize_11(id0,id1,id2); }

  private native int[]  GetFrameSize_12();
  public int[]  GetFrameSize()
    { return GetFrameSize_12(); }

  private native void SetOutputFormat_13(int id0);
  public void SetOutputFormat(int id0)
    { SetOutputFormat_13(id0); }

  private native void SetOutputFormatToLuminance_14();
  public void SetOutputFormatToLuminance()
    { SetOutputFormatToLuminance_14(); }

  private native void SetOutputFormatToRGB_15();
  public void SetOutputFormatToRGB()
    { SetOutputFormatToRGB_15(); }

  private native void SetOutputFormatToRGBA_16();
  public void SetOutputFormatToRGBA()
    { SetOutputFormatToRGBA_16(); }

  private native int GetOutputFormat_17();
  public int GetOutputFormat()
    { return GetOutputFormat_17(); }

  private native void SetFrameBufferSize_18(int id0);
  public void SetFrameBufferSize(int id0)
    { SetFrameBufferSize_18(id0); }

  private native int GetFrameBufferSize_19();
  public int GetFrameBufferSize()
    { return GetFrameBufferSize_19(); }

  private native void SetNumberOfOutputFrames_20(int id0);
  public void SetNumberOfOutputFrames(int id0)
    { SetNumberOfOutputFrames_20(id0); }

  private native int GetNumberOfOutputFrames_21();
  public int GetNumberOfOutputFrames()
    { return GetNumberOfOutputFrames_21(); }

  private native void AutoAdvanceOn_22();
  public void AutoAdvanceOn()
    { AutoAdvanceOn_22(); }

  private native void AutoAdvanceOff_23();
  public void AutoAdvanceOff()
    { AutoAdvanceOff_23(); }

  private native void SetAutoAdvance_24(int id0);
  public void SetAutoAdvance(int id0)
    { SetAutoAdvance_24(id0); }

  private native int GetAutoAdvance_25();
  public int GetAutoAdvance()
    { return GetAutoAdvance_25(); }

  private native void Advance_26(int id0);
  public void Advance(int id0)
    { Advance_26(id0); }

  private native void Advance_27();
  public void Advance()
    { Advance_27(); }

  private native void Rewind_28(int id0);
  public void Rewind(int id0)
    { Rewind_28(id0); }

  private native void Rewind_29();
  public void Rewind()
    { Rewind_29(); }

  private native void SetClipRegion_30(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetClipRegion(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetClipRegion_30(id0,id1,id2,id3,id4,id5); }

  private native int[]  GetClipRegion_31();
  public int[]  GetClipRegion()
    { return GetClipRegion_31(); }

  private native void SetOutputWholeExtent_32(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetOutputWholeExtent(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetOutputWholeExtent_32(id0,id1,id2,id3,id4,id5); }

  private native void SetOutputWholeExtent_33(int id0[]);
  public void SetOutputWholeExtent(int id0[])
    { SetOutputWholeExtent_33(id0); }

  private native int[]  GetOutputWholeExtent_34();
  public int[]  GetOutputWholeExtent()
    { return GetOutputWholeExtent_34(); }

  private native void SetDataSpacing_35(double id0,double id1,double id2);
  public void SetDataSpacing(double id0,double id1,double id2)
    { SetDataSpacing_35(id0,id1,id2); }

  private native void SetDataSpacing_36(double id0[]);
  public void SetDataSpacing(double id0[])
    { SetDataSpacing_36(id0); }

  private native double[] GetDataSpacing_37();
  public double[] GetDataSpacing()
    { return GetDataSpacing_37(); }

  private native void SetDataOrigin_38(double id0,double id1,double id2);
  public void SetDataOrigin(double id0,double id1,double id2)
    { SetDataOrigin_38(id0,id1,id2); }

  private native void SetDataOrigin_39(double id0[]);
  public void SetDataOrigin(double id0[])
    { SetDataOrigin_39(id0); }

  private native double[] GetDataOrigin_40();
  public double[] GetDataOrigin()
    { return GetDataOrigin_40(); }

  private native void SetOpacity_41(double id0);
  public void SetOpacity(double id0)
    { SetOpacity_41(id0); }

  private native double GetOpacity_42();
  public double GetOpacity()
    { return GetOpacity_42(); }

  private native void SetPreview_43(int id0);
  public void SetPreview(int id0)
    { SetPreview_43(id0); }

  private native void PreviewOn_44();
  public void PreviewOn()
    { PreviewOn_44(); }

  private native void PreviewOff_45();
  public void PreviewOff()
    { PreviewOff_45(); }

  private native int GetPreview_46();
  public int GetPreview()
    { return GetPreview_46(); }

  private native double GetFrameTimeStamp_47(int id0);
  public double GetFrameTimeStamp(int id0)
    { return GetFrameTimeStamp_47(id0); }

  private native double GetFrameTimeStamp_48();
  public double GetFrameTimeStamp()
    { return GetFrameTimeStamp_48(); }

  private native void SetGrabOnUpdate_49(int id0);
  public void SetGrabOnUpdate(int id0)
    { SetGrabOnUpdate_49(id0); }

  private native void GrabOnUpdateOn_50();
  public void GrabOnUpdateOn()
    { GrabOnUpdateOn_50(); }

  private native void GrabOnUpdateOff_51();
  public void GrabOnUpdateOff()
    { GrabOnUpdateOff_51(); }

  private native int GetGrabOnUpdate_52();
  public int GetGrabOnUpdate()
    { return GetGrabOnUpdate_52(); }

  private native void InternalGrab_53();
  public void InternalGrab()
    { InternalGrab_53(); }

  private native void UpdateInformation_54();
  public void UpdateInformation()
    { UpdateInformation_54(); }

  public vtkVideoSource() { super(); };

  protected vtkVideoSource(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
