// java wrapper for vtkVolumeProMapper object
//

package vtk;
import vtk.*;

public class vtkVolumeProMapper extends vtkVolumeMapper
{

  private native String GetClassName_0();
  public String GetClassName()
    { return GetClassName_0(); }

  private native int IsA_1(String id0);
  public int IsA(String id0)
    { return IsA_1(id0); }

  private native void Render_2(vtkRenderer id0,vtkVolume id1);
  public void Render(vtkRenderer id0,vtkVolume id1)
    { Render_2(id0,id1); }

  private native int GetMapperType_3();
  public int GetMapperType()
    { return GetMapperType_3(); }

  private native void SetBlendMode_4(int id0);
  public void SetBlendMode(int id0)
    { SetBlendMode_4(id0); }

  private native int GetBlendMode_5();
  public int GetBlendMode()
    { return GetBlendMode_5(); }

  private native void SetBlendModeToComposite_6();
  public void SetBlendModeToComposite()
    { SetBlendModeToComposite_6(); }

  private native void SetBlendModeToMaximumIntensity_7();
  public void SetBlendModeToMaximumIntensity()
    { SetBlendModeToMaximumIntensity_7(); }

  private native void SetBlendModeToMinimumIntensity_8();
  public void SetBlendModeToMinimumIntensity()
    { SetBlendModeToMinimumIntensity_8(); }

  private native String GetBlendModeAsString_9();
  public String GetBlendModeAsString()
    { return GetBlendModeAsString_9(); }

  private native void SetSubVolume_10(int id0,int id1,int id2,int id3,int id4,int id5);
  public void SetSubVolume(int id0,int id1,int id2,int id3,int id4,int id5)
    { SetSubVolume_10(id0,id1,id2,id3,id4,id5); }

  private native void SetSubVolume_11(int id0[]);
  public void SetSubVolume(int id0[])
    { SetSubVolume_11(id0); }

  private native int[]  GetSubVolume_12();
  public int[]  GetSubVolume()
    { return GetSubVolume_12(); }

  private native void SetCursor_13(int id0);
  public void SetCursor(int id0)
    { SetCursor_13(id0); }

  private native int GetCursor_14();
  public int GetCursor()
    { return GetCursor_14(); }

  private native void CursorOn_15();
  public void CursorOn()
    { CursorOn_15(); }

  private native void CursorOff_16();
  public void CursorOff()
    { CursorOff_16(); }

  private native void SetCursorType_17(int id0);
  public void SetCursorType(int id0)
    { SetCursorType_17(id0); }

  private native int GetCursorType_18();
  public int GetCursorType()
    { return GetCursorType_18(); }

  private native void SetCursorTypeToCrossHair_19();
  public void SetCursorTypeToCrossHair()
    { SetCursorTypeToCrossHair_19(); }

  private native void SetCursorTypeToPlane_20();
  public void SetCursorTypeToPlane()
    { SetCursorTypeToPlane_20(); }

  private native String GetCursorTypeAsString_21();
  public String GetCursorTypeAsString()
    { return GetCursorTypeAsString_21(); }

  private native void SetCursorPosition_22(double id0,double id1,double id2);
  public void SetCursorPosition(double id0,double id1,double id2)
    { SetCursorPosition_22(id0,id1,id2); }

  private native void SetCursorPosition_23(double id0[]);
  public void SetCursorPosition(double id0[])
    { SetCursorPosition_23(id0); }

  private native double[] GetCursorPosition_24();
  public double[] GetCursorPosition()
    { return GetCursorPosition_24(); }

  private native void SetCursorXAxisColor_25(double id0,double id1,double id2);
  public void SetCursorXAxisColor(double id0,double id1,double id2)
    { SetCursorXAxisColor_25(id0,id1,id2); }

  private native void SetCursorXAxisColor_26(double id0[]);
  public void SetCursorXAxisColor(double id0[])
    { SetCursorXAxisColor_26(id0); }

  private native double[] GetCursorXAxisColor_27();
  public double[] GetCursorXAxisColor()
    { return GetCursorXAxisColor_27(); }

  private native void SetCursorYAxisColor_28(double id0,double id1,double id2);
  public void SetCursorYAxisColor(double id0,double id1,double id2)
    { SetCursorYAxisColor_28(id0,id1,id2); }

  private native void SetCursorYAxisColor_29(double id0[]);
  public void SetCursorYAxisColor(double id0[])
    { SetCursorYAxisColor_29(id0); }

  private native double[] GetCursorYAxisColor_30();
  public double[] GetCursorYAxisColor()
    { return GetCursorYAxisColor_30(); }

  private native void SetCursorZAxisColor_31(double id0,double id1,double id2);
  public void SetCursorZAxisColor(double id0,double id1,double id2)
    { SetCursorZAxisColor_31(id0,id1,id2); }

  private native void SetCursorZAxisColor_32(double id0[]);
  public void SetCursorZAxisColor(double id0[])
    { SetCursorZAxisColor_32(id0); }

  private native double[] GetCursorZAxisColor_33();
  public double[] GetCursorZAxisColor()
    { return GetCursorZAxisColor_33(); }

  private native void SetSuperSampling_34(int id0);
  public void SetSuperSampling(int id0)
    { SetSuperSampling_34(id0); }

  private native int GetSuperSampling_35();
  public int GetSuperSampling()
    { return GetSuperSampling_35(); }

  private native void SuperSamplingOn_36();
  public void SuperSamplingOn()
    { SuperSamplingOn_36(); }

  private native void SuperSamplingOff_37();
  public void SuperSamplingOff()
    { SuperSamplingOff_37(); }

  private native void SetSuperSamplingFactor_38(double id0,double id1,double id2);
  public void SetSuperSamplingFactor(double id0,double id1,double id2)
    { SetSuperSamplingFactor_38(id0,id1,id2); }

  private native double[] GetSuperSamplingFactor_39();
  public double[] GetSuperSamplingFactor()
    { return GetSuperSamplingFactor_39(); }

  private native void SetCutPlane_40(int id0);
  public void SetCutPlane(int id0)
    { SetCutPlane_40(id0); }

  private native int GetCutPlane_41();
  public int GetCutPlane()
    { return GetCutPlane_41(); }

  private native void CutPlaneOn_42();
  public void CutPlaneOn()
    { CutPlaneOn_42(); }

  private native void CutPlaneOff_43();
  public void CutPlaneOff()
    { CutPlaneOff_43(); }

  private native void SetCutPlaneEquation_44(double id0,double id1,double id2,double id3);
  public void SetCutPlaneEquation(double id0,double id1,double id2,double id3)
    { SetCutPlaneEquation_44(id0,id1,id2,id3); }

  private native void SetCutPlaneEquation_45(double id0[]);
  public void SetCutPlaneEquation(double id0[])
    { SetCutPlaneEquation_45(id0); }

  private native double[] GetCutPlaneEquation_46();
  public double[] GetCutPlaneEquation()
    { return GetCutPlaneEquation_46(); }

  private native void SetCutPlaneThickness_47(double id0);
  public void SetCutPlaneThickness(double id0)
    { SetCutPlaneThickness_47(id0); }

  private native double GetCutPlaneThickness_48();
  public double GetCutPlaneThickness()
    { return GetCutPlaneThickness_48(); }

  private native void SetCutPlaneFallOffDistance_49(int id0);
  public void SetCutPlaneFallOffDistance(int id0)
    { SetCutPlaneFallOffDistance_49(id0); }

  private native int GetCutPlaneFallOffDistance_50();
  public int GetCutPlaneFallOffDistance()
    { return GetCutPlaneFallOffDistance_50(); }

  private native void SetGradientOpacityModulation_51(int id0);
  public void SetGradientOpacityModulation(int id0)
    { SetGradientOpacityModulation_51(id0); }

  private native int GetGradientOpacityModulation_52();
  public int GetGradientOpacityModulation()
    { return GetGradientOpacityModulation_52(); }

  private native void GradientOpacityModulationOn_53();
  public void GradientOpacityModulationOn()
    { GradientOpacityModulationOn_53(); }

  private native void GradientOpacityModulationOff_54();
  public void GradientOpacityModulationOff()
    { GradientOpacityModulationOff_54(); }

  private native void SetGradientDiffuseModulation_55(int id0);
  public void SetGradientDiffuseModulation(int id0)
    { SetGradientDiffuseModulation_55(id0); }

  private native int GetGradientDiffuseModulation_56();
  public int GetGradientDiffuseModulation()
    { return GetGradientDiffuseModulation_56(); }

  private native void GradientDiffuseModulationOn_57();
  public void GradientDiffuseModulationOn()
    { GradientDiffuseModulationOn_57(); }

  private native void GradientDiffuseModulationOff_58();
  public void GradientDiffuseModulationOff()
    { GradientDiffuseModulationOff_58(); }

  private native void SetGradientSpecularModulation_59(int id0);
  public void SetGradientSpecularModulation(int id0)
    { SetGradientSpecularModulation_59(id0); }

  private native int GetGradientSpecularModulation_60();
  public int GetGradientSpecularModulation()
    { return GetGradientSpecularModulation_60(); }

  private native void GradientSpecularModulationOn_61();
  public void GradientSpecularModulationOn()
    { GradientSpecularModulationOn_61(); }

  private native void GradientSpecularModulationOff_62();
  public void GradientSpecularModulationOff()
    { GradientSpecularModulationOff_62(); }

  private native int GetNoHardware_63();
  public int GetNoHardware()
    { return GetNoHardware_63(); }

  private native int GetWrongVLIVersion_64();
  public int GetWrongVLIVersion()
    { return GetWrongVLIVersion_64(); }

  private native int GetNumberOfBoards_65();
  public int GetNumberOfBoards()
    { return GetNumberOfBoards_65(); }

  private native int GetMajorBoardVersion_66();
  public int GetMajorBoardVersion()
    { return GetMajorBoardVersion_66(); }

  private native int GetMinorBoardVersion_67();
  public int GetMinorBoardVersion()
    { return GetMinorBoardVersion_67(); }

  private native int GetAvailableBoardMemory_68();
  public int GetAvailableBoardMemory()
    { return GetAvailableBoardMemory_68(); }

  public vtkVolumeProMapper() { super(); };

  protected vtkVolumeProMapper(int dmy) { super(dmy); };
  public native void   VTKInit();
  protected native void   VTKCastInit();

}
